class Encoding::Converter::TranscodingPath
  @paths = {}

  @paths["[ASCII-8BIT, BIG5]"] = [[:"ASCII-8BIT", :"UTF-8", :BIG5]]
  @paths["[ASCII-8BIT, BIG5-HKSCS]"] = [[:"ASCII-8BIT", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ASCII-8BIT, BIG5-UAO]"] = [[:"ASCII-8BIT", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ASCII-8BIT, CP50220]"] = [[:"ASCII-8BIT", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ASCII-8BIT, CP50221]"] = [[:"ASCII-8BIT", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ASCII-8BIT, CP51932]"] = [[:"ASCII-8BIT", :"UTF-8", :CP51932]]
  @paths["[ASCII-8BIT, CP850]"] = [[:"ASCII-8BIT", :"UTF-8", :CP850]]
  @paths["[ASCII-8BIT, CP852]"] = [[:"ASCII-8BIT", :"UTF-8", :CP852]]
  @paths["[ASCII-8BIT, CP855]"] = [[:"ASCII-8BIT", :"UTF-8", :CP855]]
  @paths["[ASCII-8BIT, CP949]"] = [[:"ASCII-8BIT", :"UTF-8", :CP949]]
  @paths["[ASCII-8BIT, CP950]"] = [[:"ASCII-8BIT", :"UTF-8", :CP950]]
  @paths["[ASCII-8BIT, CP951]"] = [[:"ASCII-8BIT", :"UTF-8", :CP951]]
  @paths["[ASCII-8BIT, EUC-JP]"] = [[:"ASCII-8BIT", :"UTF-8", :"EUC-JP"]]
  @paths["[ASCII-8BIT, EUC-KR]"] = [[:"ASCII-8BIT", :"UTF-8", :"EUC-KR"]]
  @paths["[ASCII-8BIT, EUCJP-MS]"] = [[:"ASCII-8BIT", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ASCII-8BIT, GB12345]"] = [[:"ASCII-8BIT", :"UTF-8", :GB12345]]
  @paths["[ASCII-8BIT, GB18030]"] = [[:"ASCII-8BIT", :"UTF-8", :GB18030]]
  @paths["[ASCII-8BIT, GB2312]"] = [[:"ASCII-8BIT", :"UTF-8", :GB2312]]
  @paths["[ASCII-8BIT, GBK]"] = [[:"ASCII-8BIT", :"UTF-8", :GBK]]
  @paths["[ASCII-8BIT, IBM437]"] = [[:"ASCII-8BIT", :"UTF-8", :IBM437]]
  @paths["[ASCII-8BIT, IBM737]"] = [[:"ASCII-8BIT", :"UTF-8", :IBM737]]
  @paths["[ASCII-8BIT, IBM775]"] = [[:"ASCII-8BIT", :"UTF-8", :IBM775]]
  @paths["[ASCII-8BIT, IBM852]"] = [[:"ASCII-8BIT", :"UTF-8", :IBM852]]
  @paths["[ASCII-8BIT, IBM855]"] = [[:"ASCII-8BIT", :"UTF-8", :IBM855]]
  @paths["[ASCII-8BIT, IBM857]"] = [[:"ASCII-8BIT", :"UTF-8", :IBM857]]
  @paths["[ASCII-8BIT, IBM860]"] = [[:"ASCII-8BIT", :"UTF-8", :IBM860]]
  @paths["[ASCII-8BIT, IBM861]"] = [[:"ASCII-8BIT", :"UTF-8", :IBM861]]
  @paths["[ASCII-8BIT, IBM862]"] = [[:"ASCII-8BIT", :"UTF-8", :IBM862]]
  @paths["[ASCII-8BIT, IBM863]"] = [[:"ASCII-8BIT", :"UTF-8", :IBM863]]
  @paths["[ASCII-8BIT, IBM865]"] = [[:"ASCII-8BIT", :"UTF-8", :IBM865]]
  @paths["[ASCII-8BIT, IBM866]"] = [[:"ASCII-8BIT", :"UTF-8", :IBM866]]
  @paths["[ASCII-8BIT, IBM869]"] = [[:"ASCII-8BIT", :"UTF-8", :IBM869]]
  @paths["[ASCII-8BIT, ISO-2022-JP]"] = [[:"ASCII-8BIT", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ASCII-8BIT, ISO-2022-JP-KDDI]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ASCII-8BIT, ISO-8859-1]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ASCII-8BIT, ISO-8859-10]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ASCII-8BIT, ISO-8859-11]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ASCII-8BIT, ISO-8859-13]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ASCII-8BIT, ISO-8859-14]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ASCII-8BIT, ISO-8859-15]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ASCII-8BIT, ISO-8859-2]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ASCII-8BIT, ISO-8859-3]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ASCII-8BIT, ISO-8859-4]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ASCII-8BIT, ISO-8859-5]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ASCII-8BIT, ISO-8859-6]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ASCII-8BIT, ISO-8859-7]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ASCII-8BIT, ISO-8859-8]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ASCII-8BIT, ISO-8859-9]"] = [[:"ASCII-8BIT", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ASCII-8BIT, KOI8-R]"] = [[:"ASCII-8BIT", :"UTF-8", :"KOI8-R"]]
  @paths["[ASCII-8BIT, KOI8-U]"] = [[:"ASCII-8BIT", :"UTF-8", :"KOI8-U"]]
  @paths["[ASCII-8BIT, MACCROATIAN]"] = [[:"ASCII-8BIT", :"UTF-8", :MACCROATIAN]]
  @paths["[ASCII-8BIT, MACCYRILLIC]"] = [[:"ASCII-8BIT", :"UTF-8", :MACCYRILLIC]]
  @paths["[ASCII-8BIT, MACGREEK]"] = [[:"ASCII-8BIT", :"UTF-8", :MACGREEK]]
  @paths["[ASCII-8BIT, MACICELAND]"] = [[:"ASCII-8BIT", :"UTF-8", :MACICELAND]]
  @paths["[ASCII-8BIT, MACROMAN]"] = [[:"ASCII-8BIT", :"UTF-8", :MACROMAN]]
  @paths["[ASCII-8BIT, MACROMANIA]"] = [[:"ASCII-8BIT", :"UTF-8", :MACROMANIA]]
  @paths["[ASCII-8BIT, MACTURKISH]"] = [[:"ASCII-8BIT", :"UTF-8", :MACTURKISH]]
  @paths["[ASCII-8BIT, MACUKRAINE]"] = [[:"ASCII-8BIT", :"UTF-8", :MACUKRAINE]]
  @paths["[ASCII-8BIT, SHIFT_JIS]"] = [[:"ASCII-8BIT", :"UTF-8", :SHIFT_JIS]]
  @paths["[ASCII-8BIT, SJIS-DOCOMO]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ASCII-8BIT, SJIS-KDDI]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ASCII-8BIT, SJIS-SOFTBANK]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ASCII-8BIT, STATELESS-ISO-2022-JP]"] = [[:"ASCII-8BIT", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ASCII-8BIT, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ASCII-8BIT, TIS-620]"] = [[:"ASCII-8BIT", :"UTF-8", :"TIS-620"]]
  @paths["[ASCII-8BIT, US-ASCII]"] = [[:"ASCII-8BIT", :"UTF-8", :"US-ASCII"]]
  @paths["[ASCII-8BIT, UTF-16]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF-16"]]
  @paths["[ASCII-8BIT, UTF-16BE]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF-16BE"]]
  @paths["[ASCII-8BIT, UTF-16LE]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF-16LE"]]
  @paths["[ASCII-8BIT, UTF-32]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF-32"]]
  @paths["[ASCII-8BIT, UTF-32BE]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF-32BE"]]
  @paths["[ASCII-8BIT, UTF-32LE]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF-32LE"]]
  @paths["[ASCII-8BIT, UTF-8]"] = [[:"ASCII-8BIT", :"UTF-8"]]
  @paths["[ASCII-8BIT, UTF8-DOCOMO]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ASCII-8BIT, UTF8-KDDI]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ASCII-8BIT, UTF8-MAC]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ASCII-8BIT, UTF8-SOFTBANK]"] = [[:"ASCII-8BIT", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ASCII-8BIT, WINDOWS-1250]"] = [[:"ASCII-8BIT", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ASCII-8BIT, WINDOWS-1251]"] = [[:"ASCII-8BIT", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ASCII-8BIT, WINDOWS-1252]"] = [[:"ASCII-8BIT", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ASCII-8BIT, WINDOWS-1253]"] = [[:"ASCII-8BIT", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ASCII-8BIT, WINDOWS-1254]"] = [[:"ASCII-8BIT", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ASCII-8BIT, WINDOWS-1255]"] = [[:"ASCII-8BIT", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ASCII-8BIT, WINDOWS-1256]"] = [[:"ASCII-8BIT", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ASCII-8BIT, WINDOWS-1257]"] = [[:"ASCII-8BIT", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ASCII-8BIT, WINDOWS-31J]"] = [[:"ASCII-8BIT", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ASCII-8BIT, WINDOWS-874]"] = [[:"ASCII-8BIT", :"UTF-8", :"WINDOWS-874"]]
  @paths["[BIG5, ASCII-8BIT]"] = [[:BIG5, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[BIG5, BIG5-HKSCS]"] = [[:BIG5, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[BIG5, BIG5-UAO]"] = [[:BIG5, :"UTF-8", :"BIG5-UAO"]]
  @paths["[BIG5, CP50220]"] = [[:BIG5, :"UTF-8", :CP51932, :CP50220]]
  @paths["[BIG5, CP50221]"] = [[:BIG5, :"UTF-8", :CP51932, :CP50221]]
  @paths["[BIG5, CP51932]"] = [[:BIG5, :"UTF-8", :CP51932]]
  @paths["[BIG5, CP850]"] = [[:BIG5, :"UTF-8", :CP850]]
  @paths["[BIG5, CP852]"] = [[:BIG5, :"UTF-8", :CP852]]
  @paths["[BIG5, CP855]"] = [[:BIG5, :"UTF-8", :CP855]]
  @paths["[BIG5, CP949]"] = [[:BIG5, :"UTF-8", :CP949]]
  @paths["[BIG5, CP950]"] = [[:BIG5, :"UTF-8", :CP950]]
  @paths["[BIG5, CP951]"] = [[:BIG5, :"UTF-8", :CP951]]
  @paths["[BIG5, EUC-JP]"] = [[:BIG5, :"UTF-8", :"EUC-JP"]]
  @paths["[BIG5, EUC-KR]"] = [[:BIG5, :"UTF-8", :"EUC-KR"]]
  @paths["[BIG5, EUCJP-MS]"] = [[:BIG5, :"UTF-8", :"EUCJP-MS"]]
  @paths["[BIG5, GB12345]"] = [[:BIG5, :"UTF-8", :GB12345]]
  @paths["[BIG5, GB18030]"] = [[:BIG5, :"UTF-8", :GB18030]]
  @paths["[BIG5, GB2312]"] = [[:BIG5, :"UTF-8", :GB2312]]
  @paths["[BIG5, GBK]"] = [[:BIG5, :"UTF-8", :GBK]]
  @paths["[BIG5, IBM437]"] = [[:BIG5, :"UTF-8", :IBM437]]
  @paths["[BIG5, IBM737]"] = [[:BIG5, :"UTF-8", :IBM737]]
  @paths["[BIG5, IBM775]"] = [[:BIG5, :"UTF-8", :IBM775]]
  @paths["[BIG5, IBM852]"] = [[:BIG5, :"UTF-8", :IBM852]]
  @paths["[BIG5, IBM855]"] = [[:BIG5, :"UTF-8", :IBM855]]
  @paths["[BIG5, IBM857]"] = [[:BIG5, :"UTF-8", :IBM857]]
  @paths["[BIG5, IBM860]"] = [[:BIG5, :"UTF-8", :IBM860]]
  @paths["[BIG5, IBM861]"] = [[:BIG5, :"UTF-8", :IBM861]]
  @paths["[BIG5, IBM862]"] = [[:BIG5, :"UTF-8", :IBM862]]
  @paths["[BIG5, IBM863]"] = [[:BIG5, :"UTF-8", :IBM863]]
  @paths["[BIG5, IBM865]"] = [[:BIG5, :"UTF-8", :IBM865]]
  @paths["[BIG5, IBM866]"] = [[:BIG5, :"UTF-8", :IBM866]]
  @paths["[BIG5, IBM869]"] = [[:BIG5, :"UTF-8", :IBM869]]
  @paths["[BIG5, ISO-2022-JP]"] = [[:BIG5, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[BIG5, ISO-2022-JP-KDDI]"] = [[:BIG5, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[BIG5, ISO-8859-1]"] = [[:BIG5, :"UTF-8", :"ISO-8859-1"]]
  @paths["[BIG5, ISO-8859-10]"] = [[:BIG5, :"UTF-8", :"ISO-8859-10"]]
  @paths["[BIG5, ISO-8859-11]"] = [[:BIG5, :"UTF-8", :"ISO-8859-11"]]
  @paths["[BIG5, ISO-8859-13]"] = [[:BIG5, :"UTF-8", :"ISO-8859-13"]]
  @paths["[BIG5, ISO-8859-14]"] = [[:BIG5, :"UTF-8", :"ISO-8859-14"]]
  @paths["[BIG5, ISO-8859-15]"] = [[:BIG5, :"UTF-8", :"ISO-8859-15"]]
  @paths["[BIG5, ISO-8859-2]"] = [[:BIG5, :"UTF-8", :"ISO-8859-2"]]
  @paths["[BIG5, ISO-8859-3]"] = [[:BIG5, :"UTF-8", :"ISO-8859-3"]]
  @paths["[BIG5, ISO-8859-4]"] = [[:BIG5, :"UTF-8", :"ISO-8859-4"]]
  @paths["[BIG5, ISO-8859-5]"] = [[:BIG5, :"UTF-8", :"ISO-8859-5"]]
  @paths["[BIG5, ISO-8859-6]"] = [[:BIG5, :"UTF-8", :"ISO-8859-6"]]
  @paths["[BIG5, ISO-8859-7]"] = [[:BIG5, :"UTF-8", :"ISO-8859-7"]]
  @paths["[BIG5, ISO-8859-8]"] = [[:BIG5, :"UTF-8", :"ISO-8859-8"]]
  @paths["[BIG5, ISO-8859-9]"] = [[:BIG5, :"UTF-8", :"ISO-8859-9"]]
  @paths["[BIG5, KOI8-R]"] = [[:BIG5, :"UTF-8", :"KOI8-R"]]
  @paths["[BIG5, KOI8-U]"] = [[:BIG5, :"UTF-8", :"KOI8-U"]]
  @paths["[BIG5, MACCROATIAN]"] = [[:BIG5, :"UTF-8", :MACCROATIAN]]
  @paths["[BIG5, MACCYRILLIC]"] = [[:BIG5, :"UTF-8", :MACCYRILLIC]]
  @paths["[BIG5, MACGREEK]"] = [[:BIG5, :"UTF-8", :MACGREEK]]
  @paths["[BIG5, MACICELAND]"] = [[:BIG5, :"UTF-8", :MACICELAND]]
  @paths["[BIG5, MACROMAN]"] = [[:BIG5, :"UTF-8", :MACROMAN]]
  @paths["[BIG5, MACROMANIA]"] = [[:BIG5, :"UTF-8", :MACROMANIA]]
  @paths["[BIG5, MACTURKISH]"] = [[:BIG5, :"UTF-8", :MACTURKISH]]
  @paths["[BIG5, MACUKRAINE]"] = [[:BIG5, :"UTF-8", :MACUKRAINE]]
  @paths["[BIG5, SHIFT_JIS]"] = [[:BIG5, :"UTF-8", :SHIFT_JIS]]
  @paths["[BIG5, SJIS-DOCOMO]"] = [[:BIG5, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[BIG5, SJIS-KDDI]"] = [[:BIG5, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[BIG5, SJIS-SOFTBANK]"] = [[:BIG5, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[BIG5, STATELESS-ISO-2022-JP]"] = [[:BIG5, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[BIG5, STATELESS-ISO-2022-JP-KDDI]"] = [[:BIG5, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[BIG5, TIS-620]"] = [[:BIG5, :"UTF-8", :"TIS-620"]]
  @paths["[BIG5, US-ASCII]"] = [[:BIG5, :"UTF-8", :"US-ASCII"]]
  @paths["[BIG5, UTF-16]"] = [[:BIG5, :"UTF-8", :"UTF-16"]]
  @paths["[BIG5, UTF-16BE]"] = [[:BIG5, :"UTF-8", :"UTF-16BE"]]
  @paths["[BIG5, UTF-16LE]"] = [[:BIG5, :"UTF-8", :"UTF-16LE"]]
  @paths["[BIG5, UTF-32]"] = [[:BIG5, :"UTF-8", :"UTF-32"]]
  @paths["[BIG5, UTF-32BE]"] = [[:BIG5, :"UTF-8", :"UTF-32BE"]]
  @paths["[BIG5, UTF-32LE]"] = [[:BIG5, :"UTF-8", :"UTF-32LE"]]
  @paths["[BIG5, UTF-8]"] = [[:BIG5, :"UTF-8"]]
  @paths["[BIG5, UTF8-DOCOMO]"] = [[:BIG5, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[BIG5, UTF8-KDDI]"] = [[:BIG5, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[BIG5, UTF8-MAC]"] = [[:BIG5, :"UTF-8", :"UTF8-MAC"]]
  @paths["[BIG5, UTF8-SOFTBANK]"] = [[:BIG5, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[BIG5, WINDOWS-1250]"] = [[:BIG5, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[BIG5, WINDOWS-1251]"] = [[:BIG5, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[BIG5, WINDOWS-1252]"] = [[:BIG5, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[BIG5, WINDOWS-1253]"] = [[:BIG5, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[BIG5, WINDOWS-1254]"] = [[:BIG5, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[BIG5, WINDOWS-1255]"] = [[:BIG5, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[BIG5, WINDOWS-1256]"] = [[:BIG5, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[BIG5, WINDOWS-1257]"] = [[:BIG5, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[BIG5, WINDOWS-31J]"] = [[:BIG5, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[BIG5, WINDOWS-874]"] = [[:BIG5, :"UTF-8", :"WINDOWS-874"]]
  @paths["[BIG5-HKSCS, ASCII-8BIT]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[BIG5-HKSCS, BIG5]"] = [[:"BIG5-HKSCS", :"UTF-8", :BIG5]]
  @paths["[BIG5-HKSCS, BIG5-UAO]"] = [[:"BIG5-HKSCS", :"UTF-8", :"BIG5-UAO"]]
  @paths["[BIG5-HKSCS, CP50220]"] = [[:"BIG5-HKSCS", :"UTF-8", :CP51932, :CP50220]]
  @paths["[BIG5-HKSCS, CP50221]"] = [[:"BIG5-HKSCS", :"UTF-8", :CP51932, :CP50221]]
  @paths["[BIG5-HKSCS, CP51932]"] = [[:"BIG5-HKSCS", :"UTF-8", :CP51932]]
  @paths["[BIG5-HKSCS, CP850]"] = [[:"BIG5-HKSCS", :"UTF-8", :CP850]]
  @paths["[BIG5-HKSCS, CP852]"] = [[:"BIG5-HKSCS", :"UTF-8", :CP852]]
  @paths["[BIG5-HKSCS, CP855]"] = [[:"BIG5-HKSCS", :"UTF-8", :CP855]]
  @paths["[BIG5-HKSCS, CP949]"] = [[:"BIG5-HKSCS", :"UTF-8", :CP949]]
  @paths["[BIG5-HKSCS, CP950]"] = [[:"BIG5-HKSCS", :"UTF-8", :CP950]]
  @paths["[BIG5-HKSCS, CP951]"] = [[:"BIG5-HKSCS", :"UTF-8", :CP951]]
  @paths["[BIG5-HKSCS, EUC-JP]"] = [[:"BIG5-HKSCS", :"UTF-8", :"EUC-JP"]]
  @paths["[BIG5-HKSCS, EUC-KR]"] = [[:"BIG5-HKSCS", :"UTF-8", :"EUC-KR"]]
  @paths["[BIG5-HKSCS, EUCJP-MS]"] = [[:"BIG5-HKSCS", :"UTF-8", :"EUCJP-MS"]]
  @paths["[BIG5-HKSCS, GB12345]"] = [[:"BIG5-HKSCS", :"UTF-8", :GB12345]]
  @paths["[BIG5-HKSCS, GB18030]"] = [[:"BIG5-HKSCS", :"UTF-8", :GB18030]]
  @paths["[BIG5-HKSCS, GB2312]"] = [[:"BIG5-HKSCS", :"UTF-8", :GB2312]]
  @paths["[BIG5-HKSCS, GBK]"] = [[:"BIG5-HKSCS", :"UTF-8", :GBK]]
  @paths["[BIG5-HKSCS, IBM437]"] = [[:"BIG5-HKSCS", :"UTF-8", :IBM437]]
  @paths["[BIG5-HKSCS, IBM737]"] = [[:"BIG5-HKSCS", :"UTF-8", :IBM737]]
  @paths["[BIG5-HKSCS, IBM775]"] = [[:"BIG5-HKSCS", :"UTF-8", :IBM775]]
  @paths["[BIG5-HKSCS, IBM852]"] = [[:"BIG5-HKSCS", :"UTF-8", :IBM852]]
  @paths["[BIG5-HKSCS, IBM855]"] = [[:"BIG5-HKSCS", :"UTF-8", :IBM855]]
  @paths["[BIG5-HKSCS, IBM857]"] = [[:"BIG5-HKSCS", :"UTF-8", :IBM857]]
  @paths["[BIG5-HKSCS, IBM860]"] = [[:"BIG5-HKSCS", :"UTF-8", :IBM860]]
  @paths["[BIG5-HKSCS, IBM861]"] = [[:"BIG5-HKSCS", :"UTF-8", :IBM861]]
  @paths["[BIG5-HKSCS, IBM862]"] = [[:"BIG5-HKSCS", :"UTF-8", :IBM862]]
  @paths["[BIG5-HKSCS, IBM863]"] = [[:"BIG5-HKSCS", :"UTF-8", :IBM863]]
  @paths["[BIG5-HKSCS, IBM865]"] = [[:"BIG5-HKSCS", :"UTF-8", :IBM865]]
  @paths["[BIG5-HKSCS, IBM866]"] = [[:"BIG5-HKSCS", :"UTF-8", :IBM866]]
  @paths["[BIG5-HKSCS, IBM869]"] = [[:"BIG5-HKSCS", :"UTF-8", :IBM869]]
  @paths["[BIG5-HKSCS, ISO-2022-JP]"] = [[:"BIG5-HKSCS", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[BIG5-HKSCS, ISO-2022-JP-KDDI]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[BIG5-HKSCS, ISO-8859-1]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-1"]]
  @paths["[BIG5-HKSCS, ISO-8859-10]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-10"]]
  @paths["[BIG5-HKSCS, ISO-8859-11]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-11"]]
  @paths["[BIG5-HKSCS, ISO-8859-13]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-13"]]
  @paths["[BIG5-HKSCS, ISO-8859-14]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-14"]]
  @paths["[BIG5-HKSCS, ISO-8859-15]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-15"]]
  @paths["[BIG5-HKSCS, ISO-8859-2]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-2"]]
  @paths["[BIG5-HKSCS, ISO-8859-3]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-3"]]
  @paths["[BIG5-HKSCS, ISO-8859-4]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-4"]]
  @paths["[BIG5-HKSCS, ISO-8859-5]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-5"]]
  @paths["[BIG5-HKSCS, ISO-8859-6]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-6"]]
  @paths["[BIG5-HKSCS, ISO-8859-7]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-7"]]
  @paths["[BIG5-HKSCS, ISO-8859-8]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-8"]]
  @paths["[BIG5-HKSCS, ISO-8859-9]"] = [[:"BIG5-HKSCS", :"UTF-8", :"ISO-8859-9"]]
  @paths["[BIG5-HKSCS, KOI8-R]"] = [[:"BIG5-HKSCS", :"UTF-8", :"KOI8-R"]]
  @paths["[BIG5-HKSCS, KOI8-U]"] = [[:"BIG5-HKSCS", :"UTF-8", :"KOI8-U"]]
  @paths["[BIG5-HKSCS, MACCROATIAN]"] = [[:"BIG5-HKSCS", :"UTF-8", :MACCROATIAN]]
  @paths["[BIG5-HKSCS, MACCYRILLIC]"] = [[:"BIG5-HKSCS", :"UTF-8", :MACCYRILLIC]]
  @paths["[BIG5-HKSCS, MACGREEK]"] = [[:"BIG5-HKSCS", :"UTF-8", :MACGREEK]]
  @paths["[BIG5-HKSCS, MACICELAND]"] = [[:"BIG5-HKSCS", :"UTF-8", :MACICELAND]]
  @paths["[BIG5-HKSCS, MACROMAN]"] = [[:"BIG5-HKSCS", :"UTF-8", :MACROMAN]]
  @paths["[BIG5-HKSCS, MACROMANIA]"] = [[:"BIG5-HKSCS", :"UTF-8", :MACROMANIA]]
  @paths["[BIG5-HKSCS, MACTURKISH]"] = [[:"BIG5-HKSCS", :"UTF-8", :MACTURKISH]]
  @paths["[BIG5-HKSCS, MACUKRAINE]"] = [[:"BIG5-HKSCS", :"UTF-8", :MACUKRAINE]]
  @paths["[BIG5-HKSCS, SHIFT_JIS]"] = [[:"BIG5-HKSCS", :"UTF-8", :SHIFT_JIS]]
  @paths["[BIG5-HKSCS, SJIS-DOCOMO]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[BIG5-HKSCS, SJIS-KDDI]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[BIG5-HKSCS, SJIS-SOFTBANK]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[BIG5-HKSCS, STATELESS-ISO-2022-JP]"] = [[:"BIG5-HKSCS", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[BIG5-HKSCS, STATELESS-ISO-2022-JP-KDDI]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[BIG5-HKSCS, TIS-620]"] = [[:"BIG5-HKSCS", :"UTF-8", :"TIS-620"]]
  @paths["[BIG5-HKSCS, US-ASCII]"] = [[:"BIG5-HKSCS", :"UTF-8", :"US-ASCII"]]
  @paths["[BIG5-HKSCS, UTF-16]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF-16"]]
  @paths["[BIG5-HKSCS, UTF-16BE]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF-16BE"]]
  @paths["[BIG5-HKSCS, UTF-16LE]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF-16LE"]]
  @paths["[BIG5-HKSCS, UTF-32]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF-32"]]
  @paths["[BIG5-HKSCS, UTF-32BE]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF-32BE"]]
  @paths["[BIG5-HKSCS, UTF-32LE]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF-32LE"]]
  @paths["[BIG5-HKSCS, UTF-8]"] = [[:"BIG5-HKSCS", :"UTF-8"]]
  @paths["[BIG5-HKSCS, UTF8-DOCOMO]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[BIG5-HKSCS, UTF8-KDDI]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[BIG5-HKSCS, UTF8-MAC]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF8-MAC"]]
  @paths["[BIG5-HKSCS, UTF8-SOFTBANK]"] = [[:"BIG5-HKSCS", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[BIG5-HKSCS, WINDOWS-1250]"] = [[:"BIG5-HKSCS", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[BIG5-HKSCS, WINDOWS-1251]"] = [[:"BIG5-HKSCS", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[BIG5-HKSCS, WINDOWS-1252]"] = [[:"BIG5-HKSCS", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[BIG5-HKSCS, WINDOWS-1253]"] = [[:"BIG5-HKSCS", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[BIG5-HKSCS, WINDOWS-1254]"] = [[:"BIG5-HKSCS", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[BIG5-HKSCS, WINDOWS-1255]"] = [[:"BIG5-HKSCS", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[BIG5-HKSCS, WINDOWS-1256]"] = [[:"BIG5-HKSCS", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[BIG5-HKSCS, WINDOWS-1257]"] = [[:"BIG5-HKSCS", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[BIG5-HKSCS, WINDOWS-31J]"] = [[:"BIG5-HKSCS", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[BIG5-HKSCS, WINDOWS-874]"] = [[:"BIG5-HKSCS", :"UTF-8", :"WINDOWS-874"]]
  @paths["[BIG5-UAO, ASCII-8BIT]"] = [[:"BIG5-UAO", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[BIG5-UAO, BIG5]"] = [[:"BIG5-UAO", :"UTF-8", :BIG5]]
  @paths["[BIG5-UAO, BIG5-HKSCS]"] = [[:"BIG5-UAO", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[BIG5-UAO, CP50220]"] = [[:"BIG5-UAO", :"UTF-8", :CP51932, :CP50220]]
  @paths["[BIG5-UAO, CP50221]"] = [[:"BIG5-UAO", :"UTF-8", :CP51932, :CP50221]]
  @paths["[BIG5-UAO, CP51932]"] = [[:"BIG5-UAO", :"UTF-8", :CP51932]]
  @paths["[BIG5-UAO, CP850]"] = [[:"BIG5-UAO", :"UTF-8", :CP850]]
  @paths["[BIG5-UAO, CP852]"] = [[:"BIG5-UAO", :"UTF-8", :CP852]]
  @paths["[BIG5-UAO, CP855]"] = [[:"BIG5-UAO", :"UTF-8", :CP855]]
  @paths["[BIG5-UAO, CP949]"] = [[:"BIG5-UAO", :"UTF-8", :CP949]]
  @paths["[BIG5-UAO, CP950]"] = [[:"BIG5-UAO", :"UTF-8", :CP950]]
  @paths["[BIG5-UAO, CP951]"] = [[:"BIG5-UAO", :"UTF-8", :CP951]]
  @paths["[BIG5-UAO, EUC-JP]"] = [[:"BIG5-UAO", :"UTF-8", :"EUC-JP"]]
  @paths["[BIG5-UAO, EUC-KR]"] = [[:"BIG5-UAO", :"UTF-8", :"EUC-KR"]]
  @paths["[BIG5-UAO, EUCJP-MS]"] = [[:"BIG5-UAO", :"UTF-8", :"EUCJP-MS"]]
  @paths["[BIG5-UAO, GB12345]"] = [[:"BIG5-UAO", :"UTF-8", :GB12345]]
  @paths["[BIG5-UAO, GB18030]"] = [[:"BIG5-UAO", :"UTF-8", :GB18030]]
  @paths["[BIG5-UAO, GB2312]"] = [[:"BIG5-UAO", :"UTF-8", :GB2312]]
  @paths["[BIG5-UAO, GBK]"] = [[:"BIG5-UAO", :"UTF-8", :GBK]]
  @paths["[BIG5-UAO, IBM437]"] = [[:"BIG5-UAO", :"UTF-8", :IBM437]]
  @paths["[BIG5-UAO, IBM737]"] = [[:"BIG5-UAO", :"UTF-8", :IBM737]]
  @paths["[BIG5-UAO, IBM775]"] = [[:"BIG5-UAO", :"UTF-8", :IBM775]]
  @paths["[BIG5-UAO, IBM852]"] = [[:"BIG5-UAO", :"UTF-8", :IBM852]]
  @paths["[BIG5-UAO, IBM855]"] = [[:"BIG5-UAO", :"UTF-8", :IBM855]]
  @paths["[BIG5-UAO, IBM857]"] = [[:"BIG5-UAO", :"UTF-8", :IBM857]]
  @paths["[BIG5-UAO, IBM860]"] = [[:"BIG5-UAO", :"UTF-8", :IBM860]]
  @paths["[BIG5-UAO, IBM861]"] = [[:"BIG5-UAO", :"UTF-8", :IBM861]]
  @paths["[BIG5-UAO, IBM862]"] = [[:"BIG5-UAO", :"UTF-8", :IBM862]]
  @paths["[BIG5-UAO, IBM863]"] = [[:"BIG5-UAO", :"UTF-8", :IBM863]]
  @paths["[BIG5-UAO, IBM865]"] = [[:"BIG5-UAO", :"UTF-8", :IBM865]]
  @paths["[BIG5-UAO, IBM866]"] = [[:"BIG5-UAO", :"UTF-8", :IBM866]]
  @paths["[BIG5-UAO, IBM869]"] = [[:"BIG5-UAO", :"UTF-8", :IBM869]]
  @paths["[BIG5-UAO, ISO-2022-JP]"] = [[:"BIG5-UAO", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[BIG5-UAO, ISO-2022-JP-KDDI]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[BIG5-UAO, ISO-8859-1]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-1"]]
  @paths["[BIG5-UAO, ISO-8859-10]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-10"]]
  @paths["[BIG5-UAO, ISO-8859-11]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-11"]]
  @paths["[BIG5-UAO, ISO-8859-13]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-13"]]
  @paths["[BIG5-UAO, ISO-8859-14]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-14"]]
  @paths["[BIG5-UAO, ISO-8859-15]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-15"]]
  @paths["[BIG5-UAO, ISO-8859-2]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-2"]]
  @paths["[BIG5-UAO, ISO-8859-3]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-3"]]
  @paths["[BIG5-UAO, ISO-8859-4]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-4"]]
  @paths["[BIG5-UAO, ISO-8859-5]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-5"]]
  @paths["[BIG5-UAO, ISO-8859-6]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-6"]]
  @paths["[BIG5-UAO, ISO-8859-7]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-7"]]
  @paths["[BIG5-UAO, ISO-8859-8]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-8"]]
  @paths["[BIG5-UAO, ISO-8859-9]"] = [[:"BIG5-UAO", :"UTF-8", :"ISO-8859-9"]]
  @paths["[BIG5-UAO, KOI8-R]"] = [[:"BIG5-UAO", :"UTF-8", :"KOI8-R"]]
  @paths["[BIG5-UAO, KOI8-U]"] = [[:"BIG5-UAO", :"UTF-8", :"KOI8-U"]]
  @paths["[BIG5-UAO, MACCROATIAN]"] = [[:"BIG5-UAO", :"UTF-8", :MACCROATIAN]]
  @paths["[BIG5-UAO, MACCYRILLIC]"] = [[:"BIG5-UAO", :"UTF-8", :MACCYRILLIC]]
  @paths["[BIG5-UAO, MACGREEK]"] = [[:"BIG5-UAO", :"UTF-8", :MACGREEK]]
  @paths["[BIG5-UAO, MACICELAND]"] = [[:"BIG5-UAO", :"UTF-8", :MACICELAND]]
  @paths["[BIG5-UAO, MACROMAN]"] = [[:"BIG5-UAO", :"UTF-8", :MACROMAN]]
  @paths["[BIG5-UAO, MACROMANIA]"] = [[:"BIG5-UAO", :"UTF-8", :MACROMANIA]]
  @paths["[BIG5-UAO, MACTURKISH]"] = [[:"BIG5-UAO", :"UTF-8", :MACTURKISH]]
  @paths["[BIG5-UAO, MACUKRAINE]"] = [[:"BIG5-UAO", :"UTF-8", :MACUKRAINE]]
  @paths["[BIG5-UAO, SHIFT_JIS]"] = [[:"BIG5-UAO", :"UTF-8", :SHIFT_JIS]]
  @paths["[BIG5-UAO, SJIS-DOCOMO]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[BIG5-UAO, SJIS-KDDI]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[BIG5-UAO, SJIS-SOFTBANK]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[BIG5-UAO, STATELESS-ISO-2022-JP]"] = [[:"BIG5-UAO", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[BIG5-UAO, STATELESS-ISO-2022-JP-KDDI]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[BIG5-UAO, TIS-620]"] = [[:"BIG5-UAO", :"UTF-8", :"TIS-620"]]
  @paths["[BIG5-UAO, US-ASCII]"] = [[:"BIG5-UAO", :"UTF-8", :"US-ASCII"]]
  @paths["[BIG5-UAO, UTF-16]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF-16"]]
  @paths["[BIG5-UAO, UTF-16BE]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF-16BE"]]
  @paths["[BIG5-UAO, UTF-16LE]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF-16LE"]]
  @paths["[BIG5-UAO, UTF-32]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF-32"]]
  @paths["[BIG5-UAO, UTF-32BE]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF-32BE"]]
  @paths["[BIG5-UAO, UTF-32LE]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF-32LE"]]
  @paths["[BIG5-UAO, UTF-8]"] = [[:"BIG5-UAO", :"UTF-8"]]
  @paths["[BIG5-UAO, UTF8-DOCOMO]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[BIG5-UAO, UTF8-KDDI]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[BIG5-UAO, UTF8-MAC]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF8-MAC"]]
  @paths["[BIG5-UAO, UTF8-SOFTBANK]"] = [[:"BIG5-UAO", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[BIG5-UAO, WINDOWS-1250]"] = [[:"BIG5-UAO", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[BIG5-UAO, WINDOWS-1251]"] = [[:"BIG5-UAO", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[BIG5-UAO, WINDOWS-1252]"] = [[:"BIG5-UAO", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[BIG5-UAO, WINDOWS-1253]"] = [[:"BIG5-UAO", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[BIG5-UAO, WINDOWS-1254]"] = [[:"BIG5-UAO", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[BIG5-UAO, WINDOWS-1255]"] = [[:"BIG5-UAO", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[BIG5-UAO, WINDOWS-1256]"] = [[:"BIG5-UAO", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[BIG5-UAO, WINDOWS-1257]"] = [[:"BIG5-UAO", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[BIG5-UAO, WINDOWS-31J]"] = [[:"BIG5-UAO", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[BIG5-UAO, WINDOWS-874]"] = [[:"BIG5-UAO", :"UTF-8", :"WINDOWS-874"]]
  @paths["[CP50220, ASCII-8BIT]"] = [[:CP50220, :CP51932, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[CP50220, BIG5]"] = [[:CP50220, :CP51932, :"UTF-8", :BIG5]]
  @paths["[CP50220, BIG5-HKSCS]"] = [[:CP50220, :CP51932, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[CP50220, BIG5-UAO]"] = [[:CP50220, :CP51932, :"UTF-8", :"BIG5-UAO"]]
  @paths["[CP50220, CP50221]"] = [[:CP50220, :CP51932, :CP50221]]
  @paths["[CP50220, CP51932]"] = [[:CP50220, :CP51932]]
  @paths["[CP50220, CP850]"] = [[:CP50220, :CP51932, :"UTF-8", :CP850]]
  @paths["[CP50220, CP852]"] = [[:CP50220, :CP51932, :"UTF-8", :CP852]]
  @paths["[CP50220, CP855]"] = [[:CP50220, :CP51932, :"UTF-8", :CP855]]
  @paths["[CP50220, CP949]"] = [[:CP50220, :CP51932, :"UTF-8", :CP949]]
  @paths["[CP50220, CP950]"] = [[:CP50220, :CP51932, :"UTF-8", :CP950]]
  @paths["[CP50220, CP951]"] = [[:CP50220, :CP51932, :"UTF-8", :CP951]]
  @paths["[CP50220, EUC-JP]"] = [[:CP50220, :CP51932, :"UTF-8", :"EUC-JP"]]
  @paths["[CP50220, EUC-KR]"] = [[:CP50220, :CP51932, :"UTF-8", :"EUC-KR"]]
  @paths["[CP50220, EUCJP-MS]"] = [[:CP50220, :CP51932, :"UTF-8", :"EUCJP-MS"]]
  @paths["[CP50220, GB12345]"] = [[:CP50220, :CP51932, :"UTF-8", :GB12345]]
  @paths["[CP50220, GB18030]"] = [[:CP50220, :CP51932, :"UTF-8", :GB18030]]
  @paths["[CP50220, GB2312]"] = [[:CP50220, :CP51932, :"UTF-8", :GB2312]]
  @paths["[CP50220, GBK]"] = [[:CP50220, :CP51932, :"UTF-8", :GBK]]
  @paths["[CP50220, IBM437]"] = [[:CP50220, :CP51932, :"UTF-8", :IBM437]]
  @paths["[CP50220, IBM737]"] = [[:CP50220, :CP51932, :"UTF-8", :IBM737]]
  @paths["[CP50220, IBM775]"] = [[:CP50220, :CP51932, :"UTF-8", :IBM775]]
  @paths["[CP50220, IBM852]"] = [[:CP50220, :CP51932, :"UTF-8", :IBM852]]
  @paths["[CP50220, IBM855]"] = [[:CP50220, :CP51932, :"UTF-8", :IBM855]]
  @paths["[CP50220, IBM857]"] = [[:CP50220, :CP51932, :"UTF-8", :IBM857]]
  @paths["[CP50220, IBM860]"] = [[:CP50220, :CP51932, :"UTF-8", :IBM860]]
  @paths["[CP50220, IBM861]"] = [[:CP50220, :CP51932, :"UTF-8", :IBM861]]
  @paths["[CP50220, IBM862]"] = [[:CP50220, :CP51932, :"UTF-8", :IBM862]]
  @paths["[CP50220, IBM863]"] = [[:CP50220, :CP51932, :"UTF-8", :IBM863]]
  @paths["[CP50220, IBM865]"] = [[:CP50220, :CP51932, :"UTF-8", :IBM865]]
  @paths["[CP50220, IBM866]"] = [[:CP50220, :CP51932, :"UTF-8", :IBM866]]
  @paths["[CP50220, IBM869]"] = [[:CP50220, :CP51932, :"UTF-8", :IBM869]]
  @paths["[CP50220, ISO-2022-JP]"] = [[:CP50220, :CP51932, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[CP50220, ISO-2022-JP-KDDI]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[CP50220, ISO-8859-1]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-1"]]
  @paths["[CP50220, ISO-8859-10]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-10"]]
  @paths["[CP50220, ISO-8859-11]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-11"]]
  @paths["[CP50220, ISO-8859-13]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-13"]]
  @paths["[CP50220, ISO-8859-14]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-14"]]
  @paths["[CP50220, ISO-8859-15]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-15"]]
  @paths["[CP50220, ISO-8859-2]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-2"]]
  @paths["[CP50220, ISO-8859-3]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-3"]]
  @paths["[CP50220, ISO-8859-4]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-4"]]
  @paths["[CP50220, ISO-8859-5]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-5"]]
  @paths["[CP50220, ISO-8859-6]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-6"]]
  @paths["[CP50220, ISO-8859-7]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-7"]]
  @paths["[CP50220, ISO-8859-8]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-8"]]
  @paths["[CP50220, ISO-8859-9]"] = [[:CP50220, :CP51932, :"UTF-8", :"ISO-8859-9"]]
  @paths["[CP50220, KOI8-R]"] = [[:CP50220, :CP51932, :"UTF-8", :"KOI8-R"]]
  @paths["[CP50220, KOI8-U]"] = [[:CP50220, :CP51932, :"UTF-8", :"KOI8-U"]]
  @paths["[CP50220, MACCROATIAN]"] = [[:CP50220, :CP51932, :"UTF-8", :MACCROATIAN]]
  @paths["[CP50220, MACCYRILLIC]"] = [[:CP50220, :CP51932, :"UTF-8", :MACCYRILLIC]]
  @paths["[CP50220, MACGREEK]"] = [[:CP50220, :CP51932, :"UTF-8", :MACGREEK]]
  @paths["[CP50220, MACICELAND]"] = [[:CP50220, :CP51932, :"UTF-8", :MACICELAND]]
  @paths["[CP50220, MACROMAN]"] = [[:CP50220, :CP51932, :"UTF-8", :MACROMAN]]
  @paths["[CP50220, MACROMANIA]"] = [[:CP50220, :CP51932, :"UTF-8", :MACROMANIA]]
  @paths["[CP50220, MACTURKISH]"] = [[:CP50220, :CP51932, :"UTF-8", :MACTURKISH]]
  @paths["[CP50220, MACUKRAINE]"] = [[:CP50220, :CP51932, :"UTF-8", :MACUKRAINE]]
  @paths["[CP50220, SHIFT_JIS]"] = [[:CP50220, :CP51932, :"UTF-8", :SHIFT_JIS]]
  @paths["[CP50220, SJIS-DOCOMO]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[CP50220, SJIS-KDDI]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[CP50220, SJIS-SOFTBANK]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[CP50220, STATELESS-ISO-2022-JP]"] = [[:CP50220, :CP51932, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[CP50220, STATELESS-ISO-2022-JP-KDDI]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[CP50220, TIS-620]"] = [[:CP50220, :CP51932, :"UTF-8", :"TIS-620"]]
  @paths["[CP50220, US-ASCII]"] = [[:CP50220, :CP51932, :"UTF-8", :"US-ASCII"]]
  @paths["[CP50220, UTF-16]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF-16"]]
  @paths["[CP50220, UTF-16BE]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF-16BE"]]
  @paths["[CP50220, UTF-16LE]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF-16LE"]]
  @paths["[CP50220, UTF-32]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF-32"]]
  @paths["[CP50220, UTF-32BE]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF-32BE"]]
  @paths["[CP50220, UTF-32LE]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF-32LE"]]
  @paths["[CP50220, UTF-8]"] = [[:CP50220, :CP51932, :"UTF-8"]]
  @paths["[CP50220, UTF8-DOCOMO]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[CP50220, UTF8-KDDI]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[CP50220, UTF8-MAC]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF8-MAC"]]
  @paths["[CP50220, UTF8-SOFTBANK]"] = [[:CP50220, :CP51932, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[CP50220, WINDOWS-1250]"] = [[:CP50220, :CP51932, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[CP50220, WINDOWS-1251]"] = [[:CP50220, :CP51932, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[CP50220, WINDOWS-1252]"] = [[:CP50220, :CP51932, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[CP50220, WINDOWS-1253]"] = [[:CP50220, :CP51932, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[CP50220, WINDOWS-1254]"] = [[:CP50220, :CP51932, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[CP50220, WINDOWS-1255]"] = [[:CP50220, :CP51932, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[CP50220, WINDOWS-1256]"] = [[:CP50220, :CP51932, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[CP50220, WINDOWS-1257]"] = [[:CP50220, :CP51932, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[CP50220, WINDOWS-31J]"] = [[:CP50220, :CP51932, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[CP50220, WINDOWS-874]"] = [[:CP50220, :CP51932, :"UTF-8", :"WINDOWS-874"]]
  @paths["[CP50221, ASCII-8BIT]"] = [[:CP50221, :CP51932, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[CP50221, BIG5]"] = [[:CP50221, :CP51932, :"UTF-8", :BIG5]]
  @paths["[CP50221, BIG5-HKSCS]"] = [[:CP50221, :CP51932, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[CP50221, BIG5-UAO]"] = [[:CP50221, :CP51932, :"UTF-8", :"BIG5-UAO"]]
  @paths["[CP50221, CP50220]"] = [[:CP50221, :CP51932, :CP50220]]
  @paths["[CP50221, CP51932]"] = [[:CP50221, :CP51932]]
  @paths["[CP50221, CP850]"] = [[:CP50221, :CP51932, :"UTF-8", :CP850]]
  @paths["[CP50221, CP852]"] = [[:CP50221, :CP51932, :"UTF-8", :CP852]]
  @paths["[CP50221, CP855]"] = [[:CP50221, :CP51932, :"UTF-8", :CP855]]
  @paths["[CP50221, CP949]"] = [[:CP50221, :CP51932, :"UTF-8", :CP949]]
  @paths["[CP50221, CP950]"] = [[:CP50221, :CP51932, :"UTF-8", :CP950]]
  @paths["[CP50221, CP951]"] = [[:CP50221, :CP51932, :"UTF-8", :CP951]]
  @paths["[CP50221, EUC-JP]"] = [[:CP50221, :CP51932, :"UTF-8", :"EUC-JP"]]
  @paths["[CP50221, EUC-KR]"] = [[:CP50221, :CP51932, :"UTF-8", :"EUC-KR"]]
  @paths["[CP50221, EUCJP-MS]"] = [[:CP50221, :CP51932, :"UTF-8", :"EUCJP-MS"]]
  @paths["[CP50221, GB12345]"] = [[:CP50221, :CP51932, :"UTF-8", :GB12345]]
  @paths["[CP50221, GB18030]"] = [[:CP50221, :CP51932, :"UTF-8", :GB18030]]
  @paths["[CP50221, GB2312]"] = [[:CP50221, :CP51932, :"UTF-8", :GB2312]]
  @paths["[CP50221, GBK]"] = [[:CP50221, :CP51932, :"UTF-8", :GBK]]
  @paths["[CP50221, IBM437]"] = [[:CP50221, :CP51932, :"UTF-8", :IBM437]]
  @paths["[CP50221, IBM737]"] = [[:CP50221, :CP51932, :"UTF-8", :IBM737]]
  @paths["[CP50221, IBM775]"] = [[:CP50221, :CP51932, :"UTF-8", :IBM775]]
  @paths["[CP50221, IBM852]"] = [[:CP50221, :CP51932, :"UTF-8", :IBM852]]
  @paths["[CP50221, IBM855]"] = [[:CP50221, :CP51932, :"UTF-8", :IBM855]]
  @paths["[CP50221, IBM857]"] = [[:CP50221, :CP51932, :"UTF-8", :IBM857]]
  @paths["[CP50221, IBM860]"] = [[:CP50221, :CP51932, :"UTF-8", :IBM860]]
  @paths["[CP50221, IBM861]"] = [[:CP50221, :CP51932, :"UTF-8", :IBM861]]
  @paths["[CP50221, IBM862]"] = [[:CP50221, :CP51932, :"UTF-8", :IBM862]]
  @paths["[CP50221, IBM863]"] = [[:CP50221, :CP51932, :"UTF-8", :IBM863]]
  @paths["[CP50221, IBM865]"] = [[:CP50221, :CP51932, :"UTF-8", :IBM865]]
  @paths["[CP50221, IBM866]"] = [[:CP50221, :CP51932, :"UTF-8", :IBM866]]
  @paths["[CP50221, IBM869]"] = [[:CP50221, :CP51932, :"UTF-8", :IBM869]]
  @paths["[CP50221, ISO-2022-JP]"] = [[:CP50221, :CP51932, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[CP50221, ISO-2022-JP-KDDI]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[CP50221, ISO-8859-1]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-1"]]
  @paths["[CP50221, ISO-8859-10]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-10"]]
  @paths["[CP50221, ISO-8859-11]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-11"]]
  @paths["[CP50221, ISO-8859-13]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-13"]]
  @paths["[CP50221, ISO-8859-14]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-14"]]
  @paths["[CP50221, ISO-8859-15]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-15"]]
  @paths["[CP50221, ISO-8859-2]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-2"]]
  @paths["[CP50221, ISO-8859-3]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-3"]]
  @paths["[CP50221, ISO-8859-4]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-4"]]
  @paths["[CP50221, ISO-8859-5]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-5"]]
  @paths["[CP50221, ISO-8859-6]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-6"]]
  @paths["[CP50221, ISO-8859-7]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-7"]]
  @paths["[CP50221, ISO-8859-8]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-8"]]
  @paths["[CP50221, ISO-8859-9]"] = [[:CP50221, :CP51932, :"UTF-8", :"ISO-8859-9"]]
  @paths["[CP50221, KOI8-R]"] = [[:CP50221, :CP51932, :"UTF-8", :"KOI8-R"]]
  @paths["[CP50221, KOI8-U]"] = [[:CP50221, :CP51932, :"UTF-8", :"KOI8-U"]]
  @paths["[CP50221, MACCROATIAN]"] = [[:CP50221, :CP51932, :"UTF-8", :MACCROATIAN]]
  @paths["[CP50221, MACCYRILLIC]"] = [[:CP50221, :CP51932, :"UTF-8", :MACCYRILLIC]]
  @paths["[CP50221, MACGREEK]"] = [[:CP50221, :CP51932, :"UTF-8", :MACGREEK]]
  @paths["[CP50221, MACICELAND]"] = [[:CP50221, :CP51932, :"UTF-8", :MACICELAND]]
  @paths["[CP50221, MACROMAN]"] = [[:CP50221, :CP51932, :"UTF-8", :MACROMAN]]
  @paths["[CP50221, MACROMANIA]"] = [[:CP50221, :CP51932, :"UTF-8", :MACROMANIA]]
  @paths["[CP50221, MACTURKISH]"] = [[:CP50221, :CP51932, :"UTF-8", :MACTURKISH]]
  @paths["[CP50221, MACUKRAINE]"] = [[:CP50221, :CP51932, :"UTF-8", :MACUKRAINE]]
  @paths["[CP50221, SHIFT_JIS]"] = [[:CP50221, :CP51932, :"UTF-8", :SHIFT_JIS]]
  @paths["[CP50221, SJIS-DOCOMO]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[CP50221, SJIS-KDDI]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[CP50221, SJIS-SOFTBANK]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[CP50221, STATELESS-ISO-2022-JP]"] = [[:CP50221, :CP51932, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[CP50221, STATELESS-ISO-2022-JP-KDDI]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[CP50221, TIS-620]"] = [[:CP50221, :CP51932, :"UTF-8", :"TIS-620"]]
  @paths["[CP50221, US-ASCII]"] = [[:CP50221, :CP51932, :"UTF-8", :"US-ASCII"]]
  @paths["[CP50221, UTF-16]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF-16"]]
  @paths["[CP50221, UTF-16BE]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF-16BE"]]
  @paths["[CP50221, UTF-16LE]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF-16LE"]]
  @paths["[CP50221, UTF-32]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF-32"]]
  @paths["[CP50221, UTF-32BE]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF-32BE"]]
  @paths["[CP50221, UTF-32LE]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF-32LE"]]
  @paths["[CP50221, UTF-8]"] = [[:CP50221, :CP51932, :"UTF-8"]]
  @paths["[CP50221, UTF8-DOCOMO]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[CP50221, UTF8-KDDI]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[CP50221, UTF8-MAC]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF8-MAC"]]
  @paths["[CP50221, UTF8-SOFTBANK]"] = [[:CP50221, :CP51932, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[CP50221, WINDOWS-1250]"] = [[:CP50221, :CP51932, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[CP50221, WINDOWS-1251]"] = [[:CP50221, :CP51932, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[CP50221, WINDOWS-1252]"] = [[:CP50221, :CP51932, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[CP50221, WINDOWS-1253]"] = [[:CP50221, :CP51932, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[CP50221, WINDOWS-1254]"] = [[:CP50221, :CP51932, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[CP50221, WINDOWS-1255]"] = [[:CP50221, :CP51932, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[CP50221, WINDOWS-1256]"] = [[:CP50221, :CP51932, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[CP50221, WINDOWS-1257]"] = [[:CP50221, :CP51932, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[CP50221, WINDOWS-31J]"] = [[:CP50221, :CP51932, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[CP50221, WINDOWS-874]"] = [[:CP50221, :CP51932, :"UTF-8", :"WINDOWS-874"]]
  @paths["[CP51932, ASCII-8BIT]"] = [[:CP51932, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[CP51932, BIG5]"] = [[:CP51932, :"UTF-8", :BIG5]]
  @paths["[CP51932, BIG5-HKSCS]"] = [[:CP51932, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[CP51932, BIG5-UAO]"] = [[:CP51932, :"UTF-8", :"BIG5-UAO"]]
  @paths["[CP51932, CP50220]"] = [[:CP51932, :CP50220]]
  @paths["[CP51932, CP50221]"] = [[:CP51932, :CP50221]]
  @paths["[CP51932, CP850]"] = [[:CP51932, :"UTF-8", :CP850]]
  @paths["[CP51932, CP852]"] = [[:CP51932, :"UTF-8", :CP852]]
  @paths["[CP51932, CP855]"] = [[:CP51932, :"UTF-8", :CP855]]
  @paths["[CP51932, CP949]"] = [[:CP51932, :"UTF-8", :CP949]]
  @paths["[CP51932, CP950]"] = [[:CP51932, :"UTF-8", :CP950]]
  @paths["[CP51932, CP951]"] = [[:CP51932, :"UTF-8", :CP951]]
  @paths["[CP51932, EUC-JP]"] = [[:CP51932, :"UTF-8", :"EUC-JP"]]
  @paths["[CP51932, EUC-KR]"] = [[:CP51932, :"UTF-8", :"EUC-KR"]]
  @paths["[CP51932, EUCJP-MS]"] = [[:CP51932, :"UTF-8", :"EUCJP-MS"]]
  @paths["[CP51932, GB12345]"] = [[:CP51932, :"UTF-8", :GB12345]]
  @paths["[CP51932, GB18030]"] = [[:CP51932, :"UTF-8", :GB18030]]
  @paths["[CP51932, GB2312]"] = [[:CP51932, :"UTF-8", :GB2312]]
  @paths["[CP51932, GBK]"] = [[:CP51932, :"UTF-8", :GBK]]
  @paths["[CP51932, IBM437]"] = [[:CP51932, :"UTF-8", :IBM437]]
  @paths["[CP51932, IBM737]"] = [[:CP51932, :"UTF-8", :IBM737]]
  @paths["[CP51932, IBM775]"] = [[:CP51932, :"UTF-8", :IBM775]]
  @paths["[CP51932, IBM852]"] = [[:CP51932, :"UTF-8", :IBM852]]
  @paths["[CP51932, IBM855]"] = [[:CP51932, :"UTF-8", :IBM855]]
  @paths["[CP51932, IBM857]"] = [[:CP51932, :"UTF-8", :IBM857]]
  @paths["[CP51932, IBM860]"] = [[:CP51932, :"UTF-8", :IBM860]]
  @paths["[CP51932, IBM861]"] = [[:CP51932, :"UTF-8", :IBM861]]
  @paths["[CP51932, IBM862]"] = [[:CP51932, :"UTF-8", :IBM862]]
  @paths["[CP51932, IBM863]"] = [[:CP51932, :"UTF-8", :IBM863]]
  @paths["[CP51932, IBM865]"] = [[:CP51932, :"UTF-8", :IBM865]]
  @paths["[CP51932, IBM866]"] = [[:CP51932, :"UTF-8", :IBM866]]
  @paths["[CP51932, IBM869]"] = [[:CP51932, :"UTF-8", :IBM869]]
  @paths["[CP51932, ISO-2022-JP]"] = [[:CP51932, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[CP51932, ISO-2022-JP-KDDI]"] = [[:CP51932, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[CP51932, ISO-8859-1]"] = [[:CP51932, :"UTF-8", :"ISO-8859-1"]]
  @paths["[CP51932, ISO-8859-10]"] = [[:CP51932, :"UTF-8", :"ISO-8859-10"]]
  @paths["[CP51932, ISO-8859-11]"] = [[:CP51932, :"UTF-8", :"ISO-8859-11"]]
  @paths["[CP51932, ISO-8859-13]"] = [[:CP51932, :"UTF-8", :"ISO-8859-13"]]
  @paths["[CP51932, ISO-8859-14]"] = [[:CP51932, :"UTF-8", :"ISO-8859-14"]]
  @paths["[CP51932, ISO-8859-15]"] = [[:CP51932, :"UTF-8", :"ISO-8859-15"]]
  @paths["[CP51932, ISO-8859-2]"] = [[:CP51932, :"UTF-8", :"ISO-8859-2"]]
  @paths["[CP51932, ISO-8859-3]"] = [[:CP51932, :"UTF-8", :"ISO-8859-3"]]
  @paths["[CP51932, ISO-8859-4]"] = [[:CP51932, :"UTF-8", :"ISO-8859-4"]]
  @paths["[CP51932, ISO-8859-5]"] = [[:CP51932, :"UTF-8", :"ISO-8859-5"]]
  @paths["[CP51932, ISO-8859-6]"] = [[:CP51932, :"UTF-8", :"ISO-8859-6"]]
  @paths["[CP51932, ISO-8859-7]"] = [[:CP51932, :"UTF-8", :"ISO-8859-7"]]
  @paths["[CP51932, ISO-8859-8]"] = [[:CP51932, :"UTF-8", :"ISO-8859-8"]]
  @paths["[CP51932, ISO-8859-9]"] = [[:CP51932, :"UTF-8", :"ISO-8859-9"]]
  @paths["[CP51932, KOI8-R]"] = [[:CP51932, :"UTF-8", :"KOI8-R"]]
  @paths["[CP51932, KOI8-U]"] = [[:CP51932, :"UTF-8", :"KOI8-U"]]
  @paths["[CP51932, MACCROATIAN]"] = [[:CP51932, :"UTF-8", :MACCROATIAN]]
  @paths["[CP51932, MACCYRILLIC]"] = [[:CP51932, :"UTF-8", :MACCYRILLIC]]
  @paths["[CP51932, MACGREEK]"] = [[:CP51932, :"UTF-8", :MACGREEK]]
  @paths["[CP51932, MACICELAND]"] = [[:CP51932, :"UTF-8", :MACICELAND]]
  @paths["[CP51932, MACROMAN]"] = [[:CP51932, :"UTF-8", :MACROMAN]]
  @paths["[CP51932, MACROMANIA]"] = [[:CP51932, :"UTF-8", :MACROMANIA]]
  @paths["[CP51932, MACTURKISH]"] = [[:CP51932, :"UTF-8", :MACTURKISH]]
  @paths["[CP51932, MACUKRAINE]"] = [[:CP51932, :"UTF-8", :MACUKRAINE]]
  @paths["[CP51932, SHIFT_JIS]"] = [[:CP51932, :"UTF-8", :SHIFT_JIS]]
  @paths["[CP51932, SJIS-DOCOMO]"] = [[:CP51932, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[CP51932, SJIS-KDDI]"] = [[:CP51932, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[CP51932, SJIS-SOFTBANK]"] = [[:CP51932, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[CP51932, STATELESS-ISO-2022-JP]"] = [[:CP51932, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[CP51932, STATELESS-ISO-2022-JP-KDDI]"] = [[:CP51932, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[CP51932, TIS-620]"] = [[:CP51932, :"UTF-8", :"TIS-620"]]
  @paths["[CP51932, US-ASCII]"] = [[:CP51932, :"UTF-8", :"US-ASCII"]]
  @paths["[CP51932, UTF-16]"] = [[:CP51932, :"UTF-8", :"UTF-16"]]
  @paths["[CP51932, UTF-16BE]"] = [[:CP51932, :"UTF-8", :"UTF-16BE"]]
  @paths["[CP51932, UTF-16LE]"] = [[:CP51932, :"UTF-8", :"UTF-16LE"]]
  @paths["[CP51932, UTF-32]"] = [[:CP51932, :"UTF-8", :"UTF-32"]]
  @paths["[CP51932, UTF-32BE]"] = [[:CP51932, :"UTF-8", :"UTF-32BE"]]
  @paths["[CP51932, UTF-32LE]"] = [[:CP51932, :"UTF-8", :"UTF-32LE"]]
  @paths["[CP51932, UTF-8]"] = [[:CP51932, :"UTF-8"]]
  @paths["[CP51932, UTF8-DOCOMO]"] = [[:CP51932, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[CP51932, UTF8-KDDI]"] = [[:CP51932, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[CP51932, UTF8-MAC]"] = [[:CP51932, :"UTF-8", :"UTF8-MAC"]]
  @paths["[CP51932, UTF8-SOFTBANK]"] = [[:CP51932, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[CP51932, WINDOWS-1250]"] = [[:CP51932, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[CP51932, WINDOWS-1251]"] = [[:CP51932, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[CP51932, WINDOWS-1252]"] = [[:CP51932, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[CP51932, WINDOWS-1253]"] = [[:CP51932, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[CP51932, WINDOWS-1254]"] = [[:CP51932, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[CP51932, WINDOWS-1255]"] = [[:CP51932, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[CP51932, WINDOWS-1256]"] = [[:CP51932, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[CP51932, WINDOWS-1257]"] = [[:CP51932, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[CP51932, WINDOWS-31J]"] = [[:CP51932, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[CP51932, WINDOWS-874]"] = [[:CP51932, :"UTF-8", :"WINDOWS-874"]]
  @paths["[CP850, ASCII-8BIT]"] = [[:CP850, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[CP850, BIG5]"] = [[:CP850, :"UTF-8", :BIG5]]
  @paths["[CP850, BIG5-HKSCS]"] = [[:CP850, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[CP850, BIG5-UAO]"] = [[:CP850, :"UTF-8", :"BIG5-UAO"]]
  @paths["[CP850, CP50220]"] = [[:CP850, :"UTF-8", :CP51932, :CP50220]]
  @paths["[CP850, CP50221]"] = [[:CP850, :"UTF-8", :CP51932, :CP50221]]
  @paths["[CP850, CP51932]"] = [[:CP850, :"UTF-8", :CP51932]]
  @paths["[CP850, CP852]"] = [[:CP850, :"UTF-8", :CP852]]
  @paths["[CP850, CP855]"] = [[:CP850, :"UTF-8", :CP855]]
  @paths["[CP850, CP949]"] = [[:CP850, :"UTF-8", :CP949]]
  @paths["[CP850, CP950]"] = [[:CP850, :"UTF-8", :CP950]]
  @paths["[CP850, CP951]"] = [[:CP850, :"UTF-8", :CP951]]
  @paths["[CP850, EUC-JP]"] = [[:CP850, :"UTF-8", :"EUC-JP"]]
  @paths["[CP850, EUC-KR]"] = [[:CP850, :"UTF-8", :"EUC-KR"]]
  @paths["[CP850, EUCJP-MS]"] = [[:CP850, :"UTF-8", :"EUCJP-MS"]]
  @paths["[CP850, GB12345]"] = [[:CP850, :"UTF-8", :GB12345]]
  @paths["[CP850, GB18030]"] = [[:CP850, :"UTF-8", :GB18030]]
  @paths["[CP850, GB2312]"] = [[:CP850, :"UTF-8", :GB2312]]
  @paths["[CP850, GBK]"] = [[:CP850, :"UTF-8", :GBK]]
  @paths["[CP850, IBM437]"] = [[:CP850, :"UTF-8", :IBM437]]
  @paths["[CP850, IBM737]"] = [[:CP850, :"UTF-8", :IBM737]]
  @paths["[CP850, IBM775]"] = [[:CP850, :"UTF-8", :IBM775]]
  @paths["[CP850, IBM852]"] = [[:CP850, :"UTF-8", :IBM852]]
  @paths["[CP850, IBM855]"] = [[:CP850, :"UTF-8", :IBM855]]
  @paths["[CP850, IBM857]"] = [[:CP850, :"UTF-8", :IBM857]]
  @paths["[CP850, IBM860]"] = [[:CP850, :"UTF-8", :IBM860]]
  @paths["[CP850, IBM861]"] = [[:CP850, :"UTF-8", :IBM861]]
  @paths["[CP850, IBM862]"] = [[:CP850, :"UTF-8", :IBM862]]
  @paths["[CP850, IBM863]"] = [[:CP850, :"UTF-8", :IBM863]]
  @paths["[CP850, IBM865]"] = [[:CP850, :"UTF-8", :IBM865]]
  @paths["[CP850, IBM866]"] = [[:CP850, :"UTF-8", :IBM866]]
  @paths["[CP850, IBM869]"] = [[:CP850, :"UTF-8", :IBM869]]
  @paths["[CP850, ISO-2022-JP]"] = [[:CP850, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[CP850, ISO-2022-JP-KDDI]"] = [[:CP850, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[CP850, ISO-8859-1]"] = [[:CP850, :"UTF-8", :"ISO-8859-1"]]
  @paths["[CP850, ISO-8859-10]"] = [[:CP850, :"UTF-8", :"ISO-8859-10"]]
  @paths["[CP850, ISO-8859-11]"] = [[:CP850, :"UTF-8", :"ISO-8859-11"]]
  @paths["[CP850, ISO-8859-13]"] = [[:CP850, :"UTF-8", :"ISO-8859-13"]]
  @paths["[CP850, ISO-8859-14]"] = [[:CP850, :"UTF-8", :"ISO-8859-14"]]
  @paths["[CP850, ISO-8859-15]"] = [[:CP850, :"UTF-8", :"ISO-8859-15"]]
  @paths["[CP850, ISO-8859-2]"] = [[:CP850, :"UTF-8", :"ISO-8859-2"]]
  @paths["[CP850, ISO-8859-3]"] = [[:CP850, :"UTF-8", :"ISO-8859-3"]]
  @paths["[CP850, ISO-8859-4]"] = [[:CP850, :"UTF-8", :"ISO-8859-4"]]
  @paths["[CP850, ISO-8859-5]"] = [[:CP850, :"UTF-8", :"ISO-8859-5"]]
  @paths["[CP850, ISO-8859-6]"] = [[:CP850, :"UTF-8", :"ISO-8859-6"]]
  @paths["[CP850, ISO-8859-7]"] = [[:CP850, :"UTF-8", :"ISO-8859-7"]]
  @paths["[CP850, ISO-8859-8]"] = [[:CP850, :"UTF-8", :"ISO-8859-8"]]
  @paths["[CP850, ISO-8859-9]"] = [[:CP850, :"UTF-8", :"ISO-8859-9"]]
  @paths["[CP850, KOI8-R]"] = [[:CP850, :"UTF-8", :"KOI8-R"]]
  @paths["[CP850, KOI8-U]"] = [[:CP850, :"UTF-8", :"KOI8-U"]]
  @paths["[CP850, MACCROATIAN]"] = [[:CP850, :"UTF-8", :MACCROATIAN]]
  @paths["[CP850, MACCYRILLIC]"] = [[:CP850, :"UTF-8", :MACCYRILLIC]]
  @paths["[CP850, MACGREEK]"] = [[:CP850, :"UTF-8", :MACGREEK]]
  @paths["[CP850, MACICELAND]"] = [[:CP850, :"UTF-8", :MACICELAND]]
  @paths["[CP850, MACROMAN]"] = [[:CP850, :"UTF-8", :MACROMAN]]
  @paths["[CP850, MACROMANIA]"] = [[:CP850, :"UTF-8", :MACROMANIA]]
  @paths["[CP850, MACTURKISH]"] = [[:CP850, :"UTF-8", :MACTURKISH]]
  @paths["[CP850, MACUKRAINE]"] = [[:CP850, :"UTF-8", :MACUKRAINE]]
  @paths["[CP850, SHIFT_JIS]"] = [[:CP850, :"UTF-8", :SHIFT_JIS]]
  @paths["[CP850, SJIS-DOCOMO]"] = [[:CP850, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[CP850, SJIS-KDDI]"] = [[:CP850, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[CP850, SJIS-SOFTBANK]"] = [[:CP850, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[CP850, STATELESS-ISO-2022-JP]"] = [[:CP850, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[CP850, STATELESS-ISO-2022-JP-KDDI]"] = [[:CP850, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[CP850, TIS-620]"] = [[:CP850, :"UTF-8", :"TIS-620"]]
  @paths["[CP850, US-ASCII]"] = [[:CP850, :"UTF-8", :"US-ASCII"]]
  @paths["[CP850, UTF-16]"] = [[:CP850, :"UTF-8", :"UTF-16"]]
  @paths["[CP850, UTF-16BE]"] = [[:CP850, :"UTF-8", :"UTF-16BE"]]
  @paths["[CP850, UTF-16LE]"] = [[:CP850, :"UTF-8", :"UTF-16LE"]]
  @paths["[CP850, UTF-32]"] = [[:CP850, :"UTF-8", :"UTF-32"]]
  @paths["[CP850, UTF-32BE]"] = [[:CP850, :"UTF-8", :"UTF-32BE"]]
  @paths["[CP850, UTF-32LE]"] = [[:CP850, :"UTF-8", :"UTF-32LE"]]
  @paths["[CP850, UTF-8]"] = [[:CP850, :"UTF-8"]]
  @paths["[CP850, UTF8-DOCOMO]"] = [[:CP850, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[CP850, UTF8-KDDI]"] = [[:CP850, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[CP850, UTF8-MAC]"] = [[:CP850, :"UTF-8", :"UTF8-MAC"]]
  @paths["[CP850, UTF8-SOFTBANK]"] = [[:CP850, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[CP850, WINDOWS-1250]"] = [[:CP850, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[CP850, WINDOWS-1251]"] = [[:CP850, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[CP850, WINDOWS-1252]"] = [[:CP850, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[CP850, WINDOWS-1253]"] = [[:CP850, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[CP850, WINDOWS-1254]"] = [[:CP850, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[CP850, WINDOWS-1255]"] = [[:CP850, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[CP850, WINDOWS-1256]"] = [[:CP850, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[CP850, WINDOWS-1257]"] = [[:CP850, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[CP850, WINDOWS-31J]"] = [[:CP850, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[CP850, WINDOWS-874]"] = [[:CP850, :"UTF-8", :"WINDOWS-874"]]
  @paths["[CP852, ASCII-8BIT]"] = [[:CP852, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[CP852, BIG5]"] = [[:CP852, :"UTF-8", :BIG5]]
  @paths["[CP852, BIG5-HKSCS]"] = [[:CP852, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[CP852, BIG5-UAO]"] = [[:CP852, :"UTF-8", :"BIG5-UAO"]]
  @paths["[CP852, CP50220]"] = [[:CP852, :"UTF-8", :CP51932, :CP50220]]
  @paths["[CP852, CP50221]"] = [[:CP852, :"UTF-8", :CP51932, :CP50221]]
  @paths["[CP852, CP51932]"] = [[:CP852, :"UTF-8", :CP51932]]
  @paths["[CP852, CP850]"] = [[:CP852, :"UTF-8", :CP850]]
  @paths["[CP852, CP855]"] = [[:CP852, :"UTF-8", :CP855]]
  @paths["[CP852, CP949]"] = [[:CP852, :"UTF-8", :CP949]]
  @paths["[CP852, CP950]"] = [[:CP852, :"UTF-8", :CP950]]
  @paths["[CP852, CP951]"] = [[:CP852, :"UTF-8", :CP951]]
  @paths["[CP852, EUC-JP]"] = [[:CP852, :"UTF-8", :"EUC-JP"]]
  @paths["[CP852, EUC-KR]"] = [[:CP852, :"UTF-8", :"EUC-KR"]]
  @paths["[CP852, EUCJP-MS]"] = [[:CP852, :"UTF-8", :"EUCJP-MS"]]
  @paths["[CP852, GB12345]"] = [[:CP852, :"UTF-8", :GB12345]]
  @paths["[CP852, GB18030]"] = [[:CP852, :"UTF-8", :GB18030]]
  @paths["[CP852, GB2312]"] = [[:CP852, :"UTF-8", :GB2312]]
  @paths["[CP852, GBK]"] = [[:CP852, :"UTF-8", :GBK]]
  @paths["[CP852, IBM437]"] = [[:CP852, :"UTF-8", :IBM437]]
  @paths["[CP852, IBM737]"] = [[:CP852, :"UTF-8", :IBM737]]
  @paths["[CP852, IBM775]"] = [[:CP852, :"UTF-8", :IBM775]]
  @paths["[CP852, IBM852]"] = [[:CP852, :"UTF-8", :IBM852]]
  @paths["[CP852, IBM855]"] = [[:CP852, :"UTF-8", :IBM855]]
  @paths["[CP852, IBM857]"] = [[:CP852, :"UTF-8", :IBM857]]
  @paths["[CP852, IBM860]"] = [[:CP852, :"UTF-8", :IBM860]]
  @paths["[CP852, IBM861]"] = [[:CP852, :"UTF-8", :IBM861]]
  @paths["[CP852, IBM862]"] = [[:CP852, :"UTF-8", :IBM862]]
  @paths["[CP852, IBM863]"] = [[:CP852, :"UTF-8", :IBM863]]
  @paths["[CP852, IBM865]"] = [[:CP852, :"UTF-8", :IBM865]]
  @paths["[CP852, IBM866]"] = [[:CP852, :"UTF-8", :IBM866]]
  @paths["[CP852, IBM869]"] = [[:CP852, :"UTF-8", :IBM869]]
  @paths["[CP852, ISO-2022-JP]"] = [[:CP852, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[CP852, ISO-2022-JP-KDDI]"] = [[:CP852, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[CP852, ISO-8859-1]"] = [[:CP852, :"UTF-8", :"ISO-8859-1"]]
  @paths["[CP852, ISO-8859-10]"] = [[:CP852, :"UTF-8", :"ISO-8859-10"]]
  @paths["[CP852, ISO-8859-11]"] = [[:CP852, :"UTF-8", :"ISO-8859-11"]]
  @paths["[CP852, ISO-8859-13]"] = [[:CP852, :"UTF-8", :"ISO-8859-13"]]
  @paths["[CP852, ISO-8859-14]"] = [[:CP852, :"UTF-8", :"ISO-8859-14"]]
  @paths["[CP852, ISO-8859-15]"] = [[:CP852, :"UTF-8", :"ISO-8859-15"]]
  @paths["[CP852, ISO-8859-2]"] = [[:CP852, :"UTF-8", :"ISO-8859-2"]]
  @paths["[CP852, ISO-8859-3]"] = [[:CP852, :"UTF-8", :"ISO-8859-3"]]
  @paths["[CP852, ISO-8859-4]"] = [[:CP852, :"UTF-8", :"ISO-8859-4"]]
  @paths["[CP852, ISO-8859-5]"] = [[:CP852, :"UTF-8", :"ISO-8859-5"]]
  @paths["[CP852, ISO-8859-6]"] = [[:CP852, :"UTF-8", :"ISO-8859-6"]]
  @paths["[CP852, ISO-8859-7]"] = [[:CP852, :"UTF-8", :"ISO-8859-7"]]
  @paths["[CP852, ISO-8859-8]"] = [[:CP852, :"UTF-8", :"ISO-8859-8"]]
  @paths["[CP852, ISO-8859-9]"] = [[:CP852, :"UTF-8", :"ISO-8859-9"]]
  @paths["[CP852, KOI8-R]"] = [[:CP852, :"UTF-8", :"KOI8-R"]]
  @paths["[CP852, KOI8-U]"] = [[:CP852, :"UTF-8", :"KOI8-U"]]
  @paths["[CP852, MACCROATIAN]"] = [[:CP852, :"UTF-8", :MACCROATIAN]]
  @paths["[CP852, MACCYRILLIC]"] = [[:CP852, :"UTF-8", :MACCYRILLIC]]
  @paths["[CP852, MACGREEK]"] = [[:CP852, :"UTF-8", :MACGREEK]]
  @paths["[CP852, MACICELAND]"] = [[:CP852, :"UTF-8", :MACICELAND]]
  @paths["[CP852, MACROMAN]"] = [[:CP852, :"UTF-8", :MACROMAN]]
  @paths["[CP852, MACROMANIA]"] = [[:CP852, :"UTF-8", :MACROMANIA]]
  @paths["[CP852, MACTURKISH]"] = [[:CP852, :"UTF-8", :MACTURKISH]]
  @paths["[CP852, MACUKRAINE]"] = [[:CP852, :"UTF-8", :MACUKRAINE]]
  @paths["[CP852, SHIFT_JIS]"] = [[:CP852, :"UTF-8", :SHIFT_JIS]]
  @paths["[CP852, SJIS-DOCOMO]"] = [[:CP852, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[CP852, SJIS-KDDI]"] = [[:CP852, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[CP852, SJIS-SOFTBANK]"] = [[:CP852, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[CP852, STATELESS-ISO-2022-JP]"] = [[:CP852, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[CP852, STATELESS-ISO-2022-JP-KDDI]"] = [[:CP852, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[CP852, TIS-620]"] = [[:CP852, :"UTF-8", :"TIS-620"]]
  @paths["[CP852, US-ASCII]"] = [[:CP852, :"UTF-8", :"US-ASCII"]]
  @paths["[CP852, UTF-16]"] = [[:CP852, :"UTF-8", :"UTF-16"]]
  @paths["[CP852, UTF-16BE]"] = [[:CP852, :"UTF-8", :"UTF-16BE"]]
  @paths["[CP852, UTF-16LE]"] = [[:CP852, :"UTF-8", :"UTF-16LE"]]
  @paths["[CP852, UTF-32]"] = [[:CP852, :"UTF-8", :"UTF-32"]]
  @paths["[CP852, UTF-32BE]"] = [[:CP852, :"UTF-8", :"UTF-32BE"]]
  @paths["[CP852, UTF-32LE]"] = [[:CP852, :"UTF-8", :"UTF-32LE"]]
  @paths["[CP852, UTF-8]"] = [[:CP852, :"UTF-8"]]
  @paths["[CP852, UTF8-DOCOMO]"] = [[:CP852, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[CP852, UTF8-KDDI]"] = [[:CP852, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[CP852, UTF8-MAC]"] = [[:CP852, :"UTF-8", :"UTF8-MAC"]]
  @paths["[CP852, UTF8-SOFTBANK]"] = [[:CP852, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[CP852, WINDOWS-1250]"] = [[:CP852, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[CP852, WINDOWS-1251]"] = [[:CP852, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[CP852, WINDOWS-1252]"] = [[:CP852, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[CP852, WINDOWS-1253]"] = [[:CP852, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[CP852, WINDOWS-1254]"] = [[:CP852, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[CP852, WINDOWS-1255]"] = [[:CP852, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[CP852, WINDOWS-1256]"] = [[:CP852, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[CP852, WINDOWS-1257]"] = [[:CP852, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[CP852, WINDOWS-31J]"] = [[:CP852, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[CP852, WINDOWS-874]"] = [[:CP852, :"UTF-8", :"WINDOWS-874"]]
  @paths["[CP855, ASCII-8BIT]"] = [[:CP855, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[CP855, BIG5]"] = [[:CP855, :"UTF-8", :BIG5]]
  @paths["[CP855, BIG5-HKSCS]"] = [[:CP855, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[CP855, BIG5-UAO]"] = [[:CP855, :"UTF-8", :"BIG5-UAO"]]
  @paths["[CP855, CP50220]"] = [[:CP855, :"UTF-8", :CP51932, :CP50220]]
  @paths["[CP855, CP50221]"] = [[:CP855, :"UTF-8", :CP51932, :CP50221]]
  @paths["[CP855, CP51932]"] = [[:CP855, :"UTF-8", :CP51932]]
  @paths["[CP855, CP850]"] = [[:CP855, :"UTF-8", :CP850]]
  @paths["[CP855, CP852]"] = [[:CP855, :"UTF-8", :CP852]]
  @paths["[CP855, CP949]"] = [[:CP855, :"UTF-8", :CP949]]
  @paths["[CP855, CP950]"] = [[:CP855, :"UTF-8", :CP950]]
  @paths["[CP855, CP951]"] = [[:CP855, :"UTF-8", :CP951]]
  @paths["[CP855, EUC-JP]"] = [[:CP855, :"UTF-8", :"EUC-JP"]]
  @paths["[CP855, EUC-KR]"] = [[:CP855, :"UTF-8", :"EUC-KR"]]
  @paths["[CP855, EUCJP-MS]"] = [[:CP855, :"UTF-8", :"EUCJP-MS"]]
  @paths["[CP855, GB12345]"] = [[:CP855, :"UTF-8", :GB12345]]
  @paths["[CP855, GB18030]"] = [[:CP855, :"UTF-8", :GB18030]]
  @paths["[CP855, GB2312]"] = [[:CP855, :"UTF-8", :GB2312]]
  @paths["[CP855, GBK]"] = [[:CP855, :"UTF-8", :GBK]]
  @paths["[CP855, IBM437]"] = [[:CP855, :"UTF-8", :IBM437]]
  @paths["[CP855, IBM737]"] = [[:CP855, :"UTF-8", :IBM737]]
  @paths["[CP855, IBM775]"] = [[:CP855, :"UTF-8", :IBM775]]
  @paths["[CP855, IBM852]"] = [[:CP855, :"UTF-8", :IBM852]]
  @paths["[CP855, IBM855]"] = [[:CP855, :"UTF-8", :IBM855]]
  @paths["[CP855, IBM857]"] = [[:CP855, :"UTF-8", :IBM857]]
  @paths["[CP855, IBM860]"] = [[:CP855, :"UTF-8", :IBM860]]
  @paths["[CP855, IBM861]"] = [[:CP855, :"UTF-8", :IBM861]]
  @paths["[CP855, IBM862]"] = [[:CP855, :"UTF-8", :IBM862]]
  @paths["[CP855, IBM863]"] = [[:CP855, :"UTF-8", :IBM863]]
  @paths["[CP855, IBM865]"] = [[:CP855, :"UTF-8", :IBM865]]
  @paths["[CP855, IBM866]"] = [[:CP855, :"UTF-8", :IBM866]]
  @paths["[CP855, IBM869]"] = [[:CP855, :"UTF-8", :IBM869]]
  @paths["[CP855, ISO-2022-JP]"] = [[:CP855, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[CP855, ISO-2022-JP-KDDI]"] = [[:CP855, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[CP855, ISO-8859-1]"] = [[:CP855, :"UTF-8", :"ISO-8859-1"]]
  @paths["[CP855, ISO-8859-10]"] = [[:CP855, :"UTF-8", :"ISO-8859-10"]]
  @paths["[CP855, ISO-8859-11]"] = [[:CP855, :"UTF-8", :"ISO-8859-11"]]
  @paths["[CP855, ISO-8859-13]"] = [[:CP855, :"UTF-8", :"ISO-8859-13"]]
  @paths["[CP855, ISO-8859-14]"] = [[:CP855, :"UTF-8", :"ISO-8859-14"]]
  @paths["[CP855, ISO-8859-15]"] = [[:CP855, :"UTF-8", :"ISO-8859-15"]]
  @paths["[CP855, ISO-8859-2]"] = [[:CP855, :"UTF-8", :"ISO-8859-2"]]
  @paths["[CP855, ISO-8859-3]"] = [[:CP855, :"UTF-8", :"ISO-8859-3"]]
  @paths["[CP855, ISO-8859-4]"] = [[:CP855, :"UTF-8", :"ISO-8859-4"]]
  @paths["[CP855, ISO-8859-5]"] = [[:CP855, :"UTF-8", :"ISO-8859-5"]]
  @paths["[CP855, ISO-8859-6]"] = [[:CP855, :"UTF-8", :"ISO-8859-6"]]
  @paths["[CP855, ISO-8859-7]"] = [[:CP855, :"UTF-8", :"ISO-8859-7"]]
  @paths["[CP855, ISO-8859-8]"] = [[:CP855, :"UTF-8", :"ISO-8859-8"]]
  @paths["[CP855, ISO-8859-9]"] = [[:CP855, :"UTF-8", :"ISO-8859-9"]]
  @paths["[CP855, KOI8-R]"] = [[:CP855, :"UTF-8", :"KOI8-R"]]
  @paths["[CP855, KOI8-U]"] = [[:CP855, :"UTF-8", :"KOI8-U"]]
  @paths["[CP855, MACCROATIAN]"] = [[:CP855, :"UTF-8", :MACCROATIAN]]
  @paths["[CP855, MACCYRILLIC]"] = [[:CP855, :"UTF-8", :MACCYRILLIC]]
  @paths["[CP855, MACGREEK]"] = [[:CP855, :"UTF-8", :MACGREEK]]
  @paths["[CP855, MACICELAND]"] = [[:CP855, :"UTF-8", :MACICELAND]]
  @paths["[CP855, MACROMAN]"] = [[:CP855, :"UTF-8", :MACROMAN]]
  @paths["[CP855, MACROMANIA]"] = [[:CP855, :"UTF-8", :MACROMANIA]]
  @paths["[CP855, MACTURKISH]"] = [[:CP855, :"UTF-8", :MACTURKISH]]
  @paths["[CP855, MACUKRAINE]"] = [[:CP855, :"UTF-8", :MACUKRAINE]]
  @paths["[CP855, SHIFT_JIS]"] = [[:CP855, :"UTF-8", :SHIFT_JIS]]
  @paths["[CP855, SJIS-DOCOMO]"] = [[:CP855, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[CP855, SJIS-KDDI]"] = [[:CP855, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[CP855, SJIS-SOFTBANK]"] = [[:CP855, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[CP855, STATELESS-ISO-2022-JP]"] = [[:CP855, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[CP855, STATELESS-ISO-2022-JP-KDDI]"] = [[:CP855, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[CP855, TIS-620]"] = [[:CP855, :"UTF-8", :"TIS-620"]]
  @paths["[CP855, US-ASCII]"] = [[:CP855, :"UTF-8", :"US-ASCII"]]
  @paths["[CP855, UTF-16]"] = [[:CP855, :"UTF-8", :"UTF-16"]]
  @paths["[CP855, UTF-16BE]"] = [[:CP855, :"UTF-8", :"UTF-16BE"]]
  @paths["[CP855, UTF-16LE]"] = [[:CP855, :"UTF-8", :"UTF-16LE"]]
  @paths["[CP855, UTF-32]"] = [[:CP855, :"UTF-8", :"UTF-32"]]
  @paths["[CP855, UTF-32BE]"] = [[:CP855, :"UTF-8", :"UTF-32BE"]]
  @paths["[CP855, UTF-32LE]"] = [[:CP855, :"UTF-8", :"UTF-32LE"]]
  @paths["[CP855, UTF-8]"] = [[:CP855, :"UTF-8"]]
  @paths["[CP855, UTF8-DOCOMO]"] = [[:CP855, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[CP855, UTF8-KDDI]"] = [[:CP855, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[CP855, UTF8-MAC]"] = [[:CP855, :"UTF-8", :"UTF8-MAC"]]
  @paths["[CP855, UTF8-SOFTBANK]"] = [[:CP855, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[CP855, WINDOWS-1250]"] = [[:CP855, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[CP855, WINDOWS-1251]"] = [[:CP855, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[CP855, WINDOWS-1252]"] = [[:CP855, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[CP855, WINDOWS-1253]"] = [[:CP855, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[CP855, WINDOWS-1254]"] = [[:CP855, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[CP855, WINDOWS-1255]"] = [[:CP855, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[CP855, WINDOWS-1256]"] = [[:CP855, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[CP855, WINDOWS-1257]"] = [[:CP855, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[CP855, WINDOWS-31J]"] = [[:CP855, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[CP855, WINDOWS-874]"] = [[:CP855, :"UTF-8", :"WINDOWS-874"]]
  @paths["[CP949, ASCII-8BIT]"] = [[:CP949, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[CP949, BIG5]"] = [[:CP949, :"UTF-8", :BIG5]]
  @paths["[CP949, BIG5-HKSCS]"] = [[:CP949, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[CP949, BIG5-UAO]"] = [[:CP949, :"UTF-8", :"BIG5-UAO"]]
  @paths["[CP949, CP50220]"] = [[:CP949, :"UTF-8", :CP51932, :CP50220]]
  @paths["[CP949, CP50221]"] = [[:CP949, :"UTF-8", :CP51932, :CP50221]]
  @paths["[CP949, CP51932]"] = [[:CP949, :"UTF-8", :CP51932]]
  @paths["[CP949, CP850]"] = [[:CP949, :"UTF-8", :CP850]]
  @paths["[CP949, CP852]"] = [[:CP949, :"UTF-8", :CP852]]
  @paths["[CP949, CP855]"] = [[:CP949, :"UTF-8", :CP855]]
  @paths["[CP949, CP950]"] = [[:CP949, :"UTF-8", :CP950]]
  @paths["[CP949, CP951]"] = [[:CP949, :"UTF-8", :CP951]]
  @paths["[CP949, EUC-JP]"] = [[:CP949, :"UTF-8", :"EUC-JP"]]
  @paths["[CP949, EUC-KR]"] = [[:CP949, :"UTF-8", :"EUC-KR"]]
  @paths["[CP949, EUCJP-MS]"] = [[:CP949, :"UTF-8", :"EUCJP-MS"]]
  @paths["[CP949, GB12345]"] = [[:CP949, :"UTF-8", :GB12345]]
  @paths["[CP949, GB18030]"] = [[:CP949, :"UTF-8", :GB18030]]
  @paths["[CP949, GB2312]"] = [[:CP949, :"UTF-8", :GB2312]]
  @paths["[CP949, GBK]"] = [[:CP949, :"UTF-8", :GBK]]
  @paths["[CP949, IBM437]"] = [[:CP949, :"UTF-8", :IBM437]]
  @paths["[CP949, IBM737]"] = [[:CP949, :"UTF-8", :IBM737]]
  @paths["[CP949, IBM775]"] = [[:CP949, :"UTF-8", :IBM775]]
  @paths["[CP949, IBM852]"] = [[:CP949, :"UTF-8", :IBM852]]
  @paths["[CP949, IBM855]"] = [[:CP949, :"UTF-8", :IBM855]]
  @paths["[CP949, IBM857]"] = [[:CP949, :"UTF-8", :IBM857]]
  @paths["[CP949, IBM860]"] = [[:CP949, :"UTF-8", :IBM860]]
  @paths["[CP949, IBM861]"] = [[:CP949, :"UTF-8", :IBM861]]
  @paths["[CP949, IBM862]"] = [[:CP949, :"UTF-8", :IBM862]]
  @paths["[CP949, IBM863]"] = [[:CP949, :"UTF-8", :IBM863]]
  @paths["[CP949, IBM865]"] = [[:CP949, :"UTF-8", :IBM865]]
  @paths["[CP949, IBM866]"] = [[:CP949, :"UTF-8", :IBM866]]
  @paths["[CP949, IBM869]"] = [[:CP949, :"UTF-8", :IBM869]]
  @paths["[CP949, ISO-2022-JP]"] = [[:CP949, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[CP949, ISO-2022-JP-KDDI]"] = [[:CP949, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[CP949, ISO-8859-1]"] = [[:CP949, :"UTF-8", :"ISO-8859-1"]]
  @paths["[CP949, ISO-8859-10]"] = [[:CP949, :"UTF-8", :"ISO-8859-10"]]
  @paths["[CP949, ISO-8859-11]"] = [[:CP949, :"UTF-8", :"ISO-8859-11"]]
  @paths["[CP949, ISO-8859-13]"] = [[:CP949, :"UTF-8", :"ISO-8859-13"]]
  @paths["[CP949, ISO-8859-14]"] = [[:CP949, :"UTF-8", :"ISO-8859-14"]]
  @paths["[CP949, ISO-8859-15]"] = [[:CP949, :"UTF-8", :"ISO-8859-15"]]
  @paths["[CP949, ISO-8859-2]"] = [[:CP949, :"UTF-8", :"ISO-8859-2"]]
  @paths["[CP949, ISO-8859-3]"] = [[:CP949, :"UTF-8", :"ISO-8859-3"]]
  @paths["[CP949, ISO-8859-4]"] = [[:CP949, :"UTF-8", :"ISO-8859-4"]]
  @paths["[CP949, ISO-8859-5]"] = [[:CP949, :"UTF-8", :"ISO-8859-5"]]
  @paths["[CP949, ISO-8859-6]"] = [[:CP949, :"UTF-8", :"ISO-8859-6"]]
  @paths["[CP949, ISO-8859-7]"] = [[:CP949, :"UTF-8", :"ISO-8859-7"]]
  @paths["[CP949, ISO-8859-8]"] = [[:CP949, :"UTF-8", :"ISO-8859-8"]]
  @paths["[CP949, ISO-8859-9]"] = [[:CP949, :"UTF-8", :"ISO-8859-9"]]
  @paths["[CP949, KOI8-R]"] = [[:CP949, :"UTF-8", :"KOI8-R"]]
  @paths["[CP949, KOI8-U]"] = [[:CP949, :"UTF-8", :"KOI8-U"]]
  @paths["[CP949, MACCROATIAN]"] = [[:CP949, :"UTF-8", :MACCROATIAN]]
  @paths["[CP949, MACCYRILLIC]"] = [[:CP949, :"UTF-8", :MACCYRILLIC]]
  @paths["[CP949, MACGREEK]"] = [[:CP949, :"UTF-8", :MACGREEK]]
  @paths["[CP949, MACICELAND]"] = [[:CP949, :"UTF-8", :MACICELAND]]
  @paths["[CP949, MACROMAN]"] = [[:CP949, :"UTF-8", :MACROMAN]]
  @paths["[CP949, MACROMANIA]"] = [[:CP949, :"UTF-8", :MACROMANIA]]
  @paths["[CP949, MACTURKISH]"] = [[:CP949, :"UTF-8", :MACTURKISH]]
  @paths["[CP949, MACUKRAINE]"] = [[:CP949, :"UTF-8", :MACUKRAINE]]
  @paths["[CP949, SHIFT_JIS]"] = [[:CP949, :"UTF-8", :SHIFT_JIS]]
  @paths["[CP949, SJIS-DOCOMO]"] = [[:CP949, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[CP949, SJIS-KDDI]"] = [[:CP949, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[CP949, SJIS-SOFTBANK]"] = [[:CP949, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[CP949, STATELESS-ISO-2022-JP]"] = [[:CP949, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[CP949, STATELESS-ISO-2022-JP-KDDI]"] = [[:CP949, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[CP949, TIS-620]"] = [[:CP949, :"UTF-8", :"TIS-620"]]
  @paths["[CP949, US-ASCII]"] = [[:CP949, :"UTF-8", :"US-ASCII"]]
  @paths["[CP949, UTF-16]"] = [[:CP949, :"UTF-8", :"UTF-16"]]
  @paths["[CP949, UTF-16BE]"] = [[:CP949, :"UTF-8", :"UTF-16BE"]]
  @paths["[CP949, UTF-16LE]"] = [[:CP949, :"UTF-8", :"UTF-16LE"]]
  @paths["[CP949, UTF-32]"] = [[:CP949, :"UTF-8", :"UTF-32"]]
  @paths["[CP949, UTF-32BE]"] = [[:CP949, :"UTF-8", :"UTF-32BE"]]
  @paths["[CP949, UTF-32LE]"] = [[:CP949, :"UTF-8", :"UTF-32LE"]]
  @paths["[CP949, UTF-8]"] = [[:CP949, :"UTF-8"]]
  @paths["[CP949, UTF8-DOCOMO]"] = [[:CP949, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[CP949, UTF8-KDDI]"] = [[:CP949, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[CP949, UTF8-MAC]"] = [[:CP949, :"UTF-8", :"UTF8-MAC"]]
  @paths["[CP949, UTF8-SOFTBANK]"] = [[:CP949, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[CP949, WINDOWS-1250]"] = [[:CP949, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[CP949, WINDOWS-1251]"] = [[:CP949, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[CP949, WINDOWS-1252]"] = [[:CP949, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[CP949, WINDOWS-1253]"] = [[:CP949, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[CP949, WINDOWS-1254]"] = [[:CP949, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[CP949, WINDOWS-1255]"] = [[:CP949, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[CP949, WINDOWS-1256]"] = [[:CP949, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[CP949, WINDOWS-1257]"] = [[:CP949, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[CP949, WINDOWS-31J]"] = [[:CP949, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[CP949, WINDOWS-874]"] = [[:CP949, :"UTF-8", :"WINDOWS-874"]]
  @paths["[CP950, ASCII-8BIT]"] = [[:CP950, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[CP950, BIG5]"] = [[:CP950, :"UTF-8", :BIG5]]
  @paths["[CP950, BIG5-HKSCS]"] = [[:CP950, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[CP950, BIG5-UAO]"] = [[:CP950, :"UTF-8", :"BIG5-UAO"]]
  @paths["[CP950, CP50220]"] = [[:CP950, :"UTF-8", :CP51932, :CP50220]]
  @paths["[CP950, CP50221]"] = [[:CP950, :"UTF-8", :CP51932, :CP50221]]
  @paths["[CP950, CP51932]"] = [[:CP950, :"UTF-8", :CP51932]]
  @paths["[CP950, CP850]"] = [[:CP950, :"UTF-8", :CP850]]
  @paths["[CP950, CP852]"] = [[:CP950, :"UTF-8", :CP852]]
  @paths["[CP950, CP855]"] = [[:CP950, :"UTF-8", :CP855]]
  @paths["[CP950, CP949]"] = [[:CP950, :"UTF-8", :CP949]]
  @paths["[CP950, CP951]"] = [[:CP950, :"UTF-8", :CP951]]
  @paths["[CP950, EUC-JP]"] = [[:CP950, :"UTF-8", :"EUC-JP"]]
  @paths["[CP950, EUC-KR]"] = [[:CP950, :"UTF-8", :"EUC-KR"]]
  @paths["[CP950, EUCJP-MS]"] = [[:CP950, :"UTF-8", :"EUCJP-MS"]]
  @paths["[CP950, GB12345]"] = [[:CP950, :"UTF-8", :GB12345]]
  @paths["[CP950, GB18030]"] = [[:CP950, :"UTF-8", :GB18030]]
  @paths["[CP950, GB2312]"] = [[:CP950, :"UTF-8", :GB2312]]
  @paths["[CP950, GBK]"] = [[:CP950, :"UTF-8", :GBK]]
  @paths["[CP950, IBM437]"] = [[:CP950, :"UTF-8", :IBM437]]
  @paths["[CP950, IBM737]"] = [[:CP950, :"UTF-8", :IBM737]]
  @paths["[CP950, IBM775]"] = [[:CP950, :"UTF-8", :IBM775]]
  @paths["[CP950, IBM852]"] = [[:CP950, :"UTF-8", :IBM852]]
  @paths["[CP950, IBM855]"] = [[:CP950, :"UTF-8", :IBM855]]
  @paths["[CP950, IBM857]"] = [[:CP950, :"UTF-8", :IBM857]]
  @paths["[CP950, IBM860]"] = [[:CP950, :"UTF-8", :IBM860]]
  @paths["[CP950, IBM861]"] = [[:CP950, :"UTF-8", :IBM861]]
  @paths["[CP950, IBM862]"] = [[:CP950, :"UTF-8", :IBM862]]
  @paths["[CP950, IBM863]"] = [[:CP950, :"UTF-8", :IBM863]]
  @paths["[CP950, IBM865]"] = [[:CP950, :"UTF-8", :IBM865]]
  @paths["[CP950, IBM866]"] = [[:CP950, :"UTF-8", :IBM866]]
  @paths["[CP950, IBM869]"] = [[:CP950, :"UTF-8", :IBM869]]
  @paths["[CP950, ISO-2022-JP]"] = [[:CP950, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[CP950, ISO-2022-JP-KDDI]"] = [[:CP950, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[CP950, ISO-8859-1]"] = [[:CP950, :"UTF-8", :"ISO-8859-1"]]
  @paths["[CP950, ISO-8859-10]"] = [[:CP950, :"UTF-8", :"ISO-8859-10"]]
  @paths["[CP950, ISO-8859-11]"] = [[:CP950, :"UTF-8", :"ISO-8859-11"]]
  @paths["[CP950, ISO-8859-13]"] = [[:CP950, :"UTF-8", :"ISO-8859-13"]]
  @paths["[CP950, ISO-8859-14]"] = [[:CP950, :"UTF-8", :"ISO-8859-14"]]
  @paths["[CP950, ISO-8859-15]"] = [[:CP950, :"UTF-8", :"ISO-8859-15"]]
  @paths["[CP950, ISO-8859-2]"] = [[:CP950, :"UTF-8", :"ISO-8859-2"]]
  @paths["[CP950, ISO-8859-3]"] = [[:CP950, :"UTF-8", :"ISO-8859-3"]]
  @paths["[CP950, ISO-8859-4]"] = [[:CP950, :"UTF-8", :"ISO-8859-4"]]
  @paths["[CP950, ISO-8859-5]"] = [[:CP950, :"UTF-8", :"ISO-8859-5"]]
  @paths["[CP950, ISO-8859-6]"] = [[:CP950, :"UTF-8", :"ISO-8859-6"]]
  @paths["[CP950, ISO-8859-7]"] = [[:CP950, :"UTF-8", :"ISO-8859-7"]]
  @paths["[CP950, ISO-8859-8]"] = [[:CP950, :"UTF-8", :"ISO-8859-8"]]
  @paths["[CP950, ISO-8859-9]"] = [[:CP950, :"UTF-8", :"ISO-8859-9"]]
  @paths["[CP950, KOI8-R]"] = [[:CP950, :"UTF-8", :"KOI8-R"]]
  @paths["[CP950, KOI8-U]"] = [[:CP950, :"UTF-8", :"KOI8-U"]]
  @paths["[CP950, MACCROATIAN]"] = [[:CP950, :"UTF-8", :MACCROATIAN]]
  @paths["[CP950, MACCYRILLIC]"] = [[:CP950, :"UTF-8", :MACCYRILLIC]]
  @paths["[CP950, MACGREEK]"] = [[:CP950, :"UTF-8", :MACGREEK]]
  @paths["[CP950, MACICELAND]"] = [[:CP950, :"UTF-8", :MACICELAND]]
  @paths["[CP950, MACROMAN]"] = [[:CP950, :"UTF-8", :MACROMAN]]
  @paths["[CP950, MACROMANIA]"] = [[:CP950, :"UTF-8", :MACROMANIA]]
  @paths["[CP950, MACTURKISH]"] = [[:CP950, :"UTF-8", :MACTURKISH]]
  @paths["[CP950, MACUKRAINE]"] = [[:CP950, :"UTF-8", :MACUKRAINE]]
  @paths["[CP950, SHIFT_JIS]"] = [[:CP950, :"UTF-8", :SHIFT_JIS]]
  @paths["[CP950, SJIS-DOCOMO]"] = [[:CP950, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[CP950, SJIS-KDDI]"] = [[:CP950, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[CP950, SJIS-SOFTBANK]"] = [[:CP950, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[CP950, STATELESS-ISO-2022-JP]"] = [[:CP950, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[CP950, STATELESS-ISO-2022-JP-KDDI]"] = [[:CP950, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[CP950, TIS-620]"] = [[:CP950, :"UTF-8", :"TIS-620"]]
  @paths["[CP950, US-ASCII]"] = [[:CP950, :"UTF-8", :"US-ASCII"]]
  @paths["[CP950, UTF-16]"] = [[:CP950, :"UTF-8", :"UTF-16"]]
  @paths["[CP950, UTF-16BE]"] = [[:CP950, :"UTF-8", :"UTF-16BE"]]
  @paths["[CP950, UTF-16LE]"] = [[:CP950, :"UTF-8", :"UTF-16LE"]]
  @paths["[CP950, UTF-32]"] = [[:CP950, :"UTF-8", :"UTF-32"]]
  @paths["[CP950, UTF-32BE]"] = [[:CP950, :"UTF-8", :"UTF-32BE"]]
  @paths["[CP950, UTF-32LE]"] = [[:CP950, :"UTF-8", :"UTF-32LE"]]
  @paths["[CP950, UTF-8]"] = [[:CP950, :"UTF-8"]]
  @paths["[CP950, UTF8-DOCOMO]"] = [[:CP950, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[CP950, UTF8-KDDI]"] = [[:CP950, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[CP950, UTF8-MAC]"] = [[:CP950, :"UTF-8", :"UTF8-MAC"]]
  @paths["[CP950, UTF8-SOFTBANK]"] = [[:CP950, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[CP950, WINDOWS-1250]"] = [[:CP950, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[CP950, WINDOWS-1251]"] = [[:CP950, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[CP950, WINDOWS-1252]"] = [[:CP950, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[CP950, WINDOWS-1253]"] = [[:CP950, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[CP950, WINDOWS-1254]"] = [[:CP950, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[CP950, WINDOWS-1255]"] = [[:CP950, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[CP950, WINDOWS-1256]"] = [[:CP950, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[CP950, WINDOWS-1257]"] = [[:CP950, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[CP950, WINDOWS-31J]"] = [[:CP950, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[CP950, WINDOWS-874]"] = [[:CP950, :"UTF-8", :"WINDOWS-874"]]
  @paths["[CP951, ASCII-8BIT]"] = [[:CP951, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[CP951, BIG5]"] = [[:CP951, :"UTF-8", :BIG5]]
  @paths["[CP951, BIG5-HKSCS]"] = [[:CP951, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[CP951, BIG5-UAO]"] = [[:CP951, :"UTF-8", :"BIG5-UAO"]]
  @paths["[CP951, CP50220]"] = [[:CP951, :"UTF-8", :CP51932, :CP50220]]
  @paths["[CP951, CP50221]"] = [[:CP951, :"UTF-8", :CP51932, :CP50221]]
  @paths["[CP951, CP51932]"] = [[:CP951, :"UTF-8", :CP51932]]
  @paths["[CP951, CP850]"] = [[:CP951, :"UTF-8", :CP850]]
  @paths["[CP951, CP852]"] = [[:CP951, :"UTF-8", :CP852]]
  @paths["[CP951, CP855]"] = [[:CP951, :"UTF-8", :CP855]]
  @paths["[CP951, CP949]"] = [[:CP951, :"UTF-8", :CP949]]
  @paths["[CP951, CP950]"] = [[:CP951, :"UTF-8", :CP950]]
  @paths["[CP951, EUC-JP]"] = [[:CP951, :"UTF-8", :"EUC-JP"]]
  @paths["[CP951, EUC-KR]"] = [[:CP951, :"UTF-8", :"EUC-KR"]]
  @paths["[CP951, EUCJP-MS]"] = [[:CP951, :"UTF-8", :"EUCJP-MS"]]
  @paths["[CP951, GB12345]"] = [[:CP951, :"UTF-8", :GB12345]]
  @paths["[CP951, GB18030]"] = [[:CP951, :"UTF-8", :GB18030]]
  @paths["[CP951, GB2312]"] = [[:CP951, :"UTF-8", :GB2312]]
  @paths["[CP951, GBK]"] = [[:CP951, :"UTF-8", :GBK]]
  @paths["[CP951, IBM437]"] = [[:CP951, :"UTF-8", :IBM437]]
  @paths["[CP951, IBM737]"] = [[:CP951, :"UTF-8", :IBM737]]
  @paths["[CP951, IBM775]"] = [[:CP951, :"UTF-8", :IBM775]]
  @paths["[CP951, IBM852]"] = [[:CP951, :"UTF-8", :IBM852]]
  @paths["[CP951, IBM855]"] = [[:CP951, :"UTF-8", :IBM855]]
  @paths["[CP951, IBM857]"] = [[:CP951, :"UTF-8", :IBM857]]
  @paths["[CP951, IBM860]"] = [[:CP951, :"UTF-8", :IBM860]]
  @paths["[CP951, IBM861]"] = [[:CP951, :"UTF-8", :IBM861]]
  @paths["[CP951, IBM862]"] = [[:CP951, :"UTF-8", :IBM862]]
  @paths["[CP951, IBM863]"] = [[:CP951, :"UTF-8", :IBM863]]
  @paths["[CP951, IBM865]"] = [[:CP951, :"UTF-8", :IBM865]]
  @paths["[CP951, IBM866]"] = [[:CP951, :"UTF-8", :IBM866]]
  @paths["[CP951, IBM869]"] = [[:CP951, :"UTF-8", :IBM869]]
  @paths["[CP951, ISO-2022-JP]"] = [[:CP951, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[CP951, ISO-2022-JP-KDDI]"] = [[:CP951, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[CP951, ISO-8859-1]"] = [[:CP951, :"UTF-8", :"ISO-8859-1"]]
  @paths["[CP951, ISO-8859-10]"] = [[:CP951, :"UTF-8", :"ISO-8859-10"]]
  @paths["[CP951, ISO-8859-11]"] = [[:CP951, :"UTF-8", :"ISO-8859-11"]]
  @paths["[CP951, ISO-8859-13]"] = [[:CP951, :"UTF-8", :"ISO-8859-13"]]
  @paths["[CP951, ISO-8859-14]"] = [[:CP951, :"UTF-8", :"ISO-8859-14"]]
  @paths["[CP951, ISO-8859-15]"] = [[:CP951, :"UTF-8", :"ISO-8859-15"]]
  @paths["[CP951, ISO-8859-2]"] = [[:CP951, :"UTF-8", :"ISO-8859-2"]]
  @paths["[CP951, ISO-8859-3]"] = [[:CP951, :"UTF-8", :"ISO-8859-3"]]
  @paths["[CP951, ISO-8859-4]"] = [[:CP951, :"UTF-8", :"ISO-8859-4"]]
  @paths["[CP951, ISO-8859-5]"] = [[:CP951, :"UTF-8", :"ISO-8859-5"]]
  @paths["[CP951, ISO-8859-6]"] = [[:CP951, :"UTF-8", :"ISO-8859-6"]]
  @paths["[CP951, ISO-8859-7]"] = [[:CP951, :"UTF-8", :"ISO-8859-7"]]
  @paths["[CP951, ISO-8859-8]"] = [[:CP951, :"UTF-8", :"ISO-8859-8"]]
  @paths["[CP951, ISO-8859-9]"] = [[:CP951, :"UTF-8", :"ISO-8859-9"]]
  @paths["[CP951, KOI8-R]"] = [[:CP951, :"UTF-8", :"KOI8-R"]]
  @paths["[CP951, KOI8-U]"] = [[:CP951, :"UTF-8", :"KOI8-U"]]
  @paths["[CP951, MACCROATIAN]"] = [[:CP951, :"UTF-8", :MACCROATIAN]]
  @paths["[CP951, MACCYRILLIC]"] = [[:CP951, :"UTF-8", :MACCYRILLIC]]
  @paths["[CP951, MACGREEK]"] = [[:CP951, :"UTF-8", :MACGREEK]]
  @paths["[CP951, MACICELAND]"] = [[:CP951, :"UTF-8", :MACICELAND]]
  @paths["[CP951, MACROMAN]"] = [[:CP951, :"UTF-8", :MACROMAN]]
  @paths["[CP951, MACROMANIA]"] = [[:CP951, :"UTF-8", :MACROMANIA]]
  @paths["[CP951, MACTURKISH]"] = [[:CP951, :"UTF-8", :MACTURKISH]]
  @paths["[CP951, MACUKRAINE]"] = [[:CP951, :"UTF-8", :MACUKRAINE]]
  @paths["[CP951, SHIFT_JIS]"] = [[:CP951, :"UTF-8", :SHIFT_JIS]]
  @paths["[CP951, SJIS-DOCOMO]"] = [[:CP951, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[CP951, SJIS-KDDI]"] = [[:CP951, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[CP951, SJIS-SOFTBANK]"] = [[:CP951, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[CP951, STATELESS-ISO-2022-JP]"] = [[:CP951, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[CP951, STATELESS-ISO-2022-JP-KDDI]"] = [[:CP951, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[CP951, TIS-620]"] = [[:CP951, :"UTF-8", :"TIS-620"]]
  @paths["[CP951, US-ASCII]"] = [[:CP951, :"UTF-8", :"US-ASCII"]]
  @paths["[CP951, UTF-16]"] = [[:CP951, :"UTF-8", :"UTF-16"]]
  @paths["[CP951, UTF-16BE]"] = [[:CP951, :"UTF-8", :"UTF-16BE"]]
  @paths["[CP951, UTF-16LE]"] = [[:CP951, :"UTF-8", :"UTF-16LE"]]
  @paths["[CP951, UTF-32]"] = [[:CP951, :"UTF-8", :"UTF-32"]]
  @paths["[CP951, UTF-32BE]"] = [[:CP951, :"UTF-8", :"UTF-32BE"]]
  @paths["[CP951, UTF-32LE]"] = [[:CP951, :"UTF-8", :"UTF-32LE"]]
  @paths["[CP951, UTF-8]"] = [[:CP951, :"UTF-8"]]
  @paths["[CP951, UTF8-DOCOMO]"] = [[:CP951, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[CP951, UTF8-KDDI]"] = [[:CP951, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[CP951, UTF8-MAC]"] = [[:CP951, :"UTF-8", :"UTF8-MAC"]]
  @paths["[CP951, UTF8-SOFTBANK]"] = [[:CP951, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[CP951, WINDOWS-1250]"] = [[:CP951, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[CP951, WINDOWS-1251]"] = [[:CP951, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[CP951, WINDOWS-1252]"] = [[:CP951, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[CP951, WINDOWS-1253]"] = [[:CP951, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[CP951, WINDOWS-1254]"] = [[:CP951, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[CP951, WINDOWS-1255]"] = [[:CP951, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[CP951, WINDOWS-1256]"] = [[:CP951, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[CP951, WINDOWS-1257]"] = [[:CP951, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[CP951, WINDOWS-31J]"] = [[:CP951, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[CP951, WINDOWS-874]"] = [[:CP951, :"UTF-8", :"WINDOWS-874"]]
  @paths["[EUC-JP, ASCII-8BIT]"] = [[:"EUC-JP", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[EUC-JP, BIG5]"] = [[:"EUC-JP", :"UTF-8", :BIG5]]
  @paths["[EUC-JP, BIG5-HKSCS]"] = [[:"EUC-JP", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[EUC-JP, BIG5-UAO]"] = [[:"EUC-JP", :"UTF-8", :"BIG5-UAO"]]
  @paths["[EUC-JP, CP50220]"] = [[:"EUC-JP", :"UTF-8", :CP51932, :CP50220]]
  @paths["[EUC-JP, CP50221]"] = [[:"EUC-JP", :"UTF-8", :CP51932, :CP50221]]
  @paths["[EUC-JP, CP51932]"] = [[:"EUC-JP", :"UTF-8", :CP51932]]
  @paths["[EUC-JP, CP850]"] = [[:"EUC-JP", :"UTF-8", :CP850]]
  @paths["[EUC-JP, CP852]"] = [[:"EUC-JP", :"UTF-8", :CP852]]
  @paths["[EUC-JP, CP855]"] = [[:"EUC-JP", :"UTF-8", :CP855]]
  @paths["[EUC-JP, CP949]"] = [[:"EUC-JP", :"UTF-8", :CP949]]
  @paths["[EUC-JP, CP950]"] = [[:"EUC-JP", :"UTF-8", :CP950]]
  @paths["[EUC-JP, CP951]"] = [[:"EUC-JP", :"UTF-8", :CP951]]
  @paths["[EUC-JP, EUC-KR]"] = [[:"EUC-JP", :"UTF-8", :"EUC-KR"]]
  @paths["[EUC-JP, EUCJP-MS]"] = [[:"EUC-JP", :"UTF-8", :"EUCJP-MS"]]
  @paths["[EUC-JP, GB12345]"] = [[:"EUC-JP", :"UTF-8", :GB12345]]
  @paths["[EUC-JP, GB18030]"] = [[:"EUC-JP", :"UTF-8", :GB18030]]
  @paths["[EUC-JP, GB2312]"] = [[:"EUC-JP", :"UTF-8", :GB2312]]
  @paths["[EUC-JP, GBK]"] = [[:"EUC-JP", :"UTF-8", :GBK]]
  @paths["[EUC-JP, IBM437]"] = [[:"EUC-JP", :"UTF-8", :IBM437]]
  @paths["[EUC-JP, IBM737]"] = [[:"EUC-JP", :"UTF-8", :IBM737]]
  @paths["[EUC-JP, IBM775]"] = [[:"EUC-JP", :"UTF-8", :IBM775]]
  @paths["[EUC-JP, IBM852]"] = [[:"EUC-JP", :"UTF-8", :IBM852]]
  @paths["[EUC-JP, IBM855]"] = [[:"EUC-JP", :"UTF-8", :IBM855]]
  @paths["[EUC-JP, IBM857]"] = [[:"EUC-JP", :"UTF-8", :IBM857]]
  @paths["[EUC-JP, IBM860]"] = [[:"EUC-JP", :"UTF-8", :IBM860]]
  @paths["[EUC-JP, IBM861]"] = [[:"EUC-JP", :"UTF-8", :IBM861]]
  @paths["[EUC-JP, IBM862]"] = [[:"EUC-JP", :"UTF-8", :IBM862]]
  @paths["[EUC-JP, IBM863]"] = [[:"EUC-JP", :"UTF-8", :IBM863]]
  @paths["[EUC-JP, IBM865]"] = [[:"EUC-JP", :"UTF-8", :IBM865]]
  @paths["[EUC-JP, IBM866]"] = [[:"EUC-JP", :"UTF-8", :IBM866]]
  @paths["[EUC-JP, IBM869]"] = [[:"EUC-JP", :"UTF-8", :IBM869]]
  @paths["[EUC-JP, ISO-2022-JP]"] = [[:"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[EUC-JP, ISO-2022-JP-KDDI]"] = [[:"EUC-JP", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[EUC-JP, ISO-8859-1]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-1"]]
  @paths["[EUC-JP, ISO-8859-10]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-10"]]
  @paths["[EUC-JP, ISO-8859-11]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-11"]]
  @paths["[EUC-JP, ISO-8859-13]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-13"]]
  @paths["[EUC-JP, ISO-8859-14]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-14"]]
  @paths["[EUC-JP, ISO-8859-15]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-15"]]
  @paths["[EUC-JP, ISO-8859-2]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-2"]]
  @paths["[EUC-JP, ISO-8859-3]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-3"]]
  @paths["[EUC-JP, ISO-8859-4]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-4"]]
  @paths["[EUC-JP, ISO-8859-5]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-5"]]
  @paths["[EUC-JP, ISO-8859-6]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-6"]]
  @paths["[EUC-JP, ISO-8859-7]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-7"]]
  @paths["[EUC-JP, ISO-8859-8]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-8"]]
  @paths["[EUC-JP, ISO-8859-9]"] = [[:"EUC-JP", :"UTF-8", :"ISO-8859-9"]]
  @paths["[EUC-JP, KOI8-R]"] = [[:"EUC-JP", :"UTF-8", :"KOI8-R"]]
  @paths["[EUC-JP, KOI8-U]"] = [[:"EUC-JP", :"UTF-8", :"KOI8-U"]]
  @paths["[EUC-JP, MACCROATIAN]"] = [[:"EUC-JP", :"UTF-8", :MACCROATIAN]]
  @paths["[EUC-JP, MACCYRILLIC]"] = [[:"EUC-JP", :"UTF-8", :MACCYRILLIC]]
  @paths["[EUC-JP, MACGREEK]"] = [[:"EUC-JP", :"UTF-8", :MACGREEK]]
  @paths["[EUC-JP, MACICELAND]"] = [[:"EUC-JP", :"UTF-8", :MACICELAND]]
  @paths["[EUC-JP, MACROMAN]"] = [[:"EUC-JP", :"UTF-8", :MACROMAN]]
  @paths["[EUC-JP, MACROMANIA]"] = [[:"EUC-JP", :"UTF-8", :MACROMANIA]]
  @paths["[EUC-JP, MACTURKISH]"] = [[:"EUC-JP", :"UTF-8", :MACTURKISH]]
  @paths["[EUC-JP, MACUKRAINE]"] = [[:"EUC-JP", :"UTF-8", :MACUKRAINE]]
  @paths["[EUC-JP, SHIFT_JIS]"] = [[:"EUC-JP", :SHIFT_JIS]]
  @paths["[EUC-JP, SJIS-DOCOMO]"] = [[:"EUC-JP", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[EUC-JP, SJIS-KDDI]"] = [[:"EUC-JP", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[EUC-JP, SJIS-SOFTBANK]"] = [[:"EUC-JP", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[EUC-JP, STATELESS-ISO-2022-JP]"] = [[:"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[EUC-JP, STATELESS-ISO-2022-JP-KDDI]"] = [[:"EUC-JP", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[EUC-JP, TIS-620]"] = [[:"EUC-JP", :"UTF-8", :"TIS-620"]]
  @paths["[EUC-JP, US-ASCII]"] = [[:"EUC-JP", :"UTF-8", :"US-ASCII"]]
  @paths["[EUC-JP, UTF-16]"] = [[:"EUC-JP", :"UTF-8", :"UTF-16"]]
  @paths["[EUC-JP, UTF-16BE]"] = [[:"EUC-JP", :"UTF-8", :"UTF-16BE"]]
  @paths["[EUC-JP, UTF-16LE]"] = [[:"EUC-JP", :"UTF-8", :"UTF-16LE"]]
  @paths["[EUC-JP, UTF-32]"] = [[:"EUC-JP", :"UTF-8", :"UTF-32"]]
  @paths["[EUC-JP, UTF-32BE]"] = [[:"EUC-JP", :"UTF-8", :"UTF-32BE"]]
  @paths["[EUC-JP, UTF-32LE]"] = [[:"EUC-JP", :"UTF-8", :"UTF-32LE"]]
  @paths["[EUC-JP, UTF-8]"] = [[:"EUC-JP", :"UTF-8"]]
  @paths["[EUC-JP, UTF8-DOCOMO]"] = [[:"EUC-JP", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[EUC-JP, UTF8-KDDI]"] = [[:"EUC-JP", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[EUC-JP, UTF8-MAC]"] = [[:"EUC-JP", :"UTF-8", :"UTF8-MAC"]]
  @paths["[EUC-JP, UTF8-SOFTBANK]"] = [[:"EUC-JP", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[EUC-JP, WINDOWS-1250]"] = [[:"EUC-JP", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[EUC-JP, WINDOWS-1251]"] = [[:"EUC-JP", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[EUC-JP, WINDOWS-1252]"] = [[:"EUC-JP", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[EUC-JP, WINDOWS-1253]"] = [[:"EUC-JP", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[EUC-JP, WINDOWS-1254]"] = [[:"EUC-JP", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[EUC-JP, WINDOWS-1255]"] = [[:"EUC-JP", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[EUC-JP, WINDOWS-1256]"] = [[:"EUC-JP", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[EUC-JP, WINDOWS-1257]"] = [[:"EUC-JP", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[EUC-JP, WINDOWS-31J]"] = [[:"EUC-JP", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[EUC-JP, WINDOWS-874]"] = [[:"EUC-JP", :"UTF-8", :"WINDOWS-874"]]
  @paths["[EUC-KR, ASCII-8BIT]"] = [[:"EUC-KR", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[EUC-KR, BIG5]"] = [[:"EUC-KR", :"UTF-8", :BIG5]]
  @paths["[EUC-KR, BIG5-HKSCS]"] = [[:"EUC-KR", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[EUC-KR, BIG5-UAO]"] = [[:"EUC-KR", :"UTF-8", :"BIG5-UAO"]]
  @paths["[EUC-KR, CP50220]"] = [[:"EUC-KR", :"UTF-8", :CP51932, :CP50220]]
  @paths["[EUC-KR, CP50221]"] = [[:"EUC-KR", :"UTF-8", :CP51932, :CP50221]]
  @paths["[EUC-KR, CP51932]"] = [[:"EUC-KR", :"UTF-8", :CP51932]]
  @paths["[EUC-KR, CP850]"] = [[:"EUC-KR", :"UTF-8", :CP850]]
  @paths["[EUC-KR, CP852]"] = [[:"EUC-KR", :"UTF-8", :CP852]]
  @paths["[EUC-KR, CP855]"] = [[:"EUC-KR", :"UTF-8", :CP855]]
  @paths["[EUC-KR, CP949]"] = [[:"EUC-KR", :"UTF-8", :CP949]]
  @paths["[EUC-KR, CP950]"] = [[:"EUC-KR", :"UTF-8", :CP950]]
  @paths["[EUC-KR, CP951]"] = [[:"EUC-KR", :"UTF-8", :CP951]]
  @paths["[EUC-KR, EUC-JP]"] = [[:"EUC-KR", :"UTF-8", :"EUC-JP"]]
  @paths["[EUC-KR, EUCJP-MS]"] = [[:"EUC-KR", :"UTF-8", :"EUCJP-MS"]]
  @paths["[EUC-KR, GB12345]"] = [[:"EUC-KR", :"UTF-8", :GB12345]]
  @paths["[EUC-KR, GB18030]"] = [[:"EUC-KR", :"UTF-8", :GB18030]]
  @paths["[EUC-KR, GB2312]"] = [[:"EUC-KR", :"UTF-8", :GB2312]]
  @paths["[EUC-KR, GBK]"] = [[:"EUC-KR", :"UTF-8", :GBK]]
  @paths["[EUC-KR, IBM437]"] = [[:"EUC-KR", :"UTF-8", :IBM437]]
  @paths["[EUC-KR, IBM737]"] = [[:"EUC-KR", :"UTF-8", :IBM737]]
  @paths["[EUC-KR, IBM775]"] = [[:"EUC-KR", :"UTF-8", :IBM775]]
  @paths["[EUC-KR, IBM852]"] = [[:"EUC-KR", :"UTF-8", :IBM852]]
  @paths["[EUC-KR, IBM855]"] = [[:"EUC-KR", :"UTF-8", :IBM855]]
  @paths["[EUC-KR, IBM857]"] = [[:"EUC-KR", :"UTF-8", :IBM857]]
  @paths["[EUC-KR, IBM860]"] = [[:"EUC-KR", :"UTF-8", :IBM860]]
  @paths["[EUC-KR, IBM861]"] = [[:"EUC-KR", :"UTF-8", :IBM861]]
  @paths["[EUC-KR, IBM862]"] = [[:"EUC-KR", :"UTF-8", :IBM862]]
  @paths["[EUC-KR, IBM863]"] = [[:"EUC-KR", :"UTF-8", :IBM863]]
  @paths["[EUC-KR, IBM865]"] = [[:"EUC-KR", :"UTF-8", :IBM865]]
  @paths["[EUC-KR, IBM866]"] = [[:"EUC-KR", :"UTF-8", :IBM866]]
  @paths["[EUC-KR, IBM869]"] = [[:"EUC-KR", :"UTF-8", :IBM869]]
  @paths["[EUC-KR, ISO-2022-JP]"] = [[:"EUC-KR", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[EUC-KR, ISO-2022-JP-KDDI]"] = [[:"EUC-KR", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[EUC-KR, ISO-8859-1]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-1"]]
  @paths["[EUC-KR, ISO-8859-10]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-10"]]
  @paths["[EUC-KR, ISO-8859-11]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-11"]]
  @paths["[EUC-KR, ISO-8859-13]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-13"]]
  @paths["[EUC-KR, ISO-8859-14]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-14"]]
  @paths["[EUC-KR, ISO-8859-15]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-15"]]
  @paths["[EUC-KR, ISO-8859-2]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-2"]]
  @paths["[EUC-KR, ISO-8859-3]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-3"]]
  @paths["[EUC-KR, ISO-8859-4]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-4"]]
  @paths["[EUC-KR, ISO-8859-5]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-5"]]
  @paths["[EUC-KR, ISO-8859-6]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-6"]]
  @paths["[EUC-KR, ISO-8859-7]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-7"]]
  @paths["[EUC-KR, ISO-8859-8]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-8"]]
  @paths["[EUC-KR, ISO-8859-9]"] = [[:"EUC-KR", :"UTF-8", :"ISO-8859-9"]]
  @paths["[EUC-KR, KOI8-R]"] = [[:"EUC-KR", :"UTF-8", :"KOI8-R"]]
  @paths["[EUC-KR, KOI8-U]"] = [[:"EUC-KR", :"UTF-8", :"KOI8-U"]]
  @paths["[EUC-KR, MACCROATIAN]"] = [[:"EUC-KR", :"UTF-8", :MACCROATIAN]]
  @paths["[EUC-KR, MACCYRILLIC]"] = [[:"EUC-KR", :"UTF-8", :MACCYRILLIC]]
  @paths["[EUC-KR, MACGREEK]"] = [[:"EUC-KR", :"UTF-8", :MACGREEK]]
  @paths["[EUC-KR, MACICELAND]"] = [[:"EUC-KR", :"UTF-8", :MACICELAND]]
  @paths["[EUC-KR, MACROMAN]"] = [[:"EUC-KR", :"UTF-8", :MACROMAN]]
  @paths["[EUC-KR, MACROMANIA]"] = [[:"EUC-KR", :"UTF-8", :MACROMANIA]]
  @paths["[EUC-KR, MACTURKISH]"] = [[:"EUC-KR", :"UTF-8", :MACTURKISH]]
  @paths["[EUC-KR, MACUKRAINE]"] = [[:"EUC-KR", :"UTF-8", :MACUKRAINE]]
  @paths["[EUC-KR, SHIFT_JIS]"] = [[:"EUC-KR", :"UTF-8", :SHIFT_JIS]]
  @paths["[EUC-KR, SJIS-DOCOMO]"] = [[:"EUC-KR", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[EUC-KR, SJIS-KDDI]"] = [[:"EUC-KR", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[EUC-KR, SJIS-SOFTBANK]"] = [[:"EUC-KR", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[EUC-KR, STATELESS-ISO-2022-JP]"] = [[:"EUC-KR", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[EUC-KR, STATELESS-ISO-2022-JP-KDDI]"] = [[:"EUC-KR", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[EUC-KR, TIS-620]"] = [[:"EUC-KR", :"UTF-8", :"TIS-620"]]
  @paths["[EUC-KR, US-ASCII]"] = [[:"EUC-KR", :"UTF-8", :"US-ASCII"]]
  @paths["[EUC-KR, UTF-16]"] = [[:"EUC-KR", :"UTF-8", :"UTF-16"]]
  @paths["[EUC-KR, UTF-16BE]"] = [[:"EUC-KR", :"UTF-8", :"UTF-16BE"]]
  @paths["[EUC-KR, UTF-16LE]"] = [[:"EUC-KR", :"UTF-8", :"UTF-16LE"]]
  @paths["[EUC-KR, UTF-32]"] = [[:"EUC-KR", :"UTF-8", :"UTF-32"]]
  @paths["[EUC-KR, UTF-32BE]"] = [[:"EUC-KR", :"UTF-8", :"UTF-32BE"]]
  @paths["[EUC-KR, UTF-32LE]"] = [[:"EUC-KR", :"UTF-8", :"UTF-32LE"]]
  @paths["[EUC-KR, UTF-8]"] = [[:"EUC-KR", :"UTF-8"]]
  @paths["[EUC-KR, UTF8-DOCOMO]"] = [[:"EUC-KR", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[EUC-KR, UTF8-KDDI]"] = [[:"EUC-KR", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[EUC-KR, UTF8-MAC]"] = [[:"EUC-KR", :"UTF-8", :"UTF8-MAC"]]
  @paths["[EUC-KR, UTF8-SOFTBANK]"] = [[:"EUC-KR", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[EUC-KR, WINDOWS-1250]"] = [[:"EUC-KR", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[EUC-KR, WINDOWS-1251]"] = [[:"EUC-KR", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[EUC-KR, WINDOWS-1252]"] = [[:"EUC-KR", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[EUC-KR, WINDOWS-1253]"] = [[:"EUC-KR", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[EUC-KR, WINDOWS-1254]"] = [[:"EUC-KR", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[EUC-KR, WINDOWS-1255]"] = [[:"EUC-KR", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[EUC-KR, WINDOWS-1256]"] = [[:"EUC-KR", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[EUC-KR, WINDOWS-1257]"] = [[:"EUC-KR", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[EUC-KR, WINDOWS-31J]"] = [[:"EUC-KR", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[EUC-KR, WINDOWS-874]"] = [[:"EUC-KR", :"UTF-8", :"WINDOWS-874"]]
  @paths["[EUCJP-MS, ASCII-8BIT]"] = [[:"EUCJP-MS", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[EUCJP-MS, BIG5]"] = [[:"EUCJP-MS", :"UTF-8", :BIG5]]
  @paths["[EUCJP-MS, BIG5-HKSCS]"] = [[:"EUCJP-MS", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[EUCJP-MS, BIG5-UAO]"] = [[:"EUCJP-MS", :"UTF-8", :"BIG5-UAO"]]
  @paths["[EUCJP-MS, CP50220]"] = [[:"EUCJP-MS", :"UTF-8", :CP51932, :CP50220]]
  @paths["[EUCJP-MS, CP50221]"] = [[:"EUCJP-MS", :"UTF-8", :CP51932, :CP50221]]
  @paths["[EUCJP-MS, CP51932]"] = [[:"EUCJP-MS", :"UTF-8", :CP51932]]
  @paths["[EUCJP-MS, CP850]"] = [[:"EUCJP-MS", :"UTF-8", :CP850]]
  @paths["[EUCJP-MS, CP852]"] = [[:"EUCJP-MS", :"UTF-8", :CP852]]
  @paths["[EUCJP-MS, CP855]"] = [[:"EUCJP-MS", :"UTF-8", :CP855]]
  @paths["[EUCJP-MS, CP949]"] = [[:"EUCJP-MS", :"UTF-8", :CP949]]
  @paths["[EUCJP-MS, CP950]"] = [[:"EUCJP-MS", :"UTF-8", :CP950]]
  @paths["[EUCJP-MS, CP951]"] = [[:"EUCJP-MS", :"UTF-8", :CP951]]
  @paths["[EUCJP-MS, EUC-JP]"] = [[:"EUCJP-MS", :"UTF-8", :"EUC-JP"]]
  @paths["[EUCJP-MS, EUC-KR]"] = [[:"EUCJP-MS", :"UTF-8", :"EUC-KR"]]
  @paths["[EUCJP-MS, GB12345]"] = [[:"EUCJP-MS", :"UTF-8", :GB12345]]
  @paths["[EUCJP-MS, GB18030]"] = [[:"EUCJP-MS", :"UTF-8", :GB18030]]
  @paths["[EUCJP-MS, GB2312]"] = [[:"EUCJP-MS", :"UTF-8", :GB2312]]
  @paths["[EUCJP-MS, GBK]"] = [[:"EUCJP-MS", :"UTF-8", :GBK]]
  @paths["[EUCJP-MS, IBM437]"] = [[:"EUCJP-MS", :"UTF-8", :IBM437]]
  @paths["[EUCJP-MS, IBM737]"] = [[:"EUCJP-MS", :"UTF-8", :IBM737]]
  @paths["[EUCJP-MS, IBM775]"] = [[:"EUCJP-MS", :"UTF-8", :IBM775]]
  @paths["[EUCJP-MS, IBM852]"] = [[:"EUCJP-MS", :"UTF-8", :IBM852]]
  @paths["[EUCJP-MS, IBM855]"] = [[:"EUCJP-MS", :"UTF-8", :IBM855]]
  @paths["[EUCJP-MS, IBM857]"] = [[:"EUCJP-MS", :"UTF-8", :IBM857]]
  @paths["[EUCJP-MS, IBM860]"] = [[:"EUCJP-MS", :"UTF-8", :IBM860]]
  @paths["[EUCJP-MS, IBM861]"] = [[:"EUCJP-MS", :"UTF-8", :IBM861]]
  @paths["[EUCJP-MS, IBM862]"] = [[:"EUCJP-MS", :"UTF-8", :IBM862]]
  @paths["[EUCJP-MS, IBM863]"] = [[:"EUCJP-MS", :"UTF-8", :IBM863]]
  @paths["[EUCJP-MS, IBM865]"] = [[:"EUCJP-MS", :"UTF-8", :IBM865]]
  @paths["[EUCJP-MS, IBM866]"] = [[:"EUCJP-MS", :"UTF-8", :IBM866]]
  @paths["[EUCJP-MS, IBM869]"] = [[:"EUCJP-MS", :"UTF-8", :IBM869]]
  @paths["[EUCJP-MS, ISO-2022-JP]"] = [[:"EUCJP-MS", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[EUCJP-MS, ISO-2022-JP-KDDI]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[EUCJP-MS, ISO-8859-1]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-1"]]
  @paths["[EUCJP-MS, ISO-8859-10]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-10"]]
  @paths["[EUCJP-MS, ISO-8859-11]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-11"]]
  @paths["[EUCJP-MS, ISO-8859-13]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-13"]]
  @paths["[EUCJP-MS, ISO-8859-14]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-14"]]
  @paths["[EUCJP-MS, ISO-8859-15]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-15"]]
  @paths["[EUCJP-MS, ISO-8859-2]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-2"]]
  @paths["[EUCJP-MS, ISO-8859-3]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-3"]]
  @paths["[EUCJP-MS, ISO-8859-4]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-4"]]
  @paths["[EUCJP-MS, ISO-8859-5]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-5"]]
  @paths["[EUCJP-MS, ISO-8859-6]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-6"]]
  @paths["[EUCJP-MS, ISO-8859-7]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-7"]]
  @paths["[EUCJP-MS, ISO-8859-8]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-8"]]
  @paths["[EUCJP-MS, ISO-8859-9]"] = [[:"EUCJP-MS", :"UTF-8", :"ISO-8859-9"]]
  @paths["[EUCJP-MS, KOI8-R]"] = [[:"EUCJP-MS", :"UTF-8", :"KOI8-R"]]
  @paths["[EUCJP-MS, KOI8-U]"] = [[:"EUCJP-MS", :"UTF-8", :"KOI8-U"]]
  @paths["[EUCJP-MS, MACCROATIAN]"] = [[:"EUCJP-MS", :"UTF-8", :MACCROATIAN]]
  @paths["[EUCJP-MS, MACCYRILLIC]"] = [[:"EUCJP-MS", :"UTF-8", :MACCYRILLIC]]
  @paths["[EUCJP-MS, MACGREEK]"] = [[:"EUCJP-MS", :"UTF-8", :MACGREEK]]
  @paths["[EUCJP-MS, MACICELAND]"] = [[:"EUCJP-MS", :"UTF-8", :MACICELAND]]
  @paths["[EUCJP-MS, MACROMAN]"] = [[:"EUCJP-MS", :"UTF-8", :MACROMAN]]
  @paths["[EUCJP-MS, MACROMANIA]"] = [[:"EUCJP-MS", :"UTF-8", :MACROMANIA]]
  @paths["[EUCJP-MS, MACTURKISH]"] = [[:"EUCJP-MS", :"UTF-8", :MACTURKISH]]
  @paths["[EUCJP-MS, MACUKRAINE]"] = [[:"EUCJP-MS", :"UTF-8", :MACUKRAINE]]
  @paths["[EUCJP-MS, SHIFT_JIS]"] = [[:"EUCJP-MS", :"UTF-8", :SHIFT_JIS]]
  @paths["[EUCJP-MS, SJIS-DOCOMO]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[EUCJP-MS, SJIS-KDDI]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[EUCJP-MS, SJIS-SOFTBANK]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[EUCJP-MS, STATELESS-ISO-2022-JP]"] = [[:"EUCJP-MS", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[EUCJP-MS, STATELESS-ISO-2022-JP-KDDI]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[EUCJP-MS, TIS-620]"] = [[:"EUCJP-MS", :"UTF-8", :"TIS-620"]]
  @paths["[EUCJP-MS, US-ASCII]"] = [[:"EUCJP-MS", :"UTF-8", :"US-ASCII"]]
  @paths["[EUCJP-MS, UTF-16]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF-16"]]
  @paths["[EUCJP-MS, UTF-16BE]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF-16BE"]]
  @paths["[EUCJP-MS, UTF-16LE]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF-16LE"]]
  @paths["[EUCJP-MS, UTF-32]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF-32"]]
  @paths["[EUCJP-MS, UTF-32BE]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF-32BE"]]
  @paths["[EUCJP-MS, UTF-32LE]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF-32LE"]]
  @paths["[EUCJP-MS, UTF-8]"] = [[:"EUCJP-MS", :"UTF-8"]]
  @paths["[EUCJP-MS, UTF8-DOCOMO]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[EUCJP-MS, UTF8-KDDI]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[EUCJP-MS, UTF8-MAC]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF8-MAC"]]
  @paths["[EUCJP-MS, UTF8-SOFTBANK]"] = [[:"EUCJP-MS", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[EUCJP-MS, WINDOWS-1250]"] = [[:"EUCJP-MS", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[EUCJP-MS, WINDOWS-1251]"] = [[:"EUCJP-MS", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[EUCJP-MS, WINDOWS-1252]"] = [[:"EUCJP-MS", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[EUCJP-MS, WINDOWS-1253]"] = [[:"EUCJP-MS", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[EUCJP-MS, WINDOWS-1254]"] = [[:"EUCJP-MS", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[EUCJP-MS, WINDOWS-1255]"] = [[:"EUCJP-MS", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[EUCJP-MS, WINDOWS-1256]"] = [[:"EUCJP-MS", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[EUCJP-MS, WINDOWS-1257]"] = [[:"EUCJP-MS", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[EUCJP-MS, WINDOWS-31J]"] = [[:"EUCJP-MS", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[EUCJP-MS, WINDOWS-874]"] = [[:"EUCJP-MS", :"UTF-8", :"WINDOWS-874"]]
  @paths["[GB12345, ASCII-8BIT]"] = [[:GB12345, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[GB12345, BIG5]"] = [[:GB12345, :"UTF-8", :BIG5]]
  @paths["[GB12345, BIG5-HKSCS]"] = [[:GB12345, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[GB12345, BIG5-UAO]"] = [[:GB12345, :"UTF-8", :"BIG5-UAO"]]
  @paths["[GB12345, CP50220]"] = [[:GB12345, :"UTF-8", :CP51932, :CP50220]]
  @paths["[GB12345, CP50221]"] = [[:GB12345, :"UTF-8", :CP51932, :CP50221]]
  @paths["[GB12345, CP51932]"] = [[:GB12345, :"UTF-8", :CP51932]]
  @paths["[GB12345, CP850]"] = [[:GB12345, :"UTF-8", :CP850]]
  @paths["[GB12345, CP852]"] = [[:GB12345, :"UTF-8", :CP852]]
  @paths["[GB12345, CP855]"] = [[:GB12345, :"UTF-8", :CP855]]
  @paths["[GB12345, CP949]"] = [[:GB12345, :"UTF-8", :CP949]]
  @paths["[GB12345, CP950]"] = [[:GB12345, :"UTF-8", :CP950]]
  @paths["[GB12345, CP951]"] = [[:GB12345, :"UTF-8", :CP951]]
  @paths["[GB12345, EUC-JP]"] = [[:GB12345, :"UTF-8", :"EUC-JP"]]
  @paths["[GB12345, EUC-KR]"] = [[:GB12345, :"UTF-8", :"EUC-KR"]]
  @paths["[GB12345, EUCJP-MS]"] = [[:GB12345, :"UTF-8", :"EUCJP-MS"]]
  @paths["[GB12345, GB18030]"] = [[:GB12345, :"UTF-8", :GB18030]]
  @paths["[GB12345, GB2312]"] = [[:GB12345, :"UTF-8", :GB2312]]
  @paths["[GB12345, GBK]"] = [[:GB12345, :"UTF-8", :GBK]]
  @paths["[GB12345, IBM437]"] = [[:GB12345, :"UTF-8", :IBM437]]
  @paths["[GB12345, IBM737]"] = [[:GB12345, :"UTF-8", :IBM737]]
  @paths["[GB12345, IBM775]"] = [[:GB12345, :"UTF-8", :IBM775]]
  @paths["[GB12345, IBM852]"] = [[:GB12345, :"UTF-8", :IBM852]]
  @paths["[GB12345, IBM855]"] = [[:GB12345, :"UTF-8", :IBM855]]
  @paths["[GB12345, IBM857]"] = [[:GB12345, :"UTF-8", :IBM857]]
  @paths["[GB12345, IBM860]"] = [[:GB12345, :"UTF-8", :IBM860]]
  @paths["[GB12345, IBM861]"] = [[:GB12345, :"UTF-8", :IBM861]]
  @paths["[GB12345, IBM862]"] = [[:GB12345, :"UTF-8", :IBM862]]
  @paths["[GB12345, IBM863]"] = [[:GB12345, :"UTF-8", :IBM863]]
  @paths["[GB12345, IBM865]"] = [[:GB12345, :"UTF-8", :IBM865]]
  @paths["[GB12345, IBM866]"] = [[:GB12345, :"UTF-8", :IBM866]]
  @paths["[GB12345, IBM869]"] = [[:GB12345, :"UTF-8", :IBM869]]
  @paths["[GB12345, ISO-2022-JP]"] = [[:GB12345, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[GB12345, ISO-2022-JP-KDDI]"] = [[:GB12345, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[GB12345, ISO-8859-1]"] = [[:GB12345, :"UTF-8", :"ISO-8859-1"]]
  @paths["[GB12345, ISO-8859-10]"] = [[:GB12345, :"UTF-8", :"ISO-8859-10"]]
  @paths["[GB12345, ISO-8859-11]"] = [[:GB12345, :"UTF-8", :"ISO-8859-11"]]
  @paths["[GB12345, ISO-8859-13]"] = [[:GB12345, :"UTF-8", :"ISO-8859-13"]]
  @paths["[GB12345, ISO-8859-14]"] = [[:GB12345, :"UTF-8", :"ISO-8859-14"]]
  @paths["[GB12345, ISO-8859-15]"] = [[:GB12345, :"UTF-8", :"ISO-8859-15"]]
  @paths["[GB12345, ISO-8859-2]"] = [[:GB12345, :"UTF-8", :"ISO-8859-2"]]
  @paths["[GB12345, ISO-8859-3]"] = [[:GB12345, :"UTF-8", :"ISO-8859-3"]]
  @paths["[GB12345, ISO-8859-4]"] = [[:GB12345, :"UTF-8", :"ISO-8859-4"]]
  @paths["[GB12345, ISO-8859-5]"] = [[:GB12345, :"UTF-8", :"ISO-8859-5"]]
  @paths["[GB12345, ISO-8859-6]"] = [[:GB12345, :"UTF-8", :"ISO-8859-6"]]
  @paths["[GB12345, ISO-8859-7]"] = [[:GB12345, :"UTF-8", :"ISO-8859-7"]]
  @paths["[GB12345, ISO-8859-8]"] = [[:GB12345, :"UTF-8", :"ISO-8859-8"]]
  @paths["[GB12345, ISO-8859-9]"] = [[:GB12345, :"UTF-8", :"ISO-8859-9"]]
  @paths["[GB12345, KOI8-R]"] = [[:GB12345, :"UTF-8", :"KOI8-R"]]
  @paths["[GB12345, KOI8-U]"] = [[:GB12345, :"UTF-8", :"KOI8-U"]]
  @paths["[GB12345, MACCROATIAN]"] = [[:GB12345, :"UTF-8", :MACCROATIAN]]
  @paths["[GB12345, MACCYRILLIC]"] = [[:GB12345, :"UTF-8", :MACCYRILLIC]]
  @paths["[GB12345, MACGREEK]"] = [[:GB12345, :"UTF-8", :MACGREEK]]
  @paths["[GB12345, MACICELAND]"] = [[:GB12345, :"UTF-8", :MACICELAND]]
  @paths["[GB12345, MACROMAN]"] = [[:GB12345, :"UTF-8", :MACROMAN]]
  @paths["[GB12345, MACROMANIA]"] = [[:GB12345, :"UTF-8", :MACROMANIA]]
  @paths["[GB12345, MACTURKISH]"] = [[:GB12345, :"UTF-8", :MACTURKISH]]
  @paths["[GB12345, MACUKRAINE]"] = [[:GB12345, :"UTF-8", :MACUKRAINE]]
  @paths["[GB12345, SHIFT_JIS]"] = [[:GB12345, :"UTF-8", :SHIFT_JIS]]
  @paths["[GB12345, SJIS-DOCOMO]"] = [[:GB12345, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[GB12345, SJIS-KDDI]"] = [[:GB12345, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[GB12345, SJIS-SOFTBANK]"] = [[:GB12345, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[GB12345, STATELESS-ISO-2022-JP]"] = [[:GB12345, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[GB12345, STATELESS-ISO-2022-JP-KDDI]"] = [[:GB12345, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[GB12345, TIS-620]"] = [[:GB12345, :"UTF-8", :"TIS-620"]]
  @paths["[GB12345, US-ASCII]"] = [[:GB12345, :"UTF-8", :"US-ASCII"]]
  @paths["[GB12345, UTF-16]"] = [[:GB12345, :"UTF-8", :"UTF-16"]]
  @paths["[GB12345, UTF-16BE]"] = [[:GB12345, :"UTF-8", :"UTF-16BE"]]
  @paths["[GB12345, UTF-16LE]"] = [[:GB12345, :"UTF-8", :"UTF-16LE"]]
  @paths["[GB12345, UTF-32]"] = [[:GB12345, :"UTF-8", :"UTF-32"]]
  @paths["[GB12345, UTF-32BE]"] = [[:GB12345, :"UTF-8", :"UTF-32BE"]]
  @paths["[GB12345, UTF-32LE]"] = [[:GB12345, :"UTF-8", :"UTF-32LE"]]
  @paths["[GB12345, UTF-8]"] = [[:GB12345, :"UTF-8"]]
  @paths["[GB12345, UTF8-DOCOMO]"] = [[:GB12345, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[GB12345, UTF8-KDDI]"] = [[:GB12345, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[GB12345, UTF8-MAC]"] = [[:GB12345, :"UTF-8", :"UTF8-MAC"]]
  @paths["[GB12345, UTF8-SOFTBANK]"] = [[:GB12345, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[GB12345, WINDOWS-1250]"] = [[:GB12345, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[GB12345, WINDOWS-1251]"] = [[:GB12345, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[GB12345, WINDOWS-1252]"] = [[:GB12345, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[GB12345, WINDOWS-1253]"] = [[:GB12345, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[GB12345, WINDOWS-1254]"] = [[:GB12345, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[GB12345, WINDOWS-1255]"] = [[:GB12345, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[GB12345, WINDOWS-1256]"] = [[:GB12345, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[GB12345, WINDOWS-1257]"] = [[:GB12345, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[GB12345, WINDOWS-31J]"] = [[:GB12345, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[GB12345, WINDOWS-874]"] = [[:GB12345, :"UTF-8", :"WINDOWS-874"]]
  @paths["[GB18030, ASCII-8BIT]"] = [[:GB18030, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[GB18030, BIG5]"] = [[:GB18030, :"UTF-8", :BIG5]]
  @paths["[GB18030, BIG5-HKSCS]"] = [[:GB18030, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[GB18030, BIG5-UAO]"] = [[:GB18030, :"UTF-8", :"BIG5-UAO"]]
  @paths["[GB18030, CP50220]"] = [[:GB18030, :"UTF-8", :CP51932, :CP50220]]
  @paths["[GB18030, CP50221]"] = [[:GB18030, :"UTF-8", :CP51932, :CP50221]]
  @paths["[GB18030, CP51932]"] = [[:GB18030, :"UTF-8", :CP51932]]
  @paths["[GB18030, CP850]"] = [[:GB18030, :"UTF-8", :CP850]]
  @paths["[GB18030, CP852]"] = [[:GB18030, :"UTF-8", :CP852]]
  @paths["[GB18030, CP855]"] = [[:GB18030, :"UTF-8", :CP855]]
  @paths["[GB18030, CP949]"] = [[:GB18030, :"UTF-8", :CP949]]
  @paths["[GB18030, CP950]"] = [[:GB18030, :"UTF-8", :CP950]]
  @paths["[GB18030, CP951]"] = [[:GB18030, :"UTF-8", :CP951]]
  @paths["[GB18030, EUC-JP]"] = [[:GB18030, :"UTF-8", :"EUC-JP"]]
  @paths["[GB18030, EUC-KR]"] = [[:GB18030, :"UTF-8", :"EUC-KR"]]
  @paths["[GB18030, EUCJP-MS]"] = [[:GB18030, :"UTF-8", :"EUCJP-MS"]]
  @paths["[GB18030, GB12345]"] = [[:GB18030, :"UTF-8", :GB12345]]
  @paths["[GB18030, GB2312]"] = [[:GB18030, :"UTF-8", :GB2312]]
  @paths["[GB18030, GBK]"] = [[:GB18030, :"UTF-8", :GBK]]
  @paths["[GB18030, IBM437]"] = [[:GB18030, :"UTF-8", :IBM437]]
  @paths["[GB18030, IBM737]"] = [[:GB18030, :"UTF-8", :IBM737]]
  @paths["[GB18030, IBM775]"] = [[:GB18030, :"UTF-8", :IBM775]]
  @paths["[GB18030, IBM852]"] = [[:GB18030, :"UTF-8", :IBM852]]
  @paths["[GB18030, IBM855]"] = [[:GB18030, :"UTF-8", :IBM855]]
  @paths["[GB18030, IBM857]"] = [[:GB18030, :"UTF-8", :IBM857]]
  @paths["[GB18030, IBM860]"] = [[:GB18030, :"UTF-8", :IBM860]]
  @paths["[GB18030, IBM861]"] = [[:GB18030, :"UTF-8", :IBM861]]
  @paths["[GB18030, IBM862]"] = [[:GB18030, :"UTF-8", :IBM862]]
  @paths["[GB18030, IBM863]"] = [[:GB18030, :"UTF-8", :IBM863]]
  @paths["[GB18030, IBM865]"] = [[:GB18030, :"UTF-8", :IBM865]]
  @paths["[GB18030, IBM866]"] = [[:GB18030, :"UTF-8", :IBM866]]
  @paths["[GB18030, IBM869]"] = [[:GB18030, :"UTF-8", :IBM869]]
  @paths["[GB18030, ISO-2022-JP]"] = [[:GB18030, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[GB18030, ISO-2022-JP-KDDI]"] = [[:GB18030, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[GB18030, ISO-8859-1]"] = [[:GB18030, :"UTF-8", :"ISO-8859-1"]]
  @paths["[GB18030, ISO-8859-10]"] = [[:GB18030, :"UTF-8", :"ISO-8859-10"]]
  @paths["[GB18030, ISO-8859-11]"] = [[:GB18030, :"UTF-8", :"ISO-8859-11"]]
  @paths["[GB18030, ISO-8859-13]"] = [[:GB18030, :"UTF-8", :"ISO-8859-13"]]
  @paths["[GB18030, ISO-8859-14]"] = [[:GB18030, :"UTF-8", :"ISO-8859-14"]]
  @paths["[GB18030, ISO-8859-15]"] = [[:GB18030, :"UTF-8", :"ISO-8859-15"]]
  @paths["[GB18030, ISO-8859-2]"] = [[:GB18030, :"UTF-8", :"ISO-8859-2"]]
  @paths["[GB18030, ISO-8859-3]"] = [[:GB18030, :"UTF-8", :"ISO-8859-3"]]
  @paths["[GB18030, ISO-8859-4]"] = [[:GB18030, :"UTF-8", :"ISO-8859-4"]]
  @paths["[GB18030, ISO-8859-5]"] = [[:GB18030, :"UTF-8", :"ISO-8859-5"]]
  @paths["[GB18030, ISO-8859-6]"] = [[:GB18030, :"UTF-8", :"ISO-8859-6"]]
  @paths["[GB18030, ISO-8859-7]"] = [[:GB18030, :"UTF-8", :"ISO-8859-7"]]
  @paths["[GB18030, ISO-8859-8]"] = [[:GB18030, :"UTF-8", :"ISO-8859-8"]]
  @paths["[GB18030, ISO-8859-9]"] = [[:GB18030, :"UTF-8", :"ISO-8859-9"]]
  @paths["[GB18030, KOI8-R]"] = [[:GB18030, :"UTF-8", :"KOI8-R"]]
  @paths["[GB18030, KOI8-U]"] = [[:GB18030, :"UTF-8", :"KOI8-U"]]
  @paths["[GB18030, MACCROATIAN]"] = [[:GB18030, :"UTF-8", :MACCROATIAN]]
  @paths["[GB18030, MACCYRILLIC]"] = [[:GB18030, :"UTF-8", :MACCYRILLIC]]
  @paths["[GB18030, MACGREEK]"] = [[:GB18030, :"UTF-8", :MACGREEK]]
  @paths["[GB18030, MACICELAND]"] = [[:GB18030, :"UTF-8", :MACICELAND]]
  @paths["[GB18030, MACROMAN]"] = [[:GB18030, :"UTF-8", :MACROMAN]]
  @paths["[GB18030, MACROMANIA]"] = [[:GB18030, :"UTF-8", :MACROMANIA]]
  @paths["[GB18030, MACTURKISH]"] = [[:GB18030, :"UTF-8", :MACTURKISH]]
  @paths["[GB18030, MACUKRAINE]"] = [[:GB18030, :"UTF-8", :MACUKRAINE]]
  @paths["[GB18030, SHIFT_JIS]"] = [[:GB18030, :"UTF-8", :SHIFT_JIS]]
  @paths["[GB18030, SJIS-DOCOMO]"] = [[:GB18030, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[GB18030, SJIS-KDDI]"] = [[:GB18030, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[GB18030, SJIS-SOFTBANK]"] = [[:GB18030, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[GB18030, STATELESS-ISO-2022-JP]"] = [[:GB18030, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[GB18030, STATELESS-ISO-2022-JP-KDDI]"] = [[:GB18030, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[GB18030, TIS-620]"] = [[:GB18030, :"UTF-8", :"TIS-620"]]
  @paths["[GB18030, US-ASCII]"] = [[:GB18030, :"UTF-8", :"US-ASCII"]]
  @paths["[GB18030, UTF-16]"] = [[:GB18030, :"UTF-8", :"UTF-16"]]
  @paths["[GB18030, UTF-16BE]"] = [[:GB18030, :"UTF-8", :"UTF-16BE"]]
  @paths["[GB18030, UTF-16LE]"] = [[:GB18030, :"UTF-8", :"UTF-16LE"]]
  @paths["[GB18030, UTF-32]"] = [[:GB18030, :"UTF-8", :"UTF-32"]]
  @paths["[GB18030, UTF-32BE]"] = [[:GB18030, :"UTF-8", :"UTF-32BE"]]
  @paths["[GB18030, UTF-32LE]"] = [[:GB18030, :"UTF-8", :"UTF-32LE"]]
  @paths["[GB18030, UTF-8]"] = [[:GB18030, :"UTF-8"]]
  @paths["[GB18030, UTF8-DOCOMO]"] = [[:GB18030, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[GB18030, UTF8-KDDI]"] = [[:GB18030, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[GB18030, UTF8-MAC]"] = [[:GB18030, :"UTF-8", :"UTF8-MAC"]]
  @paths["[GB18030, UTF8-SOFTBANK]"] = [[:GB18030, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[GB18030, WINDOWS-1250]"] = [[:GB18030, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[GB18030, WINDOWS-1251]"] = [[:GB18030, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[GB18030, WINDOWS-1252]"] = [[:GB18030, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[GB18030, WINDOWS-1253]"] = [[:GB18030, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[GB18030, WINDOWS-1254]"] = [[:GB18030, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[GB18030, WINDOWS-1255]"] = [[:GB18030, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[GB18030, WINDOWS-1256]"] = [[:GB18030, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[GB18030, WINDOWS-1257]"] = [[:GB18030, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[GB18030, WINDOWS-31J]"] = [[:GB18030, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[GB18030, WINDOWS-874]"] = [[:GB18030, :"UTF-8", :"WINDOWS-874"]]
  @paths["[GB2312, ASCII-8BIT]"] = [[:GB2312, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[GB2312, BIG5]"] = [[:GB2312, :"UTF-8", :BIG5]]
  @paths["[GB2312, BIG5-HKSCS]"] = [[:GB2312, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[GB2312, BIG5-UAO]"] = [[:GB2312, :"UTF-8", :"BIG5-UAO"]]
  @paths["[GB2312, CP50220]"] = [[:GB2312, :"UTF-8", :CP51932, :CP50220]]
  @paths["[GB2312, CP50221]"] = [[:GB2312, :"UTF-8", :CP51932, :CP50221]]
  @paths["[GB2312, CP51932]"] = [[:GB2312, :"UTF-8", :CP51932]]
  @paths["[GB2312, CP850]"] = [[:GB2312, :"UTF-8", :CP850]]
  @paths["[GB2312, CP852]"] = [[:GB2312, :"UTF-8", :CP852]]
  @paths["[GB2312, CP855]"] = [[:GB2312, :"UTF-8", :CP855]]
  @paths["[GB2312, CP949]"] = [[:GB2312, :"UTF-8", :CP949]]
  @paths["[GB2312, CP950]"] = [[:GB2312, :"UTF-8", :CP950]]
  @paths["[GB2312, CP951]"] = [[:GB2312, :"UTF-8", :CP951]]
  @paths["[GB2312, EUC-JP]"] = [[:GB2312, :"UTF-8", :"EUC-JP"]]
  @paths["[GB2312, EUC-KR]"] = [[:GB2312, :"UTF-8", :"EUC-KR"]]
  @paths["[GB2312, EUCJP-MS]"] = [[:GB2312, :"UTF-8", :"EUCJP-MS"]]
  @paths["[GB2312, GB12345]"] = [[:GB2312, :"UTF-8", :GB12345]]
  @paths["[GB2312, GB18030]"] = [[:GB2312, :"UTF-8", :GB18030]]
  @paths["[GB2312, GBK]"] = [[:GB2312, :"UTF-8", :GBK]]
  @paths["[GB2312, IBM437]"] = [[:GB2312, :"UTF-8", :IBM437]]
  @paths["[GB2312, IBM737]"] = [[:GB2312, :"UTF-8", :IBM737]]
  @paths["[GB2312, IBM775]"] = [[:GB2312, :"UTF-8", :IBM775]]
  @paths["[GB2312, IBM852]"] = [[:GB2312, :"UTF-8", :IBM852]]
  @paths["[GB2312, IBM855]"] = [[:GB2312, :"UTF-8", :IBM855]]
  @paths["[GB2312, IBM857]"] = [[:GB2312, :"UTF-8", :IBM857]]
  @paths["[GB2312, IBM860]"] = [[:GB2312, :"UTF-8", :IBM860]]
  @paths["[GB2312, IBM861]"] = [[:GB2312, :"UTF-8", :IBM861]]
  @paths["[GB2312, IBM862]"] = [[:GB2312, :"UTF-8", :IBM862]]
  @paths["[GB2312, IBM863]"] = [[:GB2312, :"UTF-8", :IBM863]]
  @paths["[GB2312, IBM865]"] = [[:GB2312, :"UTF-8", :IBM865]]
  @paths["[GB2312, IBM866]"] = [[:GB2312, :"UTF-8", :IBM866]]
  @paths["[GB2312, IBM869]"] = [[:GB2312, :"UTF-8", :IBM869]]
  @paths["[GB2312, ISO-2022-JP]"] = [[:GB2312, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[GB2312, ISO-2022-JP-KDDI]"] = [[:GB2312, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[GB2312, ISO-8859-1]"] = [[:GB2312, :"UTF-8", :"ISO-8859-1"]]
  @paths["[GB2312, ISO-8859-10]"] = [[:GB2312, :"UTF-8", :"ISO-8859-10"]]
  @paths["[GB2312, ISO-8859-11]"] = [[:GB2312, :"UTF-8", :"ISO-8859-11"]]
  @paths["[GB2312, ISO-8859-13]"] = [[:GB2312, :"UTF-8", :"ISO-8859-13"]]
  @paths["[GB2312, ISO-8859-14]"] = [[:GB2312, :"UTF-8", :"ISO-8859-14"]]
  @paths["[GB2312, ISO-8859-15]"] = [[:GB2312, :"UTF-8", :"ISO-8859-15"]]
  @paths["[GB2312, ISO-8859-2]"] = [[:GB2312, :"UTF-8", :"ISO-8859-2"]]
  @paths["[GB2312, ISO-8859-3]"] = [[:GB2312, :"UTF-8", :"ISO-8859-3"]]
  @paths["[GB2312, ISO-8859-4]"] = [[:GB2312, :"UTF-8", :"ISO-8859-4"]]
  @paths["[GB2312, ISO-8859-5]"] = [[:GB2312, :"UTF-8", :"ISO-8859-5"]]
  @paths["[GB2312, ISO-8859-6]"] = [[:GB2312, :"UTF-8", :"ISO-8859-6"]]
  @paths["[GB2312, ISO-8859-7]"] = [[:GB2312, :"UTF-8", :"ISO-8859-7"]]
  @paths["[GB2312, ISO-8859-8]"] = [[:GB2312, :"UTF-8", :"ISO-8859-8"]]
  @paths["[GB2312, ISO-8859-9]"] = [[:GB2312, :"UTF-8", :"ISO-8859-9"]]
  @paths["[GB2312, KOI8-R]"] = [[:GB2312, :"UTF-8", :"KOI8-R"]]
  @paths["[GB2312, KOI8-U]"] = [[:GB2312, :"UTF-8", :"KOI8-U"]]
  @paths["[GB2312, MACCROATIAN]"] = [[:GB2312, :"UTF-8", :MACCROATIAN]]
  @paths["[GB2312, MACCYRILLIC]"] = [[:GB2312, :"UTF-8", :MACCYRILLIC]]
  @paths["[GB2312, MACGREEK]"] = [[:GB2312, :"UTF-8", :MACGREEK]]
  @paths["[GB2312, MACICELAND]"] = [[:GB2312, :"UTF-8", :MACICELAND]]
  @paths["[GB2312, MACROMAN]"] = [[:GB2312, :"UTF-8", :MACROMAN]]
  @paths["[GB2312, MACROMANIA]"] = [[:GB2312, :"UTF-8", :MACROMANIA]]
  @paths["[GB2312, MACTURKISH]"] = [[:GB2312, :"UTF-8", :MACTURKISH]]
  @paths["[GB2312, MACUKRAINE]"] = [[:GB2312, :"UTF-8", :MACUKRAINE]]
  @paths["[GB2312, SHIFT_JIS]"] = [[:GB2312, :"UTF-8", :SHIFT_JIS]]
  @paths["[GB2312, SJIS-DOCOMO]"] = [[:GB2312, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[GB2312, SJIS-KDDI]"] = [[:GB2312, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[GB2312, SJIS-SOFTBANK]"] = [[:GB2312, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[GB2312, STATELESS-ISO-2022-JP]"] = [[:GB2312, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[GB2312, STATELESS-ISO-2022-JP-KDDI]"] = [[:GB2312, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[GB2312, TIS-620]"] = [[:GB2312, :"UTF-8", :"TIS-620"]]
  @paths["[GB2312, US-ASCII]"] = [[:GB2312, :"UTF-8", :"US-ASCII"]]
  @paths["[GB2312, UTF-16]"] = [[:GB2312, :"UTF-8", :"UTF-16"]]
  @paths["[GB2312, UTF-16BE]"] = [[:GB2312, :"UTF-8", :"UTF-16BE"]]
  @paths["[GB2312, UTF-16LE]"] = [[:GB2312, :"UTF-8", :"UTF-16LE"]]
  @paths["[GB2312, UTF-32]"] = [[:GB2312, :"UTF-8", :"UTF-32"]]
  @paths["[GB2312, UTF-32BE]"] = [[:GB2312, :"UTF-8", :"UTF-32BE"]]
  @paths["[GB2312, UTF-32LE]"] = [[:GB2312, :"UTF-8", :"UTF-32LE"]]
  @paths["[GB2312, UTF-8]"] = [[:GB2312, :"UTF-8"]]
  @paths["[GB2312, UTF8-DOCOMO]"] = [[:GB2312, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[GB2312, UTF8-KDDI]"] = [[:GB2312, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[GB2312, UTF8-MAC]"] = [[:GB2312, :"UTF-8", :"UTF8-MAC"]]
  @paths["[GB2312, UTF8-SOFTBANK]"] = [[:GB2312, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[GB2312, WINDOWS-1250]"] = [[:GB2312, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[GB2312, WINDOWS-1251]"] = [[:GB2312, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[GB2312, WINDOWS-1252]"] = [[:GB2312, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[GB2312, WINDOWS-1253]"] = [[:GB2312, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[GB2312, WINDOWS-1254]"] = [[:GB2312, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[GB2312, WINDOWS-1255]"] = [[:GB2312, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[GB2312, WINDOWS-1256]"] = [[:GB2312, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[GB2312, WINDOWS-1257]"] = [[:GB2312, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[GB2312, WINDOWS-31J]"] = [[:GB2312, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[GB2312, WINDOWS-874]"] = [[:GB2312, :"UTF-8", :"WINDOWS-874"]]
  @paths["[GBK, ASCII-8BIT]"] = [[:GBK, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[GBK, BIG5]"] = [[:GBK, :"UTF-8", :BIG5]]
  @paths["[GBK, BIG5-HKSCS]"] = [[:GBK, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[GBK, BIG5-UAO]"] = [[:GBK, :"UTF-8", :"BIG5-UAO"]]
  @paths["[GBK, CP50220]"] = [[:GBK, :"UTF-8", :CP51932, :CP50220]]
  @paths["[GBK, CP50221]"] = [[:GBK, :"UTF-8", :CP51932, :CP50221]]
  @paths["[GBK, CP51932]"] = [[:GBK, :"UTF-8", :CP51932]]
  @paths["[GBK, CP850]"] = [[:GBK, :"UTF-8", :CP850]]
  @paths["[GBK, CP852]"] = [[:GBK, :"UTF-8", :CP852]]
  @paths["[GBK, CP855]"] = [[:GBK, :"UTF-8", :CP855]]
  @paths["[GBK, CP949]"] = [[:GBK, :"UTF-8", :CP949]]
  @paths["[GBK, CP950]"] = [[:GBK, :"UTF-8", :CP950]]
  @paths["[GBK, CP951]"] = [[:GBK, :"UTF-8", :CP951]]
  @paths["[GBK, EUC-JP]"] = [[:GBK, :"UTF-8", :"EUC-JP"]]
  @paths["[GBK, EUC-KR]"] = [[:GBK, :"UTF-8", :"EUC-KR"]]
  @paths["[GBK, EUCJP-MS]"] = [[:GBK, :"UTF-8", :"EUCJP-MS"]]
  @paths["[GBK, GB12345]"] = [[:GBK, :"UTF-8", :GB12345]]
  @paths["[GBK, GB18030]"] = [[:GBK, :"UTF-8", :GB18030]]
  @paths["[GBK, GB2312]"] = [[:GBK, :"UTF-8", :GB2312]]
  @paths["[GBK, IBM437]"] = [[:GBK, :"UTF-8", :IBM437]]
  @paths["[GBK, IBM737]"] = [[:GBK, :"UTF-8", :IBM737]]
  @paths["[GBK, IBM775]"] = [[:GBK, :"UTF-8", :IBM775]]
  @paths["[GBK, IBM852]"] = [[:GBK, :"UTF-8", :IBM852]]
  @paths["[GBK, IBM855]"] = [[:GBK, :"UTF-8", :IBM855]]
  @paths["[GBK, IBM857]"] = [[:GBK, :"UTF-8", :IBM857]]
  @paths["[GBK, IBM860]"] = [[:GBK, :"UTF-8", :IBM860]]
  @paths["[GBK, IBM861]"] = [[:GBK, :"UTF-8", :IBM861]]
  @paths["[GBK, IBM862]"] = [[:GBK, :"UTF-8", :IBM862]]
  @paths["[GBK, IBM863]"] = [[:GBK, :"UTF-8", :IBM863]]
  @paths["[GBK, IBM865]"] = [[:GBK, :"UTF-8", :IBM865]]
  @paths["[GBK, IBM866]"] = [[:GBK, :"UTF-8", :IBM866]]
  @paths["[GBK, IBM869]"] = [[:GBK, :"UTF-8", :IBM869]]
  @paths["[GBK, ISO-2022-JP]"] = [[:GBK, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[GBK, ISO-2022-JP-KDDI]"] = [[:GBK, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[GBK, ISO-8859-1]"] = [[:GBK, :"UTF-8", :"ISO-8859-1"]]
  @paths["[GBK, ISO-8859-10]"] = [[:GBK, :"UTF-8", :"ISO-8859-10"]]
  @paths["[GBK, ISO-8859-11]"] = [[:GBK, :"UTF-8", :"ISO-8859-11"]]
  @paths["[GBK, ISO-8859-13]"] = [[:GBK, :"UTF-8", :"ISO-8859-13"]]
  @paths["[GBK, ISO-8859-14]"] = [[:GBK, :"UTF-8", :"ISO-8859-14"]]
  @paths["[GBK, ISO-8859-15]"] = [[:GBK, :"UTF-8", :"ISO-8859-15"]]
  @paths["[GBK, ISO-8859-2]"] = [[:GBK, :"UTF-8", :"ISO-8859-2"]]
  @paths["[GBK, ISO-8859-3]"] = [[:GBK, :"UTF-8", :"ISO-8859-3"]]
  @paths["[GBK, ISO-8859-4]"] = [[:GBK, :"UTF-8", :"ISO-8859-4"]]
  @paths["[GBK, ISO-8859-5]"] = [[:GBK, :"UTF-8", :"ISO-8859-5"]]
  @paths["[GBK, ISO-8859-6]"] = [[:GBK, :"UTF-8", :"ISO-8859-6"]]
  @paths["[GBK, ISO-8859-7]"] = [[:GBK, :"UTF-8", :"ISO-8859-7"]]
  @paths["[GBK, ISO-8859-8]"] = [[:GBK, :"UTF-8", :"ISO-8859-8"]]
  @paths["[GBK, ISO-8859-9]"] = [[:GBK, :"UTF-8", :"ISO-8859-9"]]
  @paths["[GBK, KOI8-R]"] = [[:GBK, :"UTF-8", :"KOI8-R"]]
  @paths["[GBK, KOI8-U]"] = [[:GBK, :"UTF-8", :"KOI8-U"]]
  @paths["[GBK, MACCROATIAN]"] = [[:GBK, :"UTF-8", :MACCROATIAN]]
  @paths["[GBK, MACCYRILLIC]"] = [[:GBK, :"UTF-8", :MACCYRILLIC]]
  @paths["[GBK, MACGREEK]"] = [[:GBK, :"UTF-8", :MACGREEK]]
  @paths["[GBK, MACICELAND]"] = [[:GBK, :"UTF-8", :MACICELAND]]
  @paths["[GBK, MACROMAN]"] = [[:GBK, :"UTF-8", :MACROMAN]]
  @paths["[GBK, MACROMANIA]"] = [[:GBK, :"UTF-8", :MACROMANIA]]
  @paths["[GBK, MACTURKISH]"] = [[:GBK, :"UTF-8", :MACTURKISH]]
  @paths["[GBK, MACUKRAINE]"] = [[:GBK, :"UTF-8", :MACUKRAINE]]
  @paths["[GBK, SHIFT_JIS]"] = [[:GBK, :"UTF-8", :SHIFT_JIS]]
  @paths["[GBK, SJIS-DOCOMO]"] = [[:GBK, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[GBK, SJIS-KDDI]"] = [[:GBK, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[GBK, SJIS-SOFTBANK]"] = [[:GBK, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[GBK, STATELESS-ISO-2022-JP]"] = [[:GBK, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[GBK, STATELESS-ISO-2022-JP-KDDI]"] = [[:GBK, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[GBK, TIS-620]"] = [[:GBK, :"UTF-8", :"TIS-620"]]
  @paths["[GBK, US-ASCII]"] = [[:GBK, :"UTF-8", :"US-ASCII"]]
  @paths["[GBK, UTF-16]"] = [[:GBK, :"UTF-8", :"UTF-16"]]
  @paths["[GBK, UTF-16BE]"] = [[:GBK, :"UTF-8", :"UTF-16BE"]]
  @paths["[GBK, UTF-16LE]"] = [[:GBK, :"UTF-8", :"UTF-16LE"]]
  @paths["[GBK, UTF-32]"] = [[:GBK, :"UTF-8", :"UTF-32"]]
  @paths["[GBK, UTF-32BE]"] = [[:GBK, :"UTF-8", :"UTF-32BE"]]
  @paths["[GBK, UTF-32LE]"] = [[:GBK, :"UTF-8", :"UTF-32LE"]]
  @paths["[GBK, UTF-8]"] = [[:GBK, :"UTF-8"]]
  @paths["[GBK, UTF8-DOCOMO]"] = [[:GBK, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[GBK, UTF8-KDDI]"] = [[:GBK, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[GBK, UTF8-MAC]"] = [[:GBK, :"UTF-8", :"UTF8-MAC"]]
  @paths["[GBK, UTF8-SOFTBANK]"] = [[:GBK, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[GBK, WINDOWS-1250]"] = [[:GBK, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[GBK, WINDOWS-1251]"] = [[:GBK, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[GBK, WINDOWS-1252]"] = [[:GBK, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[GBK, WINDOWS-1253]"] = [[:GBK, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[GBK, WINDOWS-1254]"] = [[:GBK, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[GBK, WINDOWS-1255]"] = [[:GBK, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[GBK, WINDOWS-1256]"] = [[:GBK, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[GBK, WINDOWS-1257]"] = [[:GBK, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[GBK, WINDOWS-31J]"] = [[:GBK, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[GBK, WINDOWS-874]"] = [[:GBK, :"UTF-8", :"WINDOWS-874"]]
  @paths["[IBM437, ASCII-8BIT]"] = [[:IBM437, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[IBM437, BIG5]"] = [[:IBM437, :"UTF-8", :BIG5]]
  @paths["[IBM437, BIG5-HKSCS]"] = [[:IBM437, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[IBM437, BIG5-UAO]"] = [[:IBM437, :"UTF-8", :"BIG5-UAO"]]
  @paths["[IBM437, CP50220]"] = [[:IBM437, :"UTF-8", :CP51932, :CP50220]]
  @paths["[IBM437, CP50221]"] = [[:IBM437, :"UTF-8", :CP51932, :CP50221]]
  @paths["[IBM437, CP51932]"] = [[:IBM437, :"UTF-8", :CP51932]]
  @paths["[IBM437, CP850]"] = [[:IBM437, :"UTF-8", :CP850]]
  @paths["[IBM437, CP852]"] = [[:IBM437, :"UTF-8", :CP852]]
  @paths["[IBM437, CP855]"] = [[:IBM437, :"UTF-8", :CP855]]
  @paths["[IBM437, CP949]"] = [[:IBM437, :"UTF-8", :CP949]]
  @paths["[IBM437, CP950]"] = [[:IBM437, :"UTF-8", :CP950]]
  @paths["[IBM437, CP951]"] = [[:IBM437, :"UTF-8", :CP951]]
  @paths["[IBM437, EUC-JP]"] = [[:IBM437, :"UTF-8", :"EUC-JP"]]
  @paths["[IBM437, EUC-KR]"] = [[:IBM437, :"UTF-8", :"EUC-KR"]]
  @paths["[IBM437, EUCJP-MS]"] = [[:IBM437, :"UTF-8", :"EUCJP-MS"]]
  @paths["[IBM437, GB12345]"] = [[:IBM437, :"UTF-8", :GB12345]]
  @paths["[IBM437, GB18030]"] = [[:IBM437, :"UTF-8", :GB18030]]
  @paths["[IBM437, GB2312]"] = [[:IBM437, :"UTF-8", :GB2312]]
  @paths["[IBM437, GBK]"] = [[:IBM437, :"UTF-8", :GBK]]
  @paths["[IBM437, IBM737]"] = [[:IBM437, :"UTF-8", :IBM737]]
  @paths["[IBM437, IBM775]"] = [[:IBM437, :"UTF-8", :IBM775]]
  @paths["[IBM437, IBM852]"] = [[:IBM437, :"UTF-8", :IBM852]]
  @paths["[IBM437, IBM855]"] = [[:IBM437, :"UTF-8", :IBM855]]
  @paths["[IBM437, IBM857]"] = [[:IBM437, :"UTF-8", :IBM857]]
  @paths["[IBM437, IBM860]"] = [[:IBM437, :"UTF-8", :IBM860]]
  @paths["[IBM437, IBM861]"] = [[:IBM437, :"UTF-8", :IBM861]]
  @paths["[IBM437, IBM862]"] = [[:IBM437, :"UTF-8", :IBM862]]
  @paths["[IBM437, IBM863]"] = [[:IBM437, :"UTF-8", :IBM863]]
  @paths["[IBM437, IBM865]"] = [[:IBM437, :"UTF-8", :IBM865]]
  @paths["[IBM437, IBM866]"] = [[:IBM437, :"UTF-8", :IBM866]]
  @paths["[IBM437, IBM869]"] = [[:IBM437, :"UTF-8", :IBM869]]
  @paths["[IBM437, ISO-2022-JP]"] = [[:IBM437, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[IBM437, ISO-2022-JP-KDDI]"] = [[:IBM437, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[IBM437, ISO-8859-1]"] = [[:IBM437, :"UTF-8", :"ISO-8859-1"]]
  @paths["[IBM437, ISO-8859-10]"] = [[:IBM437, :"UTF-8", :"ISO-8859-10"]]
  @paths["[IBM437, ISO-8859-11]"] = [[:IBM437, :"UTF-8", :"ISO-8859-11"]]
  @paths["[IBM437, ISO-8859-13]"] = [[:IBM437, :"UTF-8", :"ISO-8859-13"]]
  @paths["[IBM437, ISO-8859-14]"] = [[:IBM437, :"UTF-8", :"ISO-8859-14"]]
  @paths["[IBM437, ISO-8859-15]"] = [[:IBM437, :"UTF-8", :"ISO-8859-15"]]
  @paths["[IBM437, ISO-8859-2]"] = [[:IBM437, :"UTF-8", :"ISO-8859-2"]]
  @paths["[IBM437, ISO-8859-3]"] = [[:IBM437, :"UTF-8", :"ISO-8859-3"]]
  @paths["[IBM437, ISO-8859-4]"] = [[:IBM437, :"UTF-8", :"ISO-8859-4"]]
  @paths["[IBM437, ISO-8859-5]"] = [[:IBM437, :"UTF-8", :"ISO-8859-5"]]
  @paths["[IBM437, ISO-8859-6]"] = [[:IBM437, :"UTF-8", :"ISO-8859-6"]]
  @paths["[IBM437, ISO-8859-7]"] = [[:IBM437, :"UTF-8", :"ISO-8859-7"]]
  @paths["[IBM437, ISO-8859-8]"] = [[:IBM437, :"UTF-8", :"ISO-8859-8"]]
  @paths["[IBM437, ISO-8859-9]"] = [[:IBM437, :"UTF-8", :"ISO-8859-9"]]
  @paths["[IBM437, KOI8-R]"] = [[:IBM437, :"UTF-8", :"KOI8-R"]]
  @paths["[IBM437, KOI8-U]"] = [[:IBM437, :"UTF-8", :"KOI8-U"]]
  @paths["[IBM437, MACCROATIAN]"] = [[:IBM437, :"UTF-8", :MACCROATIAN]]
  @paths["[IBM437, MACCYRILLIC]"] = [[:IBM437, :"UTF-8", :MACCYRILLIC]]
  @paths["[IBM437, MACGREEK]"] = [[:IBM437, :"UTF-8", :MACGREEK]]
  @paths["[IBM437, MACICELAND]"] = [[:IBM437, :"UTF-8", :MACICELAND]]
  @paths["[IBM437, MACROMAN]"] = [[:IBM437, :"UTF-8", :MACROMAN]]
  @paths["[IBM437, MACROMANIA]"] = [[:IBM437, :"UTF-8", :MACROMANIA]]
  @paths["[IBM437, MACTURKISH]"] = [[:IBM437, :"UTF-8", :MACTURKISH]]
  @paths["[IBM437, MACUKRAINE]"] = [[:IBM437, :"UTF-8", :MACUKRAINE]]
  @paths["[IBM437, SHIFT_JIS]"] = [[:IBM437, :"UTF-8", :SHIFT_JIS]]
  @paths["[IBM437, SJIS-DOCOMO]"] = [[:IBM437, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[IBM437, SJIS-KDDI]"] = [[:IBM437, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[IBM437, SJIS-SOFTBANK]"] = [[:IBM437, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[IBM437, STATELESS-ISO-2022-JP]"] = [[:IBM437, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[IBM437, STATELESS-ISO-2022-JP-KDDI]"] = [[:IBM437, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[IBM437, TIS-620]"] = [[:IBM437, :"UTF-8", :"TIS-620"]]
  @paths["[IBM437, US-ASCII]"] = [[:IBM437, :"UTF-8", :"US-ASCII"]]
  @paths["[IBM437, UTF-16]"] = [[:IBM437, :"UTF-8", :"UTF-16"]]
  @paths["[IBM437, UTF-16BE]"] = [[:IBM437, :"UTF-8", :"UTF-16BE"]]
  @paths["[IBM437, UTF-16LE]"] = [[:IBM437, :"UTF-8", :"UTF-16LE"]]
  @paths["[IBM437, UTF-32]"] = [[:IBM437, :"UTF-8", :"UTF-32"]]
  @paths["[IBM437, UTF-32BE]"] = [[:IBM437, :"UTF-8", :"UTF-32BE"]]
  @paths["[IBM437, UTF-32LE]"] = [[:IBM437, :"UTF-8", :"UTF-32LE"]]
  @paths["[IBM437, UTF-8]"] = [[:IBM437, :"UTF-8"]]
  @paths["[IBM437, UTF8-DOCOMO]"] = [[:IBM437, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[IBM437, UTF8-KDDI]"] = [[:IBM437, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[IBM437, UTF8-MAC]"] = [[:IBM437, :"UTF-8", :"UTF8-MAC"]]
  @paths["[IBM437, UTF8-SOFTBANK]"] = [[:IBM437, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[IBM437, WINDOWS-1250]"] = [[:IBM437, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[IBM437, WINDOWS-1251]"] = [[:IBM437, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[IBM437, WINDOWS-1252]"] = [[:IBM437, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[IBM437, WINDOWS-1253]"] = [[:IBM437, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[IBM437, WINDOWS-1254]"] = [[:IBM437, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[IBM437, WINDOWS-1255]"] = [[:IBM437, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[IBM437, WINDOWS-1256]"] = [[:IBM437, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[IBM437, WINDOWS-1257]"] = [[:IBM437, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[IBM437, WINDOWS-31J]"] = [[:IBM437, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[IBM437, WINDOWS-874]"] = [[:IBM437, :"UTF-8", :"WINDOWS-874"]]
  @paths["[IBM737, ASCII-8BIT]"] = [[:IBM737, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[IBM737, BIG5]"] = [[:IBM737, :"UTF-8", :BIG5]]
  @paths["[IBM737, BIG5-HKSCS]"] = [[:IBM737, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[IBM737, BIG5-UAO]"] = [[:IBM737, :"UTF-8", :"BIG5-UAO"]]
  @paths["[IBM737, CP50220]"] = [[:IBM737, :"UTF-8", :CP51932, :CP50220]]
  @paths["[IBM737, CP50221]"] = [[:IBM737, :"UTF-8", :CP51932, :CP50221]]
  @paths["[IBM737, CP51932]"] = [[:IBM737, :"UTF-8", :CP51932]]
  @paths["[IBM737, CP850]"] = [[:IBM737, :"UTF-8", :CP850]]
  @paths["[IBM737, CP852]"] = [[:IBM737, :"UTF-8", :CP852]]
  @paths["[IBM737, CP855]"] = [[:IBM737, :"UTF-8", :CP855]]
  @paths["[IBM737, CP949]"] = [[:IBM737, :"UTF-8", :CP949]]
  @paths["[IBM737, CP950]"] = [[:IBM737, :"UTF-8", :CP950]]
  @paths["[IBM737, CP951]"] = [[:IBM737, :"UTF-8", :CP951]]
  @paths["[IBM737, EUC-JP]"] = [[:IBM737, :"UTF-8", :"EUC-JP"]]
  @paths["[IBM737, EUC-KR]"] = [[:IBM737, :"UTF-8", :"EUC-KR"]]
  @paths["[IBM737, EUCJP-MS]"] = [[:IBM737, :"UTF-8", :"EUCJP-MS"]]
  @paths["[IBM737, GB12345]"] = [[:IBM737, :"UTF-8", :GB12345]]
  @paths["[IBM737, GB18030]"] = [[:IBM737, :"UTF-8", :GB18030]]
  @paths["[IBM737, GB2312]"] = [[:IBM737, :"UTF-8", :GB2312]]
  @paths["[IBM737, GBK]"] = [[:IBM737, :"UTF-8", :GBK]]
  @paths["[IBM737, IBM437]"] = [[:IBM737, :"UTF-8", :IBM437]]
  @paths["[IBM737, IBM775]"] = [[:IBM737, :"UTF-8", :IBM775]]
  @paths["[IBM737, IBM852]"] = [[:IBM737, :"UTF-8", :IBM852]]
  @paths["[IBM737, IBM855]"] = [[:IBM737, :"UTF-8", :IBM855]]
  @paths["[IBM737, IBM857]"] = [[:IBM737, :"UTF-8", :IBM857]]
  @paths["[IBM737, IBM860]"] = [[:IBM737, :"UTF-8", :IBM860]]
  @paths["[IBM737, IBM861]"] = [[:IBM737, :"UTF-8", :IBM861]]
  @paths["[IBM737, IBM862]"] = [[:IBM737, :"UTF-8", :IBM862]]
  @paths["[IBM737, IBM863]"] = [[:IBM737, :"UTF-8", :IBM863]]
  @paths["[IBM737, IBM865]"] = [[:IBM737, :"UTF-8", :IBM865]]
  @paths["[IBM737, IBM866]"] = [[:IBM737, :"UTF-8", :IBM866]]
  @paths["[IBM737, IBM869]"] = [[:IBM737, :"UTF-8", :IBM869]]
  @paths["[IBM737, ISO-2022-JP]"] = [[:IBM737, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[IBM737, ISO-2022-JP-KDDI]"] = [[:IBM737, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[IBM737, ISO-8859-1]"] = [[:IBM737, :"UTF-8", :"ISO-8859-1"]]
  @paths["[IBM737, ISO-8859-10]"] = [[:IBM737, :"UTF-8", :"ISO-8859-10"]]
  @paths["[IBM737, ISO-8859-11]"] = [[:IBM737, :"UTF-8", :"ISO-8859-11"]]
  @paths["[IBM737, ISO-8859-13]"] = [[:IBM737, :"UTF-8", :"ISO-8859-13"]]
  @paths["[IBM737, ISO-8859-14]"] = [[:IBM737, :"UTF-8", :"ISO-8859-14"]]
  @paths["[IBM737, ISO-8859-15]"] = [[:IBM737, :"UTF-8", :"ISO-8859-15"]]
  @paths["[IBM737, ISO-8859-2]"] = [[:IBM737, :"UTF-8", :"ISO-8859-2"]]
  @paths["[IBM737, ISO-8859-3]"] = [[:IBM737, :"UTF-8", :"ISO-8859-3"]]
  @paths["[IBM737, ISO-8859-4]"] = [[:IBM737, :"UTF-8", :"ISO-8859-4"]]
  @paths["[IBM737, ISO-8859-5]"] = [[:IBM737, :"UTF-8", :"ISO-8859-5"]]
  @paths["[IBM737, ISO-8859-6]"] = [[:IBM737, :"UTF-8", :"ISO-8859-6"]]
  @paths["[IBM737, ISO-8859-7]"] = [[:IBM737, :"UTF-8", :"ISO-8859-7"]]
  @paths["[IBM737, ISO-8859-8]"] = [[:IBM737, :"UTF-8", :"ISO-8859-8"]]
  @paths["[IBM737, ISO-8859-9]"] = [[:IBM737, :"UTF-8", :"ISO-8859-9"]]
  @paths["[IBM737, KOI8-R]"] = [[:IBM737, :"UTF-8", :"KOI8-R"]]
  @paths["[IBM737, KOI8-U]"] = [[:IBM737, :"UTF-8", :"KOI8-U"]]
  @paths["[IBM737, MACCROATIAN]"] = [[:IBM737, :"UTF-8", :MACCROATIAN]]
  @paths["[IBM737, MACCYRILLIC]"] = [[:IBM737, :"UTF-8", :MACCYRILLIC]]
  @paths["[IBM737, MACGREEK]"] = [[:IBM737, :"UTF-8", :MACGREEK]]
  @paths["[IBM737, MACICELAND]"] = [[:IBM737, :"UTF-8", :MACICELAND]]
  @paths["[IBM737, MACROMAN]"] = [[:IBM737, :"UTF-8", :MACROMAN]]
  @paths["[IBM737, MACROMANIA]"] = [[:IBM737, :"UTF-8", :MACROMANIA]]
  @paths["[IBM737, MACTURKISH]"] = [[:IBM737, :"UTF-8", :MACTURKISH]]
  @paths["[IBM737, MACUKRAINE]"] = [[:IBM737, :"UTF-8", :MACUKRAINE]]
  @paths["[IBM737, SHIFT_JIS]"] = [[:IBM737, :"UTF-8", :SHIFT_JIS]]
  @paths["[IBM737, SJIS-DOCOMO]"] = [[:IBM737, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[IBM737, SJIS-KDDI]"] = [[:IBM737, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[IBM737, SJIS-SOFTBANK]"] = [[:IBM737, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[IBM737, STATELESS-ISO-2022-JP]"] = [[:IBM737, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[IBM737, STATELESS-ISO-2022-JP-KDDI]"] = [[:IBM737, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[IBM737, TIS-620]"] = [[:IBM737, :"UTF-8", :"TIS-620"]]
  @paths["[IBM737, US-ASCII]"] = [[:IBM737, :"UTF-8", :"US-ASCII"]]
  @paths["[IBM737, UTF-16]"] = [[:IBM737, :"UTF-8", :"UTF-16"]]
  @paths["[IBM737, UTF-16BE]"] = [[:IBM737, :"UTF-8", :"UTF-16BE"]]
  @paths["[IBM737, UTF-16LE]"] = [[:IBM737, :"UTF-8", :"UTF-16LE"]]
  @paths["[IBM737, UTF-32]"] = [[:IBM737, :"UTF-8", :"UTF-32"]]
  @paths["[IBM737, UTF-32BE]"] = [[:IBM737, :"UTF-8", :"UTF-32BE"]]
  @paths["[IBM737, UTF-32LE]"] = [[:IBM737, :"UTF-8", :"UTF-32LE"]]
  @paths["[IBM737, UTF-8]"] = [[:IBM737, :"UTF-8"]]
  @paths["[IBM737, UTF8-DOCOMO]"] = [[:IBM737, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[IBM737, UTF8-KDDI]"] = [[:IBM737, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[IBM737, UTF8-MAC]"] = [[:IBM737, :"UTF-8", :"UTF8-MAC"]]
  @paths["[IBM737, UTF8-SOFTBANK]"] = [[:IBM737, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[IBM737, WINDOWS-1250]"] = [[:IBM737, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[IBM737, WINDOWS-1251]"] = [[:IBM737, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[IBM737, WINDOWS-1252]"] = [[:IBM737, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[IBM737, WINDOWS-1253]"] = [[:IBM737, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[IBM737, WINDOWS-1254]"] = [[:IBM737, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[IBM737, WINDOWS-1255]"] = [[:IBM737, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[IBM737, WINDOWS-1256]"] = [[:IBM737, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[IBM737, WINDOWS-1257]"] = [[:IBM737, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[IBM737, WINDOWS-31J]"] = [[:IBM737, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[IBM737, WINDOWS-874]"] = [[:IBM737, :"UTF-8", :"WINDOWS-874"]]
  @paths["[IBM775, ASCII-8BIT]"] = [[:IBM775, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[IBM775, BIG5]"] = [[:IBM775, :"UTF-8", :BIG5]]
  @paths["[IBM775, BIG5-HKSCS]"] = [[:IBM775, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[IBM775, BIG5-UAO]"] = [[:IBM775, :"UTF-8", :"BIG5-UAO"]]
  @paths["[IBM775, CP50220]"] = [[:IBM775, :"UTF-8", :CP51932, :CP50220]]
  @paths["[IBM775, CP50221]"] = [[:IBM775, :"UTF-8", :CP51932, :CP50221]]
  @paths["[IBM775, CP51932]"] = [[:IBM775, :"UTF-8", :CP51932]]
  @paths["[IBM775, CP850]"] = [[:IBM775, :"UTF-8", :CP850]]
  @paths["[IBM775, CP852]"] = [[:IBM775, :"UTF-8", :CP852]]
  @paths["[IBM775, CP855]"] = [[:IBM775, :"UTF-8", :CP855]]
  @paths["[IBM775, CP949]"] = [[:IBM775, :"UTF-8", :CP949]]
  @paths["[IBM775, CP950]"] = [[:IBM775, :"UTF-8", :CP950]]
  @paths["[IBM775, CP951]"] = [[:IBM775, :"UTF-8", :CP951]]
  @paths["[IBM775, EUC-JP]"] = [[:IBM775, :"UTF-8", :"EUC-JP"]]
  @paths["[IBM775, EUC-KR]"] = [[:IBM775, :"UTF-8", :"EUC-KR"]]
  @paths["[IBM775, EUCJP-MS]"] = [[:IBM775, :"UTF-8", :"EUCJP-MS"]]
  @paths["[IBM775, GB12345]"] = [[:IBM775, :"UTF-8", :GB12345]]
  @paths["[IBM775, GB18030]"] = [[:IBM775, :"UTF-8", :GB18030]]
  @paths["[IBM775, GB2312]"] = [[:IBM775, :"UTF-8", :GB2312]]
  @paths["[IBM775, GBK]"] = [[:IBM775, :"UTF-8", :GBK]]
  @paths["[IBM775, IBM437]"] = [[:IBM775, :"UTF-8", :IBM437]]
  @paths["[IBM775, IBM737]"] = [[:IBM775, :"UTF-8", :IBM737]]
  @paths["[IBM775, IBM852]"] = [[:IBM775, :"UTF-8", :IBM852]]
  @paths["[IBM775, IBM855]"] = [[:IBM775, :"UTF-8", :IBM855]]
  @paths["[IBM775, IBM857]"] = [[:IBM775, :"UTF-8", :IBM857]]
  @paths["[IBM775, IBM860]"] = [[:IBM775, :"UTF-8", :IBM860]]
  @paths["[IBM775, IBM861]"] = [[:IBM775, :"UTF-8", :IBM861]]
  @paths["[IBM775, IBM862]"] = [[:IBM775, :"UTF-8", :IBM862]]
  @paths["[IBM775, IBM863]"] = [[:IBM775, :"UTF-8", :IBM863]]
  @paths["[IBM775, IBM865]"] = [[:IBM775, :"UTF-8", :IBM865]]
  @paths["[IBM775, IBM866]"] = [[:IBM775, :"UTF-8", :IBM866]]
  @paths["[IBM775, IBM869]"] = [[:IBM775, :"UTF-8", :IBM869]]
  @paths["[IBM775, ISO-2022-JP]"] = [[:IBM775, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[IBM775, ISO-2022-JP-KDDI]"] = [[:IBM775, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[IBM775, ISO-8859-1]"] = [[:IBM775, :"UTF-8", :"ISO-8859-1"]]
  @paths["[IBM775, ISO-8859-10]"] = [[:IBM775, :"UTF-8", :"ISO-8859-10"]]
  @paths["[IBM775, ISO-8859-11]"] = [[:IBM775, :"UTF-8", :"ISO-8859-11"]]
  @paths["[IBM775, ISO-8859-13]"] = [[:IBM775, :"UTF-8", :"ISO-8859-13"]]
  @paths["[IBM775, ISO-8859-14]"] = [[:IBM775, :"UTF-8", :"ISO-8859-14"]]
  @paths["[IBM775, ISO-8859-15]"] = [[:IBM775, :"UTF-8", :"ISO-8859-15"]]
  @paths["[IBM775, ISO-8859-2]"] = [[:IBM775, :"UTF-8", :"ISO-8859-2"]]
  @paths["[IBM775, ISO-8859-3]"] = [[:IBM775, :"UTF-8", :"ISO-8859-3"]]
  @paths["[IBM775, ISO-8859-4]"] = [[:IBM775, :"UTF-8", :"ISO-8859-4"]]
  @paths["[IBM775, ISO-8859-5]"] = [[:IBM775, :"UTF-8", :"ISO-8859-5"]]
  @paths["[IBM775, ISO-8859-6]"] = [[:IBM775, :"UTF-8", :"ISO-8859-6"]]
  @paths["[IBM775, ISO-8859-7]"] = [[:IBM775, :"UTF-8", :"ISO-8859-7"]]
  @paths["[IBM775, ISO-8859-8]"] = [[:IBM775, :"UTF-8", :"ISO-8859-8"]]
  @paths["[IBM775, ISO-8859-9]"] = [[:IBM775, :"UTF-8", :"ISO-8859-9"]]
  @paths["[IBM775, KOI8-R]"] = [[:IBM775, :"UTF-8", :"KOI8-R"]]
  @paths["[IBM775, KOI8-U]"] = [[:IBM775, :"UTF-8", :"KOI8-U"]]
  @paths["[IBM775, MACCROATIAN]"] = [[:IBM775, :"UTF-8", :MACCROATIAN]]
  @paths["[IBM775, MACCYRILLIC]"] = [[:IBM775, :"UTF-8", :MACCYRILLIC]]
  @paths["[IBM775, MACGREEK]"] = [[:IBM775, :"UTF-8", :MACGREEK]]
  @paths["[IBM775, MACICELAND]"] = [[:IBM775, :"UTF-8", :MACICELAND]]
  @paths["[IBM775, MACROMAN]"] = [[:IBM775, :"UTF-8", :MACROMAN]]
  @paths["[IBM775, MACROMANIA]"] = [[:IBM775, :"UTF-8", :MACROMANIA]]
  @paths["[IBM775, MACTURKISH]"] = [[:IBM775, :"UTF-8", :MACTURKISH]]
  @paths["[IBM775, MACUKRAINE]"] = [[:IBM775, :"UTF-8", :MACUKRAINE]]
  @paths["[IBM775, SHIFT_JIS]"] = [[:IBM775, :"UTF-8", :SHIFT_JIS]]
  @paths["[IBM775, SJIS-DOCOMO]"] = [[:IBM775, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[IBM775, SJIS-KDDI]"] = [[:IBM775, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[IBM775, SJIS-SOFTBANK]"] = [[:IBM775, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[IBM775, STATELESS-ISO-2022-JP]"] = [[:IBM775, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[IBM775, STATELESS-ISO-2022-JP-KDDI]"] = [[:IBM775, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[IBM775, TIS-620]"] = [[:IBM775, :"UTF-8", :"TIS-620"]]
  @paths["[IBM775, US-ASCII]"] = [[:IBM775, :"UTF-8", :"US-ASCII"]]
  @paths["[IBM775, UTF-16]"] = [[:IBM775, :"UTF-8", :"UTF-16"]]
  @paths["[IBM775, UTF-16BE]"] = [[:IBM775, :"UTF-8", :"UTF-16BE"]]
  @paths["[IBM775, UTF-16LE]"] = [[:IBM775, :"UTF-8", :"UTF-16LE"]]
  @paths["[IBM775, UTF-32]"] = [[:IBM775, :"UTF-8", :"UTF-32"]]
  @paths["[IBM775, UTF-32BE]"] = [[:IBM775, :"UTF-8", :"UTF-32BE"]]
  @paths["[IBM775, UTF-32LE]"] = [[:IBM775, :"UTF-8", :"UTF-32LE"]]
  @paths["[IBM775, UTF-8]"] = [[:IBM775, :"UTF-8"]]
  @paths["[IBM775, UTF8-DOCOMO]"] = [[:IBM775, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[IBM775, UTF8-KDDI]"] = [[:IBM775, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[IBM775, UTF8-MAC]"] = [[:IBM775, :"UTF-8", :"UTF8-MAC"]]
  @paths["[IBM775, UTF8-SOFTBANK]"] = [[:IBM775, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[IBM775, WINDOWS-1250]"] = [[:IBM775, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[IBM775, WINDOWS-1251]"] = [[:IBM775, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[IBM775, WINDOWS-1252]"] = [[:IBM775, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[IBM775, WINDOWS-1253]"] = [[:IBM775, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[IBM775, WINDOWS-1254]"] = [[:IBM775, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[IBM775, WINDOWS-1255]"] = [[:IBM775, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[IBM775, WINDOWS-1256]"] = [[:IBM775, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[IBM775, WINDOWS-1257]"] = [[:IBM775, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[IBM775, WINDOWS-31J]"] = [[:IBM775, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[IBM775, WINDOWS-874]"] = [[:IBM775, :"UTF-8", :"WINDOWS-874"]]
  @paths["[IBM852, ASCII-8BIT]"] = [[:IBM852, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[IBM852, BIG5]"] = [[:IBM852, :"UTF-8", :BIG5]]
  @paths["[IBM852, BIG5-HKSCS]"] = [[:IBM852, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[IBM852, BIG5-UAO]"] = [[:IBM852, :"UTF-8", :"BIG5-UAO"]]
  @paths["[IBM852, CP50220]"] = [[:IBM852, :"UTF-8", :CP51932, :CP50220]]
  @paths["[IBM852, CP50221]"] = [[:IBM852, :"UTF-8", :CP51932, :CP50221]]
  @paths["[IBM852, CP51932]"] = [[:IBM852, :"UTF-8", :CP51932]]
  @paths["[IBM852, CP850]"] = [[:IBM852, :"UTF-8", :CP850]]
  @paths["[IBM852, CP852]"] = [[:IBM852, :"UTF-8", :CP852]]
  @paths["[IBM852, CP855]"] = [[:IBM852, :"UTF-8", :CP855]]
  @paths["[IBM852, CP949]"] = [[:IBM852, :"UTF-8", :CP949]]
  @paths["[IBM852, CP950]"] = [[:IBM852, :"UTF-8", :CP950]]
  @paths["[IBM852, CP951]"] = [[:IBM852, :"UTF-8", :CP951]]
  @paths["[IBM852, EUC-JP]"] = [[:IBM852, :"UTF-8", :"EUC-JP"]]
  @paths["[IBM852, EUC-KR]"] = [[:IBM852, :"UTF-8", :"EUC-KR"]]
  @paths["[IBM852, EUCJP-MS]"] = [[:IBM852, :"UTF-8", :"EUCJP-MS"]]
  @paths["[IBM852, GB12345]"] = [[:IBM852, :"UTF-8", :GB12345]]
  @paths["[IBM852, GB18030]"] = [[:IBM852, :"UTF-8", :GB18030]]
  @paths["[IBM852, GB2312]"] = [[:IBM852, :"UTF-8", :GB2312]]
  @paths["[IBM852, GBK]"] = [[:IBM852, :"UTF-8", :GBK]]
  @paths["[IBM852, IBM437]"] = [[:IBM852, :"UTF-8", :IBM437]]
  @paths["[IBM852, IBM737]"] = [[:IBM852, :"UTF-8", :IBM737]]
  @paths["[IBM852, IBM775]"] = [[:IBM852, :"UTF-8", :IBM775]]
  @paths["[IBM852, IBM855]"] = [[:IBM852, :"UTF-8", :IBM855]]
  @paths["[IBM852, IBM857]"] = [[:IBM852, :"UTF-8", :IBM857]]
  @paths["[IBM852, IBM860]"] = [[:IBM852, :"UTF-8", :IBM860]]
  @paths["[IBM852, IBM861]"] = [[:IBM852, :"UTF-8", :IBM861]]
  @paths["[IBM852, IBM862]"] = [[:IBM852, :"UTF-8", :IBM862]]
  @paths["[IBM852, IBM863]"] = [[:IBM852, :"UTF-8", :IBM863]]
  @paths["[IBM852, IBM865]"] = [[:IBM852, :"UTF-8", :IBM865]]
  @paths["[IBM852, IBM866]"] = [[:IBM852, :"UTF-8", :IBM866]]
  @paths["[IBM852, IBM869]"] = [[:IBM852, :"UTF-8", :IBM869]]
  @paths["[IBM852, ISO-2022-JP]"] = [[:IBM852, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[IBM852, ISO-2022-JP-KDDI]"] = [[:IBM852, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[IBM852, ISO-8859-1]"] = [[:IBM852, :"UTF-8", :"ISO-8859-1"]]
  @paths["[IBM852, ISO-8859-10]"] = [[:IBM852, :"UTF-8", :"ISO-8859-10"]]
  @paths["[IBM852, ISO-8859-11]"] = [[:IBM852, :"UTF-8", :"ISO-8859-11"]]
  @paths["[IBM852, ISO-8859-13]"] = [[:IBM852, :"UTF-8", :"ISO-8859-13"]]
  @paths["[IBM852, ISO-8859-14]"] = [[:IBM852, :"UTF-8", :"ISO-8859-14"]]
  @paths["[IBM852, ISO-8859-15]"] = [[:IBM852, :"UTF-8", :"ISO-8859-15"]]
  @paths["[IBM852, ISO-8859-2]"] = [[:IBM852, :"UTF-8", :"ISO-8859-2"]]
  @paths["[IBM852, ISO-8859-3]"] = [[:IBM852, :"UTF-8", :"ISO-8859-3"]]
  @paths["[IBM852, ISO-8859-4]"] = [[:IBM852, :"UTF-8", :"ISO-8859-4"]]
  @paths["[IBM852, ISO-8859-5]"] = [[:IBM852, :"UTF-8", :"ISO-8859-5"]]
  @paths["[IBM852, ISO-8859-6]"] = [[:IBM852, :"UTF-8", :"ISO-8859-6"]]
  @paths["[IBM852, ISO-8859-7]"] = [[:IBM852, :"UTF-8", :"ISO-8859-7"]]
  @paths["[IBM852, ISO-8859-8]"] = [[:IBM852, :"UTF-8", :"ISO-8859-8"]]
  @paths["[IBM852, ISO-8859-9]"] = [[:IBM852, :"UTF-8", :"ISO-8859-9"]]
  @paths["[IBM852, KOI8-R]"] = [[:IBM852, :"UTF-8", :"KOI8-R"]]
  @paths["[IBM852, KOI8-U]"] = [[:IBM852, :"UTF-8", :"KOI8-U"]]
  @paths["[IBM852, MACCROATIAN]"] = [[:IBM852, :"UTF-8", :MACCROATIAN]]
  @paths["[IBM852, MACCYRILLIC]"] = [[:IBM852, :"UTF-8", :MACCYRILLIC]]
  @paths["[IBM852, MACGREEK]"] = [[:IBM852, :"UTF-8", :MACGREEK]]
  @paths["[IBM852, MACICELAND]"] = [[:IBM852, :"UTF-8", :MACICELAND]]
  @paths["[IBM852, MACROMAN]"] = [[:IBM852, :"UTF-8", :MACROMAN]]
  @paths["[IBM852, MACROMANIA]"] = [[:IBM852, :"UTF-8", :MACROMANIA]]
  @paths["[IBM852, MACTURKISH]"] = [[:IBM852, :"UTF-8", :MACTURKISH]]
  @paths["[IBM852, MACUKRAINE]"] = [[:IBM852, :"UTF-8", :MACUKRAINE]]
  @paths["[IBM852, SHIFT_JIS]"] = [[:IBM852, :"UTF-8", :SHIFT_JIS]]
  @paths["[IBM852, SJIS-DOCOMO]"] = [[:IBM852, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[IBM852, SJIS-KDDI]"] = [[:IBM852, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[IBM852, SJIS-SOFTBANK]"] = [[:IBM852, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[IBM852, STATELESS-ISO-2022-JP]"] = [[:IBM852, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[IBM852, STATELESS-ISO-2022-JP-KDDI]"] = [[:IBM852, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[IBM852, TIS-620]"] = [[:IBM852, :"UTF-8", :"TIS-620"]]
  @paths["[IBM852, US-ASCII]"] = [[:IBM852, :"UTF-8", :"US-ASCII"]]
  @paths["[IBM852, UTF-16]"] = [[:IBM852, :"UTF-8", :"UTF-16"]]
  @paths["[IBM852, UTF-16BE]"] = [[:IBM852, :"UTF-8", :"UTF-16BE"]]
  @paths["[IBM852, UTF-16LE]"] = [[:IBM852, :"UTF-8", :"UTF-16LE"]]
  @paths["[IBM852, UTF-32]"] = [[:IBM852, :"UTF-8", :"UTF-32"]]
  @paths["[IBM852, UTF-32BE]"] = [[:IBM852, :"UTF-8", :"UTF-32BE"]]
  @paths["[IBM852, UTF-32LE]"] = [[:IBM852, :"UTF-8", :"UTF-32LE"]]
  @paths["[IBM852, UTF-8]"] = [[:IBM852, :"UTF-8"]]
  @paths["[IBM852, UTF8-DOCOMO]"] = [[:IBM852, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[IBM852, UTF8-KDDI]"] = [[:IBM852, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[IBM852, UTF8-MAC]"] = [[:IBM852, :"UTF-8", :"UTF8-MAC"]]
  @paths["[IBM852, UTF8-SOFTBANK]"] = [[:IBM852, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[IBM852, WINDOWS-1250]"] = [[:IBM852, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[IBM852, WINDOWS-1251]"] = [[:IBM852, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[IBM852, WINDOWS-1252]"] = [[:IBM852, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[IBM852, WINDOWS-1253]"] = [[:IBM852, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[IBM852, WINDOWS-1254]"] = [[:IBM852, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[IBM852, WINDOWS-1255]"] = [[:IBM852, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[IBM852, WINDOWS-1256]"] = [[:IBM852, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[IBM852, WINDOWS-1257]"] = [[:IBM852, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[IBM852, WINDOWS-31J]"] = [[:IBM852, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[IBM852, WINDOWS-874]"] = [[:IBM852, :"UTF-8", :"WINDOWS-874"]]
  @paths["[IBM855, ASCII-8BIT]"] = [[:IBM855, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[IBM855, BIG5]"] = [[:IBM855, :"UTF-8", :BIG5]]
  @paths["[IBM855, BIG5-HKSCS]"] = [[:IBM855, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[IBM855, BIG5-UAO]"] = [[:IBM855, :"UTF-8", :"BIG5-UAO"]]
  @paths["[IBM855, CP50220]"] = [[:IBM855, :"UTF-8", :CP51932, :CP50220]]
  @paths["[IBM855, CP50221]"] = [[:IBM855, :"UTF-8", :CP51932, :CP50221]]
  @paths["[IBM855, CP51932]"] = [[:IBM855, :"UTF-8", :CP51932]]
  @paths["[IBM855, CP850]"] = [[:IBM855, :"UTF-8", :CP850]]
  @paths["[IBM855, CP852]"] = [[:IBM855, :"UTF-8", :CP852]]
  @paths["[IBM855, CP855]"] = [[:IBM855, :"UTF-8", :CP855]]
  @paths["[IBM855, CP949]"] = [[:IBM855, :"UTF-8", :CP949]]
  @paths["[IBM855, CP950]"] = [[:IBM855, :"UTF-8", :CP950]]
  @paths["[IBM855, CP951]"] = [[:IBM855, :"UTF-8", :CP951]]
  @paths["[IBM855, EUC-JP]"] = [[:IBM855, :"UTF-8", :"EUC-JP"]]
  @paths["[IBM855, EUC-KR]"] = [[:IBM855, :"UTF-8", :"EUC-KR"]]
  @paths["[IBM855, EUCJP-MS]"] = [[:IBM855, :"UTF-8", :"EUCJP-MS"]]
  @paths["[IBM855, GB12345]"] = [[:IBM855, :"UTF-8", :GB12345]]
  @paths["[IBM855, GB18030]"] = [[:IBM855, :"UTF-8", :GB18030]]
  @paths["[IBM855, GB2312]"] = [[:IBM855, :"UTF-8", :GB2312]]
  @paths["[IBM855, GBK]"] = [[:IBM855, :"UTF-8", :GBK]]
  @paths["[IBM855, IBM437]"] = [[:IBM855, :"UTF-8", :IBM437]]
  @paths["[IBM855, IBM737]"] = [[:IBM855, :"UTF-8", :IBM737]]
  @paths["[IBM855, IBM775]"] = [[:IBM855, :"UTF-8", :IBM775]]
  @paths["[IBM855, IBM852]"] = [[:IBM855, :"UTF-8", :IBM852]]
  @paths["[IBM855, IBM857]"] = [[:IBM855, :"UTF-8", :IBM857]]
  @paths["[IBM855, IBM860]"] = [[:IBM855, :"UTF-8", :IBM860]]
  @paths["[IBM855, IBM861]"] = [[:IBM855, :"UTF-8", :IBM861]]
  @paths["[IBM855, IBM862]"] = [[:IBM855, :"UTF-8", :IBM862]]
  @paths["[IBM855, IBM863]"] = [[:IBM855, :"UTF-8", :IBM863]]
  @paths["[IBM855, IBM865]"] = [[:IBM855, :"UTF-8", :IBM865]]
  @paths["[IBM855, IBM866]"] = [[:IBM855, :"UTF-8", :IBM866]]
  @paths["[IBM855, IBM869]"] = [[:IBM855, :"UTF-8", :IBM869]]
  @paths["[IBM855, ISO-2022-JP]"] = [[:IBM855, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[IBM855, ISO-2022-JP-KDDI]"] = [[:IBM855, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[IBM855, ISO-8859-1]"] = [[:IBM855, :"UTF-8", :"ISO-8859-1"]]
  @paths["[IBM855, ISO-8859-10]"] = [[:IBM855, :"UTF-8", :"ISO-8859-10"]]
  @paths["[IBM855, ISO-8859-11]"] = [[:IBM855, :"UTF-8", :"ISO-8859-11"]]
  @paths["[IBM855, ISO-8859-13]"] = [[:IBM855, :"UTF-8", :"ISO-8859-13"]]
  @paths["[IBM855, ISO-8859-14]"] = [[:IBM855, :"UTF-8", :"ISO-8859-14"]]
  @paths["[IBM855, ISO-8859-15]"] = [[:IBM855, :"UTF-8", :"ISO-8859-15"]]
  @paths["[IBM855, ISO-8859-2]"] = [[:IBM855, :"UTF-8", :"ISO-8859-2"]]
  @paths["[IBM855, ISO-8859-3]"] = [[:IBM855, :"UTF-8", :"ISO-8859-3"]]
  @paths["[IBM855, ISO-8859-4]"] = [[:IBM855, :"UTF-8", :"ISO-8859-4"]]
  @paths["[IBM855, ISO-8859-5]"] = [[:IBM855, :"UTF-8", :"ISO-8859-5"]]
  @paths["[IBM855, ISO-8859-6]"] = [[:IBM855, :"UTF-8", :"ISO-8859-6"]]
  @paths["[IBM855, ISO-8859-7]"] = [[:IBM855, :"UTF-8", :"ISO-8859-7"]]
  @paths["[IBM855, ISO-8859-8]"] = [[:IBM855, :"UTF-8", :"ISO-8859-8"]]
  @paths["[IBM855, ISO-8859-9]"] = [[:IBM855, :"UTF-8", :"ISO-8859-9"]]
  @paths["[IBM855, KOI8-R]"] = [[:IBM855, :"UTF-8", :"KOI8-R"]]
  @paths["[IBM855, KOI8-U]"] = [[:IBM855, :"UTF-8", :"KOI8-U"]]
  @paths["[IBM855, MACCROATIAN]"] = [[:IBM855, :"UTF-8", :MACCROATIAN]]
  @paths["[IBM855, MACCYRILLIC]"] = [[:IBM855, :"UTF-8", :MACCYRILLIC]]
  @paths["[IBM855, MACGREEK]"] = [[:IBM855, :"UTF-8", :MACGREEK]]
  @paths["[IBM855, MACICELAND]"] = [[:IBM855, :"UTF-8", :MACICELAND]]
  @paths["[IBM855, MACROMAN]"] = [[:IBM855, :"UTF-8", :MACROMAN]]
  @paths["[IBM855, MACROMANIA]"] = [[:IBM855, :"UTF-8", :MACROMANIA]]
  @paths["[IBM855, MACTURKISH]"] = [[:IBM855, :"UTF-8", :MACTURKISH]]
  @paths["[IBM855, MACUKRAINE]"] = [[:IBM855, :"UTF-8", :MACUKRAINE]]
  @paths["[IBM855, SHIFT_JIS]"] = [[:IBM855, :"UTF-8", :SHIFT_JIS]]
  @paths["[IBM855, SJIS-DOCOMO]"] = [[:IBM855, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[IBM855, SJIS-KDDI]"] = [[:IBM855, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[IBM855, SJIS-SOFTBANK]"] = [[:IBM855, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[IBM855, STATELESS-ISO-2022-JP]"] = [[:IBM855, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[IBM855, STATELESS-ISO-2022-JP-KDDI]"] = [[:IBM855, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[IBM855, TIS-620]"] = [[:IBM855, :"UTF-8", :"TIS-620"]]
  @paths["[IBM855, US-ASCII]"] = [[:IBM855, :"UTF-8", :"US-ASCII"]]
  @paths["[IBM855, UTF-16]"] = [[:IBM855, :"UTF-8", :"UTF-16"]]
  @paths["[IBM855, UTF-16BE]"] = [[:IBM855, :"UTF-8", :"UTF-16BE"]]
  @paths["[IBM855, UTF-16LE]"] = [[:IBM855, :"UTF-8", :"UTF-16LE"]]
  @paths["[IBM855, UTF-32]"] = [[:IBM855, :"UTF-8", :"UTF-32"]]
  @paths["[IBM855, UTF-32BE]"] = [[:IBM855, :"UTF-8", :"UTF-32BE"]]
  @paths["[IBM855, UTF-32LE]"] = [[:IBM855, :"UTF-8", :"UTF-32LE"]]
  @paths["[IBM855, UTF-8]"] = [[:IBM855, :"UTF-8"]]
  @paths["[IBM855, UTF8-DOCOMO]"] = [[:IBM855, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[IBM855, UTF8-KDDI]"] = [[:IBM855, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[IBM855, UTF8-MAC]"] = [[:IBM855, :"UTF-8", :"UTF8-MAC"]]
  @paths["[IBM855, UTF8-SOFTBANK]"] = [[:IBM855, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[IBM855, WINDOWS-1250]"] = [[:IBM855, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[IBM855, WINDOWS-1251]"] = [[:IBM855, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[IBM855, WINDOWS-1252]"] = [[:IBM855, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[IBM855, WINDOWS-1253]"] = [[:IBM855, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[IBM855, WINDOWS-1254]"] = [[:IBM855, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[IBM855, WINDOWS-1255]"] = [[:IBM855, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[IBM855, WINDOWS-1256]"] = [[:IBM855, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[IBM855, WINDOWS-1257]"] = [[:IBM855, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[IBM855, WINDOWS-31J]"] = [[:IBM855, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[IBM855, WINDOWS-874]"] = [[:IBM855, :"UTF-8", :"WINDOWS-874"]]
  @paths["[IBM857, ASCII-8BIT]"] = [[:IBM857, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[IBM857, BIG5]"] = [[:IBM857, :"UTF-8", :BIG5]]
  @paths["[IBM857, BIG5-HKSCS]"] = [[:IBM857, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[IBM857, BIG5-UAO]"] = [[:IBM857, :"UTF-8", :"BIG5-UAO"]]
  @paths["[IBM857, CP50220]"] = [[:IBM857, :"UTF-8", :CP51932, :CP50220]]
  @paths["[IBM857, CP50221]"] = [[:IBM857, :"UTF-8", :CP51932, :CP50221]]
  @paths["[IBM857, CP51932]"] = [[:IBM857, :"UTF-8", :CP51932]]
  @paths["[IBM857, CP850]"] = [[:IBM857, :"UTF-8", :CP850]]
  @paths["[IBM857, CP852]"] = [[:IBM857, :"UTF-8", :CP852]]
  @paths["[IBM857, CP855]"] = [[:IBM857, :"UTF-8", :CP855]]
  @paths["[IBM857, CP949]"] = [[:IBM857, :"UTF-8", :CP949]]
  @paths["[IBM857, CP950]"] = [[:IBM857, :"UTF-8", :CP950]]
  @paths["[IBM857, CP951]"] = [[:IBM857, :"UTF-8", :CP951]]
  @paths["[IBM857, EUC-JP]"] = [[:IBM857, :"UTF-8", :"EUC-JP"]]
  @paths["[IBM857, EUC-KR]"] = [[:IBM857, :"UTF-8", :"EUC-KR"]]
  @paths["[IBM857, EUCJP-MS]"] = [[:IBM857, :"UTF-8", :"EUCJP-MS"]]
  @paths["[IBM857, GB12345]"] = [[:IBM857, :"UTF-8", :GB12345]]
  @paths["[IBM857, GB18030]"] = [[:IBM857, :"UTF-8", :GB18030]]
  @paths["[IBM857, GB2312]"] = [[:IBM857, :"UTF-8", :GB2312]]
  @paths["[IBM857, GBK]"] = [[:IBM857, :"UTF-8", :GBK]]
  @paths["[IBM857, IBM437]"] = [[:IBM857, :"UTF-8", :IBM437]]
  @paths["[IBM857, IBM737]"] = [[:IBM857, :"UTF-8", :IBM737]]
  @paths["[IBM857, IBM775]"] = [[:IBM857, :"UTF-8", :IBM775]]
  @paths["[IBM857, IBM852]"] = [[:IBM857, :"UTF-8", :IBM852]]
  @paths["[IBM857, IBM855]"] = [[:IBM857, :"UTF-8", :IBM855]]
  @paths["[IBM857, IBM860]"] = [[:IBM857, :"UTF-8", :IBM860]]
  @paths["[IBM857, IBM861]"] = [[:IBM857, :"UTF-8", :IBM861]]
  @paths["[IBM857, IBM862]"] = [[:IBM857, :"UTF-8", :IBM862]]
  @paths["[IBM857, IBM863]"] = [[:IBM857, :"UTF-8", :IBM863]]
  @paths["[IBM857, IBM865]"] = [[:IBM857, :"UTF-8", :IBM865]]
  @paths["[IBM857, IBM866]"] = [[:IBM857, :"UTF-8", :IBM866]]
  @paths["[IBM857, IBM869]"] = [[:IBM857, :"UTF-8", :IBM869]]
  @paths["[IBM857, ISO-2022-JP]"] = [[:IBM857, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[IBM857, ISO-2022-JP-KDDI]"] = [[:IBM857, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[IBM857, ISO-8859-1]"] = [[:IBM857, :"UTF-8", :"ISO-8859-1"]]
  @paths["[IBM857, ISO-8859-10]"] = [[:IBM857, :"UTF-8", :"ISO-8859-10"]]
  @paths["[IBM857, ISO-8859-11]"] = [[:IBM857, :"UTF-8", :"ISO-8859-11"]]
  @paths["[IBM857, ISO-8859-13]"] = [[:IBM857, :"UTF-8", :"ISO-8859-13"]]
  @paths["[IBM857, ISO-8859-14]"] = [[:IBM857, :"UTF-8", :"ISO-8859-14"]]
  @paths["[IBM857, ISO-8859-15]"] = [[:IBM857, :"UTF-8", :"ISO-8859-15"]]
  @paths["[IBM857, ISO-8859-2]"] = [[:IBM857, :"UTF-8", :"ISO-8859-2"]]
  @paths["[IBM857, ISO-8859-3]"] = [[:IBM857, :"UTF-8", :"ISO-8859-3"]]
  @paths["[IBM857, ISO-8859-4]"] = [[:IBM857, :"UTF-8", :"ISO-8859-4"]]
  @paths["[IBM857, ISO-8859-5]"] = [[:IBM857, :"UTF-8", :"ISO-8859-5"]]
  @paths["[IBM857, ISO-8859-6]"] = [[:IBM857, :"UTF-8", :"ISO-8859-6"]]
  @paths["[IBM857, ISO-8859-7]"] = [[:IBM857, :"UTF-8", :"ISO-8859-7"]]
  @paths["[IBM857, ISO-8859-8]"] = [[:IBM857, :"UTF-8", :"ISO-8859-8"]]
  @paths["[IBM857, ISO-8859-9]"] = [[:IBM857, :"UTF-8", :"ISO-8859-9"]]
  @paths["[IBM857, KOI8-R]"] = [[:IBM857, :"UTF-8", :"KOI8-R"]]
  @paths["[IBM857, KOI8-U]"] = [[:IBM857, :"UTF-8", :"KOI8-U"]]
  @paths["[IBM857, MACCROATIAN]"] = [[:IBM857, :"UTF-8", :MACCROATIAN]]
  @paths["[IBM857, MACCYRILLIC]"] = [[:IBM857, :"UTF-8", :MACCYRILLIC]]
  @paths["[IBM857, MACGREEK]"] = [[:IBM857, :"UTF-8", :MACGREEK]]
  @paths["[IBM857, MACICELAND]"] = [[:IBM857, :"UTF-8", :MACICELAND]]
  @paths["[IBM857, MACROMAN]"] = [[:IBM857, :"UTF-8", :MACROMAN]]
  @paths["[IBM857, MACROMANIA]"] = [[:IBM857, :"UTF-8", :MACROMANIA]]
  @paths["[IBM857, MACTURKISH]"] = [[:IBM857, :"UTF-8", :MACTURKISH]]
  @paths["[IBM857, MACUKRAINE]"] = [[:IBM857, :"UTF-8", :MACUKRAINE]]
  @paths["[IBM857, SHIFT_JIS]"] = [[:IBM857, :"UTF-8", :SHIFT_JIS]]
  @paths["[IBM857, SJIS-DOCOMO]"] = [[:IBM857, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[IBM857, SJIS-KDDI]"] = [[:IBM857, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[IBM857, SJIS-SOFTBANK]"] = [[:IBM857, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[IBM857, STATELESS-ISO-2022-JP]"] = [[:IBM857, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[IBM857, STATELESS-ISO-2022-JP-KDDI]"] = [[:IBM857, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[IBM857, TIS-620]"] = [[:IBM857, :"UTF-8", :"TIS-620"]]
  @paths["[IBM857, US-ASCII]"] = [[:IBM857, :"UTF-8", :"US-ASCII"]]
  @paths["[IBM857, UTF-16]"] = [[:IBM857, :"UTF-8", :"UTF-16"]]
  @paths["[IBM857, UTF-16BE]"] = [[:IBM857, :"UTF-8", :"UTF-16BE"]]
  @paths["[IBM857, UTF-16LE]"] = [[:IBM857, :"UTF-8", :"UTF-16LE"]]
  @paths["[IBM857, UTF-32]"] = [[:IBM857, :"UTF-8", :"UTF-32"]]
  @paths["[IBM857, UTF-32BE]"] = [[:IBM857, :"UTF-8", :"UTF-32BE"]]
  @paths["[IBM857, UTF-32LE]"] = [[:IBM857, :"UTF-8", :"UTF-32LE"]]
  @paths["[IBM857, UTF-8]"] = [[:IBM857, :"UTF-8"]]
  @paths["[IBM857, UTF8-DOCOMO]"] = [[:IBM857, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[IBM857, UTF8-KDDI]"] = [[:IBM857, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[IBM857, UTF8-MAC]"] = [[:IBM857, :"UTF-8", :"UTF8-MAC"]]
  @paths["[IBM857, UTF8-SOFTBANK]"] = [[:IBM857, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[IBM857, WINDOWS-1250]"] = [[:IBM857, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[IBM857, WINDOWS-1251]"] = [[:IBM857, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[IBM857, WINDOWS-1252]"] = [[:IBM857, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[IBM857, WINDOWS-1253]"] = [[:IBM857, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[IBM857, WINDOWS-1254]"] = [[:IBM857, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[IBM857, WINDOWS-1255]"] = [[:IBM857, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[IBM857, WINDOWS-1256]"] = [[:IBM857, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[IBM857, WINDOWS-1257]"] = [[:IBM857, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[IBM857, WINDOWS-31J]"] = [[:IBM857, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[IBM857, WINDOWS-874]"] = [[:IBM857, :"UTF-8", :"WINDOWS-874"]]
  @paths["[IBM860, ASCII-8BIT]"] = [[:IBM860, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[IBM860, BIG5]"] = [[:IBM860, :"UTF-8", :BIG5]]
  @paths["[IBM860, BIG5-HKSCS]"] = [[:IBM860, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[IBM860, BIG5-UAO]"] = [[:IBM860, :"UTF-8", :"BIG5-UAO"]]
  @paths["[IBM860, CP50220]"] = [[:IBM860, :"UTF-8", :CP51932, :CP50220]]
  @paths["[IBM860, CP50221]"] = [[:IBM860, :"UTF-8", :CP51932, :CP50221]]
  @paths["[IBM860, CP51932]"] = [[:IBM860, :"UTF-8", :CP51932]]
  @paths["[IBM860, CP850]"] = [[:IBM860, :"UTF-8", :CP850]]
  @paths["[IBM860, CP852]"] = [[:IBM860, :"UTF-8", :CP852]]
  @paths["[IBM860, CP855]"] = [[:IBM860, :"UTF-8", :CP855]]
  @paths["[IBM860, CP949]"] = [[:IBM860, :"UTF-8", :CP949]]
  @paths["[IBM860, CP950]"] = [[:IBM860, :"UTF-8", :CP950]]
  @paths["[IBM860, CP951]"] = [[:IBM860, :"UTF-8", :CP951]]
  @paths["[IBM860, EUC-JP]"] = [[:IBM860, :"UTF-8", :"EUC-JP"]]
  @paths["[IBM860, EUC-KR]"] = [[:IBM860, :"UTF-8", :"EUC-KR"]]
  @paths["[IBM860, EUCJP-MS]"] = [[:IBM860, :"UTF-8", :"EUCJP-MS"]]
  @paths["[IBM860, GB12345]"] = [[:IBM860, :"UTF-8", :GB12345]]
  @paths["[IBM860, GB18030]"] = [[:IBM860, :"UTF-8", :GB18030]]
  @paths["[IBM860, GB2312]"] = [[:IBM860, :"UTF-8", :GB2312]]
  @paths["[IBM860, GBK]"] = [[:IBM860, :"UTF-8", :GBK]]
  @paths["[IBM860, IBM437]"] = [[:IBM860, :"UTF-8", :IBM437]]
  @paths["[IBM860, IBM737]"] = [[:IBM860, :"UTF-8", :IBM737]]
  @paths["[IBM860, IBM775]"] = [[:IBM860, :"UTF-8", :IBM775]]
  @paths["[IBM860, IBM852]"] = [[:IBM860, :"UTF-8", :IBM852]]
  @paths["[IBM860, IBM855]"] = [[:IBM860, :"UTF-8", :IBM855]]
  @paths["[IBM860, IBM857]"] = [[:IBM860, :"UTF-8", :IBM857]]
  @paths["[IBM860, IBM861]"] = [[:IBM860, :"UTF-8", :IBM861]]
  @paths["[IBM860, IBM862]"] = [[:IBM860, :"UTF-8", :IBM862]]
  @paths["[IBM860, IBM863]"] = [[:IBM860, :"UTF-8", :IBM863]]
  @paths["[IBM860, IBM865]"] = [[:IBM860, :"UTF-8", :IBM865]]
  @paths["[IBM860, IBM866]"] = [[:IBM860, :"UTF-8", :IBM866]]
  @paths["[IBM860, IBM869]"] = [[:IBM860, :"UTF-8", :IBM869]]
  @paths["[IBM860, ISO-2022-JP]"] = [[:IBM860, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[IBM860, ISO-2022-JP-KDDI]"] = [[:IBM860, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[IBM860, ISO-8859-1]"] = [[:IBM860, :"UTF-8", :"ISO-8859-1"]]
  @paths["[IBM860, ISO-8859-10]"] = [[:IBM860, :"UTF-8", :"ISO-8859-10"]]
  @paths["[IBM860, ISO-8859-11]"] = [[:IBM860, :"UTF-8", :"ISO-8859-11"]]
  @paths["[IBM860, ISO-8859-13]"] = [[:IBM860, :"UTF-8", :"ISO-8859-13"]]
  @paths["[IBM860, ISO-8859-14]"] = [[:IBM860, :"UTF-8", :"ISO-8859-14"]]
  @paths["[IBM860, ISO-8859-15]"] = [[:IBM860, :"UTF-8", :"ISO-8859-15"]]
  @paths["[IBM860, ISO-8859-2]"] = [[:IBM860, :"UTF-8", :"ISO-8859-2"]]
  @paths["[IBM860, ISO-8859-3]"] = [[:IBM860, :"UTF-8", :"ISO-8859-3"]]
  @paths["[IBM860, ISO-8859-4]"] = [[:IBM860, :"UTF-8", :"ISO-8859-4"]]
  @paths["[IBM860, ISO-8859-5]"] = [[:IBM860, :"UTF-8", :"ISO-8859-5"]]
  @paths["[IBM860, ISO-8859-6]"] = [[:IBM860, :"UTF-8", :"ISO-8859-6"]]
  @paths["[IBM860, ISO-8859-7]"] = [[:IBM860, :"UTF-8", :"ISO-8859-7"]]
  @paths["[IBM860, ISO-8859-8]"] = [[:IBM860, :"UTF-8", :"ISO-8859-8"]]
  @paths["[IBM860, ISO-8859-9]"] = [[:IBM860, :"UTF-8", :"ISO-8859-9"]]
  @paths["[IBM860, KOI8-R]"] = [[:IBM860, :"UTF-8", :"KOI8-R"]]
  @paths["[IBM860, KOI8-U]"] = [[:IBM860, :"UTF-8", :"KOI8-U"]]
  @paths["[IBM860, MACCROATIAN]"] = [[:IBM860, :"UTF-8", :MACCROATIAN]]
  @paths["[IBM860, MACCYRILLIC]"] = [[:IBM860, :"UTF-8", :MACCYRILLIC]]
  @paths["[IBM860, MACGREEK]"] = [[:IBM860, :"UTF-8", :MACGREEK]]
  @paths["[IBM860, MACICELAND]"] = [[:IBM860, :"UTF-8", :MACICELAND]]
  @paths["[IBM860, MACROMAN]"] = [[:IBM860, :"UTF-8", :MACROMAN]]
  @paths["[IBM860, MACROMANIA]"] = [[:IBM860, :"UTF-8", :MACROMANIA]]
  @paths["[IBM860, MACTURKISH]"] = [[:IBM860, :"UTF-8", :MACTURKISH]]
  @paths["[IBM860, MACUKRAINE]"] = [[:IBM860, :"UTF-8", :MACUKRAINE]]
  @paths["[IBM860, SHIFT_JIS]"] = [[:IBM860, :"UTF-8", :SHIFT_JIS]]
  @paths["[IBM860, SJIS-DOCOMO]"] = [[:IBM860, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[IBM860, SJIS-KDDI]"] = [[:IBM860, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[IBM860, SJIS-SOFTBANK]"] = [[:IBM860, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[IBM860, STATELESS-ISO-2022-JP]"] = [[:IBM860, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[IBM860, STATELESS-ISO-2022-JP-KDDI]"] = [[:IBM860, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[IBM860, TIS-620]"] = [[:IBM860, :"UTF-8", :"TIS-620"]]
  @paths["[IBM860, US-ASCII]"] = [[:IBM860, :"UTF-8", :"US-ASCII"]]
  @paths["[IBM860, UTF-16]"] = [[:IBM860, :"UTF-8", :"UTF-16"]]
  @paths["[IBM860, UTF-16BE]"] = [[:IBM860, :"UTF-8", :"UTF-16BE"]]
  @paths["[IBM860, UTF-16LE]"] = [[:IBM860, :"UTF-8", :"UTF-16LE"]]
  @paths["[IBM860, UTF-32]"] = [[:IBM860, :"UTF-8", :"UTF-32"]]
  @paths["[IBM860, UTF-32BE]"] = [[:IBM860, :"UTF-8", :"UTF-32BE"]]
  @paths["[IBM860, UTF-32LE]"] = [[:IBM860, :"UTF-8", :"UTF-32LE"]]
  @paths["[IBM860, UTF-8]"] = [[:IBM860, :"UTF-8"]]
  @paths["[IBM860, UTF8-DOCOMO]"] = [[:IBM860, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[IBM860, UTF8-KDDI]"] = [[:IBM860, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[IBM860, UTF8-MAC]"] = [[:IBM860, :"UTF-8", :"UTF8-MAC"]]
  @paths["[IBM860, UTF8-SOFTBANK]"] = [[:IBM860, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[IBM860, WINDOWS-1250]"] = [[:IBM860, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[IBM860, WINDOWS-1251]"] = [[:IBM860, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[IBM860, WINDOWS-1252]"] = [[:IBM860, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[IBM860, WINDOWS-1253]"] = [[:IBM860, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[IBM860, WINDOWS-1254]"] = [[:IBM860, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[IBM860, WINDOWS-1255]"] = [[:IBM860, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[IBM860, WINDOWS-1256]"] = [[:IBM860, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[IBM860, WINDOWS-1257]"] = [[:IBM860, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[IBM860, WINDOWS-31J]"] = [[:IBM860, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[IBM860, WINDOWS-874]"] = [[:IBM860, :"UTF-8", :"WINDOWS-874"]]
  @paths["[IBM861, ASCII-8BIT]"] = [[:IBM861, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[IBM861, BIG5]"] = [[:IBM861, :"UTF-8", :BIG5]]
  @paths["[IBM861, BIG5-HKSCS]"] = [[:IBM861, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[IBM861, BIG5-UAO]"] = [[:IBM861, :"UTF-8", :"BIG5-UAO"]]
  @paths["[IBM861, CP50220]"] = [[:IBM861, :"UTF-8", :CP51932, :CP50220]]
  @paths["[IBM861, CP50221]"] = [[:IBM861, :"UTF-8", :CP51932, :CP50221]]
  @paths["[IBM861, CP51932]"] = [[:IBM861, :"UTF-8", :CP51932]]
  @paths["[IBM861, CP850]"] = [[:IBM861, :"UTF-8", :CP850]]
  @paths["[IBM861, CP852]"] = [[:IBM861, :"UTF-8", :CP852]]
  @paths["[IBM861, CP855]"] = [[:IBM861, :"UTF-8", :CP855]]
  @paths["[IBM861, CP949]"] = [[:IBM861, :"UTF-8", :CP949]]
  @paths["[IBM861, CP950]"] = [[:IBM861, :"UTF-8", :CP950]]
  @paths["[IBM861, CP951]"] = [[:IBM861, :"UTF-8", :CP951]]
  @paths["[IBM861, EUC-JP]"] = [[:IBM861, :"UTF-8", :"EUC-JP"]]
  @paths["[IBM861, EUC-KR]"] = [[:IBM861, :"UTF-8", :"EUC-KR"]]
  @paths["[IBM861, EUCJP-MS]"] = [[:IBM861, :"UTF-8", :"EUCJP-MS"]]
  @paths["[IBM861, GB12345]"] = [[:IBM861, :"UTF-8", :GB12345]]
  @paths["[IBM861, GB18030]"] = [[:IBM861, :"UTF-8", :GB18030]]
  @paths["[IBM861, GB2312]"] = [[:IBM861, :"UTF-8", :GB2312]]
  @paths["[IBM861, GBK]"] = [[:IBM861, :"UTF-8", :GBK]]
  @paths["[IBM861, IBM437]"] = [[:IBM861, :"UTF-8", :IBM437]]
  @paths["[IBM861, IBM737]"] = [[:IBM861, :"UTF-8", :IBM737]]
  @paths["[IBM861, IBM775]"] = [[:IBM861, :"UTF-8", :IBM775]]
  @paths["[IBM861, IBM852]"] = [[:IBM861, :"UTF-8", :IBM852]]
  @paths["[IBM861, IBM855]"] = [[:IBM861, :"UTF-8", :IBM855]]
  @paths["[IBM861, IBM857]"] = [[:IBM861, :"UTF-8", :IBM857]]
  @paths["[IBM861, IBM860]"] = [[:IBM861, :"UTF-8", :IBM860]]
  @paths["[IBM861, IBM862]"] = [[:IBM861, :"UTF-8", :IBM862]]
  @paths["[IBM861, IBM863]"] = [[:IBM861, :"UTF-8", :IBM863]]
  @paths["[IBM861, IBM865]"] = [[:IBM861, :"UTF-8", :IBM865]]
  @paths["[IBM861, IBM866]"] = [[:IBM861, :"UTF-8", :IBM866]]
  @paths["[IBM861, IBM869]"] = [[:IBM861, :"UTF-8", :IBM869]]
  @paths["[IBM861, ISO-2022-JP]"] = [[:IBM861, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[IBM861, ISO-2022-JP-KDDI]"] = [[:IBM861, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[IBM861, ISO-8859-1]"] = [[:IBM861, :"UTF-8", :"ISO-8859-1"]]
  @paths["[IBM861, ISO-8859-10]"] = [[:IBM861, :"UTF-8", :"ISO-8859-10"]]
  @paths["[IBM861, ISO-8859-11]"] = [[:IBM861, :"UTF-8", :"ISO-8859-11"]]
  @paths["[IBM861, ISO-8859-13]"] = [[:IBM861, :"UTF-8", :"ISO-8859-13"]]
  @paths["[IBM861, ISO-8859-14]"] = [[:IBM861, :"UTF-8", :"ISO-8859-14"]]
  @paths["[IBM861, ISO-8859-15]"] = [[:IBM861, :"UTF-8", :"ISO-8859-15"]]
  @paths["[IBM861, ISO-8859-2]"] = [[:IBM861, :"UTF-8", :"ISO-8859-2"]]
  @paths["[IBM861, ISO-8859-3]"] = [[:IBM861, :"UTF-8", :"ISO-8859-3"]]
  @paths["[IBM861, ISO-8859-4]"] = [[:IBM861, :"UTF-8", :"ISO-8859-4"]]
  @paths["[IBM861, ISO-8859-5]"] = [[:IBM861, :"UTF-8", :"ISO-8859-5"]]
  @paths["[IBM861, ISO-8859-6]"] = [[:IBM861, :"UTF-8", :"ISO-8859-6"]]
  @paths["[IBM861, ISO-8859-7]"] = [[:IBM861, :"UTF-8", :"ISO-8859-7"]]
  @paths["[IBM861, ISO-8859-8]"] = [[:IBM861, :"UTF-8", :"ISO-8859-8"]]
  @paths["[IBM861, ISO-8859-9]"] = [[:IBM861, :"UTF-8", :"ISO-8859-9"]]
  @paths["[IBM861, KOI8-R]"] = [[:IBM861, :"UTF-8", :"KOI8-R"]]
  @paths["[IBM861, KOI8-U]"] = [[:IBM861, :"UTF-8", :"KOI8-U"]]
  @paths["[IBM861, MACCROATIAN]"] = [[:IBM861, :"UTF-8", :MACCROATIAN]]
  @paths["[IBM861, MACCYRILLIC]"] = [[:IBM861, :"UTF-8", :MACCYRILLIC]]
  @paths["[IBM861, MACGREEK]"] = [[:IBM861, :"UTF-8", :MACGREEK]]
  @paths["[IBM861, MACICELAND]"] = [[:IBM861, :"UTF-8", :MACICELAND]]
  @paths["[IBM861, MACROMAN]"] = [[:IBM861, :"UTF-8", :MACROMAN]]
  @paths["[IBM861, MACROMANIA]"] = [[:IBM861, :"UTF-8", :MACROMANIA]]
  @paths["[IBM861, MACTURKISH]"] = [[:IBM861, :"UTF-8", :MACTURKISH]]
  @paths["[IBM861, MACUKRAINE]"] = [[:IBM861, :"UTF-8", :MACUKRAINE]]
  @paths["[IBM861, SHIFT_JIS]"] = [[:IBM861, :"UTF-8", :SHIFT_JIS]]
  @paths["[IBM861, SJIS-DOCOMO]"] = [[:IBM861, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[IBM861, SJIS-KDDI]"] = [[:IBM861, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[IBM861, SJIS-SOFTBANK]"] = [[:IBM861, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[IBM861, STATELESS-ISO-2022-JP]"] = [[:IBM861, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[IBM861, STATELESS-ISO-2022-JP-KDDI]"] = [[:IBM861, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[IBM861, TIS-620]"] = [[:IBM861, :"UTF-8", :"TIS-620"]]
  @paths["[IBM861, US-ASCII]"] = [[:IBM861, :"UTF-8", :"US-ASCII"]]
  @paths["[IBM861, UTF-16]"] = [[:IBM861, :"UTF-8", :"UTF-16"]]
  @paths["[IBM861, UTF-16BE]"] = [[:IBM861, :"UTF-8", :"UTF-16BE"]]
  @paths["[IBM861, UTF-16LE]"] = [[:IBM861, :"UTF-8", :"UTF-16LE"]]
  @paths["[IBM861, UTF-32]"] = [[:IBM861, :"UTF-8", :"UTF-32"]]
  @paths["[IBM861, UTF-32BE]"] = [[:IBM861, :"UTF-8", :"UTF-32BE"]]
  @paths["[IBM861, UTF-32LE]"] = [[:IBM861, :"UTF-8", :"UTF-32LE"]]
  @paths["[IBM861, UTF-8]"] = [[:IBM861, :"UTF-8"]]
  @paths["[IBM861, UTF8-DOCOMO]"] = [[:IBM861, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[IBM861, UTF8-KDDI]"] = [[:IBM861, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[IBM861, UTF8-MAC]"] = [[:IBM861, :"UTF-8", :"UTF8-MAC"]]
  @paths["[IBM861, UTF8-SOFTBANK]"] = [[:IBM861, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[IBM861, WINDOWS-1250]"] = [[:IBM861, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[IBM861, WINDOWS-1251]"] = [[:IBM861, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[IBM861, WINDOWS-1252]"] = [[:IBM861, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[IBM861, WINDOWS-1253]"] = [[:IBM861, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[IBM861, WINDOWS-1254]"] = [[:IBM861, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[IBM861, WINDOWS-1255]"] = [[:IBM861, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[IBM861, WINDOWS-1256]"] = [[:IBM861, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[IBM861, WINDOWS-1257]"] = [[:IBM861, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[IBM861, WINDOWS-31J]"] = [[:IBM861, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[IBM861, WINDOWS-874]"] = [[:IBM861, :"UTF-8", :"WINDOWS-874"]]
  @paths["[IBM862, ASCII-8BIT]"] = [[:IBM862, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[IBM862, BIG5]"] = [[:IBM862, :"UTF-8", :BIG5]]
  @paths["[IBM862, BIG5-HKSCS]"] = [[:IBM862, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[IBM862, BIG5-UAO]"] = [[:IBM862, :"UTF-8", :"BIG5-UAO"]]
  @paths["[IBM862, CP50220]"] = [[:IBM862, :"UTF-8", :CP51932, :CP50220]]
  @paths["[IBM862, CP50221]"] = [[:IBM862, :"UTF-8", :CP51932, :CP50221]]
  @paths["[IBM862, CP51932]"] = [[:IBM862, :"UTF-8", :CP51932]]
  @paths["[IBM862, CP850]"] = [[:IBM862, :"UTF-8", :CP850]]
  @paths["[IBM862, CP852]"] = [[:IBM862, :"UTF-8", :CP852]]
  @paths["[IBM862, CP855]"] = [[:IBM862, :"UTF-8", :CP855]]
  @paths["[IBM862, CP949]"] = [[:IBM862, :"UTF-8", :CP949]]
  @paths["[IBM862, CP950]"] = [[:IBM862, :"UTF-8", :CP950]]
  @paths["[IBM862, CP951]"] = [[:IBM862, :"UTF-8", :CP951]]
  @paths["[IBM862, EUC-JP]"] = [[:IBM862, :"UTF-8", :"EUC-JP"]]
  @paths["[IBM862, EUC-KR]"] = [[:IBM862, :"UTF-8", :"EUC-KR"]]
  @paths["[IBM862, EUCJP-MS]"] = [[:IBM862, :"UTF-8", :"EUCJP-MS"]]
  @paths["[IBM862, GB12345]"] = [[:IBM862, :"UTF-8", :GB12345]]
  @paths["[IBM862, GB18030]"] = [[:IBM862, :"UTF-8", :GB18030]]
  @paths["[IBM862, GB2312]"] = [[:IBM862, :"UTF-8", :GB2312]]
  @paths["[IBM862, GBK]"] = [[:IBM862, :"UTF-8", :GBK]]
  @paths["[IBM862, IBM437]"] = [[:IBM862, :"UTF-8", :IBM437]]
  @paths["[IBM862, IBM737]"] = [[:IBM862, :"UTF-8", :IBM737]]
  @paths["[IBM862, IBM775]"] = [[:IBM862, :"UTF-8", :IBM775]]
  @paths["[IBM862, IBM852]"] = [[:IBM862, :"UTF-8", :IBM852]]
  @paths["[IBM862, IBM855]"] = [[:IBM862, :"UTF-8", :IBM855]]
  @paths["[IBM862, IBM857]"] = [[:IBM862, :"UTF-8", :IBM857]]
  @paths["[IBM862, IBM860]"] = [[:IBM862, :"UTF-8", :IBM860]]
  @paths["[IBM862, IBM861]"] = [[:IBM862, :"UTF-8", :IBM861]]
  @paths["[IBM862, IBM863]"] = [[:IBM862, :"UTF-8", :IBM863]]
  @paths["[IBM862, IBM865]"] = [[:IBM862, :"UTF-8", :IBM865]]
  @paths["[IBM862, IBM866]"] = [[:IBM862, :"UTF-8", :IBM866]]
  @paths["[IBM862, IBM869]"] = [[:IBM862, :"UTF-8", :IBM869]]
  @paths["[IBM862, ISO-2022-JP]"] = [[:IBM862, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[IBM862, ISO-2022-JP-KDDI]"] = [[:IBM862, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[IBM862, ISO-8859-1]"] = [[:IBM862, :"UTF-8", :"ISO-8859-1"]]
  @paths["[IBM862, ISO-8859-10]"] = [[:IBM862, :"UTF-8", :"ISO-8859-10"]]
  @paths["[IBM862, ISO-8859-11]"] = [[:IBM862, :"UTF-8", :"ISO-8859-11"]]
  @paths["[IBM862, ISO-8859-13]"] = [[:IBM862, :"UTF-8", :"ISO-8859-13"]]
  @paths["[IBM862, ISO-8859-14]"] = [[:IBM862, :"UTF-8", :"ISO-8859-14"]]
  @paths["[IBM862, ISO-8859-15]"] = [[:IBM862, :"UTF-8", :"ISO-8859-15"]]
  @paths["[IBM862, ISO-8859-2]"] = [[:IBM862, :"UTF-8", :"ISO-8859-2"]]
  @paths["[IBM862, ISO-8859-3]"] = [[:IBM862, :"UTF-8", :"ISO-8859-3"]]
  @paths["[IBM862, ISO-8859-4]"] = [[:IBM862, :"UTF-8", :"ISO-8859-4"]]
  @paths["[IBM862, ISO-8859-5]"] = [[:IBM862, :"UTF-8", :"ISO-8859-5"]]
  @paths["[IBM862, ISO-8859-6]"] = [[:IBM862, :"UTF-8", :"ISO-8859-6"]]
  @paths["[IBM862, ISO-8859-7]"] = [[:IBM862, :"UTF-8", :"ISO-8859-7"]]
  @paths["[IBM862, ISO-8859-8]"] = [[:IBM862, :"UTF-8", :"ISO-8859-8"]]
  @paths["[IBM862, ISO-8859-9]"] = [[:IBM862, :"UTF-8", :"ISO-8859-9"]]
  @paths["[IBM862, KOI8-R]"] = [[:IBM862, :"UTF-8", :"KOI8-R"]]
  @paths["[IBM862, KOI8-U]"] = [[:IBM862, :"UTF-8", :"KOI8-U"]]
  @paths["[IBM862, MACCROATIAN]"] = [[:IBM862, :"UTF-8", :MACCROATIAN]]
  @paths["[IBM862, MACCYRILLIC]"] = [[:IBM862, :"UTF-8", :MACCYRILLIC]]
  @paths["[IBM862, MACGREEK]"] = [[:IBM862, :"UTF-8", :MACGREEK]]
  @paths["[IBM862, MACICELAND]"] = [[:IBM862, :"UTF-8", :MACICELAND]]
  @paths["[IBM862, MACROMAN]"] = [[:IBM862, :"UTF-8", :MACROMAN]]
  @paths["[IBM862, MACROMANIA]"] = [[:IBM862, :"UTF-8", :MACROMANIA]]
  @paths["[IBM862, MACTURKISH]"] = [[:IBM862, :"UTF-8", :MACTURKISH]]
  @paths["[IBM862, MACUKRAINE]"] = [[:IBM862, :"UTF-8", :MACUKRAINE]]
  @paths["[IBM862, SHIFT_JIS]"] = [[:IBM862, :"UTF-8", :SHIFT_JIS]]
  @paths["[IBM862, SJIS-DOCOMO]"] = [[:IBM862, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[IBM862, SJIS-KDDI]"] = [[:IBM862, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[IBM862, SJIS-SOFTBANK]"] = [[:IBM862, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[IBM862, STATELESS-ISO-2022-JP]"] = [[:IBM862, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[IBM862, STATELESS-ISO-2022-JP-KDDI]"] = [[:IBM862, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[IBM862, TIS-620]"] = [[:IBM862, :"UTF-8", :"TIS-620"]]
  @paths["[IBM862, US-ASCII]"] = [[:IBM862, :"UTF-8", :"US-ASCII"]]
  @paths["[IBM862, UTF-16]"] = [[:IBM862, :"UTF-8", :"UTF-16"]]
  @paths["[IBM862, UTF-16BE]"] = [[:IBM862, :"UTF-8", :"UTF-16BE"]]
  @paths["[IBM862, UTF-16LE]"] = [[:IBM862, :"UTF-8", :"UTF-16LE"]]
  @paths["[IBM862, UTF-32]"] = [[:IBM862, :"UTF-8", :"UTF-32"]]
  @paths["[IBM862, UTF-32BE]"] = [[:IBM862, :"UTF-8", :"UTF-32BE"]]
  @paths["[IBM862, UTF-32LE]"] = [[:IBM862, :"UTF-8", :"UTF-32LE"]]
  @paths["[IBM862, UTF-8]"] = [[:IBM862, :"UTF-8"]]
  @paths["[IBM862, UTF8-DOCOMO]"] = [[:IBM862, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[IBM862, UTF8-KDDI]"] = [[:IBM862, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[IBM862, UTF8-MAC]"] = [[:IBM862, :"UTF-8", :"UTF8-MAC"]]
  @paths["[IBM862, UTF8-SOFTBANK]"] = [[:IBM862, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[IBM862, WINDOWS-1250]"] = [[:IBM862, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[IBM862, WINDOWS-1251]"] = [[:IBM862, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[IBM862, WINDOWS-1252]"] = [[:IBM862, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[IBM862, WINDOWS-1253]"] = [[:IBM862, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[IBM862, WINDOWS-1254]"] = [[:IBM862, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[IBM862, WINDOWS-1255]"] = [[:IBM862, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[IBM862, WINDOWS-1256]"] = [[:IBM862, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[IBM862, WINDOWS-1257]"] = [[:IBM862, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[IBM862, WINDOWS-31J]"] = [[:IBM862, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[IBM862, WINDOWS-874]"] = [[:IBM862, :"UTF-8", :"WINDOWS-874"]]
  @paths["[IBM863, ASCII-8BIT]"] = [[:IBM863, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[IBM863, BIG5]"] = [[:IBM863, :"UTF-8", :BIG5]]
  @paths["[IBM863, BIG5-HKSCS]"] = [[:IBM863, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[IBM863, BIG5-UAO]"] = [[:IBM863, :"UTF-8", :"BIG5-UAO"]]
  @paths["[IBM863, CP50220]"] = [[:IBM863, :"UTF-8", :CP51932, :CP50220]]
  @paths["[IBM863, CP50221]"] = [[:IBM863, :"UTF-8", :CP51932, :CP50221]]
  @paths["[IBM863, CP51932]"] = [[:IBM863, :"UTF-8", :CP51932]]
  @paths["[IBM863, CP850]"] = [[:IBM863, :"UTF-8", :CP850]]
  @paths["[IBM863, CP852]"] = [[:IBM863, :"UTF-8", :CP852]]
  @paths["[IBM863, CP855]"] = [[:IBM863, :"UTF-8", :CP855]]
  @paths["[IBM863, CP949]"] = [[:IBM863, :"UTF-8", :CP949]]
  @paths["[IBM863, CP950]"] = [[:IBM863, :"UTF-8", :CP950]]
  @paths["[IBM863, CP951]"] = [[:IBM863, :"UTF-8", :CP951]]
  @paths["[IBM863, EUC-JP]"] = [[:IBM863, :"UTF-8", :"EUC-JP"]]
  @paths["[IBM863, EUC-KR]"] = [[:IBM863, :"UTF-8", :"EUC-KR"]]
  @paths["[IBM863, EUCJP-MS]"] = [[:IBM863, :"UTF-8", :"EUCJP-MS"]]
  @paths["[IBM863, GB12345]"] = [[:IBM863, :"UTF-8", :GB12345]]
  @paths["[IBM863, GB18030]"] = [[:IBM863, :"UTF-8", :GB18030]]
  @paths["[IBM863, GB2312]"] = [[:IBM863, :"UTF-8", :GB2312]]
  @paths["[IBM863, GBK]"] = [[:IBM863, :"UTF-8", :GBK]]
  @paths["[IBM863, IBM437]"] = [[:IBM863, :"UTF-8", :IBM437]]
  @paths["[IBM863, IBM737]"] = [[:IBM863, :"UTF-8", :IBM737]]
  @paths["[IBM863, IBM775]"] = [[:IBM863, :"UTF-8", :IBM775]]
  @paths["[IBM863, IBM852]"] = [[:IBM863, :"UTF-8", :IBM852]]
  @paths["[IBM863, IBM855]"] = [[:IBM863, :"UTF-8", :IBM855]]
  @paths["[IBM863, IBM857]"] = [[:IBM863, :"UTF-8", :IBM857]]
  @paths["[IBM863, IBM860]"] = [[:IBM863, :"UTF-8", :IBM860]]
  @paths["[IBM863, IBM861]"] = [[:IBM863, :"UTF-8", :IBM861]]
  @paths["[IBM863, IBM862]"] = [[:IBM863, :"UTF-8", :IBM862]]
  @paths["[IBM863, IBM865]"] = [[:IBM863, :"UTF-8", :IBM865]]
  @paths["[IBM863, IBM866]"] = [[:IBM863, :"UTF-8", :IBM866]]
  @paths["[IBM863, IBM869]"] = [[:IBM863, :"UTF-8", :IBM869]]
  @paths["[IBM863, ISO-2022-JP]"] = [[:IBM863, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[IBM863, ISO-2022-JP-KDDI]"] = [[:IBM863, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[IBM863, ISO-8859-1]"] = [[:IBM863, :"UTF-8", :"ISO-8859-1"]]
  @paths["[IBM863, ISO-8859-10]"] = [[:IBM863, :"UTF-8", :"ISO-8859-10"]]
  @paths["[IBM863, ISO-8859-11]"] = [[:IBM863, :"UTF-8", :"ISO-8859-11"]]
  @paths["[IBM863, ISO-8859-13]"] = [[:IBM863, :"UTF-8", :"ISO-8859-13"]]
  @paths["[IBM863, ISO-8859-14]"] = [[:IBM863, :"UTF-8", :"ISO-8859-14"]]
  @paths["[IBM863, ISO-8859-15]"] = [[:IBM863, :"UTF-8", :"ISO-8859-15"]]
  @paths["[IBM863, ISO-8859-2]"] = [[:IBM863, :"UTF-8", :"ISO-8859-2"]]
  @paths["[IBM863, ISO-8859-3]"] = [[:IBM863, :"UTF-8", :"ISO-8859-3"]]
  @paths["[IBM863, ISO-8859-4]"] = [[:IBM863, :"UTF-8", :"ISO-8859-4"]]
  @paths["[IBM863, ISO-8859-5]"] = [[:IBM863, :"UTF-8", :"ISO-8859-5"]]
  @paths["[IBM863, ISO-8859-6]"] = [[:IBM863, :"UTF-8", :"ISO-8859-6"]]
  @paths["[IBM863, ISO-8859-7]"] = [[:IBM863, :"UTF-8", :"ISO-8859-7"]]
  @paths["[IBM863, ISO-8859-8]"] = [[:IBM863, :"UTF-8", :"ISO-8859-8"]]
  @paths["[IBM863, ISO-8859-9]"] = [[:IBM863, :"UTF-8", :"ISO-8859-9"]]
  @paths["[IBM863, KOI8-R]"] = [[:IBM863, :"UTF-8", :"KOI8-R"]]
  @paths["[IBM863, KOI8-U]"] = [[:IBM863, :"UTF-8", :"KOI8-U"]]
  @paths["[IBM863, MACCROATIAN]"] = [[:IBM863, :"UTF-8", :MACCROATIAN]]
  @paths["[IBM863, MACCYRILLIC]"] = [[:IBM863, :"UTF-8", :MACCYRILLIC]]
  @paths["[IBM863, MACGREEK]"] = [[:IBM863, :"UTF-8", :MACGREEK]]
  @paths["[IBM863, MACICELAND]"] = [[:IBM863, :"UTF-8", :MACICELAND]]
  @paths["[IBM863, MACROMAN]"] = [[:IBM863, :"UTF-8", :MACROMAN]]
  @paths["[IBM863, MACROMANIA]"] = [[:IBM863, :"UTF-8", :MACROMANIA]]
  @paths["[IBM863, MACTURKISH]"] = [[:IBM863, :"UTF-8", :MACTURKISH]]
  @paths["[IBM863, MACUKRAINE]"] = [[:IBM863, :"UTF-8", :MACUKRAINE]]
  @paths["[IBM863, SHIFT_JIS]"] = [[:IBM863, :"UTF-8", :SHIFT_JIS]]
  @paths["[IBM863, SJIS-DOCOMO]"] = [[:IBM863, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[IBM863, SJIS-KDDI]"] = [[:IBM863, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[IBM863, SJIS-SOFTBANK]"] = [[:IBM863, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[IBM863, STATELESS-ISO-2022-JP]"] = [[:IBM863, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[IBM863, STATELESS-ISO-2022-JP-KDDI]"] = [[:IBM863, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[IBM863, TIS-620]"] = [[:IBM863, :"UTF-8", :"TIS-620"]]
  @paths["[IBM863, US-ASCII]"] = [[:IBM863, :"UTF-8", :"US-ASCII"]]
  @paths["[IBM863, UTF-16]"] = [[:IBM863, :"UTF-8", :"UTF-16"]]
  @paths["[IBM863, UTF-16BE]"] = [[:IBM863, :"UTF-8", :"UTF-16BE"]]
  @paths["[IBM863, UTF-16LE]"] = [[:IBM863, :"UTF-8", :"UTF-16LE"]]
  @paths["[IBM863, UTF-32]"] = [[:IBM863, :"UTF-8", :"UTF-32"]]
  @paths["[IBM863, UTF-32BE]"] = [[:IBM863, :"UTF-8", :"UTF-32BE"]]
  @paths["[IBM863, UTF-32LE]"] = [[:IBM863, :"UTF-8", :"UTF-32LE"]]
  @paths["[IBM863, UTF-8]"] = [[:IBM863, :"UTF-8"]]
  @paths["[IBM863, UTF8-DOCOMO]"] = [[:IBM863, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[IBM863, UTF8-KDDI]"] = [[:IBM863, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[IBM863, UTF8-MAC]"] = [[:IBM863, :"UTF-8", :"UTF8-MAC"]]
  @paths["[IBM863, UTF8-SOFTBANK]"] = [[:IBM863, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[IBM863, WINDOWS-1250]"] = [[:IBM863, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[IBM863, WINDOWS-1251]"] = [[:IBM863, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[IBM863, WINDOWS-1252]"] = [[:IBM863, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[IBM863, WINDOWS-1253]"] = [[:IBM863, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[IBM863, WINDOWS-1254]"] = [[:IBM863, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[IBM863, WINDOWS-1255]"] = [[:IBM863, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[IBM863, WINDOWS-1256]"] = [[:IBM863, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[IBM863, WINDOWS-1257]"] = [[:IBM863, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[IBM863, WINDOWS-31J]"] = [[:IBM863, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[IBM863, WINDOWS-874]"] = [[:IBM863, :"UTF-8", :"WINDOWS-874"]]
  @paths["[IBM865, ASCII-8BIT]"] = [[:IBM865, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[IBM865, BIG5]"] = [[:IBM865, :"UTF-8", :BIG5]]
  @paths["[IBM865, BIG5-HKSCS]"] = [[:IBM865, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[IBM865, BIG5-UAO]"] = [[:IBM865, :"UTF-8", :"BIG5-UAO"]]
  @paths["[IBM865, CP50220]"] = [[:IBM865, :"UTF-8", :CP51932, :CP50220]]
  @paths["[IBM865, CP50221]"] = [[:IBM865, :"UTF-8", :CP51932, :CP50221]]
  @paths["[IBM865, CP51932]"] = [[:IBM865, :"UTF-8", :CP51932]]
  @paths["[IBM865, CP850]"] = [[:IBM865, :"UTF-8", :CP850]]
  @paths["[IBM865, CP852]"] = [[:IBM865, :"UTF-8", :CP852]]
  @paths["[IBM865, CP855]"] = [[:IBM865, :"UTF-8", :CP855]]
  @paths["[IBM865, CP949]"] = [[:IBM865, :"UTF-8", :CP949]]
  @paths["[IBM865, CP950]"] = [[:IBM865, :"UTF-8", :CP950]]
  @paths["[IBM865, CP951]"] = [[:IBM865, :"UTF-8", :CP951]]
  @paths["[IBM865, EUC-JP]"] = [[:IBM865, :"UTF-8", :"EUC-JP"]]
  @paths["[IBM865, EUC-KR]"] = [[:IBM865, :"UTF-8", :"EUC-KR"]]
  @paths["[IBM865, EUCJP-MS]"] = [[:IBM865, :"UTF-8", :"EUCJP-MS"]]
  @paths["[IBM865, GB12345]"] = [[:IBM865, :"UTF-8", :GB12345]]
  @paths["[IBM865, GB18030]"] = [[:IBM865, :"UTF-8", :GB18030]]
  @paths["[IBM865, GB2312]"] = [[:IBM865, :"UTF-8", :GB2312]]
  @paths["[IBM865, GBK]"] = [[:IBM865, :"UTF-8", :GBK]]
  @paths["[IBM865, IBM437]"] = [[:IBM865, :"UTF-8", :IBM437]]
  @paths["[IBM865, IBM737]"] = [[:IBM865, :"UTF-8", :IBM737]]
  @paths["[IBM865, IBM775]"] = [[:IBM865, :"UTF-8", :IBM775]]
  @paths["[IBM865, IBM852]"] = [[:IBM865, :"UTF-8", :IBM852]]
  @paths["[IBM865, IBM855]"] = [[:IBM865, :"UTF-8", :IBM855]]
  @paths["[IBM865, IBM857]"] = [[:IBM865, :"UTF-8", :IBM857]]
  @paths["[IBM865, IBM860]"] = [[:IBM865, :"UTF-8", :IBM860]]
  @paths["[IBM865, IBM861]"] = [[:IBM865, :"UTF-8", :IBM861]]
  @paths["[IBM865, IBM862]"] = [[:IBM865, :"UTF-8", :IBM862]]
  @paths["[IBM865, IBM863]"] = [[:IBM865, :"UTF-8", :IBM863]]
  @paths["[IBM865, IBM866]"] = [[:IBM865, :"UTF-8", :IBM866]]
  @paths["[IBM865, IBM869]"] = [[:IBM865, :"UTF-8", :IBM869]]
  @paths["[IBM865, ISO-2022-JP]"] = [[:IBM865, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[IBM865, ISO-2022-JP-KDDI]"] = [[:IBM865, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[IBM865, ISO-8859-1]"] = [[:IBM865, :"UTF-8", :"ISO-8859-1"]]
  @paths["[IBM865, ISO-8859-10]"] = [[:IBM865, :"UTF-8", :"ISO-8859-10"]]
  @paths["[IBM865, ISO-8859-11]"] = [[:IBM865, :"UTF-8", :"ISO-8859-11"]]
  @paths["[IBM865, ISO-8859-13]"] = [[:IBM865, :"UTF-8", :"ISO-8859-13"]]
  @paths["[IBM865, ISO-8859-14]"] = [[:IBM865, :"UTF-8", :"ISO-8859-14"]]
  @paths["[IBM865, ISO-8859-15]"] = [[:IBM865, :"UTF-8", :"ISO-8859-15"]]
  @paths["[IBM865, ISO-8859-2]"] = [[:IBM865, :"UTF-8", :"ISO-8859-2"]]
  @paths["[IBM865, ISO-8859-3]"] = [[:IBM865, :"UTF-8", :"ISO-8859-3"]]
  @paths["[IBM865, ISO-8859-4]"] = [[:IBM865, :"UTF-8", :"ISO-8859-4"]]
  @paths["[IBM865, ISO-8859-5]"] = [[:IBM865, :"UTF-8", :"ISO-8859-5"]]
  @paths["[IBM865, ISO-8859-6]"] = [[:IBM865, :"UTF-8", :"ISO-8859-6"]]
  @paths["[IBM865, ISO-8859-7]"] = [[:IBM865, :"UTF-8", :"ISO-8859-7"]]
  @paths["[IBM865, ISO-8859-8]"] = [[:IBM865, :"UTF-8", :"ISO-8859-8"]]
  @paths["[IBM865, ISO-8859-9]"] = [[:IBM865, :"UTF-8", :"ISO-8859-9"]]
  @paths["[IBM865, KOI8-R]"] = [[:IBM865, :"UTF-8", :"KOI8-R"]]
  @paths["[IBM865, KOI8-U]"] = [[:IBM865, :"UTF-8", :"KOI8-U"]]
  @paths["[IBM865, MACCROATIAN]"] = [[:IBM865, :"UTF-8", :MACCROATIAN]]
  @paths["[IBM865, MACCYRILLIC]"] = [[:IBM865, :"UTF-8", :MACCYRILLIC]]
  @paths["[IBM865, MACGREEK]"] = [[:IBM865, :"UTF-8", :MACGREEK]]
  @paths["[IBM865, MACICELAND]"] = [[:IBM865, :"UTF-8", :MACICELAND]]
  @paths["[IBM865, MACROMAN]"] = [[:IBM865, :"UTF-8", :MACROMAN]]
  @paths["[IBM865, MACROMANIA]"] = [[:IBM865, :"UTF-8", :MACROMANIA]]
  @paths["[IBM865, MACTURKISH]"] = [[:IBM865, :"UTF-8", :MACTURKISH]]
  @paths["[IBM865, MACUKRAINE]"] = [[:IBM865, :"UTF-8", :MACUKRAINE]]
  @paths["[IBM865, SHIFT_JIS]"] = [[:IBM865, :"UTF-8", :SHIFT_JIS]]
  @paths["[IBM865, SJIS-DOCOMO]"] = [[:IBM865, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[IBM865, SJIS-KDDI]"] = [[:IBM865, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[IBM865, SJIS-SOFTBANK]"] = [[:IBM865, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[IBM865, STATELESS-ISO-2022-JP]"] = [[:IBM865, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[IBM865, STATELESS-ISO-2022-JP-KDDI]"] = [[:IBM865, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[IBM865, TIS-620]"] = [[:IBM865, :"UTF-8", :"TIS-620"]]
  @paths["[IBM865, US-ASCII]"] = [[:IBM865, :"UTF-8", :"US-ASCII"]]
  @paths["[IBM865, UTF-16]"] = [[:IBM865, :"UTF-8", :"UTF-16"]]
  @paths["[IBM865, UTF-16BE]"] = [[:IBM865, :"UTF-8", :"UTF-16BE"]]
  @paths["[IBM865, UTF-16LE]"] = [[:IBM865, :"UTF-8", :"UTF-16LE"]]
  @paths["[IBM865, UTF-32]"] = [[:IBM865, :"UTF-8", :"UTF-32"]]
  @paths["[IBM865, UTF-32BE]"] = [[:IBM865, :"UTF-8", :"UTF-32BE"]]
  @paths["[IBM865, UTF-32LE]"] = [[:IBM865, :"UTF-8", :"UTF-32LE"]]
  @paths["[IBM865, UTF-8]"] = [[:IBM865, :"UTF-8"]]
  @paths["[IBM865, UTF8-DOCOMO]"] = [[:IBM865, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[IBM865, UTF8-KDDI]"] = [[:IBM865, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[IBM865, UTF8-MAC]"] = [[:IBM865, :"UTF-8", :"UTF8-MAC"]]
  @paths["[IBM865, UTF8-SOFTBANK]"] = [[:IBM865, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[IBM865, WINDOWS-1250]"] = [[:IBM865, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[IBM865, WINDOWS-1251]"] = [[:IBM865, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[IBM865, WINDOWS-1252]"] = [[:IBM865, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[IBM865, WINDOWS-1253]"] = [[:IBM865, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[IBM865, WINDOWS-1254]"] = [[:IBM865, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[IBM865, WINDOWS-1255]"] = [[:IBM865, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[IBM865, WINDOWS-1256]"] = [[:IBM865, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[IBM865, WINDOWS-1257]"] = [[:IBM865, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[IBM865, WINDOWS-31J]"] = [[:IBM865, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[IBM865, WINDOWS-874]"] = [[:IBM865, :"UTF-8", :"WINDOWS-874"]]
  @paths["[IBM866, ASCII-8BIT]"] = [[:IBM866, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[IBM866, BIG5]"] = [[:IBM866, :"UTF-8", :BIG5]]
  @paths["[IBM866, BIG5-HKSCS]"] = [[:IBM866, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[IBM866, BIG5-UAO]"] = [[:IBM866, :"UTF-8", :"BIG5-UAO"]]
  @paths["[IBM866, CP50220]"] = [[:IBM866, :"UTF-8", :CP51932, :CP50220]]
  @paths["[IBM866, CP50221]"] = [[:IBM866, :"UTF-8", :CP51932, :CP50221]]
  @paths["[IBM866, CP51932]"] = [[:IBM866, :"UTF-8", :CP51932]]
  @paths["[IBM866, CP850]"] = [[:IBM866, :"UTF-8", :CP850]]
  @paths["[IBM866, CP852]"] = [[:IBM866, :"UTF-8", :CP852]]
  @paths["[IBM866, CP855]"] = [[:IBM866, :"UTF-8", :CP855]]
  @paths["[IBM866, CP949]"] = [[:IBM866, :"UTF-8", :CP949]]
  @paths["[IBM866, CP950]"] = [[:IBM866, :"UTF-8", :CP950]]
  @paths["[IBM866, CP951]"] = [[:IBM866, :"UTF-8", :CP951]]
  @paths["[IBM866, EUC-JP]"] = [[:IBM866, :"UTF-8", :"EUC-JP"]]
  @paths["[IBM866, EUC-KR]"] = [[:IBM866, :"UTF-8", :"EUC-KR"]]
  @paths["[IBM866, EUCJP-MS]"] = [[:IBM866, :"UTF-8", :"EUCJP-MS"]]
  @paths["[IBM866, GB12345]"] = [[:IBM866, :"UTF-8", :GB12345]]
  @paths["[IBM866, GB18030]"] = [[:IBM866, :"UTF-8", :GB18030]]
  @paths["[IBM866, GB2312]"] = [[:IBM866, :"UTF-8", :GB2312]]
  @paths["[IBM866, GBK]"] = [[:IBM866, :"UTF-8", :GBK]]
  @paths["[IBM866, IBM437]"] = [[:IBM866, :"UTF-8", :IBM437]]
  @paths["[IBM866, IBM737]"] = [[:IBM866, :"UTF-8", :IBM737]]
  @paths["[IBM866, IBM775]"] = [[:IBM866, :"UTF-8", :IBM775]]
  @paths["[IBM866, IBM852]"] = [[:IBM866, :"UTF-8", :IBM852]]
  @paths["[IBM866, IBM855]"] = [[:IBM866, :"UTF-8", :IBM855]]
  @paths["[IBM866, IBM857]"] = [[:IBM866, :"UTF-8", :IBM857]]
  @paths["[IBM866, IBM860]"] = [[:IBM866, :"UTF-8", :IBM860]]
  @paths["[IBM866, IBM861]"] = [[:IBM866, :"UTF-8", :IBM861]]
  @paths["[IBM866, IBM862]"] = [[:IBM866, :"UTF-8", :IBM862]]
  @paths["[IBM866, IBM863]"] = [[:IBM866, :"UTF-8", :IBM863]]
  @paths["[IBM866, IBM865]"] = [[:IBM866, :"UTF-8", :IBM865]]
  @paths["[IBM866, IBM869]"] = [[:IBM866, :"UTF-8", :IBM869]]
  @paths["[IBM866, ISO-2022-JP]"] = [[:IBM866, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[IBM866, ISO-2022-JP-KDDI]"] = [[:IBM866, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[IBM866, ISO-8859-1]"] = [[:IBM866, :"UTF-8", :"ISO-8859-1"]]
  @paths["[IBM866, ISO-8859-10]"] = [[:IBM866, :"UTF-8", :"ISO-8859-10"]]
  @paths["[IBM866, ISO-8859-11]"] = [[:IBM866, :"UTF-8", :"ISO-8859-11"]]
  @paths["[IBM866, ISO-8859-13]"] = [[:IBM866, :"UTF-8", :"ISO-8859-13"]]
  @paths["[IBM866, ISO-8859-14]"] = [[:IBM866, :"UTF-8", :"ISO-8859-14"]]
  @paths["[IBM866, ISO-8859-15]"] = [[:IBM866, :"UTF-8", :"ISO-8859-15"]]
  @paths["[IBM866, ISO-8859-2]"] = [[:IBM866, :"UTF-8", :"ISO-8859-2"]]
  @paths["[IBM866, ISO-8859-3]"] = [[:IBM866, :"UTF-8", :"ISO-8859-3"]]
  @paths["[IBM866, ISO-8859-4]"] = [[:IBM866, :"UTF-8", :"ISO-8859-4"]]
  @paths["[IBM866, ISO-8859-5]"] = [[:IBM866, :"UTF-8", :"ISO-8859-5"]]
  @paths["[IBM866, ISO-8859-6]"] = [[:IBM866, :"UTF-8", :"ISO-8859-6"]]
  @paths["[IBM866, ISO-8859-7]"] = [[:IBM866, :"UTF-8", :"ISO-8859-7"]]
  @paths["[IBM866, ISO-8859-8]"] = [[:IBM866, :"UTF-8", :"ISO-8859-8"]]
  @paths["[IBM866, ISO-8859-9]"] = [[:IBM866, :"UTF-8", :"ISO-8859-9"]]
  @paths["[IBM866, KOI8-R]"] = [[:IBM866, :"UTF-8", :"KOI8-R"]]
  @paths["[IBM866, KOI8-U]"] = [[:IBM866, :"UTF-8", :"KOI8-U"]]
  @paths["[IBM866, MACCROATIAN]"] = [[:IBM866, :"UTF-8", :MACCROATIAN]]
  @paths["[IBM866, MACCYRILLIC]"] = [[:IBM866, :"UTF-8", :MACCYRILLIC]]
  @paths["[IBM866, MACGREEK]"] = [[:IBM866, :"UTF-8", :MACGREEK]]
  @paths["[IBM866, MACICELAND]"] = [[:IBM866, :"UTF-8", :MACICELAND]]
  @paths["[IBM866, MACROMAN]"] = [[:IBM866, :"UTF-8", :MACROMAN]]
  @paths["[IBM866, MACROMANIA]"] = [[:IBM866, :"UTF-8", :MACROMANIA]]
  @paths["[IBM866, MACTURKISH]"] = [[:IBM866, :"UTF-8", :MACTURKISH]]
  @paths["[IBM866, MACUKRAINE]"] = [[:IBM866, :"UTF-8", :MACUKRAINE]]
  @paths["[IBM866, SHIFT_JIS]"] = [[:IBM866, :"UTF-8", :SHIFT_JIS]]
  @paths["[IBM866, SJIS-DOCOMO]"] = [[:IBM866, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[IBM866, SJIS-KDDI]"] = [[:IBM866, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[IBM866, SJIS-SOFTBANK]"] = [[:IBM866, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[IBM866, STATELESS-ISO-2022-JP]"] = [[:IBM866, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[IBM866, STATELESS-ISO-2022-JP-KDDI]"] = [[:IBM866, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[IBM866, TIS-620]"] = [[:IBM866, :"UTF-8", :"TIS-620"]]
  @paths["[IBM866, US-ASCII]"] = [[:IBM866, :"UTF-8", :"US-ASCII"]]
  @paths["[IBM866, UTF-16]"] = [[:IBM866, :"UTF-8", :"UTF-16"]]
  @paths["[IBM866, UTF-16BE]"] = [[:IBM866, :"UTF-8", :"UTF-16BE"]]
  @paths["[IBM866, UTF-16LE]"] = [[:IBM866, :"UTF-8", :"UTF-16LE"]]
  @paths["[IBM866, UTF-32]"] = [[:IBM866, :"UTF-8", :"UTF-32"]]
  @paths["[IBM866, UTF-32BE]"] = [[:IBM866, :"UTF-8", :"UTF-32BE"]]
  @paths["[IBM866, UTF-32LE]"] = [[:IBM866, :"UTF-8", :"UTF-32LE"]]
  @paths["[IBM866, UTF-8]"] = [[:IBM866, :"UTF-8"]]
  @paths["[IBM866, UTF8-DOCOMO]"] = [[:IBM866, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[IBM866, UTF8-KDDI]"] = [[:IBM866, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[IBM866, UTF8-MAC]"] = [[:IBM866, :"UTF-8", :"UTF8-MAC"]]
  @paths["[IBM866, UTF8-SOFTBANK]"] = [[:IBM866, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[IBM866, WINDOWS-1250]"] = [[:IBM866, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[IBM866, WINDOWS-1251]"] = [[:IBM866, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[IBM866, WINDOWS-1252]"] = [[:IBM866, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[IBM866, WINDOWS-1253]"] = [[:IBM866, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[IBM866, WINDOWS-1254]"] = [[:IBM866, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[IBM866, WINDOWS-1255]"] = [[:IBM866, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[IBM866, WINDOWS-1256]"] = [[:IBM866, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[IBM866, WINDOWS-1257]"] = [[:IBM866, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[IBM866, WINDOWS-31J]"] = [[:IBM866, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[IBM866, WINDOWS-874]"] = [[:IBM866, :"UTF-8", :"WINDOWS-874"]]
  @paths["[IBM869, ASCII-8BIT]"] = [[:IBM869, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[IBM869, BIG5]"] = [[:IBM869, :"UTF-8", :BIG5]]
  @paths["[IBM869, BIG5-HKSCS]"] = [[:IBM869, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[IBM869, BIG5-UAO]"] = [[:IBM869, :"UTF-8", :"BIG5-UAO"]]
  @paths["[IBM869, CP50220]"] = [[:IBM869, :"UTF-8", :CP51932, :CP50220]]
  @paths["[IBM869, CP50221]"] = [[:IBM869, :"UTF-8", :CP51932, :CP50221]]
  @paths["[IBM869, CP51932]"] = [[:IBM869, :"UTF-8", :CP51932]]
  @paths["[IBM869, CP850]"] = [[:IBM869, :"UTF-8", :CP850]]
  @paths["[IBM869, CP852]"] = [[:IBM869, :"UTF-8", :CP852]]
  @paths["[IBM869, CP855]"] = [[:IBM869, :"UTF-8", :CP855]]
  @paths["[IBM869, CP949]"] = [[:IBM869, :"UTF-8", :CP949]]
  @paths["[IBM869, CP950]"] = [[:IBM869, :"UTF-8", :CP950]]
  @paths["[IBM869, CP951]"] = [[:IBM869, :"UTF-8", :CP951]]
  @paths["[IBM869, EUC-JP]"] = [[:IBM869, :"UTF-8", :"EUC-JP"]]
  @paths["[IBM869, EUC-KR]"] = [[:IBM869, :"UTF-8", :"EUC-KR"]]
  @paths["[IBM869, EUCJP-MS]"] = [[:IBM869, :"UTF-8", :"EUCJP-MS"]]
  @paths["[IBM869, GB12345]"] = [[:IBM869, :"UTF-8", :GB12345]]
  @paths["[IBM869, GB18030]"] = [[:IBM869, :"UTF-8", :GB18030]]
  @paths["[IBM869, GB2312]"] = [[:IBM869, :"UTF-8", :GB2312]]
  @paths["[IBM869, GBK]"] = [[:IBM869, :"UTF-8", :GBK]]
  @paths["[IBM869, IBM437]"] = [[:IBM869, :"UTF-8", :IBM437]]
  @paths["[IBM869, IBM737]"] = [[:IBM869, :"UTF-8", :IBM737]]
  @paths["[IBM869, IBM775]"] = [[:IBM869, :"UTF-8", :IBM775]]
  @paths["[IBM869, IBM852]"] = [[:IBM869, :"UTF-8", :IBM852]]
  @paths["[IBM869, IBM855]"] = [[:IBM869, :"UTF-8", :IBM855]]
  @paths["[IBM869, IBM857]"] = [[:IBM869, :"UTF-8", :IBM857]]
  @paths["[IBM869, IBM860]"] = [[:IBM869, :"UTF-8", :IBM860]]
  @paths["[IBM869, IBM861]"] = [[:IBM869, :"UTF-8", :IBM861]]
  @paths["[IBM869, IBM862]"] = [[:IBM869, :"UTF-8", :IBM862]]
  @paths["[IBM869, IBM863]"] = [[:IBM869, :"UTF-8", :IBM863]]
  @paths["[IBM869, IBM865]"] = [[:IBM869, :"UTF-8", :IBM865]]
  @paths["[IBM869, IBM866]"] = [[:IBM869, :"UTF-8", :IBM866]]
  @paths["[IBM869, ISO-2022-JP]"] = [[:IBM869, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[IBM869, ISO-2022-JP-KDDI]"] = [[:IBM869, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[IBM869, ISO-8859-1]"] = [[:IBM869, :"UTF-8", :"ISO-8859-1"]]
  @paths["[IBM869, ISO-8859-10]"] = [[:IBM869, :"UTF-8", :"ISO-8859-10"]]
  @paths["[IBM869, ISO-8859-11]"] = [[:IBM869, :"UTF-8", :"ISO-8859-11"]]
  @paths["[IBM869, ISO-8859-13]"] = [[:IBM869, :"UTF-8", :"ISO-8859-13"]]
  @paths["[IBM869, ISO-8859-14]"] = [[:IBM869, :"UTF-8", :"ISO-8859-14"]]
  @paths["[IBM869, ISO-8859-15]"] = [[:IBM869, :"UTF-8", :"ISO-8859-15"]]
  @paths["[IBM869, ISO-8859-2]"] = [[:IBM869, :"UTF-8", :"ISO-8859-2"]]
  @paths["[IBM869, ISO-8859-3]"] = [[:IBM869, :"UTF-8", :"ISO-8859-3"]]
  @paths["[IBM869, ISO-8859-4]"] = [[:IBM869, :"UTF-8", :"ISO-8859-4"]]
  @paths["[IBM869, ISO-8859-5]"] = [[:IBM869, :"UTF-8", :"ISO-8859-5"]]
  @paths["[IBM869, ISO-8859-6]"] = [[:IBM869, :"UTF-8", :"ISO-8859-6"]]
  @paths["[IBM869, ISO-8859-7]"] = [[:IBM869, :"UTF-8", :"ISO-8859-7"]]
  @paths["[IBM869, ISO-8859-8]"] = [[:IBM869, :"UTF-8", :"ISO-8859-8"]]
  @paths["[IBM869, ISO-8859-9]"] = [[:IBM869, :"UTF-8", :"ISO-8859-9"]]
  @paths["[IBM869, KOI8-R]"] = [[:IBM869, :"UTF-8", :"KOI8-R"]]
  @paths["[IBM869, KOI8-U]"] = [[:IBM869, :"UTF-8", :"KOI8-U"]]
  @paths["[IBM869, MACCROATIAN]"] = [[:IBM869, :"UTF-8", :MACCROATIAN]]
  @paths["[IBM869, MACCYRILLIC]"] = [[:IBM869, :"UTF-8", :MACCYRILLIC]]
  @paths["[IBM869, MACGREEK]"] = [[:IBM869, :"UTF-8", :MACGREEK]]
  @paths["[IBM869, MACICELAND]"] = [[:IBM869, :"UTF-8", :MACICELAND]]
  @paths["[IBM869, MACROMAN]"] = [[:IBM869, :"UTF-8", :MACROMAN]]
  @paths["[IBM869, MACROMANIA]"] = [[:IBM869, :"UTF-8", :MACROMANIA]]
  @paths["[IBM869, MACTURKISH]"] = [[:IBM869, :"UTF-8", :MACTURKISH]]
  @paths["[IBM869, MACUKRAINE]"] = [[:IBM869, :"UTF-8", :MACUKRAINE]]
  @paths["[IBM869, SHIFT_JIS]"] = [[:IBM869, :"UTF-8", :SHIFT_JIS]]
  @paths["[IBM869, SJIS-DOCOMO]"] = [[:IBM869, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[IBM869, SJIS-KDDI]"] = [[:IBM869, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[IBM869, SJIS-SOFTBANK]"] = [[:IBM869, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[IBM869, STATELESS-ISO-2022-JP]"] = [[:IBM869, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[IBM869, STATELESS-ISO-2022-JP-KDDI]"] = [[:IBM869, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[IBM869, TIS-620]"] = [[:IBM869, :"UTF-8", :"TIS-620"]]
  @paths["[IBM869, US-ASCII]"] = [[:IBM869, :"UTF-8", :"US-ASCII"]]
  @paths["[IBM869, UTF-16]"] = [[:IBM869, :"UTF-8", :"UTF-16"]]
  @paths["[IBM869, UTF-16BE]"] = [[:IBM869, :"UTF-8", :"UTF-16BE"]]
  @paths["[IBM869, UTF-16LE]"] = [[:IBM869, :"UTF-8", :"UTF-16LE"]]
  @paths["[IBM869, UTF-32]"] = [[:IBM869, :"UTF-8", :"UTF-32"]]
  @paths["[IBM869, UTF-32BE]"] = [[:IBM869, :"UTF-8", :"UTF-32BE"]]
  @paths["[IBM869, UTF-32LE]"] = [[:IBM869, :"UTF-8", :"UTF-32LE"]]
  @paths["[IBM869, UTF-8]"] = [[:IBM869, :"UTF-8"]]
  @paths["[IBM869, UTF8-DOCOMO]"] = [[:IBM869, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[IBM869, UTF8-KDDI]"] = [[:IBM869, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[IBM869, UTF8-MAC]"] = [[:IBM869, :"UTF-8", :"UTF8-MAC"]]
  @paths["[IBM869, UTF8-SOFTBANK]"] = [[:IBM869, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[IBM869, WINDOWS-1250]"] = [[:IBM869, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[IBM869, WINDOWS-1251]"] = [[:IBM869, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[IBM869, WINDOWS-1252]"] = [[:IBM869, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[IBM869, WINDOWS-1253]"] = [[:IBM869, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[IBM869, WINDOWS-1254]"] = [[:IBM869, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[IBM869, WINDOWS-1255]"] = [[:IBM869, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[IBM869, WINDOWS-1256]"] = [[:IBM869, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[IBM869, WINDOWS-1257]"] = [[:IBM869, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[IBM869, WINDOWS-31J]"] = [[:IBM869, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[IBM869, WINDOWS-874]"] = [[:IBM869, :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-2022-JP, ASCII-8BIT]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-2022-JP, BIG5]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :BIG5]]
  @paths["[ISO-2022-JP, BIG5-HKSCS]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-2022-JP, BIG5-UAO]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-2022-JP, CP50220]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-2022-JP, CP50221]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-2022-JP, CP51932]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP51932]]
  @paths["[ISO-2022-JP, CP850]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP850]]
  @paths["[ISO-2022-JP, CP852]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP852]]
  @paths["[ISO-2022-JP, CP855]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP855]]
  @paths["[ISO-2022-JP, CP949]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP949]]
  @paths["[ISO-2022-JP, CP950]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP950]]
  @paths["[ISO-2022-JP, CP951]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP951]]
  @paths["[ISO-2022-JP, EUC-JP]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP"]]
  @paths["[ISO-2022-JP, EUC-KR]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-2022-JP, EUCJP-MS]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-2022-JP, GB12345]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :GB12345]]
  @paths["[ISO-2022-JP, GB18030]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :GB18030]]
  @paths["[ISO-2022-JP, GB2312]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :GB2312]]
  @paths["[ISO-2022-JP, GBK]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :GBK]]
  @paths["[ISO-2022-JP, IBM437]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM437]]
  @paths["[ISO-2022-JP, IBM737]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM737]]
  @paths["[ISO-2022-JP, IBM775]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM775]]
  @paths["[ISO-2022-JP, IBM852]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM852]]
  @paths["[ISO-2022-JP, IBM855]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM855]]
  @paths["[ISO-2022-JP, IBM857]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM857]]
  @paths["[ISO-2022-JP, IBM860]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM860]]
  @paths["[ISO-2022-JP, IBM861]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM861]]
  @paths["[ISO-2022-JP, IBM862]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM862]]
  @paths["[ISO-2022-JP, IBM863]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM863]]
  @paths["[ISO-2022-JP, IBM865]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM865]]
  @paths["[ISO-2022-JP, IBM866]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM866]]
  @paths["[ISO-2022-JP, IBM869]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM869]]
  @paths["[ISO-2022-JP, ISO-2022-JP-KDDI]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-2022-JP, ISO-8859-1]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-2022-JP, ISO-8859-10]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-2022-JP, ISO-8859-11]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-2022-JP, ISO-8859-13]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-2022-JP, ISO-8859-14]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-2022-JP, ISO-8859-15]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-2022-JP, ISO-8859-2]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-2022-JP, ISO-8859-3]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-2022-JP, ISO-8859-4]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-2022-JP, ISO-8859-5]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-2022-JP, ISO-8859-6]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-2022-JP, ISO-8859-7]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-2022-JP, ISO-8859-8]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-2022-JP, ISO-8859-9]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-2022-JP, KOI8-R]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-2022-JP, KOI8-U]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-2022-JP, MACCROATIAN]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-2022-JP, MACCYRILLIC]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-2022-JP, MACGREEK]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACGREEK]]
  @paths["[ISO-2022-JP, MACICELAND]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACICELAND]]
  @paths["[ISO-2022-JP, MACROMAN]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACROMAN]]
  @paths["[ISO-2022-JP, MACROMANIA]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-2022-JP, MACTURKISH]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-2022-JP, MACUKRAINE]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-2022-JP, SHIFT_JIS]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :SHIFT_JIS]]
  @paths["[ISO-2022-JP, SJIS-DOCOMO]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-2022-JP, SJIS-KDDI]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-2022-JP, SJIS-SOFTBANK]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-2022-JP, STATELESS-ISO-2022-JP]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-2022-JP, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-2022-JP, TIS-620]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-2022-JP, US-ASCII]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-2022-JP, UTF-16]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-2022-JP, UTF-16BE]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-2022-JP, UTF-16LE]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-2022-JP, UTF-32]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-2022-JP, UTF-32BE]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-2022-JP, UTF-32LE]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-2022-JP, UTF-8]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8"]]
  @paths["[ISO-2022-JP, UTF8-DOCOMO]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-2022-JP, UTF8-KDDI]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-2022-JP, UTF8-MAC]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-2022-JP, UTF8-SOFTBANK]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-2022-JP, WINDOWS-1250]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-2022-JP, WINDOWS-1251]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-2022-JP, WINDOWS-1252]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-2022-JP, WINDOWS-1253]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-2022-JP, WINDOWS-1254]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-2022-JP, WINDOWS-1255]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-2022-JP, WINDOWS-1256]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-2022-JP, WINDOWS-1257]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-2022-JP, WINDOWS-31J]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-2022-JP, WINDOWS-874]"] = [[:"ISO-2022-JP", :"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-2022-JP-KDDI, ASCII-8BIT]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-2022-JP-KDDI, BIG5]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :BIG5]]
  @paths["[ISO-2022-JP-KDDI, BIG5-HKSCS]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-2022-JP-KDDI, BIG5-UAO]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-2022-JP-KDDI, CP50220]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-2022-JP-KDDI, CP50221]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-2022-JP-KDDI, CP51932]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP51932]]
  @paths["[ISO-2022-JP-KDDI, CP850]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP850]]
  @paths["[ISO-2022-JP-KDDI, CP852]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP852]]
  @paths["[ISO-2022-JP-KDDI, CP855]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP855]]
  @paths["[ISO-2022-JP-KDDI, CP949]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP949]]
  @paths["[ISO-2022-JP-KDDI, CP950]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP950]]
  @paths["[ISO-2022-JP-KDDI, CP951]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP951]]
  @paths["[ISO-2022-JP-KDDI, EUC-JP]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-2022-JP-KDDI, EUC-KR]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-2022-JP-KDDI, EUCJP-MS]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-2022-JP-KDDI, GB12345]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :GB12345]]
  @paths["[ISO-2022-JP-KDDI, GB18030]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :GB18030]]
  @paths["[ISO-2022-JP-KDDI, GB2312]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :GB2312]]
  @paths["[ISO-2022-JP-KDDI, GBK]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :GBK]]
  @paths["[ISO-2022-JP-KDDI, IBM437]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM437]]
  @paths["[ISO-2022-JP-KDDI, IBM737]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM737]]
  @paths["[ISO-2022-JP-KDDI, IBM775]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM775]]
  @paths["[ISO-2022-JP-KDDI, IBM852]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM852]]
  @paths["[ISO-2022-JP-KDDI, IBM855]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM855]]
  @paths["[ISO-2022-JP-KDDI, IBM857]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM857]]
  @paths["[ISO-2022-JP-KDDI, IBM860]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM860]]
  @paths["[ISO-2022-JP-KDDI, IBM861]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM861]]
  @paths["[ISO-2022-JP-KDDI, IBM862]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM862]]
  @paths["[ISO-2022-JP-KDDI, IBM863]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM863]]
  @paths["[ISO-2022-JP-KDDI, IBM865]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM865]]
  @paths["[ISO-2022-JP-KDDI, IBM866]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM866]]
  @paths["[ISO-2022-JP-KDDI, IBM869]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM869]]
  @paths["[ISO-2022-JP-KDDI, ISO-2022-JP]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-1]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-10]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-11]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-13]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-14]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-15]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-2]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-3]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-4]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-5]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-6]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-7]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-8]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-2022-JP-KDDI, ISO-8859-9]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-2022-JP-KDDI, KOI8-R]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-2022-JP-KDDI, KOI8-U]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-2022-JP-KDDI, MACCROATIAN]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-2022-JP-KDDI, MACCYRILLIC]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-2022-JP-KDDI, MACGREEK]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACGREEK]]
  @paths["[ISO-2022-JP-KDDI, MACICELAND]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACICELAND]]
  @paths["[ISO-2022-JP-KDDI, MACROMAN]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACROMAN]]
  @paths["[ISO-2022-JP-KDDI, MACROMANIA]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-2022-JP-KDDI, MACTURKISH]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-2022-JP-KDDI, MACUKRAINE]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-2022-JP-KDDI, SHIFT_JIS]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-2022-JP-KDDI, SJIS-DOCOMO]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-2022-JP-KDDI, SJIS-KDDI]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-2022-JP-KDDI, SJIS-SOFTBANK]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-2022-JP-KDDI, STATELESS-ISO-2022-JP]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-2022-JP-KDDI, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-2022-JP-KDDI, TIS-620]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-2022-JP-KDDI, US-ASCII]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-2022-JP-KDDI, UTF-16]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-2022-JP-KDDI, UTF-16BE]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-2022-JP-KDDI, UTF-16LE]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-2022-JP-KDDI, UTF-32]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-2022-JP-KDDI, UTF-32BE]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-2022-JP-KDDI, UTF-32LE]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-2022-JP-KDDI, UTF-8]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8"]]
  @paths["[ISO-2022-JP-KDDI, UTF8-DOCOMO]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF8-DOCOMO"]]
  @paths["[ISO-2022-JP-KDDI, UTF8-KDDI]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI"]]
  @paths["[ISO-2022-JP-KDDI, UTF8-MAC]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-2022-JP-KDDI, UTF8-SOFTBANK]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF8-SOFTBANK"]]
  @paths["[ISO-2022-JP-KDDI, WINDOWS-1250]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-2022-JP-KDDI, WINDOWS-1251]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-2022-JP-KDDI, WINDOWS-1252]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-2022-JP-KDDI, WINDOWS-1253]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-2022-JP-KDDI, WINDOWS-1254]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-2022-JP-KDDI, WINDOWS-1255]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-2022-JP-KDDI, WINDOWS-1256]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-2022-JP-KDDI, WINDOWS-1257]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-2022-JP-KDDI, WINDOWS-31J]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-2022-JP-KDDI, WINDOWS-874]"] = [[:"ISO-2022-JP-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-1, ASCII-8BIT]"] = [[:"ISO-8859-1", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-1, BIG5]"] = [[:"ISO-8859-1", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-1, BIG5-HKSCS]"] = [[:"ISO-8859-1", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-1, BIG5-UAO]"] = [[:"ISO-8859-1", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-1, CP50220]"] = [[:"ISO-8859-1", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-1, CP50221]"] = [[:"ISO-8859-1", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-1, CP51932]"] = [[:"ISO-8859-1", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-1, CP850]"] = [[:"ISO-8859-1", :"UTF-8", :CP850]]
  @paths["[ISO-8859-1, CP852]"] = [[:"ISO-8859-1", :"UTF-8", :CP852]]
  @paths["[ISO-8859-1, CP855]"] = [[:"ISO-8859-1", :"UTF-8", :CP855]]
  @paths["[ISO-8859-1, CP949]"] = [[:"ISO-8859-1", :"UTF-8", :CP949]]
  @paths["[ISO-8859-1, CP950]"] = [[:"ISO-8859-1", :"UTF-8", :CP950]]
  @paths["[ISO-8859-1, CP951]"] = [[:"ISO-8859-1", :"UTF-8", :CP951]]
  @paths["[ISO-8859-1, EUC-JP]"] = [[:"ISO-8859-1", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-1, EUC-KR]"] = [[:"ISO-8859-1", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-1, EUCJP-MS]"] = [[:"ISO-8859-1", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-1, GB12345]"] = [[:"ISO-8859-1", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-1, GB18030]"] = [[:"ISO-8859-1", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-1, GB2312]"] = [[:"ISO-8859-1", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-1, GBK]"] = [[:"ISO-8859-1", :"UTF-8", :GBK]]
  @paths["[ISO-8859-1, IBM437]"] = [[:"ISO-8859-1", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-1, IBM737]"] = [[:"ISO-8859-1", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-1, IBM775]"] = [[:"ISO-8859-1", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-1, IBM852]"] = [[:"ISO-8859-1", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-1, IBM855]"] = [[:"ISO-8859-1", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-1, IBM857]"] = [[:"ISO-8859-1", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-1, IBM860]"] = [[:"ISO-8859-1", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-1, IBM861]"] = [[:"ISO-8859-1", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-1, IBM862]"] = [[:"ISO-8859-1", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-1, IBM863]"] = [[:"ISO-8859-1", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-1, IBM865]"] = [[:"ISO-8859-1", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-1, IBM866]"] = [[:"ISO-8859-1", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-1, IBM869]"] = [[:"ISO-8859-1", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-1, ISO-2022-JP]"] = [[:"ISO-8859-1", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-1, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-1, ISO-8859-10]"] = [[:"ISO-8859-1", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-8859-1, ISO-8859-11]"] = [[:"ISO-8859-1", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-8859-1, ISO-8859-13]"] = [[:"ISO-8859-1", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-8859-1, ISO-8859-14]"] = [[:"ISO-8859-1", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-8859-1, ISO-8859-15]"] = [[:"ISO-8859-1", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-8859-1, ISO-8859-2]"] = [[:"ISO-8859-1", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-8859-1, ISO-8859-3]"] = [[:"ISO-8859-1", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-8859-1, ISO-8859-4]"] = [[:"ISO-8859-1", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-8859-1, ISO-8859-5]"] = [[:"ISO-8859-1", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-8859-1, ISO-8859-6]"] = [[:"ISO-8859-1", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-8859-1, ISO-8859-7]"] = [[:"ISO-8859-1", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-8859-1, ISO-8859-8]"] = [[:"ISO-8859-1", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-8859-1, ISO-8859-9]"] = [[:"ISO-8859-1", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-8859-1, KOI8-R]"] = [[:"ISO-8859-1", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-1, KOI8-U]"] = [[:"ISO-8859-1", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-1, MACCROATIAN]"] = [[:"ISO-8859-1", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-1, MACCYRILLIC]"] = [[:"ISO-8859-1", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-1, MACGREEK]"] = [[:"ISO-8859-1", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-1, MACICELAND]"] = [[:"ISO-8859-1", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-1, MACROMAN]"] = [[:"ISO-8859-1", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-1, MACROMANIA]"] = [[:"ISO-8859-1", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-1, MACTURKISH]"] = [[:"ISO-8859-1", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-1, MACUKRAINE]"] = [[:"ISO-8859-1", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-1, SHIFT_JIS]"] = [[:"ISO-8859-1", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-1, SJIS-DOCOMO]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-1, SJIS-KDDI]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-1, SJIS-SOFTBANK]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-1, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-1", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-1, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-1, TIS-620]"] = [[:"ISO-8859-1", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-1, US-ASCII]"] = [[:"ISO-8859-1", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-1, UTF-16]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-1, UTF-16BE]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-1, UTF-16LE]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-1, UTF-32]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-1, UTF-32BE]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-1, UTF-32LE]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-1, UTF-8]"] = [[:"ISO-8859-1", :"UTF-8"]]
  @paths["[ISO-8859-1, UTF8-DOCOMO]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-1, UTF8-KDDI]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-1, UTF8-MAC]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-1, UTF8-SOFTBANK]"] = [[:"ISO-8859-1", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-1, WINDOWS-1250]"] = [[:"ISO-8859-1", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-1, WINDOWS-1251]"] = [[:"ISO-8859-1", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-1, WINDOWS-1252]"] = [[:"ISO-8859-1", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-1, WINDOWS-1253]"] = [[:"ISO-8859-1", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-1, WINDOWS-1254]"] = [[:"ISO-8859-1", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-1, WINDOWS-1255]"] = [[:"ISO-8859-1", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-1, WINDOWS-1256]"] = [[:"ISO-8859-1", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-1, WINDOWS-1257]"] = [[:"ISO-8859-1", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-1, WINDOWS-31J]"] = [[:"ISO-8859-1", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-1, WINDOWS-874]"] = [[:"ISO-8859-1", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-10, ASCII-8BIT]"] = [[:"ISO-8859-10", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-10, BIG5]"] = [[:"ISO-8859-10", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-10, BIG5-HKSCS]"] = [[:"ISO-8859-10", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-10, BIG5-UAO]"] = [[:"ISO-8859-10", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-10, CP50220]"] = [[:"ISO-8859-10", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-10, CP50221]"] = [[:"ISO-8859-10", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-10, CP51932]"] = [[:"ISO-8859-10", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-10, CP850]"] = [[:"ISO-8859-10", :"UTF-8", :CP850]]
  @paths["[ISO-8859-10, CP852]"] = [[:"ISO-8859-10", :"UTF-8", :CP852]]
  @paths["[ISO-8859-10, CP855]"] = [[:"ISO-8859-10", :"UTF-8", :CP855]]
  @paths["[ISO-8859-10, CP949]"] = [[:"ISO-8859-10", :"UTF-8", :CP949]]
  @paths["[ISO-8859-10, CP950]"] = [[:"ISO-8859-10", :"UTF-8", :CP950]]
  @paths["[ISO-8859-10, CP951]"] = [[:"ISO-8859-10", :"UTF-8", :CP951]]
  @paths["[ISO-8859-10, EUC-JP]"] = [[:"ISO-8859-10", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-10, EUC-KR]"] = [[:"ISO-8859-10", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-10, EUCJP-MS]"] = [[:"ISO-8859-10", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-10, GB12345]"] = [[:"ISO-8859-10", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-10, GB18030]"] = [[:"ISO-8859-10", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-10, GB2312]"] = [[:"ISO-8859-10", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-10, GBK]"] = [[:"ISO-8859-10", :"UTF-8", :GBK]]
  @paths["[ISO-8859-10, IBM437]"] = [[:"ISO-8859-10", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-10, IBM737]"] = [[:"ISO-8859-10", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-10, IBM775]"] = [[:"ISO-8859-10", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-10, IBM852]"] = [[:"ISO-8859-10", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-10, IBM855]"] = [[:"ISO-8859-10", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-10, IBM857]"] = [[:"ISO-8859-10", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-10, IBM860]"] = [[:"ISO-8859-10", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-10, IBM861]"] = [[:"ISO-8859-10", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-10, IBM862]"] = [[:"ISO-8859-10", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-10, IBM863]"] = [[:"ISO-8859-10", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-10, IBM865]"] = [[:"ISO-8859-10", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-10, IBM866]"] = [[:"ISO-8859-10", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-10, IBM869]"] = [[:"ISO-8859-10", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-10, ISO-2022-JP]"] = [[:"ISO-8859-10", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-10, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-10, ISO-8859-1]"] = [[:"ISO-8859-10", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-8859-10, ISO-8859-11]"] = [[:"ISO-8859-10", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-8859-10, ISO-8859-13]"] = [[:"ISO-8859-10", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-8859-10, ISO-8859-14]"] = [[:"ISO-8859-10", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-8859-10, ISO-8859-15]"] = [[:"ISO-8859-10", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-8859-10, ISO-8859-2]"] = [[:"ISO-8859-10", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-8859-10, ISO-8859-3]"] = [[:"ISO-8859-10", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-8859-10, ISO-8859-4]"] = [[:"ISO-8859-10", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-8859-10, ISO-8859-5]"] = [[:"ISO-8859-10", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-8859-10, ISO-8859-6]"] = [[:"ISO-8859-10", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-8859-10, ISO-8859-7]"] = [[:"ISO-8859-10", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-8859-10, ISO-8859-8]"] = [[:"ISO-8859-10", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-8859-10, ISO-8859-9]"] = [[:"ISO-8859-10", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-8859-10, KOI8-R]"] = [[:"ISO-8859-10", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-10, KOI8-U]"] = [[:"ISO-8859-10", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-10, MACCROATIAN]"] = [[:"ISO-8859-10", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-10, MACCYRILLIC]"] = [[:"ISO-8859-10", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-10, MACGREEK]"] = [[:"ISO-8859-10", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-10, MACICELAND]"] = [[:"ISO-8859-10", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-10, MACROMAN]"] = [[:"ISO-8859-10", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-10, MACROMANIA]"] = [[:"ISO-8859-10", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-10, MACTURKISH]"] = [[:"ISO-8859-10", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-10, MACUKRAINE]"] = [[:"ISO-8859-10", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-10, SHIFT_JIS]"] = [[:"ISO-8859-10", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-10, SJIS-DOCOMO]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-10, SJIS-KDDI]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-10, SJIS-SOFTBANK]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-10, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-10", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-10, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-10, TIS-620]"] = [[:"ISO-8859-10", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-10, US-ASCII]"] = [[:"ISO-8859-10", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-10, UTF-16]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-10, UTF-16BE]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-10, UTF-16LE]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-10, UTF-32]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-10, UTF-32BE]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-10, UTF-32LE]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-10, UTF-8]"] = [[:"ISO-8859-10", :"UTF-8"]]
  @paths["[ISO-8859-10, UTF8-DOCOMO]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-10, UTF8-KDDI]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-10, UTF8-MAC]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-10, UTF8-SOFTBANK]"] = [[:"ISO-8859-10", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-10, WINDOWS-1250]"] = [[:"ISO-8859-10", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-10, WINDOWS-1251]"] = [[:"ISO-8859-10", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-10, WINDOWS-1252]"] = [[:"ISO-8859-10", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-10, WINDOWS-1253]"] = [[:"ISO-8859-10", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-10, WINDOWS-1254]"] = [[:"ISO-8859-10", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-10, WINDOWS-1255]"] = [[:"ISO-8859-10", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-10, WINDOWS-1256]"] = [[:"ISO-8859-10", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-10, WINDOWS-1257]"] = [[:"ISO-8859-10", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-10, WINDOWS-31J]"] = [[:"ISO-8859-10", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-10, WINDOWS-874]"] = [[:"ISO-8859-10", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-11, ASCII-8BIT]"] = [[:"ISO-8859-11", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-11, BIG5]"] = [[:"ISO-8859-11", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-11, BIG5-HKSCS]"] = [[:"ISO-8859-11", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-11, BIG5-UAO]"] = [[:"ISO-8859-11", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-11, CP50220]"] = [[:"ISO-8859-11", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-11, CP50221]"] = [[:"ISO-8859-11", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-11, CP51932]"] = [[:"ISO-8859-11", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-11, CP850]"] = [[:"ISO-8859-11", :"UTF-8", :CP850]]
  @paths["[ISO-8859-11, CP852]"] = [[:"ISO-8859-11", :"UTF-8", :CP852]]
  @paths["[ISO-8859-11, CP855]"] = [[:"ISO-8859-11", :"UTF-8", :CP855]]
  @paths["[ISO-8859-11, CP949]"] = [[:"ISO-8859-11", :"UTF-8", :CP949]]
  @paths["[ISO-8859-11, CP950]"] = [[:"ISO-8859-11", :"UTF-8", :CP950]]
  @paths["[ISO-8859-11, CP951]"] = [[:"ISO-8859-11", :"UTF-8", :CP951]]
  @paths["[ISO-8859-11, EUC-JP]"] = [[:"ISO-8859-11", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-11, EUC-KR]"] = [[:"ISO-8859-11", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-11, EUCJP-MS]"] = [[:"ISO-8859-11", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-11, GB12345]"] = [[:"ISO-8859-11", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-11, GB18030]"] = [[:"ISO-8859-11", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-11, GB2312]"] = [[:"ISO-8859-11", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-11, GBK]"] = [[:"ISO-8859-11", :"UTF-8", :GBK]]
  @paths["[ISO-8859-11, IBM437]"] = [[:"ISO-8859-11", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-11, IBM737]"] = [[:"ISO-8859-11", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-11, IBM775]"] = [[:"ISO-8859-11", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-11, IBM852]"] = [[:"ISO-8859-11", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-11, IBM855]"] = [[:"ISO-8859-11", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-11, IBM857]"] = [[:"ISO-8859-11", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-11, IBM860]"] = [[:"ISO-8859-11", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-11, IBM861]"] = [[:"ISO-8859-11", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-11, IBM862]"] = [[:"ISO-8859-11", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-11, IBM863]"] = [[:"ISO-8859-11", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-11, IBM865]"] = [[:"ISO-8859-11", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-11, IBM866]"] = [[:"ISO-8859-11", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-11, IBM869]"] = [[:"ISO-8859-11", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-11, ISO-2022-JP]"] = [[:"ISO-8859-11", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-11, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-11, ISO-8859-1]"] = [[:"ISO-8859-11", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-8859-11, ISO-8859-10]"] = [[:"ISO-8859-11", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-8859-11, ISO-8859-13]"] = [[:"ISO-8859-11", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-8859-11, ISO-8859-14]"] = [[:"ISO-8859-11", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-8859-11, ISO-8859-15]"] = [[:"ISO-8859-11", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-8859-11, ISO-8859-2]"] = [[:"ISO-8859-11", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-8859-11, ISO-8859-3]"] = [[:"ISO-8859-11", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-8859-11, ISO-8859-4]"] = [[:"ISO-8859-11", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-8859-11, ISO-8859-5]"] = [[:"ISO-8859-11", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-8859-11, ISO-8859-6]"] = [[:"ISO-8859-11", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-8859-11, ISO-8859-7]"] = [[:"ISO-8859-11", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-8859-11, ISO-8859-8]"] = [[:"ISO-8859-11", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-8859-11, ISO-8859-9]"] = [[:"ISO-8859-11", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-8859-11, KOI8-R]"] = [[:"ISO-8859-11", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-11, KOI8-U]"] = [[:"ISO-8859-11", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-11, MACCROATIAN]"] = [[:"ISO-8859-11", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-11, MACCYRILLIC]"] = [[:"ISO-8859-11", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-11, MACGREEK]"] = [[:"ISO-8859-11", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-11, MACICELAND]"] = [[:"ISO-8859-11", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-11, MACROMAN]"] = [[:"ISO-8859-11", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-11, MACROMANIA]"] = [[:"ISO-8859-11", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-11, MACTURKISH]"] = [[:"ISO-8859-11", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-11, MACUKRAINE]"] = [[:"ISO-8859-11", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-11, SHIFT_JIS]"] = [[:"ISO-8859-11", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-11, SJIS-DOCOMO]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-11, SJIS-KDDI]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-11, SJIS-SOFTBANK]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-11, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-11", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-11, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-11, TIS-620]"] = [[:"ISO-8859-11", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-11, US-ASCII]"] = [[:"ISO-8859-11", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-11, UTF-16]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-11, UTF-16BE]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-11, UTF-16LE]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-11, UTF-32]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-11, UTF-32BE]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-11, UTF-32LE]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-11, UTF-8]"] = [[:"ISO-8859-11", :"UTF-8"]]
  @paths["[ISO-8859-11, UTF8-DOCOMO]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-11, UTF8-KDDI]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-11, UTF8-MAC]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-11, UTF8-SOFTBANK]"] = [[:"ISO-8859-11", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-11, WINDOWS-1250]"] = [[:"ISO-8859-11", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-11, WINDOWS-1251]"] = [[:"ISO-8859-11", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-11, WINDOWS-1252]"] = [[:"ISO-8859-11", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-11, WINDOWS-1253]"] = [[:"ISO-8859-11", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-11, WINDOWS-1254]"] = [[:"ISO-8859-11", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-11, WINDOWS-1255]"] = [[:"ISO-8859-11", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-11, WINDOWS-1256]"] = [[:"ISO-8859-11", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-11, WINDOWS-1257]"] = [[:"ISO-8859-11", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-11, WINDOWS-31J]"] = [[:"ISO-8859-11", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-11, WINDOWS-874]"] = [[:"ISO-8859-11", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-13, ASCII-8BIT]"] = [[:"ISO-8859-13", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-13, BIG5]"] = [[:"ISO-8859-13", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-13, BIG5-HKSCS]"] = [[:"ISO-8859-13", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-13, BIG5-UAO]"] = [[:"ISO-8859-13", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-13, CP50220]"] = [[:"ISO-8859-13", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-13, CP50221]"] = [[:"ISO-8859-13", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-13, CP51932]"] = [[:"ISO-8859-13", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-13, CP850]"] = [[:"ISO-8859-13", :"UTF-8", :CP850]]
  @paths["[ISO-8859-13, CP852]"] = [[:"ISO-8859-13", :"UTF-8", :CP852]]
  @paths["[ISO-8859-13, CP855]"] = [[:"ISO-8859-13", :"UTF-8", :CP855]]
  @paths["[ISO-8859-13, CP949]"] = [[:"ISO-8859-13", :"UTF-8", :CP949]]
  @paths["[ISO-8859-13, CP950]"] = [[:"ISO-8859-13", :"UTF-8", :CP950]]
  @paths["[ISO-8859-13, CP951]"] = [[:"ISO-8859-13", :"UTF-8", :CP951]]
  @paths["[ISO-8859-13, EUC-JP]"] = [[:"ISO-8859-13", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-13, EUC-KR]"] = [[:"ISO-8859-13", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-13, EUCJP-MS]"] = [[:"ISO-8859-13", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-13, GB12345]"] = [[:"ISO-8859-13", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-13, GB18030]"] = [[:"ISO-8859-13", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-13, GB2312]"] = [[:"ISO-8859-13", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-13, GBK]"] = [[:"ISO-8859-13", :"UTF-8", :GBK]]
  @paths["[ISO-8859-13, IBM437]"] = [[:"ISO-8859-13", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-13, IBM737]"] = [[:"ISO-8859-13", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-13, IBM775]"] = [[:"ISO-8859-13", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-13, IBM852]"] = [[:"ISO-8859-13", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-13, IBM855]"] = [[:"ISO-8859-13", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-13, IBM857]"] = [[:"ISO-8859-13", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-13, IBM860]"] = [[:"ISO-8859-13", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-13, IBM861]"] = [[:"ISO-8859-13", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-13, IBM862]"] = [[:"ISO-8859-13", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-13, IBM863]"] = [[:"ISO-8859-13", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-13, IBM865]"] = [[:"ISO-8859-13", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-13, IBM866]"] = [[:"ISO-8859-13", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-13, IBM869]"] = [[:"ISO-8859-13", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-13, ISO-2022-JP]"] = [[:"ISO-8859-13", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-13, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-13, ISO-8859-1]"] = [[:"ISO-8859-13", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-8859-13, ISO-8859-10]"] = [[:"ISO-8859-13", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-8859-13, ISO-8859-11]"] = [[:"ISO-8859-13", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-8859-13, ISO-8859-14]"] = [[:"ISO-8859-13", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-8859-13, ISO-8859-15]"] = [[:"ISO-8859-13", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-8859-13, ISO-8859-2]"] = [[:"ISO-8859-13", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-8859-13, ISO-8859-3]"] = [[:"ISO-8859-13", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-8859-13, ISO-8859-4]"] = [[:"ISO-8859-13", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-8859-13, ISO-8859-5]"] = [[:"ISO-8859-13", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-8859-13, ISO-8859-6]"] = [[:"ISO-8859-13", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-8859-13, ISO-8859-7]"] = [[:"ISO-8859-13", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-8859-13, ISO-8859-8]"] = [[:"ISO-8859-13", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-8859-13, ISO-8859-9]"] = [[:"ISO-8859-13", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-8859-13, KOI8-R]"] = [[:"ISO-8859-13", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-13, KOI8-U]"] = [[:"ISO-8859-13", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-13, MACCROATIAN]"] = [[:"ISO-8859-13", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-13, MACCYRILLIC]"] = [[:"ISO-8859-13", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-13, MACGREEK]"] = [[:"ISO-8859-13", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-13, MACICELAND]"] = [[:"ISO-8859-13", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-13, MACROMAN]"] = [[:"ISO-8859-13", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-13, MACROMANIA]"] = [[:"ISO-8859-13", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-13, MACTURKISH]"] = [[:"ISO-8859-13", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-13, MACUKRAINE]"] = [[:"ISO-8859-13", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-13, SHIFT_JIS]"] = [[:"ISO-8859-13", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-13, SJIS-DOCOMO]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-13, SJIS-KDDI]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-13, SJIS-SOFTBANK]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-13, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-13", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-13, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-13, TIS-620]"] = [[:"ISO-8859-13", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-13, US-ASCII]"] = [[:"ISO-8859-13", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-13, UTF-16]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-13, UTF-16BE]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-13, UTF-16LE]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-13, UTF-32]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-13, UTF-32BE]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-13, UTF-32LE]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-13, UTF-8]"] = [[:"ISO-8859-13", :"UTF-8"]]
  @paths["[ISO-8859-13, UTF8-DOCOMO]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-13, UTF8-KDDI]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-13, UTF8-MAC]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-13, UTF8-SOFTBANK]"] = [[:"ISO-8859-13", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-13, WINDOWS-1250]"] = [[:"ISO-8859-13", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-13, WINDOWS-1251]"] = [[:"ISO-8859-13", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-13, WINDOWS-1252]"] = [[:"ISO-8859-13", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-13, WINDOWS-1253]"] = [[:"ISO-8859-13", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-13, WINDOWS-1254]"] = [[:"ISO-8859-13", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-13, WINDOWS-1255]"] = [[:"ISO-8859-13", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-13, WINDOWS-1256]"] = [[:"ISO-8859-13", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-13, WINDOWS-1257]"] = [[:"ISO-8859-13", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-13, WINDOWS-31J]"] = [[:"ISO-8859-13", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-13, WINDOWS-874]"] = [[:"ISO-8859-13", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-14, ASCII-8BIT]"] = [[:"ISO-8859-14", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-14, BIG5]"] = [[:"ISO-8859-14", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-14, BIG5-HKSCS]"] = [[:"ISO-8859-14", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-14, BIG5-UAO]"] = [[:"ISO-8859-14", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-14, CP50220]"] = [[:"ISO-8859-14", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-14, CP50221]"] = [[:"ISO-8859-14", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-14, CP51932]"] = [[:"ISO-8859-14", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-14, CP850]"] = [[:"ISO-8859-14", :"UTF-8", :CP850]]
  @paths["[ISO-8859-14, CP852]"] = [[:"ISO-8859-14", :"UTF-8", :CP852]]
  @paths["[ISO-8859-14, CP855]"] = [[:"ISO-8859-14", :"UTF-8", :CP855]]
  @paths["[ISO-8859-14, CP949]"] = [[:"ISO-8859-14", :"UTF-8", :CP949]]
  @paths["[ISO-8859-14, CP950]"] = [[:"ISO-8859-14", :"UTF-8", :CP950]]
  @paths["[ISO-8859-14, CP951]"] = [[:"ISO-8859-14", :"UTF-8", :CP951]]
  @paths["[ISO-8859-14, EUC-JP]"] = [[:"ISO-8859-14", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-14, EUC-KR]"] = [[:"ISO-8859-14", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-14, EUCJP-MS]"] = [[:"ISO-8859-14", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-14, GB12345]"] = [[:"ISO-8859-14", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-14, GB18030]"] = [[:"ISO-8859-14", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-14, GB2312]"] = [[:"ISO-8859-14", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-14, GBK]"] = [[:"ISO-8859-14", :"UTF-8", :GBK]]
  @paths["[ISO-8859-14, IBM437]"] = [[:"ISO-8859-14", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-14, IBM737]"] = [[:"ISO-8859-14", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-14, IBM775]"] = [[:"ISO-8859-14", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-14, IBM852]"] = [[:"ISO-8859-14", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-14, IBM855]"] = [[:"ISO-8859-14", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-14, IBM857]"] = [[:"ISO-8859-14", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-14, IBM860]"] = [[:"ISO-8859-14", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-14, IBM861]"] = [[:"ISO-8859-14", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-14, IBM862]"] = [[:"ISO-8859-14", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-14, IBM863]"] = [[:"ISO-8859-14", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-14, IBM865]"] = [[:"ISO-8859-14", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-14, IBM866]"] = [[:"ISO-8859-14", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-14, IBM869]"] = [[:"ISO-8859-14", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-14, ISO-2022-JP]"] = [[:"ISO-8859-14", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-14, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-14, ISO-8859-1]"] = [[:"ISO-8859-14", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-8859-14, ISO-8859-10]"] = [[:"ISO-8859-14", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-8859-14, ISO-8859-11]"] = [[:"ISO-8859-14", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-8859-14, ISO-8859-13]"] = [[:"ISO-8859-14", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-8859-14, ISO-8859-15]"] = [[:"ISO-8859-14", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-8859-14, ISO-8859-2]"] = [[:"ISO-8859-14", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-8859-14, ISO-8859-3]"] = [[:"ISO-8859-14", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-8859-14, ISO-8859-4]"] = [[:"ISO-8859-14", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-8859-14, ISO-8859-5]"] = [[:"ISO-8859-14", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-8859-14, ISO-8859-6]"] = [[:"ISO-8859-14", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-8859-14, ISO-8859-7]"] = [[:"ISO-8859-14", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-8859-14, ISO-8859-8]"] = [[:"ISO-8859-14", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-8859-14, ISO-8859-9]"] = [[:"ISO-8859-14", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-8859-14, KOI8-R]"] = [[:"ISO-8859-14", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-14, KOI8-U]"] = [[:"ISO-8859-14", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-14, MACCROATIAN]"] = [[:"ISO-8859-14", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-14, MACCYRILLIC]"] = [[:"ISO-8859-14", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-14, MACGREEK]"] = [[:"ISO-8859-14", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-14, MACICELAND]"] = [[:"ISO-8859-14", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-14, MACROMAN]"] = [[:"ISO-8859-14", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-14, MACROMANIA]"] = [[:"ISO-8859-14", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-14, MACTURKISH]"] = [[:"ISO-8859-14", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-14, MACUKRAINE]"] = [[:"ISO-8859-14", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-14, SHIFT_JIS]"] = [[:"ISO-8859-14", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-14, SJIS-DOCOMO]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-14, SJIS-KDDI]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-14, SJIS-SOFTBANK]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-14, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-14", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-14, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-14, TIS-620]"] = [[:"ISO-8859-14", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-14, US-ASCII]"] = [[:"ISO-8859-14", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-14, UTF-16]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-14, UTF-16BE]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-14, UTF-16LE]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-14, UTF-32]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-14, UTF-32BE]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-14, UTF-32LE]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-14, UTF-8]"] = [[:"ISO-8859-14", :"UTF-8"]]
  @paths["[ISO-8859-14, UTF8-DOCOMO]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-14, UTF8-KDDI]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-14, UTF8-MAC]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-14, UTF8-SOFTBANK]"] = [[:"ISO-8859-14", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-14, WINDOWS-1250]"] = [[:"ISO-8859-14", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-14, WINDOWS-1251]"] = [[:"ISO-8859-14", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-14, WINDOWS-1252]"] = [[:"ISO-8859-14", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-14, WINDOWS-1253]"] = [[:"ISO-8859-14", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-14, WINDOWS-1254]"] = [[:"ISO-8859-14", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-14, WINDOWS-1255]"] = [[:"ISO-8859-14", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-14, WINDOWS-1256]"] = [[:"ISO-8859-14", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-14, WINDOWS-1257]"] = [[:"ISO-8859-14", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-14, WINDOWS-31J]"] = [[:"ISO-8859-14", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-14, WINDOWS-874]"] = [[:"ISO-8859-14", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-15, ASCII-8BIT]"] = [[:"ISO-8859-15", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-15, BIG5]"] = [[:"ISO-8859-15", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-15, BIG5-HKSCS]"] = [[:"ISO-8859-15", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-15, BIG5-UAO]"] = [[:"ISO-8859-15", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-15, CP50220]"] = [[:"ISO-8859-15", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-15, CP50221]"] = [[:"ISO-8859-15", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-15, CP51932]"] = [[:"ISO-8859-15", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-15, CP850]"] = [[:"ISO-8859-15", :"UTF-8", :CP850]]
  @paths["[ISO-8859-15, CP852]"] = [[:"ISO-8859-15", :"UTF-8", :CP852]]
  @paths["[ISO-8859-15, CP855]"] = [[:"ISO-8859-15", :"UTF-8", :CP855]]
  @paths["[ISO-8859-15, CP949]"] = [[:"ISO-8859-15", :"UTF-8", :CP949]]
  @paths["[ISO-8859-15, CP950]"] = [[:"ISO-8859-15", :"UTF-8", :CP950]]
  @paths["[ISO-8859-15, CP951]"] = [[:"ISO-8859-15", :"UTF-8", :CP951]]
  @paths["[ISO-8859-15, EUC-JP]"] = [[:"ISO-8859-15", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-15, EUC-KR]"] = [[:"ISO-8859-15", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-15, EUCJP-MS]"] = [[:"ISO-8859-15", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-15, GB12345]"] = [[:"ISO-8859-15", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-15, GB18030]"] = [[:"ISO-8859-15", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-15, GB2312]"] = [[:"ISO-8859-15", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-15, GBK]"] = [[:"ISO-8859-15", :"UTF-8", :GBK]]
  @paths["[ISO-8859-15, IBM437]"] = [[:"ISO-8859-15", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-15, IBM737]"] = [[:"ISO-8859-15", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-15, IBM775]"] = [[:"ISO-8859-15", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-15, IBM852]"] = [[:"ISO-8859-15", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-15, IBM855]"] = [[:"ISO-8859-15", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-15, IBM857]"] = [[:"ISO-8859-15", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-15, IBM860]"] = [[:"ISO-8859-15", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-15, IBM861]"] = [[:"ISO-8859-15", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-15, IBM862]"] = [[:"ISO-8859-15", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-15, IBM863]"] = [[:"ISO-8859-15", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-15, IBM865]"] = [[:"ISO-8859-15", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-15, IBM866]"] = [[:"ISO-8859-15", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-15, IBM869]"] = [[:"ISO-8859-15", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-15, ISO-2022-JP]"] = [[:"ISO-8859-15", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-15, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-15, ISO-8859-1]"] = [[:"ISO-8859-15", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-8859-15, ISO-8859-10]"] = [[:"ISO-8859-15", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-8859-15, ISO-8859-11]"] = [[:"ISO-8859-15", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-8859-15, ISO-8859-13]"] = [[:"ISO-8859-15", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-8859-15, ISO-8859-14]"] = [[:"ISO-8859-15", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-8859-15, ISO-8859-2]"] = [[:"ISO-8859-15", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-8859-15, ISO-8859-3]"] = [[:"ISO-8859-15", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-8859-15, ISO-8859-4]"] = [[:"ISO-8859-15", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-8859-15, ISO-8859-5]"] = [[:"ISO-8859-15", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-8859-15, ISO-8859-6]"] = [[:"ISO-8859-15", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-8859-15, ISO-8859-7]"] = [[:"ISO-8859-15", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-8859-15, ISO-8859-8]"] = [[:"ISO-8859-15", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-8859-15, ISO-8859-9]"] = [[:"ISO-8859-15", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-8859-15, KOI8-R]"] = [[:"ISO-8859-15", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-15, KOI8-U]"] = [[:"ISO-8859-15", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-15, MACCROATIAN]"] = [[:"ISO-8859-15", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-15, MACCYRILLIC]"] = [[:"ISO-8859-15", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-15, MACGREEK]"] = [[:"ISO-8859-15", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-15, MACICELAND]"] = [[:"ISO-8859-15", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-15, MACROMAN]"] = [[:"ISO-8859-15", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-15, MACROMANIA]"] = [[:"ISO-8859-15", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-15, MACTURKISH]"] = [[:"ISO-8859-15", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-15, MACUKRAINE]"] = [[:"ISO-8859-15", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-15, SHIFT_JIS]"] = [[:"ISO-8859-15", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-15, SJIS-DOCOMO]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-15, SJIS-KDDI]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-15, SJIS-SOFTBANK]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-15, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-15", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-15, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-15, TIS-620]"] = [[:"ISO-8859-15", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-15, US-ASCII]"] = [[:"ISO-8859-15", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-15, UTF-16]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-15, UTF-16BE]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-15, UTF-16LE]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-15, UTF-32]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-15, UTF-32BE]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-15, UTF-32LE]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-15, UTF-8]"] = [[:"ISO-8859-15", :"UTF-8"]]
  @paths["[ISO-8859-15, UTF8-DOCOMO]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-15, UTF8-KDDI]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-15, UTF8-MAC]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-15, UTF8-SOFTBANK]"] = [[:"ISO-8859-15", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-15, WINDOWS-1250]"] = [[:"ISO-8859-15", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-15, WINDOWS-1251]"] = [[:"ISO-8859-15", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-15, WINDOWS-1252]"] = [[:"ISO-8859-15", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-15, WINDOWS-1253]"] = [[:"ISO-8859-15", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-15, WINDOWS-1254]"] = [[:"ISO-8859-15", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-15, WINDOWS-1255]"] = [[:"ISO-8859-15", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-15, WINDOWS-1256]"] = [[:"ISO-8859-15", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-15, WINDOWS-1257]"] = [[:"ISO-8859-15", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-15, WINDOWS-31J]"] = [[:"ISO-8859-15", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-15, WINDOWS-874]"] = [[:"ISO-8859-15", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-2, ASCII-8BIT]"] = [[:"ISO-8859-2", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-2, BIG5]"] = [[:"ISO-8859-2", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-2, BIG5-HKSCS]"] = [[:"ISO-8859-2", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-2, BIG5-UAO]"] = [[:"ISO-8859-2", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-2, CP50220]"] = [[:"ISO-8859-2", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-2, CP50221]"] = [[:"ISO-8859-2", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-2, CP51932]"] = [[:"ISO-8859-2", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-2, CP850]"] = [[:"ISO-8859-2", :"UTF-8", :CP850]]
  @paths["[ISO-8859-2, CP852]"] = [[:"ISO-8859-2", :"UTF-8", :CP852]]
  @paths["[ISO-8859-2, CP855]"] = [[:"ISO-8859-2", :"UTF-8", :CP855]]
  @paths["[ISO-8859-2, CP949]"] = [[:"ISO-8859-2", :"UTF-8", :CP949]]
  @paths["[ISO-8859-2, CP950]"] = [[:"ISO-8859-2", :"UTF-8", :CP950]]
  @paths["[ISO-8859-2, CP951]"] = [[:"ISO-8859-2", :"UTF-8", :CP951]]
  @paths["[ISO-8859-2, EUC-JP]"] = [[:"ISO-8859-2", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-2, EUC-KR]"] = [[:"ISO-8859-2", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-2, EUCJP-MS]"] = [[:"ISO-8859-2", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-2, GB12345]"] = [[:"ISO-8859-2", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-2, GB18030]"] = [[:"ISO-8859-2", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-2, GB2312]"] = [[:"ISO-8859-2", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-2, GBK]"] = [[:"ISO-8859-2", :"UTF-8", :GBK]]
  @paths["[ISO-8859-2, IBM437]"] = [[:"ISO-8859-2", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-2, IBM737]"] = [[:"ISO-8859-2", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-2, IBM775]"] = [[:"ISO-8859-2", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-2, IBM852]"] = [[:"ISO-8859-2", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-2, IBM855]"] = [[:"ISO-8859-2", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-2, IBM857]"] = [[:"ISO-8859-2", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-2, IBM860]"] = [[:"ISO-8859-2", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-2, IBM861]"] = [[:"ISO-8859-2", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-2, IBM862]"] = [[:"ISO-8859-2", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-2, IBM863]"] = [[:"ISO-8859-2", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-2, IBM865]"] = [[:"ISO-8859-2", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-2, IBM866]"] = [[:"ISO-8859-2", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-2, IBM869]"] = [[:"ISO-8859-2", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-2, ISO-2022-JP]"] = [[:"ISO-8859-2", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-2, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-2, ISO-8859-1]"] = [[:"ISO-8859-2", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-8859-2, ISO-8859-10]"] = [[:"ISO-8859-2", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-8859-2, ISO-8859-11]"] = [[:"ISO-8859-2", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-8859-2, ISO-8859-13]"] = [[:"ISO-8859-2", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-8859-2, ISO-8859-14]"] = [[:"ISO-8859-2", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-8859-2, ISO-8859-15]"] = [[:"ISO-8859-2", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-8859-2, ISO-8859-3]"] = [[:"ISO-8859-2", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-8859-2, ISO-8859-4]"] = [[:"ISO-8859-2", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-8859-2, ISO-8859-5]"] = [[:"ISO-8859-2", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-8859-2, ISO-8859-6]"] = [[:"ISO-8859-2", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-8859-2, ISO-8859-7]"] = [[:"ISO-8859-2", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-8859-2, ISO-8859-8]"] = [[:"ISO-8859-2", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-8859-2, ISO-8859-9]"] = [[:"ISO-8859-2", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-8859-2, KOI8-R]"] = [[:"ISO-8859-2", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-2, KOI8-U]"] = [[:"ISO-8859-2", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-2, MACCROATIAN]"] = [[:"ISO-8859-2", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-2, MACCYRILLIC]"] = [[:"ISO-8859-2", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-2, MACGREEK]"] = [[:"ISO-8859-2", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-2, MACICELAND]"] = [[:"ISO-8859-2", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-2, MACROMAN]"] = [[:"ISO-8859-2", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-2, MACROMANIA]"] = [[:"ISO-8859-2", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-2, MACTURKISH]"] = [[:"ISO-8859-2", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-2, MACUKRAINE]"] = [[:"ISO-8859-2", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-2, SHIFT_JIS]"] = [[:"ISO-8859-2", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-2, SJIS-DOCOMO]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-2, SJIS-KDDI]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-2, SJIS-SOFTBANK]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-2, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-2", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-2, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-2, TIS-620]"] = [[:"ISO-8859-2", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-2, US-ASCII]"] = [[:"ISO-8859-2", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-2, UTF-16]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-2, UTF-16BE]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-2, UTF-16LE]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-2, UTF-32]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-2, UTF-32BE]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-2, UTF-32LE]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-2, UTF-8]"] = [[:"ISO-8859-2", :"UTF-8"]]
  @paths["[ISO-8859-2, UTF8-DOCOMO]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-2, UTF8-KDDI]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-2, UTF8-MAC]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-2, UTF8-SOFTBANK]"] = [[:"ISO-8859-2", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-2, WINDOWS-1250]"] = [[:"ISO-8859-2", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-2, WINDOWS-1251]"] = [[:"ISO-8859-2", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-2, WINDOWS-1252]"] = [[:"ISO-8859-2", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-2, WINDOWS-1253]"] = [[:"ISO-8859-2", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-2, WINDOWS-1254]"] = [[:"ISO-8859-2", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-2, WINDOWS-1255]"] = [[:"ISO-8859-2", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-2, WINDOWS-1256]"] = [[:"ISO-8859-2", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-2, WINDOWS-1257]"] = [[:"ISO-8859-2", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-2, WINDOWS-31J]"] = [[:"ISO-8859-2", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-2, WINDOWS-874]"] = [[:"ISO-8859-2", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-3, ASCII-8BIT]"] = [[:"ISO-8859-3", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-3, BIG5]"] = [[:"ISO-8859-3", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-3, BIG5-HKSCS]"] = [[:"ISO-8859-3", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-3, BIG5-UAO]"] = [[:"ISO-8859-3", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-3, CP50220]"] = [[:"ISO-8859-3", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-3, CP50221]"] = [[:"ISO-8859-3", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-3, CP51932]"] = [[:"ISO-8859-3", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-3, CP850]"] = [[:"ISO-8859-3", :"UTF-8", :CP850]]
  @paths["[ISO-8859-3, CP852]"] = [[:"ISO-8859-3", :"UTF-8", :CP852]]
  @paths["[ISO-8859-3, CP855]"] = [[:"ISO-8859-3", :"UTF-8", :CP855]]
  @paths["[ISO-8859-3, CP949]"] = [[:"ISO-8859-3", :"UTF-8", :CP949]]
  @paths["[ISO-8859-3, CP950]"] = [[:"ISO-8859-3", :"UTF-8", :CP950]]
  @paths["[ISO-8859-3, CP951]"] = [[:"ISO-8859-3", :"UTF-8", :CP951]]
  @paths["[ISO-8859-3, EUC-JP]"] = [[:"ISO-8859-3", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-3, EUC-KR]"] = [[:"ISO-8859-3", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-3, EUCJP-MS]"] = [[:"ISO-8859-3", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-3, GB12345]"] = [[:"ISO-8859-3", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-3, GB18030]"] = [[:"ISO-8859-3", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-3, GB2312]"] = [[:"ISO-8859-3", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-3, GBK]"] = [[:"ISO-8859-3", :"UTF-8", :GBK]]
  @paths["[ISO-8859-3, IBM437]"] = [[:"ISO-8859-3", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-3, IBM737]"] = [[:"ISO-8859-3", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-3, IBM775]"] = [[:"ISO-8859-3", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-3, IBM852]"] = [[:"ISO-8859-3", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-3, IBM855]"] = [[:"ISO-8859-3", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-3, IBM857]"] = [[:"ISO-8859-3", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-3, IBM860]"] = [[:"ISO-8859-3", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-3, IBM861]"] = [[:"ISO-8859-3", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-3, IBM862]"] = [[:"ISO-8859-3", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-3, IBM863]"] = [[:"ISO-8859-3", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-3, IBM865]"] = [[:"ISO-8859-3", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-3, IBM866]"] = [[:"ISO-8859-3", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-3, IBM869]"] = [[:"ISO-8859-3", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-3, ISO-2022-JP]"] = [[:"ISO-8859-3", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-3, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-3, ISO-8859-1]"] = [[:"ISO-8859-3", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-8859-3, ISO-8859-10]"] = [[:"ISO-8859-3", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-8859-3, ISO-8859-11]"] = [[:"ISO-8859-3", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-8859-3, ISO-8859-13]"] = [[:"ISO-8859-3", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-8859-3, ISO-8859-14]"] = [[:"ISO-8859-3", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-8859-3, ISO-8859-15]"] = [[:"ISO-8859-3", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-8859-3, ISO-8859-2]"] = [[:"ISO-8859-3", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-8859-3, ISO-8859-4]"] = [[:"ISO-8859-3", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-8859-3, ISO-8859-5]"] = [[:"ISO-8859-3", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-8859-3, ISO-8859-6]"] = [[:"ISO-8859-3", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-8859-3, ISO-8859-7]"] = [[:"ISO-8859-3", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-8859-3, ISO-8859-8]"] = [[:"ISO-8859-3", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-8859-3, ISO-8859-9]"] = [[:"ISO-8859-3", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-8859-3, KOI8-R]"] = [[:"ISO-8859-3", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-3, KOI8-U]"] = [[:"ISO-8859-3", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-3, MACCROATIAN]"] = [[:"ISO-8859-3", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-3, MACCYRILLIC]"] = [[:"ISO-8859-3", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-3, MACGREEK]"] = [[:"ISO-8859-3", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-3, MACICELAND]"] = [[:"ISO-8859-3", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-3, MACROMAN]"] = [[:"ISO-8859-3", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-3, MACROMANIA]"] = [[:"ISO-8859-3", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-3, MACTURKISH]"] = [[:"ISO-8859-3", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-3, MACUKRAINE]"] = [[:"ISO-8859-3", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-3, SHIFT_JIS]"] = [[:"ISO-8859-3", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-3, SJIS-DOCOMO]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-3, SJIS-KDDI]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-3, SJIS-SOFTBANK]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-3, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-3", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-3, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-3, TIS-620]"] = [[:"ISO-8859-3", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-3, US-ASCII]"] = [[:"ISO-8859-3", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-3, UTF-16]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-3, UTF-16BE]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-3, UTF-16LE]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-3, UTF-32]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-3, UTF-32BE]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-3, UTF-32LE]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-3, UTF-8]"] = [[:"ISO-8859-3", :"UTF-8"]]
  @paths["[ISO-8859-3, UTF8-DOCOMO]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-3, UTF8-KDDI]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-3, UTF8-MAC]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-3, UTF8-SOFTBANK]"] = [[:"ISO-8859-3", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-3, WINDOWS-1250]"] = [[:"ISO-8859-3", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-3, WINDOWS-1251]"] = [[:"ISO-8859-3", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-3, WINDOWS-1252]"] = [[:"ISO-8859-3", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-3, WINDOWS-1253]"] = [[:"ISO-8859-3", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-3, WINDOWS-1254]"] = [[:"ISO-8859-3", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-3, WINDOWS-1255]"] = [[:"ISO-8859-3", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-3, WINDOWS-1256]"] = [[:"ISO-8859-3", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-3, WINDOWS-1257]"] = [[:"ISO-8859-3", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-3, WINDOWS-31J]"] = [[:"ISO-8859-3", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-3, WINDOWS-874]"] = [[:"ISO-8859-3", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-4, ASCII-8BIT]"] = [[:"ISO-8859-4", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-4, BIG5]"] = [[:"ISO-8859-4", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-4, BIG5-HKSCS]"] = [[:"ISO-8859-4", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-4, BIG5-UAO]"] = [[:"ISO-8859-4", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-4, CP50220]"] = [[:"ISO-8859-4", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-4, CP50221]"] = [[:"ISO-8859-4", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-4, CP51932]"] = [[:"ISO-8859-4", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-4, CP850]"] = [[:"ISO-8859-4", :"UTF-8", :CP850]]
  @paths["[ISO-8859-4, CP852]"] = [[:"ISO-8859-4", :"UTF-8", :CP852]]
  @paths["[ISO-8859-4, CP855]"] = [[:"ISO-8859-4", :"UTF-8", :CP855]]
  @paths["[ISO-8859-4, CP949]"] = [[:"ISO-8859-4", :"UTF-8", :CP949]]
  @paths["[ISO-8859-4, CP950]"] = [[:"ISO-8859-4", :"UTF-8", :CP950]]
  @paths["[ISO-8859-4, CP951]"] = [[:"ISO-8859-4", :"UTF-8", :CP951]]
  @paths["[ISO-8859-4, EUC-JP]"] = [[:"ISO-8859-4", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-4, EUC-KR]"] = [[:"ISO-8859-4", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-4, EUCJP-MS]"] = [[:"ISO-8859-4", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-4, GB12345]"] = [[:"ISO-8859-4", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-4, GB18030]"] = [[:"ISO-8859-4", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-4, GB2312]"] = [[:"ISO-8859-4", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-4, GBK]"] = [[:"ISO-8859-4", :"UTF-8", :GBK]]
  @paths["[ISO-8859-4, IBM437]"] = [[:"ISO-8859-4", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-4, IBM737]"] = [[:"ISO-8859-4", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-4, IBM775]"] = [[:"ISO-8859-4", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-4, IBM852]"] = [[:"ISO-8859-4", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-4, IBM855]"] = [[:"ISO-8859-4", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-4, IBM857]"] = [[:"ISO-8859-4", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-4, IBM860]"] = [[:"ISO-8859-4", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-4, IBM861]"] = [[:"ISO-8859-4", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-4, IBM862]"] = [[:"ISO-8859-4", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-4, IBM863]"] = [[:"ISO-8859-4", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-4, IBM865]"] = [[:"ISO-8859-4", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-4, IBM866]"] = [[:"ISO-8859-4", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-4, IBM869]"] = [[:"ISO-8859-4", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-4, ISO-2022-JP]"] = [[:"ISO-8859-4", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-4, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-4, ISO-8859-1]"] = [[:"ISO-8859-4", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-8859-4, ISO-8859-10]"] = [[:"ISO-8859-4", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-8859-4, ISO-8859-11]"] = [[:"ISO-8859-4", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-8859-4, ISO-8859-13]"] = [[:"ISO-8859-4", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-8859-4, ISO-8859-14]"] = [[:"ISO-8859-4", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-8859-4, ISO-8859-15]"] = [[:"ISO-8859-4", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-8859-4, ISO-8859-2]"] = [[:"ISO-8859-4", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-8859-4, ISO-8859-3]"] = [[:"ISO-8859-4", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-8859-4, ISO-8859-5]"] = [[:"ISO-8859-4", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-8859-4, ISO-8859-6]"] = [[:"ISO-8859-4", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-8859-4, ISO-8859-7]"] = [[:"ISO-8859-4", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-8859-4, ISO-8859-8]"] = [[:"ISO-8859-4", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-8859-4, ISO-8859-9]"] = [[:"ISO-8859-4", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-8859-4, KOI8-R]"] = [[:"ISO-8859-4", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-4, KOI8-U]"] = [[:"ISO-8859-4", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-4, MACCROATIAN]"] = [[:"ISO-8859-4", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-4, MACCYRILLIC]"] = [[:"ISO-8859-4", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-4, MACGREEK]"] = [[:"ISO-8859-4", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-4, MACICELAND]"] = [[:"ISO-8859-4", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-4, MACROMAN]"] = [[:"ISO-8859-4", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-4, MACROMANIA]"] = [[:"ISO-8859-4", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-4, MACTURKISH]"] = [[:"ISO-8859-4", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-4, MACUKRAINE]"] = [[:"ISO-8859-4", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-4, SHIFT_JIS]"] = [[:"ISO-8859-4", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-4, SJIS-DOCOMO]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-4, SJIS-KDDI]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-4, SJIS-SOFTBANK]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-4, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-4", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-4, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-4, TIS-620]"] = [[:"ISO-8859-4", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-4, US-ASCII]"] = [[:"ISO-8859-4", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-4, UTF-16]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-4, UTF-16BE]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-4, UTF-16LE]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-4, UTF-32]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-4, UTF-32BE]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-4, UTF-32LE]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-4, UTF-8]"] = [[:"ISO-8859-4", :"UTF-8"]]
  @paths["[ISO-8859-4, UTF8-DOCOMO]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-4, UTF8-KDDI]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-4, UTF8-MAC]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-4, UTF8-SOFTBANK]"] = [[:"ISO-8859-4", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-4, WINDOWS-1250]"] = [[:"ISO-8859-4", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-4, WINDOWS-1251]"] = [[:"ISO-8859-4", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-4, WINDOWS-1252]"] = [[:"ISO-8859-4", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-4, WINDOWS-1253]"] = [[:"ISO-8859-4", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-4, WINDOWS-1254]"] = [[:"ISO-8859-4", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-4, WINDOWS-1255]"] = [[:"ISO-8859-4", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-4, WINDOWS-1256]"] = [[:"ISO-8859-4", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-4, WINDOWS-1257]"] = [[:"ISO-8859-4", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-4, WINDOWS-31J]"] = [[:"ISO-8859-4", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-4, WINDOWS-874]"] = [[:"ISO-8859-4", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-5, ASCII-8BIT]"] = [[:"ISO-8859-5", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-5, BIG5]"] = [[:"ISO-8859-5", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-5, BIG5-HKSCS]"] = [[:"ISO-8859-5", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-5, BIG5-UAO]"] = [[:"ISO-8859-5", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-5, CP50220]"] = [[:"ISO-8859-5", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-5, CP50221]"] = [[:"ISO-8859-5", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-5, CP51932]"] = [[:"ISO-8859-5", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-5, CP850]"] = [[:"ISO-8859-5", :"UTF-8", :CP850]]
  @paths["[ISO-8859-5, CP852]"] = [[:"ISO-8859-5", :"UTF-8", :CP852]]
  @paths["[ISO-8859-5, CP855]"] = [[:"ISO-8859-5", :"UTF-8", :CP855]]
  @paths["[ISO-8859-5, CP949]"] = [[:"ISO-8859-5", :"UTF-8", :CP949]]
  @paths["[ISO-8859-5, CP950]"] = [[:"ISO-8859-5", :"UTF-8", :CP950]]
  @paths["[ISO-8859-5, CP951]"] = [[:"ISO-8859-5", :"UTF-8", :CP951]]
  @paths["[ISO-8859-5, EUC-JP]"] = [[:"ISO-8859-5", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-5, EUC-KR]"] = [[:"ISO-8859-5", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-5, EUCJP-MS]"] = [[:"ISO-8859-5", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-5, GB12345]"] = [[:"ISO-8859-5", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-5, GB18030]"] = [[:"ISO-8859-5", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-5, GB2312]"] = [[:"ISO-8859-5", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-5, GBK]"] = [[:"ISO-8859-5", :"UTF-8", :GBK]]
  @paths["[ISO-8859-5, IBM437]"] = [[:"ISO-8859-5", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-5, IBM737]"] = [[:"ISO-8859-5", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-5, IBM775]"] = [[:"ISO-8859-5", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-5, IBM852]"] = [[:"ISO-8859-5", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-5, IBM855]"] = [[:"ISO-8859-5", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-5, IBM857]"] = [[:"ISO-8859-5", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-5, IBM860]"] = [[:"ISO-8859-5", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-5, IBM861]"] = [[:"ISO-8859-5", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-5, IBM862]"] = [[:"ISO-8859-5", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-5, IBM863]"] = [[:"ISO-8859-5", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-5, IBM865]"] = [[:"ISO-8859-5", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-5, IBM866]"] = [[:"ISO-8859-5", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-5, IBM869]"] = [[:"ISO-8859-5", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-5, ISO-2022-JP]"] = [[:"ISO-8859-5", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-5, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-5, ISO-8859-1]"] = [[:"ISO-8859-5", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-8859-5, ISO-8859-10]"] = [[:"ISO-8859-5", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-8859-5, ISO-8859-11]"] = [[:"ISO-8859-5", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-8859-5, ISO-8859-13]"] = [[:"ISO-8859-5", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-8859-5, ISO-8859-14]"] = [[:"ISO-8859-5", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-8859-5, ISO-8859-15]"] = [[:"ISO-8859-5", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-8859-5, ISO-8859-2]"] = [[:"ISO-8859-5", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-8859-5, ISO-8859-3]"] = [[:"ISO-8859-5", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-8859-5, ISO-8859-4]"] = [[:"ISO-8859-5", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-8859-5, ISO-8859-6]"] = [[:"ISO-8859-5", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-8859-5, ISO-8859-7]"] = [[:"ISO-8859-5", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-8859-5, ISO-8859-8]"] = [[:"ISO-8859-5", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-8859-5, ISO-8859-9]"] = [[:"ISO-8859-5", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-8859-5, KOI8-R]"] = [[:"ISO-8859-5", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-5, KOI8-U]"] = [[:"ISO-8859-5", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-5, MACCROATIAN]"] = [[:"ISO-8859-5", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-5, MACCYRILLIC]"] = [[:"ISO-8859-5", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-5, MACGREEK]"] = [[:"ISO-8859-5", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-5, MACICELAND]"] = [[:"ISO-8859-5", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-5, MACROMAN]"] = [[:"ISO-8859-5", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-5, MACROMANIA]"] = [[:"ISO-8859-5", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-5, MACTURKISH]"] = [[:"ISO-8859-5", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-5, MACUKRAINE]"] = [[:"ISO-8859-5", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-5, SHIFT_JIS]"] = [[:"ISO-8859-5", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-5, SJIS-DOCOMO]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-5, SJIS-KDDI]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-5, SJIS-SOFTBANK]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-5, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-5", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-5, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-5, TIS-620]"] = [[:"ISO-8859-5", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-5, US-ASCII]"] = [[:"ISO-8859-5", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-5, UTF-16]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-5, UTF-16BE]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-5, UTF-16LE]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-5, UTF-32]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-5, UTF-32BE]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-5, UTF-32LE]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-5, UTF-8]"] = [[:"ISO-8859-5", :"UTF-8"]]
  @paths["[ISO-8859-5, UTF8-DOCOMO]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-5, UTF8-KDDI]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-5, UTF8-MAC]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-5, UTF8-SOFTBANK]"] = [[:"ISO-8859-5", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-5, WINDOWS-1250]"] = [[:"ISO-8859-5", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-5, WINDOWS-1251]"] = [[:"ISO-8859-5", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-5, WINDOWS-1252]"] = [[:"ISO-8859-5", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-5, WINDOWS-1253]"] = [[:"ISO-8859-5", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-5, WINDOWS-1254]"] = [[:"ISO-8859-5", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-5, WINDOWS-1255]"] = [[:"ISO-8859-5", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-5, WINDOWS-1256]"] = [[:"ISO-8859-5", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-5, WINDOWS-1257]"] = [[:"ISO-8859-5", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-5, WINDOWS-31J]"] = [[:"ISO-8859-5", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-5, WINDOWS-874]"] = [[:"ISO-8859-5", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-6, ASCII-8BIT]"] = [[:"ISO-8859-6", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-6, BIG5]"] = [[:"ISO-8859-6", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-6, BIG5-HKSCS]"] = [[:"ISO-8859-6", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-6, BIG5-UAO]"] = [[:"ISO-8859-6", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-6, CP50220]"] = [[:"ISO-8859-6", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-6, CP50221]"] = [[:"ISO-8859-6", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-6, CP51932]"] = [[:"ISO-8859-6", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-6, CP850]"] = [[:"ISO-8859-6", :"UTF-8", :CP850]]
  @paths["[ISO-8859-6, CP852]"] = [[:"ISO-8859-6", :"UTF-8", :CP852]]
  @paths["[ISO-8859-6, CP855]"] = [[:"ISO-8859-6", :"UTF-8", :CP855]]
  @paths["[ISO-8859-6, CP949]"] = [[:"ISO-8859-6", :"UTF-8", :CP949]]
  @paths["[ISO-8859-6, CP950]"] = [[:"ISO-8859-6", :"UTF-8", :CP950]]
  @paths["[ISO-8859-6, CP951]"] = [[:"ISO-8859-6", :"UTF-8", :CP951]]
  @paths["[ISO-8859-6, EUC-JP]"] = [[:"ISO-8859-6", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-6, EUC-KR]"] = [[:"ISO-8859-6", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-6, EUCJP-MS]"] = [[:"ISO-8859-6", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-6, GB12345]"] = [[:"ISO-8859-6", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-6, GB18030]"] = [[:"ISO-8859-6", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-6, GB2312]"] = [[:"ISO-8859-6", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-6, GBK]"] = [[:"ISO-8859-6", :"UTF-8", :GBK]]
  @paths["[ISO-8859-6, IBM437]"] = [[:"ISO-8859-6", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-6, IBM737]"] = [[:"ISO-8859-6", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-6, IBM775]"] = [[:"ISO-8859-6", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-6, IBM852]"] = [[:"ISO-8859-6", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-6, IBM855]"] = [[:"ISO-8859-6", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-6, IBM857]"] = [[:"ISO-8859-6", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-6, IBM860]"] = [[:"ISO-8859-6", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-6, IBM861]"] = [[:"ISO-8859-6", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-6, IBM862]"] = [[:"ISO-8859-6", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-6, IBM863]"] = [[:"ISO-8859-6", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-6, IBM865]"] = [[:"ISO-8859-6", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-6, IBM866]"] = [[:"ISO-8859-6", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-6, IBM869]"] = [[:"ISO-8859-6", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-6, ISO-2022-JP]"] = [[:"ISO-8859-6", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-6, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-6, ISO-8859-1]"] = [[:"ISO-8859-6", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-8859-6, ISO-8859-10]"] = [[:"ISO-8859-6", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-8859-6, ISO-8859-11]"] = [[:"ISO-8859-6", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-8859-6, ISO-8859-13]"] = [[:"ISO-8859-6", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-8859-6, ISO-8859-14]"] = [[:"ISO-8859-6", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-8859-6, ISO-8859-15]"] = [[:"ISO-8859-6", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-8859-6, ISO-8859-2]"] = [[:"ISO-8859-6", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-8859-6, ISO-8859-3]"] = [[:"ISO-8859-6", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-8859-6, ISO-8859-4]"] = [[:"ISO-8859-6", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-8859-6, ISO-8859-5]"] = [[:"ISO-8859-6", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-8859-6, ISO-8859-7]"] = [[:"ISO-8859-6", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-8859-6, ISO-8859-8]"] = [[:"ISO-8859-6", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-8859-6, ISO-8859-9]"] = [[:"ISO-8859-6", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-8859-6, KOI8-R]"] = [[:"ISO-8859-6", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-6, KOI8-U]"] = [[:"ISO-8859-6", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-6, MACCROATIAN]"] = [[:"ISO-8859-6", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-6, MACCYRILLIC]"] = [[:"ISO-8859-6", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-6, MACGREEK]"] = [[:"ISO-8859-6", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-6, MACICELAND]"] = [[:"ISO-8859-6", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-6, MACROMAN]"] = [[:"ISO-8859-6", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-6, MACROMANIA]"] = [[:"ISO-8859-6", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-6, MACTURKISH]"] = [[:"ISO-8859-6", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-6, MACUKRAINE]"] = [[:"ISO-8859-6", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-6, SHIFT_JIS]"] = [[:"ISO-8859-6", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-6, SJIS-DOCOMO]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-6, SJIS-KDDI]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-6, SJIS-SOFTBANK]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-6, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-6", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-6, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-6, TIS-620]"] = [[:"ISO-8859-6", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-6, US-ASCII]"] = [[:"ISO-8859-6", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-6, UTF-16]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-6, UTF-16BE]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-6, UTF-16LE]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-6, UTF-32]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-6, UTF-32BE]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-6, UTF-32LE]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-6, UTF-8]"] = [[:"ISO-8859-6", :"UTF-8"]]
  @paths["[ISO-8859-6, UTF8-DOCOMO]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-6, UTF8-KDDI]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-6, UTF8-MAC]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-6, UTF8-SOFTBANK]"] = [[:"ISO-8859-6", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-6, WINDOWS-1250]"] = [[:"ISO-8859-6", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-6, WINDOWS-1251]"] = [[:"ISO-8859-6", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-6, WINDOWS-1252]"] = [[:"ISO-8859-6", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-6, WINDOWS-1253]"] = [[:"ISO-8859-6", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-6, WINDOWS-1254]"] = [[:"ISO-8859-6", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-6, WINDOWS-1255]"] = [[:"ISO-8859-6", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-6, WINDOWS-1256]"] = [[:"ISO-8859-6", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-6, WINDOWS-1257]"] = [[:"ISO-8859-6", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-6, WINDOWS-31J]"] = [[:"ISO-8859-6", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-6, WINDOWS-874]"] = [[:"ISO-8859-6", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-7, ASCII-8BIT]"] = [[:"ISO-8859-7", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-7, BIG5]"] = [[:"ISO-8859-7", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-7, BIG5-HKSCS]"] = [[:"ISO-8859-7", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-7, BIG5-UAO]"] = [[:"ISO-8859-7", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-7, CP50220]"] = [[:"ISO-8859-7", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-7, CP50221]"] = [[:"ISO-8859-7", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-7, CP51932]"] = [[:"ISO-8859-7", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-7, CP850]"] = [[:"ISO-8859-7", :"UTF-8", :CP850]]
  @paths["[ISO-8859-7, CP852]"] = [[:"ISO-8859-7", :"UTF-8", :CP852]]
  @paths["[ISO-8859-7, CP855]"] = [[:"ISO-8859-7", :"UTF-8", :CP855]]
  @paths["[ISO-8859-7, CP949]"] = [[:"ISO-8859-7", :"UTF-8", :CP949]]
  @paths["[ISO-8859-7, CP950]"] = [[:"ISO-8859-7", :"UTF-8", :CP950]]
  @paths["[ISO-8859-7, CP951]"] = [[:"ISO-8859-7", :"UTF-8", :CP951]]
  @paths["[ISO-8859-7, EUC-JP]"] = [[:"ISO-8859-7", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-7, EUC-KR]"] = [[:"ISO-8859-7", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-7, EUCJP-MS]"] = [[:"ISO-8859-7", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-7, GB12345]"] = [[:"ISO-8859-7", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-7, GB18030]"] = [[:"ISO-8859-7", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-7, GB2312]"] = [[:"ISO-8859-7", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-7, GBK]"] = [[:"ISO-8859-7", :"UTF-8", :GBK]]
  @paths["[ISO-8859-7, IBM437]"] = [[:"ISO-8859-7", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-7, IBM737]"] = [[:"ISO-8859-7", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-7, IBM775]"] = [[:"ISO-8859-7", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-7, IBM852]"] = [[:"ISO-8859-7", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-7, IBM855]"] = [[:"ISO-8859-7", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-7, IBM857]"] = [[:"ISO-8859-7", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-7, IBM860]"] = [[:"ISO-8859-7", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-7, IBM861]"] = [[:"ISO-8859-7", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-7, IBM862]"] = [[:"ISO-8859-7", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-7, IBM863]"] = [[:"ISO-8859-7", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-7, IBM865]"] = [[:"ISO-8859-7", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-7, IBM866]"] = [[:"ISO-8859-7", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-7, IBM869]"] = [[:"ISO-8859-7", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-7, ISO-2022-JP]"] = [[:"ISO-8859-7", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-7, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-7, ISO-8859-1]"] = [[:"ISO-8859-7", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-8859-7, ISO-8859-10]"] = [[:"ISO-8859-7", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-8859-7, ISO-8859-11]"] = [[:"ISO-8859-7", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-8859-7, ISO-8859-13]"] = [[:"ISO-8859-7", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-8859-7, ISO-8859-14]"] = [[:"ISO-8859-7", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-8859-7, ISO-8859-15]"] = [[:"ISO-8859-7", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-8859-7, ISO-8859-2]"] = [[:"ISO-8859-7", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-8859-7, ISO-8859-3]"] = [[:"ISO-8859-7", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-8859-7, ISO-8859-4]"] = [[:"ISO-8859-7", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-8859-7, ISO-8859-5]"] = [[:"ISO-8859-7", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-8859-7, ISO-8859-6]"] = [[:"ISO-8859-7", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-8859-7, ISO-8859-8]"] = [[:"ISO-8859-7", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-8859-7, ISO-8859-9]"] = [[:"ISO-8859-7", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-8859-7, KOI8-R]"] = [[:"ISO-8859-7", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-7, KOI8-U]"] = [[:"ISO-8859-7", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-7, MACCROATIAN]"] = [[:"ISO-8859-7", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-7, MACCYRILLIC]"] = [[:"ISO-8859-7", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-7, MACGREEK]"] = [[:"ISO-8859-7", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-7, MACICELAND]"] = [[:"ISO-8859-7", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-7, MACROMAN]"] = [[:"ISO-8859-7", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-7, MACROMANIA]"] = [[:"ISO-8859-7", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-7, MACTURKISH]"] = [[:"ISO-8859-7", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-7, MACUKRAINE]"] = [[:"ISO-8859-7", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-7, SHIFT_JIS]"] = [[:"ISO-8859-7", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-7, SJIS-DOCOMO]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-7, SJIS-KDDI]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-7, SJIS-SOFTBANK]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-7, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-7", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-7, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-7, TIS-620]"] = [[:"ISO-8859-7", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-7, US-ASCII]"] = [[:"ISO-8859-7", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-7, UTF-16]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-7, UTF-16BE]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-7, UTF-16LE]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-7, UTF-32]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-7, UTF-32BE]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-7, UTF-32LE]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-7, UTF-8]"] = [[:"ISO-8859-7", :"UTF-8"]]
  @paths["[ISO-8859-7, UTF8-DOCOMO]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-7, UTF8-KDDI]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-7, UTF8-MAC]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-7, UTF8-SOFTBANK]"] = [[:"ISO-8859-7", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-7, WINDOWS-1250]"] = [[:"ISO-8859-7", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-7, WINDOWS-1251]"] = [[:"ISO-8859-7", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-7, WINDOWS-1252]"] = [[:"ISO-8859-7", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-7, WINDOWS-1253]"] = [[:"ISO-8859-7", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-7, WINDOWS-1254]"] = [[:"ISO-8859-7", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-7, WINDOWS-1255]"] = [[:"ISO-8859-7", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-7, WINDOWS-1256]"] = [[:"ISO-8859-7", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-7, WINDOWS-1257]"] = [[:"ISO-8859-7", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-7, WINDOWS-31J]"] = [[:"ISO-8859-7", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-7, WINDOWS-874]"] = [[:"ISO-8859-7", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-8, ASCII-8BIT]"] = [[:"ISO-8859-8", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-8, BIG5]"] = [[:"ISO-8859-8", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-8, BIG5-HKSCS]"] = [[:"ISO-8859-8", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-8, BIG5-UAO]"] = [[:"ISO-8859-8", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-8, CP50220]"] = [[:"ISO-8859-8", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-8, CP50221]"] = [[:"ISO-8859-8", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-8, CP51932]"] = [[:"ISO-8859-8", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-8, CP850]"] = [[:"ISO-8859-8", :"UTF-8", :CP850]]
  @paths["[ISO-8859-8, CP852]"] = [[:"ISO-8859-8", :"UTF-8", :CP852]]
  @paths["[ISO-8859-8, CP855]"] = [[:"ISO-8859-8", :"UTF-8", :CP855]]
  @paths["[ISO-8859-8, CP949]"] = [[:"ISO-8859-8", :"UTF-8", :CP949]]
  @paths["[ISO-8859-8, CP950]"] = [[:"ISO-8859-8", :"UTF-8", :CP950]]
  @paths["[ISO-8859-8, CP951]"] = [[:"ISO-8859-8", :"UTF-8", :CP951]]
  @paths["[ISO-8859-8, EUC-JP]"] = [[:"ISO-8859-8", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-8, EUC-KR]"] = [[:"ISO-8859-8", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-8, EUCJP-MS]"] = [[:"ISO-8859-8", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-8, GB12345]"] = [[:"ISO-8859-8", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-8, GB18030]"] = [[:"ISO-8859-8", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-8, GB2312]"] = [[:"ISO-8859-8", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-8, GBK]"] = [[:"ISO-8859-8", :"UTF-8", :GBK]]
  @paths["[ISO-8859-8, IBM437]"] = [[:"ISO-8859-8", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-8, IBM737]"] = [[:"ISO-8859-8", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-8, IBM775]"] = [[:"ISO-8859-8", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-8, IBM852]"] = [[:"ISO-8859-8", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-8, IBM855]"] = [[:"ISO-8859-8", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-8, IBM857]"] = [[:"ISO-8859-8", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-8, IBM860]"] = [[:"ISO-8859-8", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-8, IBM861]"] = [[:"ISO-8859-8", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-8, IBM862]"] = [[:"ISO-8859-8", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-8, IBM863]"] = [[:"ISO-8859-8", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-8, IBM865]"] = [[:"ISO-8859-8", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-8, IBM866]"] = [[:"ISO-8859-8", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-8, IBM869]"] = [[:"ISO-8859-8", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-8, ISO-2022-JP]"] = [[:"ISO-8859-8", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-8, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-8, ISO-8859-1]"] = [[:"ISO-8859-8", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-8859-8, ISO-8859-10]"] = [[:"ISO-8859-8", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-8859-8, ISO-8859-11]"] = [[:"ISO-8859-8", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-8859-8, ISO-8859-13]"] = [[:"ISO-8859-8", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-8859-8, ISO-8859-14]"] = [[:"ISO-8859-8", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-8859-8, ISO-8859-15]"] = [[:"ISO-8859-8", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-8859-8, ISO-8859-2]"] = [[:"ISO-8859-8", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-8859-8, ISO-8859-3]"] = [[:"ISO-8859-8", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-8859-8, ISO-8859-4]"] = [[:"ISO-8859-8", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-8859-8, ISO-8859-5]"] = [[:"ISO-8859-8", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-8859-8, ISO-8859-6]"] = [[:"ISO-8859-8", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-8859-8, ISO-8859-7]"] = [[:"ISO-8859-8", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-8859-8, ISO-8859-9]"] = [[:"ISO-8859-8", :"UTF-8", :"ISO-8859-9"]]
  @paths["[ISO-8859-8, KOI8-R]"] = [[:"ISO-8859-8", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-8, KOI8-U]"] = [[:"ISO-8859-8", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-8, MACCROATIAN]"] = [[:"ISO-8859-8", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-8, MACCYRILLIC]"] = [[:"ISO-8859-8", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-8, MACGREEK]"] = [[:"ISO-8859-8", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-8, MACICELAND]"] = [[:"ISO-8859-8", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-8, MACROMAN]"] = [[:"ISO-8859-8", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-8, MACROMANIA]"] = [[:"ISO-8859-8", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-8, MACTURKISH]"] = [[:"ISO-8859-8", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-8, MACUKRAINE]"] = [[:"ISO-8859-8", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-8, SHIFT_JIS]"] = [[:"ISO-8859-8", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-8, SJIS-DOCOMO]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-8, SJIS-KDDI]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-8, SJIS-SOFTBANK]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-8, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-8", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-8, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-8, TIS-620]"] = [[:"ISO-8859-8", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-8, US-ASCII]"] = [[:"ISO-8859-8", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-8, UTF-16]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-8, UTF-16BE]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-8, UTF-16LE]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-8, UTF-32]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-8, UTF-32BE]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-8, UTF-32LE]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-8, UTF-8]"] = [[:"ISO-8859-8", :"UTF-8"]]
  @paths["[ISO-8859-8, UTF8-DOCOMO]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-8, UTF8-KDDI]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-8, UTF8-MAC]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-8, UTF8-SOFTBANK]"] = [[:"ISO-8859-8", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-8, WINDOWS-1250]"] = [[:"ISO-8859-8", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-8, WINDOWS-1251]"] = [[:"ISO-8859-8", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-8, WINDOWS-1252]"] = [[:"ISO-8859-8", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-8, WINDOWS-1253]"] = [[:"ISO-8859-8", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-8, WINDOWS-1254]"] = [[:"ISO-8859-8", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-8, WINDOWS-1255]"] = [[:"ISO-8859-8", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-8, WINDOWS-1256]"] = [[:"ISO-8859-8", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-8, WINDOWS-1257]"] = [[:"ISO-8859-8", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-8, WINDOWS-31J]"] = [[:"ISO-8859-8", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-8, WINDOWS-874]"] = [[:"ISO-8859-8", :"UTF-8", :"WINDOWS-874"]]
  @paths["[ISO-8859-9, ASCII-8BIT]"] = [[:"ISO-8859-9", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[ISO-8859-9, BIG5]"] = [[:"ISO-8859-9", :"UTF-8", :BIG5]]
  @paths["[ISO-8859-9, BIG5-HKSCS]"] = [[:"ISO-8859-9", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[ISO-8859-9, BIG5-UAO]"] = [[:"ISO-8859-9", :"UTF-8", :"BIG5-UAO"]]
  @paths["[ISO-8859-9, CP50220]"] = [[:"ISO-8859-9", :"UTF-8", :CP51932, :CP50220]]
  @paths["[ISO-8859-9, CP50221]"] = [[:"ISO-8859-9", :"UTF-8", :CP51932, :CP50221]]
  @paths["[ISO-8859-9, CP51932]"] = [[:"ISO-8859-9", :"UTF-8", :CP51932]]
  @paths["[ISO-8859-9, CP850]"] = [[:"ISO-8859-9", :"UTF-8", :CP850]]
  @paths["[ISO-8859-9, CP852]"] = [[:"ISO-8859-9", :"UTF-8", :CP852]]
  @paths["[ISO-8859-9, CP855]"] = [[:"ISO-8859-9", :"UTF-8", :CP855]]
  @paths["[ISO-8859-9, CP949]"] = [[:"ISO-8859-9", :"UTF-8", :CP949]]
  @paths["[ISO-8859-9, CP950]"] = [[:"ISO-8859-9", :"UTF-8", :CP950]]
  @paths["[ISO-8859-9, CP951]"] = [[:"ISO-8859-9", :"UTF-8", :CP951]]
  @paths["[ISO-8859-9, EUC-JP]"] = [[:"ISO-8859-9", :"UTF-8", :"EUC-JP"]]
  @paths["[ISO-8859-9, EUC-KR]"] = [[:"ISO-8859-9", :"UTF-8", :"EUC-KR"]]
  @paths["[ISO-8859-9, EUCJP-MS]"] = [[:"ISO-8859-9", :"UTF-8", :"EUCJP-MS"]]
  @paths["[ISO-8859-9, GB12345]"] = [[:"ISO-8859-9", :"UTF-8", :GB12345]]
  @paths["[ISO-8859-9, GB18030]"] = [[:"ISO-8859-9", :"UTF-8", :GB18030]]
  @paths["[ISO-8859-9, GB2312]"] = [[:"ISO-8859-9", :"UTF-8", :GB2312]]
  @paths["[ISO-8859-9, GBK]"] = [[:"ISO-8859-9", :"UTF-8", :GBK]]
  @paths["[ISO-8859-9, IBM437]"] = [[:"ISO-8859-9", :"UTF-8", :IBM437]]
  @paths["[ISO-8859-9, IBM737]"] = [[:"ISO-8859-9", :"UTF-8", :IBM737]]
  @paths["[ISO-8859-9, IBM775]"] = [[:"ISO-8859-9", :"UTF-8", :IBM775]]
  @paths["[ISO-8859-9, IBM852]"] = [[:"ISO-8859-9", :"UTF-8", :IBM852]]
  @paths["[ISO-8859-9, IBM855]"] = [[:"ISO-8859-9", :"UTF-8", :IBM855]]
  @paths["[ISO-8859-9, IBM857]"] = [[:"ISO-8859-9", :"UTF-8", :IBM857]]
  @paths["[ISO-8859-9, IBM860]"] = [[:"ISO-8859-9", :"UTF-8", :IBM860]]
  @paths["[ISO-8859-9, IBM861]"] = [[:"ISO-8859-9", :"UTF-8", :IBM861]]
  @paths["[ISO-8859-9, IBM862]"] = [[:"ISO-8859-9", :"UTF-8", :IBM862]]
  @paths["[ISO-8859-9, IBM863]"] = [[:"ISO-8859-9", :"UTF-8", :IBM863]]
  @paths["[ISO-8859-9, IBM865]"] = [[:"ISO-8859-9", :"UTF-8", :IBM865]]
  @paths["[ISO-8859-9, IBM866]"] = [[:"ISO-8859-9", :"UTF-8", :IBM866]]
  @paths["[ISO-8859-9, IBM869]"] = [[:"ISO-8859-9", :"UTF-8", :IBM869]]
  @paths["[ISO-8859-9, ISO-2022-JP]"] = [[:"ISO-8859-9", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[ISO-8859-9, ISO-2022-JP-KDDI]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-9, ISO-8859-1]"] = [[:"ISO-8859-9", :"UTF-8", :"ISO-8859-1"]]
  @paths["[ISO-8859-9, ISO-8859-10]"] = [[:"ISO-8859-9", :"UTF-8", :"ISO-8859-10"]]
  @paths["[ISO-8859-9, ISO-8859-11]"] = [[:"ISO-8859-9", :"UTF-8", :"ISO-8859-11"]]
  @paths["[ISO-8859-9, ISO-8859-13]"] = [[:"ISO-8859-9", :"UTF-8", :"ISO-8859-13"]]
  @paths["[ISO-8859-9, ISO-8859-14]"] = [[:"ISO-8859-9", :"UTF-8", :"ISO-8859-14"]]
  @paths["[ISO-8859-9, ISO-8859-15]"] = [[:"ISO-8859-9", :"UTF-8", :"ISO-8859-15"]]
  @paths["[ISO-8859-9, ISO-8859-2]"] = [[:"ISO-8859-9", :"UTF-8", :"ISO-8859-2"]]
  @paths["[ISO-8859-9, ISO-8859-3]"] = [[:"ISO-8859-9", :"UTF-8", :"ISO-8859-3"]]
  @paths["[ISO-8859-9, ISO-8859-4]"] = [[:"ISO-8859-9", :"UTF-8", :"ISO-8859-4"]]
  @paths["[ISO-8859-9, ISO-8859-5]"] = [[:"ISO-8859-9", :"UTF-8", :"ISO-8859-5"]]
  @paths["[ISO-8859-9, ISO-8859-6]"] = [[:"ISO-8859-9", :"UTF-8", :"ISO-8859-6"]]
  @paths["[ISO-8859-9, ISO-8859-7]"] = [[:"ISO-8859-9", :"UTF-8", :"ISO-8859-7"]]
  @paths["[ISO-8859-9, ISO-8859-8]"] = [[:"ISO-8859-9", :"UTF-8", :"ISO-8859-8"]]
  @paths["[ISO-8859-9, KOI8-R]"] = [[:"ISO-8859-9", :"UTF-8", :"KOI8-R"]]
  @paths["[ISO-8859-9, KOI8-U]"] = [[:"ISO-8859-9", :"UTF-8", :"KOI8-U"]]
  @paths["[ISO-8859-9, MACCROATIAN]"] = [[:"ISO-8859-9", :"UTF-8", :MACCROATIAN]]
  @paths["[ISO-8859-9, MACCYRILLIC]"] = [[:"ISO-8859-9", :"UTF-8", :MACCYRILLIC]]
  @paths["[ISO-8859-9, MACGREEK]"] = [[:"ISO-8859-9", :"UTF-8", :MACGREEK]]
  @paths["[ISO-8859-9, MACICELAND]"] = [[:"ISO-8859-9", :"UTF-8", :MACICELAND]]
  @paths["[ISO-8859-9, MACROMAN]"] = [[:"ISO-8859-9", :"UTF-8", :MACROMAN]]
  @paths["[ISO-8859-9, MACROMANIA]"] = [[:"ISO-8859-9", :"UTF-8", :MACROMANIA]]
  @paths["[ISO-8859-9, MACTURKISH]"] = [[:"ISO-8859-9", :"UTF-8", :MACTURKISH]]
  @paths["[ISO-8859-9, MACUKRAINE]"] = [[:"ISO-8859-9", :"UTF-8", :MACUKRAINE]]
  @paths["[ISO-8859-9, SHIFT_JIS]"] = [[:"ISO-8859-9", :"UTF-8", :SHIFT_JIS]]
  @paths["[ISO-8859-9, SJIS-DOCOMO]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[ISO-8859-9, SJIS-KDDI]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[ISO-8859-9, SJIS-SOFTBANK]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[ISO-8859-9, STATELESS-ISO-2022-JP]"] = [[:"ISO-8859-9", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[ISO-8859-9, STATELESS-ISO-2022-JP-KDDI]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[ISO-8859-9, TIS-620]"] = [[:"ISO-8859-9", :"UTF-8", :"TIS-620"]]
  @paths["[ISO-8859-9, US-ASCII]"] = [[:"ISO-8859-9", :"UTF-8", :"US-ASCII"]]
  @paths["[ISO-8859-9, UTF-16]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF-16"]]
  @paths["[ISO-8859-9, UTF-16BE]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF-16BE"]]
  @paths["[ISO-8859-9, UTF-16LE]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF-16LE"]]
  @paths["[ISO-8859-9, UTF-32]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF-32"]]
  @paths["[ISO-8859-9, UTF-32BE]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF-32BE"]]
  @paths["[ISO-8859-9, UTF-32LE]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF-32LE"]]
  @paths["[ISO-8859-9, UTF-8]"] = [[:"ISO-8859-9", :"UTF-8"]]
  @paths["[ISO-8859-9, UTF8-DOCOMO]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[ISO-8859-9, UTF8-KDDI]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[ISO-8859-9, UTF8-MAC]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF8-MAC"]]
  @paths["[ISO-8859-9, UTF8-SOFTBANK]"] = [[:"ISO-8859-9", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[ISO-8859-9, WINDOWS-1250]"] = [[:"ISO-8859-9", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[ISO-8859-9, WINDOWS-1251]"] = [[:"ISO-8859-9", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[ISO-8859-9, WINDOWS-1252]"] = [[:"ISO-8859-9", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[ISO-8859-9, WINDOWS-1253]"] = [[:"ISO-8859-9", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[ISO-8859-9, WINDOWS-1254]"] = [[:"ISO-8859-9", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[ISO-8859-9, WINDOWS-1255]"] = [[:"ISO-8859-9", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[ISO-8859-9, WINDOWS-1256]"] = [[:"ISO-8859-9", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[ISO-8859-9, WINDOWS-1257]"] = [[:"ISO-8859-9", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[ISO-8859-9, WINDOWS-31J]"] = [[:"ISO-8859-9", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[ISO-8859-9, WINDOWS-874]"] = [[:"ISO-8859-9", :"UTF-8", :"WINDOWS-874"]]
  @paths["[KOI8-R, ASCII-8BIT]"] = [[:"KOI8-R", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[KOI8-R, BIG5]"] = [[:"KOI8-R", :"UTF-8", :BIG5]]
  @paths["[KOI8-R, BIG5-HKSCS]"] = [[:"KOI8-R", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[KOI8-R, BIG5-UAO]"] = [[:"KOI8-R", :"UTF-8", :"BIG5-UAO"]]
  @paths["[KOI8-R, CP50220]"] = [[:"KOI8-R", :"UTF-8", :CP51932, :CP50220]]
  @paths["[KOI8-R, CP50221]"] = [[:"KOI8-R", :"UTF-8", :CP51932, :CP50221]]
  @paths["[KOI8-R, CP51932]"] = [[:"KOI8-R", :"UTF-8", :CP51932]]
  @paths["[KOI8-R, CP850]"] = [[:"KOI8-R", :"UTF-8", :CP850]]
  @paths["[KOI8-R, CP852]"] = [[:"KOI8-R", :"UTF-8", :CP852]]
  @paths["[KOI8-R, CP855]"] = [[:"KOI8-R", :"UTF-8", :CP855]]
  @paths["[KOI8-R, CP949]"] = [[:"KOI8-R", :"UTF-8", :CP949]]
  @paths["[KOI8-R, CP950]"] = [[:"KOI8-R", :"UTF-8", :CP950]]
  @paths["[KOI8-R, CP951]"] = [[:"KOI8-R", :"UTF-8", :CP951]]
  @paths["[KOI8-R, EUC-JP]"] = [[:"KOI8-R", :"UTF-8", :"EUC-JP"]]
  @paths["[KOI8-R, EUC-KR]"] = [[:"KOI8-R", :"UTF-8", :"EUC-KR"]]
  @paths["[KOI8-R, EUCJP-MS]"] = [[:"KOI8-R", :"UTF-8", :"EUCJP-MS"]]
  @paths["[KOI8-R, GB12345]"] = [[:"KOI8-R", :"UTF-8", :GB12345]]
  @paths["[KOI8-R, GB18030]"] = [[:"KOI8-R", :"UTF-8", :GB18030]]
  @paths["[KOI8-R, GB2312]"] = [[:"KOI8-R", :"UTF-8", :GB2312]]
  @paths["[KOI8-R, GBK]"] = [[:"KOI8-R", :"UTF-8", :GBK]]
  @paths["[KOI8-R, IBM437]"] = [[:"KOI8-R", :"UTF-8", :IBM437]]
  @paths["[KOI8-R, IBM737]"] = [[:"KOI8-R", :"UTF-8", :IBM737]]
  @paths["[KOI8-R, IBM775]"] = [[:"KOI8-R", :"UTF-8", :IBM775]]
  @paths["[KOI8-R, IBM852]"] = [[:"KOI8-R", :"UTF-8", :IBM852]]
  @paths["[KOI8-R, IBM855]"] = [[:"KOI8-R", :"UTF-8", :IBM855]]
  @paths["[KOI8-R, IBM857]"] = [[:"KOI8-R", :"UTF-8", :IBM857]]
  @paths["[KOI8-R, IBM860]"] = [[:"KOI8-R", :"UTF-8", :IBM860]]
  @paths["[KOI8-R, IBM861]"] = [[:"KOI8-R", :"UTF-8", :IBM861]]
  @paths["[KOI8-R, IBM862]"] = [[:"KOI8-R", :"UTF-8", :IBM862]]
  @paths["[KOI8-R, IBM863]"] = [[:"KOI8-R", :"UTF-8", :IBM863]]
  @paths["[KOI8-R, IBM865]"] = [[:"KOI8-R", :"UTF-8", :IBM865]]
  @paths["[KOI8-R, IBM866]"] = [[:"KOI8-R", :"UTF-8", :IBM866]]
  @paths["[KOI8-R, IBM869]"] = [[:"KOI8-R", :"UTF-8", :IBM869]]
  @paths["[KOI8-R, ISO-2022-JP]"] = [[:"KOI8-R", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[KOI8-R, ISO-2022-JP-KDDI]"] = [[:"KOI8-R", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[KOI8-R, ISO-8859-1]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-1"]]
  @paths["[KOI8-R, ISO-8859-10]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-10"]]
  @paths["[KOI8-R, ISO-8859-11]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-11"]]
  @paths["[KOI8-R, ISO-8859-13]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-13"]]
  @paths["[KOI8-R, ISO-8859-14]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-14"]]
  @paths["[KOI8-R, ISO-8859-15]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-15"]]
  @paths["[KOI8-R, ISO-8859-2]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-2"]]
  @paths["[KOI8-R, ISO-8859-3]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-3"]]
  @paths["[KOI8-R, ISO-8859-4]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-4"]]
  @paths["[KOI8-R, ISO-8859-5]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-5"]]
  @paths["[KOI8-R, ISO-8859-6]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-6"]]
  @paths["[KOI8-R, ISO-8859-7]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-7"]]
  @paths["[KOI8-R, ISO-8859-8]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-8"]]
  @paths["[KOI8-R, ISO-8859-9]"] = [[:"KOI8-R", :"UTF-8", :"ISO-8859-9"]]
  @paths["[KOI8-R, KOI8-U]"] = [[:"KOI8-R", :"UTF-8", :"KOI8-U"]]
  @paths["[KOI8-R, MACCROATIAN]"] = [[:"KOI8-R", :"UTF-8", :MACCROATIAN]]
  @paths["[KOI8-R, MACCYRILLIC]"] = [[:"KOI8-R", :"UTF-8", :MACCYRILLIC]]
  @paths["[KOI8-R, MACGREEK]"] = [[:"KOI8-R", :"UTF-8", :MACGREEK]]
  @paths["[KOI8-R, MACICELAND]"] = [[:"KOI8-R", :"UTF-8", :MACICELAND]]
  @paths["[KOI8-R, MACROMAN]"] = [[:"KOI8-R", :"UTF-8", :MACROMAN]]
  @paths["[KOI8-R, MACROMANIA]"] = [[:"KOI8-R", :"UTF-8", :MACROMANIA]]
  @paths["[KOI8-R, MACTURKISH]"] = [[:"KOI8-R", :"UTF-8", :MACTURKISH]]
  @paths["[KOI8-R, MACUKRAINE]"] = [[:"KOI8-R", :"UTF-8", :MACUKRAINE]]
  @paths["[KOI8-R, SHIFT_JIS]"] = [[:"KOI8-R", :"UTF-8", :SHIFT_JIS]]
  @paths["[KOI8-R, SJIS-DOCOMO]"] = [[:"KOI8-R", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[KOI8-R, SJIS-KDDI]"] = [[:"KOI8-R", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[KOI8-R, SJIS-SOFTBANK]"] = [[:"KOI8-R", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[KOI8-R, STATELESS-ISO-2022-JP]"] = [[:"KOI8-R", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[KOI8-R, STATELESS-ISO-2022-JP-KDDI]"] = [[:"KOI8-R", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[KOI8-R, TIS-620]"] = [[:"KOI8-R", :"UTF-8", :"TIS-620"]]
  @paths["[KOI8-R, US-ASCII]"] = [[:"KOI8-R", :"UTF-8", :"US-ASCII"]]
  @paths["[KOI8-R, UTF-16]"] = [[:"KOI8-R", :"UTF-8", :"UTF-16"]]
  @paths["[KOI8-R, UTF-16BE]"] = [[:"KOI8-R", :"UTF-8", :"UTF-16BE"]]
  @paths["[KOI8-R, UTF-16LE]"] = [[:"KOI8-R", :"UTF-8", :"UTF-16LE"]]
  @paths["[KOI8-R, UTF-32]"] = [[:"KOI8-R", :"UTF-8", :"UTF-32"]]
  @paths["[KOI8-R, UTF-32BE]"] = [[:"KOI8-R", :"UTF-8", :"UTF-32BE"]]
  @paths["[KOI8-R, UTF-32LE]"] = [[:"KOI8-R", :"UTF-8", :"UTF-32LE"]]
  @paths["[KOI8-R, UTF-8]"] = [[:"KOI8-R", :"UTF-8"]]
  @paths["[KOI8-R, UTF8-DOCOMO]"] = [[:"KOI8-R", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[KOI8-R, UTF8-KDDI]"] = [[:"KOI8-R", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[KOI8-R, UTF8-MAC]"] = [[:"KOI8-R", :"UTF-8", :"UTF8-MAC"]]
  @paths["[KOI8-R, UTF8-SOFTBANK]"] = [[:"KOI8-R", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[KOI8-R, WINDOWS-1250]"] = [[:"KOI8-R", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[KOI8-R, WINDOWS-1251]"] = [[:"KOI8-R", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[KOI8-R, WINDOWS-1252]"] = [[:"KOI8-R", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[KOI8-R, WINDOWS-1253]"] = [[:"KOI8-R", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[KOI8-R, WINDOWS-1254]"] = [[:"KOI8-R", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[KOI8-R, WINDOWS-1255]"] = [[:"KOI8-R", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[KOI8-R, WINDOWS-1256]"] = [[:"KOI8-R", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[KOI8-R, WINDOWS-1257]"] = [[:"KOI8-R", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[KOI8-R, WINDOWS-31J]"] = [[:"KOI8-R", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[KOI8-R, WINDOWS-874]"] = [[:"KOI8-R", :"UTF-8", :"WINDOWS-874"]]
  @paths["[KOI8-U, ASCII-8BIT]"] = [[:"KOI8-U", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[KOI8-U, BIG5]"] = [[:"KOI8-U", :"UTF-8", :BIG5]]
  @paths["[KOI8-U, BIG5-HKSCS]"] = [[:"KOI8-U", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[KOI8-U, BIG5-UAO]"] = [[:"KOI8-U", :"UTF-8", :"BIG5-UAO"]]
  @paths["[KOI8-U, CP50220]"] = [[:"KOI8-U", :"UTF-8", :CP51932, :CP50220]]
  @paths["[KOI8-U, CP50221]"] = [[:"KOI8-U", :"UTF-8", :CP51932, :CP50221]]
  @paths["[KOI8-U, CP51932]"] = [[:"KOI8-U", :"UTF-8", :CP51932]]
  @paths["[KOI8-U, CP850]"] = [[:"KOI8-U", :"UTF-8", :CP850]]
  @paths["[KOI8-U, CP852]"] = [[:"KOI8-U", :"UTF-8", :CP852]]
  @paths["[KOI8-U, CP855]"] = [[:"KOI8-U", :"UTF-8", :CP855]]
  @paths["[KOI8-U, CP949]"] = [[:"KOI8-U", :"UTF-8", :CP949]]
  @paths["[KOI8-U, CP950]"] = [[:"KOI8-U", :"UTF-8", :CP950]]
  @paths["[KOI8-U, CP951]"] = [[:"KOI8-U", :"UTF-8", :CP951]]
  @paths["[KOI8-U, EUC-JP]"] = [[:"KOI8-U", :"UTF-8", :"EUC-JP"]]
  @paths["[KOI8-U, EUC-KR]"] = [[:"KOI8-U", :"UTF-8", :"EUC-KR"]]
  @paths["[KOI8-U, EUCJP-MS]"] = [[:"KOI8-U", :"UTF-8", :"EUCJP-MS"]]
  @paths["[KOI8-U, GB12345]"] = [[:"KOI8-U", :"UTF-8", :GB12345]]
  @paths["[KOI8-U, GB18030]"] = [[:"KOI8-U", :"UTF-8", :GB18030]]
  @paths["[KOI8-U, GB2312]"] = [[:"KOI8-U", :"UTF-8", :GB2312]]
  @paths["[KOI8-U, GBK]"] = [[:"KOI8-U", :"UTF-8", :GBK]]
  @paths["[KOI8-U, IBM437]"] = [[:"KOI8-U", :"UTF-8", :IBM437]]
  @paths["[KOI8-U, IBM737]"] = [[:"KOI8-U", :"UTF-8", :IBM737]]
  @paths["[KOI8-U, IBM775]"] = [[:"KOI8-U", :"UTF-8", :IBM775]]
  @paths["[KOI8-U, IBM852]"] = [[:"KOI8-U", :"UTF-8", :IBM852]]
  @paths["[KOI8-U, IBM855]"] = [[:"KOI8-U", :"UTF-8", :IBM855]]
  @paths["[KOI8-U, IBM857]"] = [[:"KOI8-U", :"UTF-8", :IBM857]]
  @paths["[KOI8-U, IBM860]"] = [[:"KOI8-U", :"UTF-8", :IBM860]]
  @paths["[KOI8-U, IBM861]"] = [[:"KOI8-U", :"UTF-8", :IBM861]]
  @paths["[KOI8-U, IBM862]"] = [[:"KOI8-U", :"UTF-8", :IBM862]]
  @paths["[KOI8-U, IBM863]"] = [[:"KOI8-U", :"UTF-8", :IBM863]]
  @paths["[KOI8-U, IBM865]"] = [[:"KOI8-U", :"UTF-8", :IBM865]]
  @paths["[KOI8-U, IBM866]"] = [[:"KOI8-U", :"UTF-8", :IBM866]]
  @paths["[KOI8-U, IBM869]"] = [[:"KOI8-U", :"UTF-8", :IBM869]]
  @paths["[KOI8-U, ISO-2022-JP]"] = [[:"KOI8-U", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[KOI8-U, ISO-2022-JP-KDDI]"] = [[:"KOI8-U", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[KOI8-U, ISO-8859-1]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-1"]]
  @paths["[KOI8-U, ISO-8859-10]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-10"]]
  @paths["[KOI8-U, ISO-8859-11]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-11"]]
  @paths["[KOI8-U, ISO-8859-13]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-13"]]
  @paths["[KOI8-U, ISO-8859-14]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-14"]]
  @paths["[KOI8-U, ISO-8859-15]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-15"]]
  @paths["[KOI8-U, ISO-8859-2]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-2"]]
  @paths["[KOI8-U, ISO-8859-3]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-3"]]
  @paths["[KOI8-U, ISO-8859-4]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-4"]]
  @paths["[KOI8-U, ISO-8859-5]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-5"]]
  @paths["[KOI8-U, ISO-8859-6]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-6"]]
  @paths["[KOI8-U, ISO-8859-7]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-7"]]
  @paths["[KOI8-U, ISO-8859-8]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-8"]]
  @paths["[KOI8-U, ISO-8859-9]"] = [[:"KOI8-U", :"UTF-8", :"ISO-8859-9"]]
  @paths["[KOI8-U, KOI8-R]"] = [[:"KOI8-U", :"UTF-8", :"KOI8-R"]]
  @paths["[KOI8-U, MACCROATIAN]"] = [[:"KOI8-U", :"UTF-8", :MACCROATIAN]]
  @paths["[KOI8-U, MACCYRILLIC]"] = [[:"KOI8-U", :"UTF-8", :MACCYRILLIC]]
  @paths["[KOI8-U, MACGREEK]"] = [[:"KOI8-U", :"UTF-8", :MACGREEK]]
  @paths["[KOI8-U, MACICELAND]"] = [[:"KOI8-U", :"UTF-8", :MACICELAND]]
  @paths["[KOI8-U, MACROMAN]"] = [[:"KOI8-U", :"UTF-8", :MACROMAN]]
  @paths["[KOI8-U, MACROMANIA]"] = [[:"KOI8-U", :"UTF-8", :MACROMANIA]]
  @paths["[KOI8-U, MACTURKISH]"] = [[:"KOI8-U", :"UTF-8", :MACTURKISH]]
  @paths["[KOI8-U, MACUKRAINE]"] = [[:"KOI8-U", :"UTF-8", :MACUKRAINE]]
  @paths["[KOI8-U, SHIFT_JIS]"] = [[:"KOI8-U", :"UTF-8", :SHIFT_JIS]]
  @paths["[KOI8-U, SJIS-DOCOMO]"] = [[:"KOI8-U", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[KOI8-U, SJIS-KDDI]"] = [[:"KOI8-U", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[KOI8-U, SJIS-SOFTBANK]"] = [[:"KOI8-U", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[KOI8-U, STATELESS-ISO-2022-JP]"] = [[:"KOI8-U", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[KOI8-U, STATELESS-ISO-2022-JP-KDDI]"] = [[:"KOI8-U", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[KOI8-U, TIS-620]"] = [[:"KOI8-U", :"UTF-8", :"TIS-620"]]
  @paths["[KOI8-U, US-ASCII]"] = [[:"KOI8-U", :"UTF-8", :"US-ASCII"]]
  @paths["[KOI8-U, UTF-16]"] = [[:"KOI8-U", :"UTF-8", :"UTF-16"]]
  @paths["[KOI8-U, UTF-16BE]"] = [[:"KOI8-U", :"UTF-8", :"UTF-16BE"]]
  @paths["[KOI8-U, UTF-16LE]"] = [[:"KOI8-U", :"UTF-8", :"UTF-16LE"]]
  @paths["[KOI8-U, UTF-32]"] = [[:"KOI8-U", :"UTF-8", :"UTF-32"]]
  @paths["[KOI8-U, UTF-32BE]"] = [[:"KOI8-U", :"UTF-8", :"UTF-32BE"]]
  @paths["[KOI8-U, UTF-32LE]"] = [[:"KOI8-U", :"UTF-8", :"UTF-32LE"]]
  @paths["[KOI8-U, UTF-8]"] = [[:"KOI8-U", :"UTF-8"]]
  @paths["[KOI8-U, UTF8-DOCOMO]"] = [[:"KOI8-U", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[KOI8-U, UTF8-KDDI]"] = [[:"KOI8-U", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[KOI8-U, UTF8-MAC]"] = [[:"KOI8-U", :"UTF-8", :"UTF8-MAC"]]
  @paths["[KOI8-U, UTF8-SOFTBANK]"] = [[:"KOI8-U", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[KOI8-U, WINDOWS-1250]"] = [[:"KOI8-U", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[KOI8-U, WINDOWS-1251]"] = [[:"KOI8-U", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[KOI8-U, WINDOWS-1252]"] = [[:"KOI8-U", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[KOI8-U, WINDOWS-1253]"] = [[:"KOI8-U", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[KOI8-U, WINDOWS-1254]"] = [[:"KOI8-U", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[KOI8-U, WINDOWS-1255]"] = [[:"KOI8-U", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[KOI8-U, WINDOWS-1256]"] = [[:"KOI8-U", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[KOI8-U, WINDOWS-1257]"] = [[:"KOI8-U", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[KOI8-U, WINDOWS-31J]"] = [[:"KOI8-U", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[KOI8-U, WINDOWS-874]"] = [[:"KOI8-U", :"UTF-8", :"WINDOWS-874"]]
  @paths["[MACCROATIAN, ASCII-8BIT]"] = [[:MACCROATIAN, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[MACCROATIAN, BIG5]"] = [[:MACCROATIAN, :"UTF-8", :BIG5]]
  @paths["[MACCROATIAN, BIG5-HKSCS]"] = [[:MACCROATIAN, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[MACCROATIAN, BIG5-UAO]"] = [[:MACCROATIAN, :"UTF-8", :"BIG5-UAO"]]
  @paths["[MACCROATIAN, CP50220]"] = [[:MACCROATIAN, :"UTF-8", :CP51932, :CP50220]]
  @paths["[MACCROATIAN, CP50221]"] = [[:MACCROATIAN, :"UTF-8", :CP51932, :CP50221]]
  @paths["[MACCROATIAN, CP51932]"] = [[:MACCROATIAN, :"UTF-8", :CP51932]]
  @paths["[MACCROATIAN, CP850]"] = [[:MACCROATIAN, :"UTF-8", :CP850]]
  @paths["[MACCROATIAN, CP852]"] = [[:MACCROATIAN, :"UTF-8", :CP852]]
  @paths["[MACCROATIAN, CP855]"] = [[:MACCROATIAN, :"UTF-8", :CP855]]
  @paths["[MACCROATIAN, CP949]"] = [[:MACCROATIAN, :"UTF-8", :CP949]]
  @paths["[MACCROATIAN, CP950]"] = [[:MACCROATIAN, :"UTF-8", :CP950]]
  @paths["[MACCROATIAN, CP951]"] = [[:MACCROATIAN, :"UTF-8", :CP951]]
  @paths["[MACCROATIAN, EUC-JP]"] = [[:MACCROATIAN, :"UTF-8", :"EUC-JP"]]
  @paths["[MACCROATIAN, EUC-KR]"] = [[:MACCROATIAN, :"UTF-8", :"EUC-KR"]]
  @paths["[MACCROATIAN, EUCJP-MS]"] = [[:MACCROATIAN, :"UTF-8", :"EUCJP-MS"]]
  @paths["[MACCROATIAN, GB12345]"] = [[:MACCROATIAN, :"UTF-8", :GB12345]]
  @paths["[MACCROATIAN, GB18030]"] = [[:MACCROATIAN, :"UTF-8", :GB18030]]
  @paths["[MACCROATIAN, GB2312]"] = [[:MACCROATIAN, :"UTF-8", :GB2312]]
  @paths["[MACCROATIAN, GBK]"] = [[:MACCROATIAN, :"UTF-8", :GBK]]
  @paths["[MACCROATIAN, IBM437]"] = [[:MACCROATIAN, :"UTF-8", :IBM437]]
  @paths["[MACCROATIAN, IBM737]"] = [[:MACCROATIAN, :"UTF-8", :IBM737]]
  @paths["[MACCROATIAN, IBM775]"] = [[:MACCROATIAN, :"UTF-8", :IBM775]]
  @paths["[MACCROATIAN, IBM852]"] = [[:MACCROATIAN, :"UTF-8", :IBM852]]
  @paths["[MACCROATIAN, IBM855]"] = [[:MACCROATIAN, :"UTF-8", :IBM855]]
  @paths["[MACCROATIAN, IBM857]"] = [[:MACCROATIAN, :"UTF-8", :IBM857]]
  @paths["[MACCROATIAN, IBM860]"] = [[:MACCROATIAN, :"UTF-8", :IBM860]]
  @paths["[MACCROATIAN, IBM861]"] = [[:MACCROATIAN, :"UTF-8", :IBM861]]
  @paths["[MACCROATIAN, IBM862]"] = [[:MACCROATIAN, :"UTF-8", :IBM862]]
  @paths["[MACCROATIAN, IBM863]"] = [[:MACCROATIAN, :"UTF-8", :IBM863]]
  @paths["[MACCROATIAN, IBM865]"] = [[:MACCROATIAN, :"UTF-8", :IBM865]]
  @paths["[MACCROATIAN, IBM866]"] = [[:MACCROATIAN, :"UTF-8", :IBM866]]
  @paths["[MACCROATIAN, IBM869]"] = [[:MACCROATIAN, :"UTF-8", :IBM869]]
  @paths["[MACCROATIAN, ISO-2022-JP]"] = [[:MACCROATIAN, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[MACCROATIAN, ISO-2022-JP-KDDI]"] = [[:MACCROATIAN, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[MACCROATIAN, ISO-8859-1]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-1"]]
  @paths["[MACCROATIAN, ISO-8859-10]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-10"]]
  @paths["[MACCROATIAN, ISO-8859-11]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-11"]]
  @paths["[MACCROATIAN, ISO-8859-13]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-13"]]
  @paths["[MACCROATIAN, ISO-8859-14]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-14"]]
  @paths["[MACCROATIAN, ISO-8859-15]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-15"]]
  @paths["[MACCROATIAN, ISO-8859-2]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-2"]]
  @paths["[MACCROATIAN, ISO-8859-3]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-3"]]
  @paths["[MACCROATIAN, ISO-8859-4]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-4"]]
  @paths["[MACCROATIAN, ISO-8859-5]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-5"]]
  @paths["[MACCROATIAN, ISO-8859-6]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-6"]]
  @paths["[MACCROATIAN, ISO-8859-7]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-7"]]
  @paths["[MACCROATIAN, ISO-8859-8]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-8"]]
  @paths["[MACCROATIAN, ISO-8859-9]"] = [[:MACCROATIAN, :"UTF-8", :"ISO-8859-9"]]
  @paths["[MACCROATIAN, KOI8-R]"] = [[:MACCROATIAN, :"UTF-8", :"KOI8-R"]]
  @paths["[MACCROATIAN, KOI8-U]"] = [[:MACCROATIAN, :"UTF-8", :"KOI8-U"]]
  @paths["[MACCROATIAN, MACCYRILLIC]"] = [[:MACCROATIAN, :"UTF-8", :MACCYRILLIC]]
  @paths["[MACCROATIAN, MACGREEK]"] = [[:MACCROATIAN, :"UTF-8", :MACGREEK]]
  @paths["[MACCROATIAN, MACICELAND]"] = [[:MACCROATIAN, :"UTF-8", :MACICELAND]]
  @paths["[MACCROATIAN, MACROMAN]"] = [[:MACCROATIAN, :"UTF-8", :MACROMAN]]
  @paths["[MACCROATIAN, MACROMANIA]"] = [[:MACCROATIAN, :"UTF-8", :MACROMANIA]]
  @paths["[MACCROATIAN, MACTURKISH]"] = [[:MACCROATIAN, :"UTF-8", :MACTURKISH]]
  @paths["[MACCROATIAN, MACUKRAINE]"] = [[:MACCROATIAN, :"UTF-8", :MACUKRAINE]]
  @paths["[MACCROATIAN, SHIFT_JIS]"] = [[:MACCROATIAN, :"UTF-8", :SHIFT_JIS]]
  @paths["[MACCROATIAN, SJIS-DOCOMO]"] = [[:MACCROATIAN, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[MACCROATIAN, SJIS-KDDI]"] = [[:MACCROATIAN, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[MACCROATIAN, SJIS-SOFTBANK]"] = [[:MACCROATIAN, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[MACCROATIAN, STATELESS-ISO-2022-JP]"] = [[:MACCROATIAN, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[MACCROATIAN, STATELESS-ISO-2022-JP-KDDI]"] = [[:MACCROATIAN, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[MACCROATIAN, TIS-620]"] = [[:MACCROATIAN, :"UTF-8", :"TIS-620"]]
  @paths["[MACCROATIAN, US-ASCII]"] = [[:MACCROATIAN, :"UTF-8", :"US-ASCII"]]
  @paths["[MACCROATIAN, UTF-16]"] = [[:MACCROATIAN, :"UTF-8", :"UTF-16"]]
  @paths["[MACCROATIAN, UTF-16BE]"] = [[:MACCROATIAN, :"UTF-8", :"UTF-16BE"]]
  @paths["[MACCROATIAN, UTF-16LE]"] = [[:MACCROATIAN, :"UTF-8", :"UTF-16LE"]]
  @paths["[MACCROATIAN, UTF-32]"] = [[:MACCROATIAN, :"UTF-8", :"UTF-32"]]
  @paths["[MACCROATIAN, UTF-32BE]"] = [[:MACCROATIAN, :"UTF-8", :"UTF-32BE"]]
  @paths["[MACCROATIAN, UTF-32LE]"] = [[:MACCROATIAN, :"UTF-8", :"UTF-32LE"]]
  @paths["[MACCROATIAN, UTF-8]"] = [[:MACCROATIAN, :"UTF-8"]]
  @paths["[MACCROATIAN, UTF8-DOCOMO]"] = [[:MACCROATIAN, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[MACCROATIAN, UTF8-KDDI]"] = [[:MACCROATIAN, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[MACCROATIAN, UTF8-MAC]"] = [[:MACCROATIAN, :"UTF-8", :"UTF8-MAC"]]
  @paths["[MACCROATIAN, UTF8-SOFTBANK]"] = [[:MACCROATIAN, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[MACCROATIAN, WINDOWS-1250]"] = [[:MACCROATIAN, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[MACCROATIAN, WINDOWS-1251]"] = [[:MACCROATIAN, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[MACCROATIAN, WINDOWS-1252]"] = [[:MACCROATIAN, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[MACCROATIAN, WINDOWS-1253]"] = [[:MACCROATIAN, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[MACCROATIAN, WINDOWS-1254]"] = [[:MACCROATIAN, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[MACCROATIAN, WINDOWS-1255]"] = [[:MACCROATIAN, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[MACCROATIAN, WINDOWS-1256]"] = [[:MACCROATIAN, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[MACCROATIAN, WINDOWS-1257]"] = [[:MACCROATIAN, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[MACCROATIAN, WINDOWS-31J]"] = [[:MACCROATIAN, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[MACCROATIAN, WINDOWS-874]"] = [[:MACCROATIAN, :"UTF-8", :"WINDOWS-874"]]
  @paths["[MACCYRILLIC, ASCII-8BIT]"] = [[:MACCYRILLIC, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[MACCYRILLIC, BIG5]"] = [[:MACCYRILLIC, :"UTF-8", :BIG5]]
  @paths["[MACCYRILLIC, BIG5-HKSCS]"] = [[:MACCYRILLIC, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[MACCYRILLIC, BIG5-UAO]"] = [[:MACCYRILLIC, :"UTF-8", :"BIG5-UAO"]]
  @paths["[MACCYRILLIC, CP50220]"] = [[:MACCYRILLIC, :"UTF-8", :CP51932, :CP50220]]
  @paths["[MACCYRILLIC, CP50221]"] = [[:MACCYRILLIC, :"UTF-8", :CP51932, :CP50221]]
  @paths["[MACCYRILLIC, CP51932]"] = [[:MACCYRILLIC, :"UTF-8", :CP51932]]
  @paths["[MACCYRILLIC, CP850]"] = [[:MACCYRILLIC, :"UTF-8", :CP850]]
  @paths["[MACCYRILLIC, CP852]"] = [[:MACCYRILLIC, :"UTF-8", :CP852]]
  @paths["[MACCYRILLIC, CP855]"] = [[:MACCYRILLIC, :"UTF-8", :CP855]]
  @paths["[MACCYRILLIC, CP949]"] = [[:MACCYRILLIC, :"UTF-8", :CP949]]
  @paths["[MACCYRILLIC, CP950]"] = [[:MACCYRILLIC, :"UTF-8", :CP950]]
  @paths["[MACCYRILLIC, CP951]"] = [[:MACCYRILLIC, :"UTF-8", :CP951]]
  @paths["[MACCYRILLIC, EUC-JP]"] = [[:MACCYRILLIC, :"UTF-8", :"EUC-JP"]]
  @paths["[MACCYRILLIC, EUC-KR]"] = [[:MACCYRILLIC, :"UTF-8", :"EUC-KR"]]
  @paths["[MACCYRILLIC, EUCJP-MS]"] = [[:MACCYRILLIC, :"UTF-8", :"EUCJP-MS"]]
  @paths["[MACCYRILLIC, GB12345]"] = [[:MACCYRILLIC, :"UTF-8", :GB12345]]
  @paths["[MACCYRILLIC, GB18030]"] = [[:MACCYRILLIC, :"UTF-8", :GB18030]]
  @paths["[MACCYRILLIC, GB2312]"] = [[:MACCYRILLIC, :"UTF-8", :GB2312]]
  @paths["[MACCYRILLIC, GBK]"] = [[:MACCYRILLIC, :"UTF-8", :GBK]]
  @paths["[MACCYRILLIC, IBM437]"] = [[:MACCYRILLIC, :"UTF-8", :IBM437]]
  @paths["[MACCYRILLIC, IBM737]"] = [[:MACCYRILLIC, :"UTF-8", :IBM737]]
  @paths["[MACCYRILLIC, IBM775]"] = [[:MACCYRILLIC, :"UTF-8", :IBM775]]
  @paths["[MACCYRILLIC, IBM852]"] = [[:MACCYRILLIC, :"UTF-8", :IBM852]]
  @paths["[MACCYRILLIC, IBM855]"] = [[:MACCYRILLIC, :"UTF-8", :IBM855]]
  @paths["[MACCYRILLIC, IBM857]"] = [[:MACCYRILLIC, :"UTF-8", :IBM857]]
  @paths["[MACCYRILLIC, IBM860]"] = [[:MACCYRILLIC, :"UTF-8", :IBM860]]
  @paths["[MACCYRILLIC, IBM861]"] = [[:MACCYRILLIC, :"UTF-8", :IBM861]]
  @paths["[MACCYRILLIC, IBM862]"] = [[:MACCYRILLIC, :"UTF-8", :IBM862]]
  @paths["[MACCYRILLIC, IBM863]"] = [[:MACCYRILLIC, :"UTF-8", :IBM863]]
  @paths["[MACCYRILLIC, IBM865]"] = [[:MACCYRILLIC, :"UTF-8", :IBM865]]
  @paths["[MACCYRILLIC, IBM866]"] = [[:MACCYRILLIC, :"UTF-8", :IBM866]]
  @paths["[MACCYRILLIC, IBM869]"] = [[:MACCYRILLIC, :"UTF-8", :IBM869]]
  @paths["[MACCYRILLIC, ISO-2022-JP]"] = [[:MACCYRILLIC, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[MACCYRILLIC, ISO-2022-JP-KDDI]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[MACCYRILLIC, ISO-8859-1]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-1"]]
  @paths["[MACCYRILLIC, ISO-8859-10]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-10"]]
  @paths["[MACCYRILLIC, ISO-8859-11]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-11"]]
  @paths["[MACCYRILLIC, ISO-8859-13]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-13"]]
  @paths["[MACCYRILLIC, ISO-8859-14]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-14"]]
  @paths["[MACCYRILLIC, ISO-8859-15]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-15"]]
  @paths["[MACCYRILLIC, ISO-8859-2]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-2"]]
  @paths["[MACCYRILLIC, ISO-8859-3]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-3"]]
  @paths["[MACCYRILLIC, ISO-8859-4]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-4"]]
  @paths["[MACCYRILLIC, ISO-8859-5]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-5"]]
  @paths["[MACCYRILLIC, ISO-8859-6]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-6"]]
  @paths["[MACCYRILLIC, ISO-8859-7]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-7"]]
  @paths["[MACCYRILLIC, ISO-8859-8]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-8"]]
  @paths["[MACCYRILLIC, ISO-8859-9]"] = [[:MACCYRILLIC, :"UTF-8", :"ISO-8859-9"]]
  @paths["[MACCYRILLIC, KOI8-R]"] = [[:MACCYRILLIC, :"UTF-8", :"KOI8-R"]]
  @paths["[MACCYRILLIC, KOI8-U]"] = [[:MACCYRILLIC, :"UTF-8", :"KOI8-U"]]
  @paths["[MACCYRILLIC, MACCROATIAN]"] = [[:MACCYRILLIC, :"UTF-8", :MACCROATIAN]]
  @paths["[MACCYRILLIC, MACGREEK]"] = [[:MACCYRILLIC, :"UTF-8", :MACGREEK]]
  @paths["[MACCYRILLIC, MACICELAND]"] = [[:MACCYRILLIC, :"UTF-8", :MACICELAND]]
  @paths["[MACCYRILLIC, MACROMAN]"] = [[:MACCYRILLIC, :"UTF-8", :MACROMAN]]
  @paths["[MACCYRILLIC, MACROMANIA]"] = [[:MACCYRILLIC, :"UTF-8", :MACROMANIA]]
  @paths["[MACCYRILLIC, MACTURKISH]"] = [[:MACCYRILLIC, :"UTF-8", :MACTURKISH]]
  @paths["[MACCYRILLIC, MACUKRAINE]"] = [[:MACCYRILLIC, :"UTF-8", :MACUKRAINE]]
  @paths["[MACCYRILLIC, SHIFT_JIS]"] = [[:MACCYRILLIC, :"UTF-8", :SHIFT_JIS]]
  @paths["[MACCYRILLIC, SJIS-DOCOMO]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[MACCYRILLIC, SJIS-KDDI]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[MACCYRILLIC, SJIS-SOFTBANK]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[MACCYRILLIC, STATELESS-ISO-2022-JP]"] = [[:MACCYRILLIC, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[MACCYRILLIC, STATELESS-ISO-2022-JP-KDDI]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[MACCYRILLIC, TIS-620]"] = [[:MACCYRILLIC, :"UTF-8", :"TIS-620"]]
  @paths["[MACCYRILLIC, US-ASCII]"] = [[:MACCYRILLIC, :"UTF-8", :"US-ASCII"]]
  @paths["[MACCYRILLIC, UTF-16]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF-16"]]
  @paths["[MACCYRILLIC, UTF-16BE]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF-16BE"]]
  @paths["[MACCYRILLIC, UTF-16LE]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF-16LE"]]
  @paths["[MACCYRILLIC, UTF-32]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF-32"]]
  @paths["[MACCYRILLIC, UTF-32BE]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF-32BE"]]
  @paths["[MACCYRILLIC, UTF-32LE]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF-32LE"]]
  @paths["[MACCYRILLIC, UTF-8]"] = [[:MACCYRILLIC, :"UTF-8"]]
  @paths["[MACCYRILLIC, UTF8-DOCOMO]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[MACCYRILLIC, UTF8-KDDI]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[MACCYRILLIC, UTF8-MAC]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF8-MAC"]]
  @paths["[MACCYRILLIC, UTF8-SOFTBANK]"] = [[:MACCYRILLIC, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[MACCYRILLIC, WINDOWS-1250]"] = [[:MACCYRILLIC, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[MACCYRILLIC, WINDOWS-1251]"] = [[:MACCYRILLIC, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[MACCYRILLIC, WINDOWS-1252]"] = [[:MACCYRILLIC, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[MACCYRILLIC, WINDOWS-1253]"] = [[:MACCYRILLIC, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[MACCYRILLIC, WINDOWS-1254]"] = [[:MACCYRILLIC, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[MACCYRILLIC, WINDOWS-1255]"] = [[:MACCYRILLIC, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[MACCYRILLIC, WINDOWS-1256]"] = [[:MACCYRILLIC, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[MACCYRILLIC, WINDOWS-1257]"] = [[:MACCYRILLIC, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[MACCYRILLIC, WINDOWS-31J]"] = [[:MACCYRILLIC, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[MACCYRILLIC, WINDOWS-874]"] = [[:MACCYRILLIC, :"UTF-8", :"WINDOWS-874"]]
  @paths["[MACGREEK, ASCII-8BIT]"] = [[:MACGREEK, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[MACGREEK, BIG5]"] = [[:MACGREEK, :"UTF-8", :BIG5]]
  @paths["[MACGREEK, BIG5-HKSCS]"] = [[:MACGREEK, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[MACGREEK, BIG5-UAO]"] = [[:MACGREEK, :"UTF-8", :"BIG5-UAO"]]
  @paths["[MACGREEK, CP50220]"] = [[:MACGREEK, :"UTF-8", :CP51932, :CP50220]]
  @paths["[MACGREEK, CP50221]"] = [[:MACGREEK, :"UTF-8", :CP51932, :CP50221]]
  @paths["[MACGREEK, CP51932]"] = [[:MACGREEK, :"UTF-8", :CP51932]]
  @paths["[MACGREEK, CP850]"] = [[:MACGREEK, :"UTF-8", :CP850]]
  @paths["[MACGREEK, CP852]"] = [[:MACGREEK, :"UTF-8", :CP852]]
  @paths["[MACGREEK, CP855]"] = [[:MACGREEK, :"UTF-8", :CP855]]
  @paths["[MACGREEK, CP949]"] = [[:MACGREEK, :"UTF-8", :CP949]]
  @paths["[MACGREEK, CP950]"] = [[:MACGREEK, :"UTF-8", :CP950]]
  @paths["[MACGREEK, CP951]"] = [[:MACGREEK, :"UTF-8", :CP951]]
  @paths["[MACGREEK, EUC-JP]"] = [[:MACGREEK, :"UTF-8", :"EUC-JP"]]
  @paths["[MACGREEK, EUC-KR]"] = [[:MACGREEK, :"UTF-8", :"EUC-KR"]]
  @paths["[MACGREEK, EUCJP-MS]"] = [[:MACGREEK, :"UTF-8", :"EUCJP-MS"]]
  @paths["[MACGREEK, GB12345]"] = [[:MACGREEK, :"UTF-8", :GB12345]]
  @paths["[MACGREEK, GB18030]"] = [[:MACGREEK, :"UTF-8", :GB18030]]
  @paths["[MACGREEK, GB2312]"] = [[:MACGREEK, :"UTF-8", :GB2312]]
  @paths["[MACGREEK, GBK]"] = [[:MACGREEK, :"UTF-8", :GBK]]
  @paths["[MACGREEK, IBM437]"] = [[:MACGREEK, :"UTF-8", :IBM437]]
  @paths["[MACGREEK, IBM737]"] = [[:MACGREEK, :"UTF-8", :IBM737]]
  @paths["[MACGREEK, IBM775]"] = [[:MACGREEK, :"UTF-8", :IBM775]]
  @paths["[MACGREEK, IBM852]"] = [[:MACGREEK, :"UTF-8", :IBM852]]
  @paths["[MACGREEK, IBM855]"] = [[:MACGREEK, :"UTF-8", :IBM855]]
  @paths["[MACGREEK, IBM857]"] = [[:MACGREEK, :"UTF-8", :IBM857]]
  @paths["[MACGREEK, IBM860]"] = [[:MACGREEK, :"UTF-8", :IBM860]]
  @paths["[MACGREEK, IBM861]"] = [[:MACGREEK, :"UTF-8", :IBM861]]
  @paths["[MACGREEK, IBM862]"] = [[:MACGREEK, :"UTF-8", :IBM862]]
  @paths["[MACGREEK, IBM863]"] = [[:MACGREEK, :"UTF-8", :IBM863]]
  @paths["[MACGREEK, IBM865]"] = [[:MACGREEK, :"UTF-8", :IBM865]]
  @paths["[MACGREEK, IBM866]"] = [[:MACGREEK, :"UTF-8", :IBM866]]
  @paths["[MACGREEK, IBM869]"] = [[:MACGREEK, :"UTF-8", :IBM869]]
  @paths["[MACGREEK, ISO-2022-JP]"] = [[:MACGREEK, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[MACGREEK, ISO-2022-JP-KDDI]"] = [[:MACGREEK, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[MACGREEK, ISO-8859-1]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-1"]]
  @paths["[MACGREEK, ISO-8859-10]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-10"]]
  @paths["[MACGREEK, ISO-8859-11]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-11"]]
  @paths["[MACGREEK, ISO-8859-13]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-13"]]
  @paths["[MACGREEK, ISO-8859-14]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-14"]]
  @paths["[MACGREEK, ISO-8859-15]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-15"]]
  @paths["[MACGREEK, ISO-8859-2]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-2"]]
  @paths["[MACGREEK, ISO-8859-3]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-3"]]
  @paths["[MACGREEK, ISO-8859-4]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-4"]]
  @paths["[MACGREEK, ISO-8859-5]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-5"]]
  @paths["[MACGREEK, ISO-8859-6]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-6"]]
  @paths["[MACGREEK, ISO-8859-7]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-7"]]
  @paths["[MACGREEK, ISO-8859-8]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-8"]]
  @paths["[MACGREEK, ISO-8859-9]"] = [[:MACGREEK, :"UTF-8", :"ISO-8859-9"]]
  @paths["[MACGREEK, KOI8-R]"] = [[:MACGREEK, :"UTF-8", :"KOI8-R"]]
  @paths["[MACGREEK, KOI8-U]"] = [[:MACGREEK, :"UTF-8", :"KOI8-U"]]
  @paths["[MACGREEK, MACCROATIAN]"] = [[:MACGREEK, :"UTF-8", :MACCROATIAN]]
  @paths["[MACGREEK, MACCYRILLIC]"] = [[:MACGREEK, :"UTF-8", :MACCYRILLIC]]
  @paths["[MACGREEK, MACICELAND]"] = [[:MACGREEK, :"UTF-8", :MACICELAND]]
  @paths["[MACGREEK, MACROMAN]"] = [[:MACGREEK, :"UTF-8", :MACROMAN]]
  @paths["[MACGREEK, MACROMANIA]"] = [[:MACGREEK, :"UTF-8", :MACROMANIA]]
  @paths["[MACGREEK, MACTURKISH]"] = [[:MACGREEK, :"UTF-8", :MACTURKISH]]
  @paths["[MACGREEK, MACUKRAINE]"] = [[:MACGREEK, :"UTF-8", :MACUKRAINE]]
  @paths["[MACGREEK, SHIFT_JIS]"] = [[:MACGREEK, :"UTF-8", :SHIFT_JIS]]
  @paths["[MACGREEK, SJIS-DOCOMO]"] = [[:MACGREEK, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[MACGREEK, SJIS-KDDI]"] = [[:MACGREEK, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[MACGREEK, SJIS-SOFTBANK]"] = [[:MACGREEK, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[MACGREEK, STATELESS-ISO-2022-JP]"] = [[:MACGREEK, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[MACGREEK, STATELESS-ISO-2022-JP-KDDI]"] = [[:MACGREEK, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[MACGREEK, TIS-620]"] = [[:MACGREEK, :"UTF-8", :"TIS-620"]]
  @paths["[MACGREEK, US-ASCII]"] = [[:MACGREEK, :"UTF-8", :"US-ASCII"]]
  @paths["[MACGREEK, UTF-16]"] = [[:MACGREEK, :"UTF-8", :"UTF-16"]]
  @paths["[MACGREEK, UTF-16BE]"] = [[:MACGREEK, :"UTF-8", :"UTF-16BE"]]
  @paths["[MACGREEK, UTF-16LE]"] = [[:MACGREEK, :"UTF-8", :"UTF-16LE"]]
  @paths["[MACGREEK, UTF-32]"] = [[:MACGREEK, :"UTF-8", :"UTF-32"]]
  @paths["[MACGREEK, UTF-32BE]"] = [[:MACGREEK, :"UTF-8", :"UTF-32BE"]]
  @paths["[MACGREEK, UTF-32LE]"] = [[:MACGREEK, :"UTF-8", :"UTF-32LE"]]
  @paths["[MACGREEK, UTF-8]"] = [[:MACGREEK, :"UTF-8"]]
  @paths["[MACGREEK, UTF8-DOCOMO]"] = [[:MACGREEK, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[MACGREEK, UTF8-KDDI]"] = [[:MACGREEK, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[MACGREEK, UTF8-MAC]"] = [[:MACGREEK, :"UTF-8", :"UTF8-MAC"]]
  @paths["[MACGREEK, UTF8-SOFTBANK]"] = [[:MACGREEK, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[MACGREEK, WINDOWS-1250]"] = [[:MACGREEK, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[MACGREEK, WINDOWS-1251]"] = [[:MACGREEK, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[MACGREEK, WINDOWS-1252]"] = [[:MACGREEK, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[MACGREEK, WINDOWS-1253]"] = [[:MACGREEK, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[MACGREEK, WINDOWS-1254]"] = [[:MACGREEK, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[MACGREEK, WINDOWS-1255]"] = [[:MACGREEK, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[MACGREEK, WINDOWS-1256]"] = [[:MACGREEK, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[MACGREEK, WINDOWS-1257]"] = [[:MACGREEK, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[MACGREEK, WINDOWS-31J]"] = [[:MACGREEK, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[MACGREEK, WINDOWS-874]"] = [[:MACGREEK, :"UTF-8", :"WINDOWS-874"]]
  @paths["[MACICELAND, ASCII-8BIT]"] = [[:MACICELAND, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[MACICELAND, BIG5]"] = [[:MACICELAND, :"UTF-8", :BIG5]]
  @paths["[MACICELAND, BIG5-HKSCS]"] = [[:MACICELAND, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[MACICELAND, BIG5-UAO]"] = [[:MACICELAND, :"UTF-8", :"BIG5-UAO"]]
  @paths["[MACICELAND, CP50220]"] = [[:MACICELAND, :"UTF-8", :CP51932, :CP50220]]
  @paths["[MACICELAND, CP50221]"] = [[:MACICELAND, :"UTF-8", :CP51932, :CP50221]]
  @paths["[MACICELAND, CP51932]"] = [[:MACICELAND, :"UTF-8", :CP51932]]
  @paths["[MACICELAND, CP850]"] = [[:MACICELAND, :"UTF-8", :CP850]]
  @paths["[MACICELAND, CP852]"] = [[:MACICELAND, :"UTF-8", :CP852]]
  @paths["[MACICELAND, CP855]"] = [[:MACICELAND, :"UTF-8", :CP855]]
  @paths["[MACICELAND, CP949]"] = [[:MACICELAND, :"UTF-8", :CP949]]
  @paths["[MACICELAND, CP950]"] = [[:MACICELAND, :"UTF-8", :CP950]]
  @paths["[MACICELAND, CP951]"] = [[:MACICELAND, :"UTF-8", :CP951]]
  @paths["[MACICELAND, EUC-JP]"] = [[:MACICELAND, :"UTF-8", :"EUC-JP"]]
  @paths["[MACICELAND, EUC-KR]"] = [[:MACICELAND, :"UTF-8", :"EUC-KR"]]
  @paths["[MACICELAND, EUCJP-MS]"] = [[:MACICELAND, :"UTF-8", :"EUCJP-MS"]]
  @paths["[MACICELAND, GB12345]"] = [[:MACICELAND, :"UTF-8", :GB12345]]
  @paths["[MACICELAND, GB18030]"] = [[:MACICELAND, :"UTF-8", :GB18030]]
  @paths["[MACICELAND, GB2312]"] = [[:MACICELAND, :"UTF-8", :GB2312]]
  @paths["[MACICELAND, GBK]"] = [[:MACICELAND, :"UTF-8", :GBK]]
  @paths["[MACICELAND, IBM437]"] = [[:MACICELAND, :"UTF-8", :IBM437]]
  @paths["[MACICELAND, IBM737]"] = [[:MACICELAND, :"UTF-8", :IBM737]]
  @paths["[MACICELAND, IBM775]"] = [[:MACICELAND, :"UTF-8", :IBM775]]
  @paths["[MACICELAND, IBM852]"] = [[:MACICELAND, :"UTF-8", :IBM852]]
  @paths["[MACICELAND, IBM855]"] = [[:MACICELAND, :"UTF-8", :IBM855]]
  @paths["[MACICELAND, IBM857]"] = [[:MACICELAND, :"UTF-8", :IBM857]]
  @paths["[MACICELAND, IBM860]"] = [[:MACICELAND, :"UTF-8", :IBM860]]
  @paths["[MACICELAND, IBM861]"] = [[:MACICELAND, :"UTF-8", :IBM861]]
  @paths["[MACICELAND, IBM862]"] = [[:MACICELAND, :"UTF-8", :IBM862]]
  @paths["[MACICELAND, IBM863]"] = [[:MACICELAND, :"UTF-8", :IBM863]]
  @paths["[MACICELAND, IBM865]"] = [[:MACICELAND, :"UTF-8", :IBM865]]
  @paths["[MACICELAND, IBM866]"] = [[:MACICELAND, :"UTF-8", :IBM866]]
  @paths["[MACICELAND, IBM869]"] = [[:MACICELAND, :"UTF-8", :IBM869]]
  @paths["[MACICELAND, ISO-2022-JP]"] = [[:MACICELAND, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[MACICELAND, ISO-2022-JP-KDDI]"] = [[:MACICELAND, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[MACICELAND, ISO-8859-1]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-1"]]
  @paths["[MACICELAND, ISO-8859-10]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-10"]]
  @paths["[MACICELAND, ISO-8859-11]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-11"]]
  @paths["[MACICELAND, ISO-8859-13]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-13"]]
  @paths["[MACICELAND, ISO-8859-14]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-14"]]
  @paths["[MACICELAND, ISO-8859-15]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-15"]]
  @paths["[MACICELAND, ISO-8859-2]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-2"]]
  @paths["[MACICELAND, ISO-8859-3]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-3"]]
  @paths["[MACICELAND, ISO-8859-4]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-4"]]
  @paths["[MACICELAND, ISO-8859-5]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-5"]]
  @paths["[MACICELAND, ISO-8859-6]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-6"]]
  @paths["[MACICELAND, ISO-8859-7]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-7"]]
  @paths["[MACICELAND, ISO-8859-8]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-8"]]
  @paths["[MACICELAND, ISO-8859-9]"] = [[:MACICELAND, :"UTF-8", :"ISO-8859-9"]]
  @paths["[MACICELAND, KOI8-R]"] = [[:MACICELAND, :"UTF-8", :"KOI8-R"]]
  @paths["[MACICELAND, KOI8-U]"] = [[:MACICELAND, :"UTF-8", :"KOI8-U"]]
  @paths["[MACICELAND, MACCROATIAN]"] = [[:MACICELAND, :"UTF-8", :MACCROATIAN]]
  @paths["[MACICELAND, MACCYRILLIC]"] = [[:MACICELAND, :"UTF-8", :MACCYRILLIC]]
  @paths["[MACICELAND, MACGREEK]"] = [[:MACICELAND, :"UTF-8", :MACGREEK]]
  @paths["[MACICELAND, MACROMAN]"] = [[:MACICELAND, :"UTF-8", :MACROMAN]]
  @paths["[MACICELAND, MACROMANIA]"] = [[:MACICELAND, :"UTF-8", :MACROMANIA]]
  @paths["[MACICELAND, MACTURKISH]"] = [[:MACICELAND, :"UTF-8", :MACTURKISH]]
  @paths["[MACICELAND, MACUKRAINE]"] = [[:MACICELAND, :"UTF-8", :MACUKRAINE]]
  @paths["[MACICELAND, SHIFT_JIS]"] = [[:MACICELAND, :"UTF-8", :SHIFT_JIS]]
  @paths["[MACICELAND, SJIS-DOCOMO]"] = [[:MACICELAND, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[MACICELAND, SJIS-KDDI]"] = [[:MACICELAND, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[MACICELAND, SJIS-SOFTBANK]"] = [[:MACICELAND, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[MACICELAND, STATELESS-ISO-2022-JP]"] = [[:MACICELAND, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[MACICELAND, STATELESS-ISO-2022-JP-KDDI]"] = [[:MACICELAND, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[MACICELAND, TIS-620]"] = [[:MACICELAND, :"UTF-8", :"TIS-620"]]
  @paths["[MACICELAND, US-ASCII]"] = [[:MACICELAND, :"UTF-8", :"US-ASCII"]]
  @paths["[MACICELAND, UTF-16]"] = [[:MACICELAND, :"UTF-8", :"UTF-16"]]
  @paths["[MACICELAND, UTF-16BE]"] = [[:MACICELAND, :"UTF-8", :"UTF-16BE"]]
  @paths["[MACICELAND, UTF-16LE]"] = [[:MACICELAND, :"UTF-8", :"UTF-16LE"]]
  @paths["[MACICELAND, UTF-32]"] = [[:MACICELAND, :"UTF-8", :"UTF-32"]]
  @paths["[MACICELAND, UTF-32BE]"] = [[:MACICELAND, :"UTF-8", :"UTF-32BE"]]
  @paths["[MACICELAND, UTF-32LE]"] = [[:MACICELAND, :"UTF-8", :"UTF-32LE"]]
  @paths["[MACICELAND, UTF-8]"] = [[:MACICELAND, :"UTF-8"]]
  @paths["[MACICELAND, UTF8-DOCOMO]"] = [[:MACICELAND, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[MACICELAND, UTF8-KDDI]"] = [[:MACICELAND, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[MACICELAND, UTF8-MAC]"] = [[:MACICELAND, :"UTF-8", :"UTF8-MAC"]]
  @paths["[MACICELAND, UTF8-SOFTBANK]"] = [[:MACICELAND, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[MACICELAND, WINDOWS-1250]"] = [[:MACICELAND, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[MACICELAND, WINDOWS-1251]"] = [[:MACICELAND, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[MACICELAND, WINDOWS-1252]"] = [[:MACICELAND, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[MACICELAND, WINDOWS-1253]"] = [[:MACICELAND, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[MACICELAND, WINDOWS-1254]"] = [[:MACICELAND, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[MACICELAND, WINDOWS-1255]"] = [[:MACICELAND, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[MACICELAND, WINDOWS-1256]"] = [[:MACICELAND, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[MACICELAND, WINDOWS-1257]"] = [[:MACICELAND, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[MACICELAND, WINDOWS-31J]"] = [[:MACICELAND, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[MACICELAND, WINDOWS-874]"] = [[:MACICELAND, :"UTF-8", :"WINDOWS-874"]]
  @paths["[MACROMAN, ASCII-8BIT]"] = [[:MACROMAN, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[MACROMAN, BIG5]"] = [[:MACROMAN, :"UTF-8", :BIG5]]
  @paths["[MACROMAN, BIG5-HKSCS]"] = [[:MACROMAN, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[MACROMAN, BIG5-UAO]"] = [[:MACROMAN, :"UTF-8", :"BIG5-UAO"]]
  @paths["[MACROMAN, CP50220]"] = [[:MACROMAN, :"UTF-8", :CP51932, :CP50220]]
  @paths["[MACROMAN, CP50221]"] = [[:MACROMAN, :"UTF-8", :CP51932, :CP50221]]
  @paths["[MACROMAN, CP51932]"] = [[:MACROMAN, :"UTF-8", :CP51932]]
  @paths["[MACROMAN, CP850]"] = [[:MACROMAN, :"UTF-8", :CP850]]
  @paths["[MACROMAN, CP852]"] = [[:MACROMAN, :"UTF-8", :CP852]]
  @paths["[MACROMAN, CP855]"] = [[:MACROMAN, :"UTF-8", :CP855]]
  @paths["[MACROMAN, CP949]"] = [[:MACROMAN, :"UTF-8", :CP949]]
  @paths["[MACROMAN, CP950]"] = [[:MACROMAN, :"UTF-8", :CP950]]
  @paths["[MACROMAN, CP951]"] = [[:MACROMAN, :"UTF-8", :CP951]]
  @paths["[MACROMAN, EUC-JP]"] = [[:MACROMAN, :"UTF-8", :"EUC-JP"]]
  @paths["[MACROMAN, EUC-KR]"] = [[:MACROMAN, :"UTF-8", :"EUC-KR"]]
  @paths["[MACROMAN, EUCJP-MS]"] = [[:MACROMAN, :"UTF-8", :"EUCJP-MS"]]
  @paths["[MACROMAN, GB12345]"] = [[:MACROMAN, :"UTF-8", :GB12345]]
  @paths["[MACROMAN, GB18030]"] = [[:MACROMAN, :"UTF-8", :GB18030]]
  @paths["[MACROMAN, GB2312]"] = [[:MACROMAN, :"UTF-8", :GB2312]]
  @paths["[MACROMAN, GBK]"] = [[:MACROMAN, :"UTF-8", :GBK]]
  @paths["[MACROMAN, IBM437]"] = [[:MACROMAN, :"UTF-8", :IBM437]]
  @paths["[MACROMAN, IBM737]"] = [[:MACROMAN, :"UTF-8", :IBM737]]
  @paths["[MACROMAN, IBM775]"] = [[:MACROMAN, :"UTF-8", :IBM775]]
  @paths["[MACROMAN, IBM852]"] = [[:MACROMAN, :"UTF-8", :IBM852]]
  @paths["[MACROMAN, IBM855]"] = [[:MACROMAN, :"UTF-8", :IBM855]]
  @paths["[MACROMAN, IBM857]"] = [[:MACROMAN, :"UTF-8", :IBM857]]
  @paths["[MACROMAN, IBM860]"] = [[:MACROMAN, :"UTF-8", :IBM860]]
  @paths["[MACROMAN, IBM861]"] = [[:MACROMAN, :"UTF-8", :IBM861]]
  @paths["[MACROMAN, IBM862]"] = [[:MACROMAN, :"UTF-8", :IBM862]]
  @paths["[MACROMAN, IBM863]"] = [[:MACROMAN, :"UTF-8", :IBM863]]
  @paths["[MACROMAN, IBM865]"] = [[:MACROMAN, :"UTF-8", :IBM865]]
  @paths["[MACROMAN, IBM866]"] = [[:MACROMAN, :"UTF-8", :IBM866]]
  @paths["[MACROMAN, IBM869]"] = [[:MACROMAN, :"UTF-8", :IBM869]]
  @paths["[MACROMAN, ISO-2022-JP]"] = [[:MACROMAN, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[MACROMAN, ISO-2022-JP-KDDI]"] = [[:MACROMAN, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[MACROMAN, ISO-8859-1]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-1"]]
  @paths["[MACROMAN, ISO-8859-10]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-10"]]
  @paths["[MACROMAN, ISO-8859-11]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-11"]]
  @paths["[MACROMAN, ISO-8859-13]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-13"]]
  @paths["[MACROMAN, ISO-8859-14]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-14"]]
  @paths["[MACROMAN, ISO-8859-15]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-15"]]
  @paths["[MACROMAN, ISO-8859-2]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-2"]]
  @paths["[MACROMAN, ISO-8859-3]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-3"]]
  @paths["[MACROMAN, ISO-8859-4]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-4"]]
  @paths["[MACROMAN, ISO-8859-5]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-5"]]
  @paths["[MACROMAN, ISO-8859-6]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-6"]]
  @paths["[MACROMAN, ISO-8859-7]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-7"]]
  @paths["[MACROMAN, ISO-8859-8]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-8"]]
  @paths["[MACROMAN, ISO-8859-9]"] = [[:MACROMAN, :"UTF-8", :"ISO-8859-9"]]
  @paths["[MACROMAN, KOI8-R]"] = [[:MACROMAN, :"UTF-8", :"KOI8-R"]]
  @paths["[MACROMAN, KOI8-U]"] = [[:MACROMAN, :"UTF-8", :"KOI8-U"]]
  @paths["[MACROMAN, MACCROATIAN]"] = [[:MACROMAN, :"UTF-8", :MACCROATIAN]]
  @paths["[MACROMAN, MACCYRILLIC]"] = [[:MACROMAN, :"UTF-8", :MACCYRILLIC]]
  @paths["[MACROMAN, MACGREEK]"] = [[:MACROMAN, :"UTF-8", :MACGREEK]]
  @paths["[MACROMAN, MACICELAND]"] = [[:MACROMAN, :"UTF-8", :MACICELAND]]
  @paths["[MACROMAN, MACROMANIA]"] = [[:MACROMAN, :"UTF-8", :MACROMANIA]]
  @paths["[MACROMAN, MACTURKISH]"] = [[:MACROMAN, :"UTF-8", :MACTURKISH]]
  @paths["[MACROMAN, MACUKRAINE]"] = [[:MACROMAN, :"UTF-8", :MACUKRAINE]]
  @paths["[MACROMAN, SHIFT_JIS]"] = [[:MACROMAN, :"UTF-8", :SHIFT_JIS]]
  @paths["[MACROMAN, SJIS-DOCOMO]"] = [[:MACROMAN, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[MACROMAN, SJIS-KDDI]"] = [[:MACROMAN, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[MACROMAN, SJIS-SOFTBANK]"] = [[:MACROMAN, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[MACROMAN, STATELESS-ISO-2022-JP]"] = [[:MACROMAN, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[MACROMAN, STATELESS-ISO-2022-JP-KDDI]"] = [[:MACROMAN, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[MACROMAN, TIS-620]"] = [[:MACROMAN, :"UTF-8", :"TIS-620"]]
  @paths["[MACROMAN, US-ASCII]"] = [[:MACROMAN, :"UTF-8", :"US-ASCII"]]
  @paths["[MACROMAN, UTF-16]"] = [[:MACROMAN, :"UTF-8", :"UTF-16"]]
  @paths["[MACROMAN, UTF-16BE]"] = [[:MACROMAN, :"UTF-8", :"UTF-16BE"]]
  @paths["[MACROMAN, UTF-16LE]"] = [[:MACROMAN, :"UTF-8", :"UTF-16LE"]]
  @paths["[MACROMAN, UTF-32]"] = [[:MACROMAN, :"UTF-8", :"UTF-32"]]
  @paths["[MACROMAN, UTF-32BE]"] = [[:MACROMAN, :"UTF-8", :"UTF-32BE"]]
  @paths["[MACROMAN, UTF-32LE]"] = [[:MACROMAN, :"UTF-8", :"UTF-32LE"]]
  @paths["[MACROMAN, UTF-8]"] = [[:MACROMAN, :"UTF-8"]]
  @paths["[MACROMAN, UTF8-DOCOMO]"] = [[:MACROMAN, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[MACROMAN, UTF8-KDDI]"] = [[:MACROMAN, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[MACROMAN, UTF8-MAC]"] = [[:MACROMAN, :"UTF-8", :"UTF8-MAC"]]
  @paths["[MACROMAN, UTF8-SOFTBANK]"] = [[:MACROMAN, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[MACROMAN, WINDOWS-1250]"] = [[:MACROMAN, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[MACROMAN, WINDOWS-1251]"] = [[:MACROMAN, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[MACROMAN, WINDOWS-1252]"] = [[:MACROMAN, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[MACROMAN, WINDOWS-1253]"] = [[:MACROMAN, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[MACROMAN, WINDOWS-1254]"] = [[:MACROMAN, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[MACROMAN, WINDOWS-1255]"] = [[:MACROMAN, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[MACROMAN, WINDOWS-1256]"] = [[:MACROMAN, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[MACROMAN, WINDOWS-1257]"] = [[:MACROMAN, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[MACROMAN, WINDOWS-31J]"] = [[:MACROMAN, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[MACROMAN, WINDOWS-874]"] = [[:MACROMAN, :"UTF-8", :"WINDOWS-874"]]
  @paths["[MACROMANIA, ASCII-8BIT]"] = [[:MACROMANIA, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[MACROMANIA, BIG5]"] = [[:MACROMANIA, :"UTF-8", :BIG5]]
  @paths["[MACROMANIA, BIG5-HKSCS]"] = [[:MACROMANIA, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[MACROMANIA, BIG5-UAO]"] = [[:MACROMANIA, :"UTF-8", :"BIG5-UAO"]]
  @paths["[MACROMANIA, CP50220]"] = [[:MACROMANIA, :"UTF-8", :CP51932, :CP50220]]
  @paths["[MACROMANIA, CP50221]"] = [[:MACROMANIA, :"UTF-8", :CP51932, :CP50221]]
  @paths["[MACROMANIA, CP51932]"] = [[:MACROMANIA, :"UTF-8", :CP51932]]
  @paths["[MACROMANIA, CP850]"] = [[:MACROMANIA, :"UTF-8", :CP850]]
  @paths["[MACROMANIA, CP852]"] = [[:MACROMANIA, :"UTF-8", :CP852]]
  @paths["[MACROMANIA, CP855]"] = [[:MACROMANIA, :"UTF-8", :CP855]]
  @paths["[MACROMANIA, CP949]"] = [[:MACROMANIA, :"UTF-8", :CP949]]
  @paths["[MACROMANIA, CP950]"] = [[:MACROMANIA, :"UTF-8", :CP950]]
  @paths["[MACROMANIA, CP951]"] = [[:MACROMANIA, :"UTF-8", :CP951]]
  @paths["[MACROMANIA, EUC-JP]"] = [[:MACROMANIA, :"UTF-8", :"EUC-JP"]]
  @paths["[MACROMANIA, EUC-KR]"] = [[:MACROMANIA, :"UTF-8", :"EUC-KR"]]
  @paths["[MACROMANIA, EUCJP-MS]"] = [[:MACROMANIA, :"UTF-8", :"EUCJP-MS"]]
  @paths["[MACROMANIA, GB12345]"] = [[:MACROMANIA, :"UTF-8", :GB12345]]
  @paths["[MACROMANIA, GB18030]"] = [[:MACROMANIA, :"UTF-8", :GB18030]]
  @paths["[MACROMANIA, GB2312]"] = [[:MACROMANIA, :"UTF-8", :GB2312]]
  @paths["[MACROMANIA, GBK]"] = [[:MACROMANIA, :"UTF-8", :GBK]]
  @paths["[MACROMANIA, IBM437]"] = [[:MACROMANIA, :"UTF-8", :IBM437]]
  @paths["[MACROMANIA, IBM737]"] = [[:MACROMANIA, :"UTF-8", :IBM737]]
  @paths["[MACROMANIA, IBM775]"] = [[:MACROMANIA, :"UTF-8", :IBM775]]
  @paths["[MACROMANIA, IBM852]"] = [[:MACROMANIA, :"UTF-8", :IBM852]]
  @paths["[MACROMANIA, IBM855]"] = [[:MACROMANIA, :"UTF-8", :IBM855]]
  @paths["[MACROMANIA, IBM857]"] = [[:MACROMANIA, :"UTF-8", :IBM857]]
  @paths["[MACROMANIA, IBM860]"] = [[:MACROMANIA, :"UTF-8", :IBM860]]
  @paths["[MACROMANIA, IBM861]"] = [[:MACROMANIA, :"UTF-8", :IBM861]]
  @paths["[MACROMANIA, IBM862]"] = [[:MACROMANIA, :"UTF-8", :IBM862]]
  @paths["[MACROMANIA, IBM863]"] = [[:MACROMANIA, :"UTF-8", :IBM863]]
  @paths["[MACROMANIA, IBM865]"] = [[:MACROMANIA, :"UTF-8", :IBM865]]
  @paths["[MACROMANIA, IBM866]"] = [[:MACROMANIA, :"UTF-8", :IBM866]]
  @paths["[MACROMANIA, IBM869]"] = [[:MACROMANIA, :"UTF-8", :IBM869]]
  @paths["[MACROMANIA, ISO-2022-JP]"] = [[:MACROMANIA, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[MACROMANIA, ISO-2022-JP-KDDI]"] = [[:MACROMANIA, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[MACROMANIA, ISO-8859-1]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-1"]]
  @paths["[MACROMANIA, ISO-8859-10]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-10"]]
  @paths["[MACROMANIA, ISO-8859-11]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-11"]]
  @paths["[MACROMANIA, ISO-8859-13]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-13"]]
  @paths["[MACROMANIA, ISO-8859-14]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-14"]]
  @paths["[MACROMANIA, ISO-8859-15]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-15"]]
  @paths["[MACROMANIA, ISO-8859-2]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-2"]]
  @paths["[MACROMANIA, ISO-8859-3]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-3"]]
  @paths["[MACROMANIA, ISO-8859-4]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-4"]]
  @paths["[MACROMANIA, ISO-8859-5]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-5"]]
  @paths["[MACROMANIA, ISO-8859-6]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-6"]]
  @paths["[MACROMANIA, ISO-8859-7]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-7"]]
  @paths["[MACROMANIA, ISO-8859-8]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-8"]]
  @paths["[MACROMANIA, ISO-8859-9]"] = [[:MACROMANIA, :"UTF-8", :"ISO-8859-9"]]
  @paths["[MACROMANIA, KOI8-R]"] = [[:MACROMANIA, :"UTF-8", :"KOI8-R"]]
  @paths["[MACROMANIA, KOI8-U]"] = [[:MACROMANIA, :"UTF-8", :"KOI8-U"]]
  @paths["[MACROMANIA, MACCROATIAN]"] = [[:MACROMANIA, :"UTF-8", :MACCROATIAN]]
  @paths["[MACROMANIA, MACCYRILLIC]"] = [[:MACROMANIA, :"UTF-8", :MACCYRILLIC]]
  @paths["[MACROMANIA, MACGREEK]"] = [[:MACROMANIA, :"UTF-8", :MACGREEK]]
  @paths["[MACROMANIA, MACICELAND]"] = [[:MACROMANIA, :"UTF-8", :MACICELAND]]
  @paths["[MACROMANIA, MACROMAN]"] = [[:MACROMANIA, :"UTF-8", :MACROMAN]]
  @paths["[MACROMANIA, MACTURKISH]"] = [[:MACROMANIA, :"UTF-8", :MACTURKISH]]
  @paths["[MACROMANIA, MACUKRAINE]"] = [[:MACROMANIA, :"UTF-8", :MACUKRAINE]]
  @paths["[MACROMANIA, SHIFT_JIS]"] = [[:MACROMANIA, :"UTF-8", :SHIFT_JIS]]
  @paths["[MACROMANIA, SJIS-DOCOMO]"] = [[:MACROMANIA, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[MACROMANIA, SJIS-KDDI]"] = [[:MACROMANIA, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[MACROMANIA, SJIS-SOFTBANK]"] = [[:MACROMANIA, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[MACROMANIA, STATELESS-ISO-2022-JP]"] = [[:MACROMANIA, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[MACROMANIA, STATELESS-ISO-2022-JP-KDDI]"] = [[:MACROMANIA, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[MACROMANIA, TIS-620]"] = [[:MACROMANIA, :"UTF-8", :"TIS-620"]]
  @paths["[MACROMANIA, US-ASCII]"] = [[:MACROMANIA, :"UTF-8", :"US-ASCII"]]
  @paths["[MACROMANIA, UTF-16]"] = [[:MACROMANIA, :"UTF-8", :"UTF-16"]]
  @paths["[MACROMANIA, UTF-16BE]"] = [[:MACROMANIA, :"UTF-8", :"UTF-16BE"]]
  @paths["[MACROMANIA, UTF-16LE]"] = [[:MACROMANIA, :"UTF-8", :"UTF-16LE"]]
  @paths["[MACROMANIA, UTF-32]"] = [[:MACROMANIA, :"UTF-8", :"UTF-32"]]
  @paths["[MACROMANIA, UTF-32BE]"] = [[:MACROMANIA, :"UTF-8", :"UTF-32BE"]]
  @paths["[MACROMANIA, UTF-32LE]"] = [[:MACROMANIA, :"UTF-8", :"UTF-32LE"]]
  @paths["[MACROMANIA, UTF-8]"] = [[:MACROMANIA, :"UTF-8"]]
  @paths["[MACROMANIA, UTF8-DOCOMO]"] = [[:MACROMANIA, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[MACROMANIA, UTF8-KDDI]"] = [[:MACROMANIA, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[MACROMANIA, UTF8-MAC]"] = [[:MACROMANIA, :"UTF-8", :"UTF8-MAC"]]
  @paths["[MACROMANIA, UTF8-SOFTBANK]"] = [[:MACROMANIA, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[MACROMANIA, WINDOWS-1250]"] = [[:MACROMANIA, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[MACROMANIA, WINDOWS-1251]"] = [[:MACROMANIA, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[MACROMANIA, WINDOWS-1252]"] = [[:MACROMANIA, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[MACROMANIA, WINDOWS-1253]"] = [[:MACROMANIA, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[MACROMANIA, WINDOWS-1254]"] = [[:MACROMANIA, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[MACROMANIA, WINDOWS-1255]"] = [[:MACROMANIA, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[MACROMANIA, WINDOWS-1256]"] = [[:MACROMANIA, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[MACROMANIA, WINDOWS-1257]"] = [[:MACROMANIA, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[MACROMANIA, WINDOWS-31J]"] = [[:MACROMANIA, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[MACROMANIA, WINDOWS-874]"] = [[:MACROMANIA, :"UTF-8", :"WINDOWS-874"]]
  @paths["[MACTURKISH, ASCII-8BIT]"] = [[:MACTURKISH, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[MACTURKISH, BIG5]"] = [[:MACTURKISH, :"UTF-8", :BIG5]]
  @paths["[MACTURKISH, BIG5-HKSCS]"] = [[:MACTURKISH, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[MACTURKISH, BIG5-UAO]"] = [[:MACTURKISH, :"UTF-8", :"BIG5-UAO"]]
  @paths["[MACTURKISH, CP50220]"] = [[:MACTURKISH, :"UTF-8", :CP51932, :CP50220]]
  @paths["[MACTURKISH, CP50221]"] = [[:MACTURKISH, :"UTF-8", :CP51932, :CP50221]]
  @paths["[MACTURKISH, CP51932]"] = [[:MACTURKISH, :"UTF-8", :CP51932]]
  @paths["[MACTURKISH, CP850]"] = [[:MACTURKISH, :"UTF-8", :CP850]]
  @paths["[MACTURKISH, CP852]"] = [[:MACTURKISH, :"UTF-8", :CP852]]
  @paths["[MACTURKISH, CP855]"] = [[:MACTURKISH, :"UTF-8", :CP855]]
  @paths["[MACTURKISH, CP949]"] = [[:MACTURKISH, :"UTF-8", :CP949]]
  @paths["[MACTURKISH, CP950]"] = [[:MACTURKISH, :"UTF-8", :CP950]]
  @paths["[MACTURKISH, CP951]"] = [[:MACTURKISH, :"UTF-8", :CP951]]
  @paths["[MACTURKISH, EUC-JP]"] = [[:MACTURKISH, :"UTF-8", :"EUC-JP"]]
  @paths["[MACTURKISH, EUC-KR]"] = [[:MACTURKISH, :"UTF-8", :"EUC-KR"]]
  @paths["[MACTURKISH, EUCJP-MS]"] = [[:MACTURKISH, :"UTF-8", :"EUCJP-MS"]]
  @paths["[MACTURKISH, GB12345]"] = [[:MACTURKISH, :"UTF-8", :GB12345]]
  @paths["[MACTURKISH, GB18030]"] = [[:MACTURKISH, :"UTF-8", :GB18030]]
  @paths["[MACTURKISH, GB2312]"] = [[:MACTURKISH, :"UTF-8", :GB2312]]
  @paths["[MACTURKISH, GBK]"] = [[:MACTURKISH, :"UTF-8", :GBK]]
  @paths["[MACTURKISH, IBM437]"] = [[:MACTURKISH, :"UTF-8", :IBM437]]
  @paths["[MACTURKISH, IBM737]"] = [[:MACTURKISH, :"UTF-8", :IBM737]]
  @paths["[MACTURKISH, IBM775]"] = [[:MACTURKISH, :"UTF-8", :IBM775]]
  @paths["[MACTURKISH, IBM852]"] = [[:MACTURKISH, :"UTF-8", :IBM852]]
  @paths["[MACTURKISH, IBM855]"] = [[:MACTURKISH, :"UTF-8", :IBM855]]
  @paths["[MACTURKISH, IBM857]"] = [[:MACTURKISH, :"UTF-8", :IBM857]]
  @paths["[MACTURKISH, IBM860]"] = [[:MACTURKISH, :"UTF-8", :IBM860]]
  @paths["[MACTURKISH, IBM861]"] = [[:MACTURKISH, :"UTF-8", :IBM861]]
  @paths["[MACTURKISH, IBM862]"] = [[:MACTURKISH, :"UTF-8", :IBM862]]
  @paths["[MACTURKISH, IBM863]"] = [[:MACTURKISH, :"UTF-8", :IBM863]]
  @paths["[MACTURKISH, IBM865]"] = [[:MACTURKISH, :"UTF-8", :IBM865]]
  @paths["[MACTURKISH, IBM866]"] = [[:MACTURKISH, :"UTF-8", :IBM866]]
  @paths["[MACTURKISH, IBM869]"] = [[:MACTURKISH, :"UTF-8", :IBM869]]
  @paths["[MACTURKISH, ISO-2022-JP]"] = [[:MACTURKISH, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[MACTURKISH, ISO-2022-JP-KDDI]"] = [[:MACTURKISH, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[MACTURKISH, ISO-8859-1]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-1"]]
  @paths["[MACTURKISH, ISO-8859-10]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-10"]]
  @paths["[MACTURKISH, ISO-8859-11]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-11"]]
  @paths["[MACTURKISH, ISO-8859-13]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-13"]]
  @paths["[MACTURKISH, ISO-8859-14]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-14"]]
  @paths["[MACTURKISH, ISO-8859-15]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-15"]]
  @paths["[MACTURKISH, ISO-8859-2]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-2"]]
  @paths["[MACTURKISH, ISO-8859-3]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-3"]]
  @paths["[MACTURKISH, ISO-8859-4]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-4"]]
  @paths["[MACTURKISH, ISO-8859-5]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-5"]]
  @paths["[MACTURKISH, ISO-8859-6]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-6"]]
  @paths["[MACTURKISH, ISO-8859-7]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-7"]]
  @paths["[MACTURKISH, ISO-8859-8]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-8"]]
  @paths["[MACTURKISH, ISO-8859-9]"] = [[:MACTURKISH, :"UTF-8", :"ISO-8859-9"]]
  @paths["[MACTURKISH, KOI8-R]"] = [[:MACTURKISH, :"UTF-8", :"KOI8-R"]]
  @paths["[MACTURKISH, KOI8-U]"] = [[:MACTURKISH, :"UTF-8", :"KOI8-U"]]
  @paths["[MACTURKISH, MACCROATIAN]"] = [[:MACTURKISH, :"UTF-8", :MACCROATIAN]]
  @paths["[MACTURKISH, MACCYRILLIC]"] = [[:MACTURKISH, :"UTF-8", :MACCYRILLIC]]
  @paths["[MACTURKISH, MACGREEK]"] = [[:MACTURKISH, :"UTF-8", :MACGREEK]]
  @paths["[MACTURKISH, MACICELAND]"] = [[:MACTURKISH, :"UTF-8", :MACICELAND]]
  @paths["[MACTURKISH, MACROMAN]"] = [[:MACTURKISH, :"UTF-8", :MACROMAN]]
  @paths["[MACTURKISH, MACROMANIA]"] = [[:MACTURKISH, :"UTF-8", :MACROMANIA]]
  @paths["[MACTURKISH, MACUKRAINE]"] = [[:MACTURKISH, :"UTF-8", :MACUKRAINE]]
  @paths["[MACTURKISH, SHIFT_JIS]"] = [[:MACTURKISH, :"UTF-8", :SHIFT_JIS]]
  @paths["[MACTURKISH, SJIS-DOCOMO]"] = [[:MACTURKISH, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[MACTURKISH, SJIS-KDDI]"] = [[:MACTURKISH, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[MACTURKISH, SJIS-SOFTBANK]"] = [[:MACTURKISH, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[MACTURKISH, STATELESS-ISO-2022-JP]"] = [[:MACTURKISH, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[MACTURKISH, STATELESS-ISO-2022-JP-KDDI]"] = [[:MACTURKISH, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[MACTURKISH, TIS-620]"] = [[:MACTURKISH, :"UTF-8", :"TIS-620"]]
  @paths["[MACTURKISH, US-ASCII]"] = [[:MACTURKISH, :"UTF-8", :"US-ASCII"]]
  @paths["[MACTURKISH, UTF-16]"] = [[:MACTURKISH, :"UTF-8", :"UTF-16"]]
  @paths["[MACTURKISH, UTF-16BE]"] = [[:MACTURKISH, :"UTF-8", :"UTF-16BE"]]
  @paths["[MACTURKISH, UTF-16LE]"] = [[:MACTURKISH, :"UTF-8", :"UTF-16LE"]]
  @paths["[MACTURKISH, UTF-32]"] = [[:MACTURKISH, :"UTF-8", :"UTF-32"]]
  @paths["[MACTURKISH, UTF-32BE]"] = [[:MACTURKISH, :"UTF-8", :"UTF-32BE"]]
  @paths["[MACTURKISH, UTF-32LE]"] = [[:MACTURKISH, :"UTF-8", :"UTF-32LE"]]
  @paths["[MACTURKISH, UTF-8]"] = [[:MACTURKISH, :"UTF-8"]]
  @paths["[MACTURKISH, UTF8-DOCOMO]"] = [[:MACTURKISH, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[MACTURKISH, UTF8-KDDI]"] = [[:MACTURKISH, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[MACTURKISH, UTF8-MAC]"] = [[:MACTURKISH, :"UTF-8", :"UTF8-MAC"]]
  @paths["[MACTURKISH, UTF8-SOFTBANK]"] = [[:MACTURKISH, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[MACTURKISH, WINDOWS-1250]"] = [[:MACTURKISH, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[MACTURKISH, WINDOWS-1251]"] = [[:MACTURKISH, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[MACTURKISH, WINDOWS-1252]"] = [[:MACTURKISH, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[MACTURKISH, WINDOWS-1253]"] = [[:MACTURKISH, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[MACTURKISH, WINDOWS-1254]"] = [[:MACTURKISH, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[MACTURKISH, WINDOWS-1255]"] = [[:MACTURKISH, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[MACTURKISH, WINDOWS-1256]"] = [[:MACTURKISH, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[MACTURKISH, WINDOWS-1257]"] = [[:MACTURKISH, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[MACTURKISH, WINDOWS-31J]"] = [[:MACTURKISH, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[MACTURKISH, WINDOWS-874]"] = [[:MACTURKISH, :"UTF-8", :"WINDOWS-874"]]
  @paths["[MACUKRAINE, ASCII-8BIT]"] = [[:MACUKRAINE, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[MACUKRAINE, BIG5]"] = [[:MACUKRAINE, :"UTF-8", :BIG5]]
  @paths["[MACUKRAINE, BIG5-HKSCS]"] = [[:MACUKRAINE, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[MACUKRAINE, BIG5-UAO]"] = [[:MACUKRAINE, :"UTF-8", :"BIG5-UAO"]]
  @paths["[MACUKRAINE, CP50220]"] = [[:MACUKRAINE, :"UTF-8", :CP51932, :CP50220]]
  @paths["[MACUKRAINE, CP50221]"] = [[:MACUKRAINE, :"UTF-8", :CP51932, :CP50221]]
  @paths["[MACUKRAINE, CP51932]"] = [[:MACUKRAINE, :"UTF-8", :CP51932]]
  @paths["[MACUKRAINE, CP850]"] = [[:MACUKRAINE, :"UTF-8", :CP850]]
  @paths["[MACUKRAINE, CP852]"] = [[:MACUKRAINE, :"UTF-8", :CP852]]
  @paths["[MACUKRAINE, CP855]"] = [[:MACUKRAINE, :"UTF-8", :CP855]]
  @paths["[MACUKRAINE, CP949]"] = [[:MACUKRAINE, :"UTF-8", :CP949]]
  @paths["[MACUKRAINE, CP950]"] = [[:MACUKRAINE, :"UTF-8", :CP950]]
  @paths["[MACUKRAINE, CP951]"] = [[:MACUKRAINE, :"UTF-8", :CP951]]
  @paths["[MACUKRAINE, EUC-JP]"] = [[:MACUKRAINE, :"UTF-8", :"EUC-JP"]]
  @paths["[MACUKRAINE, EUC-KR]"] = [[:MACUKRAINE, :"UTF-8", :"EUC-KR"]]
  @paths["[MACUKRAINE, EUCJP-MS]"] = [[:MACUKRAINE, :"UTF-8", :"EUCJP-MS"]]
  @paths["[MACUKRAINE, GB12345]"] = [[:MACUKRAINE, :"UTF-8", :GB12345]]
  @paths["[MACUKRAINE, GB18030]"] = [[:MACUKRAINE, :"UTF-8", :GB18030]]
  @paths["[MACUKRAINE, GB2312]"] = [[:MACUKRAINE, :"UTF-8", :GB2312]]
  @paths["[MACUKRAINE, GBK]"] = [[:MACUKRAINE, :"UTF-8", :GBK]]
  @paths["[MACUKRAINE, IBM437]"] = [[:MACUKRAINE, :"UTF-8", :IBM437]]
  @paths["[MACUKRAINE, IBM737]"] = [[:MACUKRAINE, :"UTF-8", :IBM737]]
  @paths["[MACUKRAINE, IBM775]"] = [[:MACUKRAINE, :"UTF-8", :IBM775]]
  @paths["[MACUKRAINE, IBM852]"] = [[:MACUKRAINE, :"UTF-8", :IBM852]]
  @paths["[MACUKRAINE, IBM855]"] = [[:MACUKRAINE, :"UTF-8", :IBM855]]
  @paths["[MACUKRAINE, IBM857]"] = [[:MACUKRAINE, :"UTF-8", :IBM857]]
  @paths["[MACUKRAINE, IBM860]"] = [[:MACUKRAINE, :"UTF-8", :IBM860]]
  @paths["[MACUKRAINE, IBM861]"] = [[:MACUKRAINE, :"UTF-8", :IBM861]]
  @paths["[MACUKRAINE, IBM862]"] = [[:MACUKRAINE, :"UTF-8", :IBM862]]
  @paths["[MACUKRAINE, IBM863]"] = [[:MACUKRAINE, :"UTF-8", :IBM863]]
  @paths["[MACUKRAINE, IBM865]"] = [[:MACUKRAINE, :"UTF-8", :IBM865]]
  @paths["[MACUKRAINE, IBM866]"] = [[:MACUKRAINE, :"UTF-8", :IBM866]]
  @paths["[MACUKRAINE, IBM869]"] = [[:MACUKRAINE, :"UTF-8", :IBM869]]
  @paths["[MACUKRAINE, ISO-2022-JP]"] = [[:MACUKRAINE, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[MACUKRAINE, ISO-2022-JP-KDDI]"] = [[:MACUKRAINE, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[MACUKRAINE, ISO-8859-1]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-1"]]
  @paths["[MACUKRAINE, ISO-8859-10]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-10"]]
  @paths["[MACUKRAINE, ISO-8859-11]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-11"]]
  @paths["[MACUKRAINE, ISO-8859-13]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-13"]]
  @paths["[MACUKRAINE, ISO-8859-14]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-14"]]
  @paths["[MACUKRAINE, ISO-8859-15]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-15"]]
  @paths["[MACUKRAINE, ISO-8859-2]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-2"]]
  @paths["[MACUKRAINE, ISO-8859-3]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-3"]]
  @paths["[MACUKRAINE, ISO-8859-4]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-4"]]
  @paths["[MACUKRAINE, ISO-8859-5]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-5"]]
  @paths["[MACUKRAINE, ISO-8859-6]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-6"]]
  @paths["[MACUKRAINE, ISO-8859-7]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-7"]]
  @paths["[MACUKRAINE, ISO-8859-8]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-8"]]
  @paths["[MACUKRAINE, ISO-8859-9]"] = [[:MACUKRAINE, :"UTF-8", :"ISO-8859-9"]]
  @paths["[MACUKRAINE, KOI8-R]"] = [[:MACUKRAINE, :"UTF-8", :"KOI8-R"]]
  @paths["[MACUKRAINE, KOI8-U]"] = [[:MACUKRAINE, :"UTF-8", :"KOI8-U"]]
  @paths["[MACUKRAINE, MACCROATIAN]"] = [[:MACUKRAINE, :"UTF-8", :MACCROATIAN]]
  @paths["[MACUKRAINE, MACCYRILLIC]"] = [[:MACUKRAINE, :"UTF-8", :MACCYRILLIC]]
  @paths["[MACUKRAINE, MACGREEK]"] = [[:MACUKRAINE, :"UTF-8", :MACGREEK]]
  @paths["[MACUKRAINE, MACICELAND]"] = [[:MACUKRAINE, :"UTF-8", :MACICELAND]]
  @paths["[MACUKRAINE, MACROMAN]"] = [[:MACUKRAINE, :"UTF-8", :MACROMAN]]
  @paths["[MACUKRAINE, MACROMANIA]"] = [[:MACUKRAINE, :"UTF-8", :MACROMANIA]]
  @paths["[MACUKRAINE, MACTURKISH]"] = [[:MACUKRAINE, :"UTF-8", :MACTURKISH]]
  @paths["[MACUKRAINE, SHIFT_JIS]"] = [[:MACUKRAINE, :"UTF-8", :SHIFT_JIS]]
  @paths["[MACUKRAINE, SJIS-DOCOMO]"] = [[:MACUKRAINE, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[MACUKRAINE, SJIS-KDDI]"] = [[:MACUKRAINE, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[MACUKRAINE, SJIS-SOFTBANK]"] = [[:MACUKRAINE, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[MACUKRAINE, STATELESS-ISO-2022-JP]"] = [[:MACUKRAINE, :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[MACUKRAINE, STATELESS-ISO-2022-JP-KDDI]"] = [[:MACUKRAINE, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[MACUKRAINE, TIS-620]"] = [[:MACUKRAINE, :"UTF-8", :"TIS-620"]]
  @paths["[MACUKRAINE, US-ASCII]"] = [[:MACUKRAINE, :"UTF-8", :"US-ASCII"]]
  @paths["[MACUKRAINE, UTF-16]"] = [[:MACUKRAINE, :"UTF-8", :"UTF-16"]]
  @paths["[MACUKRAINE, UTF-16BE]"] = [[:MACUKRAINE, :"UTF-8", :"UTF-16BE"]]
  @paths["[MACUKRAINE, UTF-16LE]"] = [[:MACUKRAINE, :"UTF-8", :"UTF-16LE"]]
  @paths["[MACUKRAINE, UTF-32]"] = [[:MACUKRAINE, :"UTF-8", :"UTF-32"]]
  @paths["[MACUKRAINE, UTF-32BE]"] = [[:MACUKRAINE, :"UTF-8", :"UTF-32BE"]]
  @paths["[MACUKRAINE, UTF-32LE]"] = [[:MACUKRAINE, :"UTF-8", :"UTF-32LE"]]
  @paths["[MACUKRAINE, UTF-8]"] = [[:MACUKRAINE, :"UTF-8"]]
  @paths["[MACUKRAINE, UTF8-DOCOMO]"] = [[:MACUKRAINE, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[MACUKRAINE, UTF8-KDDI]"] = [[:MACUKRAINE, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[MACUKRAINE, UTF8-MAC]"] = [[:MACUKRAINE, :"UTF-8", :"UTF8-MAC"]]
  @paths["[MACUKRAINE, UTF8-SOFTBANK]"] = [[:MACUKRAINE, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[MACUKRAINE, WINDOWS-1250]"] = [[:MACUKRAINE, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[MACUKRAINE, WINDOWS-1251]"] = [[:MACUKRAINE, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[MACUKRAINE, WINDOWS-1252]"] = [[:MACUKRAINE, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[MACUKRAINE, WINDOWS-1253]"] = [[:MACUKRAINE, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[MACUKRAINE, WINDOWS-1254]"] = [[:MACUKRAINE, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[MACUKRAINE, WINDOWS-1255]"] = [[:MACUKRAINE, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[MACUKRAINE, WINDOWS-1256]"] = [[:MACUKRAINE, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[MACUKRAINE, WINDOWS-1257]"] = [[:MACUKRAINE, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[MACUKRAINE, WINDOWS-31J]"] = [[:MACUKRAINE, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[MACUKRAINE, WINDOWS-874]"] = [[:MACUKRAINE, :"UTF-8", :"WINDOWS-874"]]
  @paths["[SHIFT_JIS, ASCII-8BIT]"] = [[:SHIFT_JIS, :"UTF-8", :"ASCII-8BIT"]]
  @paths["[SHIFT_JIS, BIG5]"] = [[:SHIFT_JIS, :"UTF-8", :BIG5]]
  @paths["[SHIFT_JIS, BIG5-HKSCS]"] = [[:SHIFT_JIS, :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[SHIFT_JIS, BIG5-UAO]"] = [[:SHIFT_JIS, :"UTF-8", :"BIG5-UAO"]]
  @paths["[SHIFT_JIS, CP50220]"] = [[:SHIFT_JIS, :"UTF-8", :CP51932, :CP50220]]
  @paths["[SHIFT_JIS, CP50221]"] = [[:SHIFT_JIS, :"UTF-8", :CP51932, :CP50221]]
  @paths["[SHIFT_JIS, CP51932]"] = [[:SHIFT_JIS, :"UTF-8", :CP51932]]
  @paths["[SHIFT_JIS, CP850]"] = [[:SHIFT_JIS, :"UTF-8", :CP850]]
  @paths["[SHIFT_JIS, CP852]"] = [[:SHIFT_JIS, :"UTF-8", :CP852]]
  @paths["[SHIFT_JIS, CP855]"] = [[:SHIFT_JIS, :"UTF-8", :CP855]]
  @paths["[SHIFT_JIS, CP949]"] = [[:SHIFT_JIS, :"UTF-8", :CP949]]
  @paths["[SHIFT_JIS, CP950]"] = [[:SHIFT_JIS, :"UTF-8", :CP950]]
  @paths["[SHIFT_JIS, CP951]"] = [[:SHIFT_JIS, :"UTF-8", :CP951]]
  @paths["[SHIFT_JIS, EUC-JP]"] = [[:SHIFT_JIS, :"EUC-JP"]]
  @paths["[SHIFT_JIS, EUC-KR]"] = [[:SHIFT_JIS, :"UTF-8", :"EUC-KR"]]
  @paths["[SHIFT_JIS, EUCJP-MS]"] = [[:SHIFT_JIS, :"UTF-8", :"EUCJP-MS"]]
  @paths["[SHIFT_JIS, GB12345]"] = [[:SHIFT_JIS, :"UTF-8", :GB12345]]
  @paths["[SHIFT_JIS, GB18030]"] = [[:SHIFT_JIS, :"UTF-8", :GB18030]]
  @paths["[SHIFT_JIS, GB2312]"] = [[:SHIFT_JIS, :"UTF-8", :GB2312]]
  @paths["[SHIFT_JIS, GBK]"] = [[:SHIFT_JIS, :"UTF-8", :GBK]]
  @paths["[SHIFT_JIS, IBM437]"] = [[:SHIFT_JIS, :"UTF-8", :IBM437]]
  @paths["[SHIFT_JIS, IBM737]"] = [[:SHIFT_JIS, :"UTF-8", :IBM737]]
  @paths["[SHIFT_JIS, IBM775]"] = [[:SHIFT_JIS, :"UTF-8", :IBM775]]
  @paths["[SHIFT_JIS, IBM852]"] = [[:SHIFT_JIS, :"UTF-8", :IBM852]]
  @paths["[SHIFT_JIS, IBM855]"] = [[:SHIFT_JIS, :"UTF-8", :IBM855]]
  @paths["[SHIFT_JIS, IBM857]"] = [[:SHIFT_JIS, :"UTF-8", :IBM857]]
  @paths["[SHIFT_JIS, IBM860]"] = [[:SHIFT_JIS, :"UTF-8", :IBM860]]
  @paths["[SHIFT_JIS, IBM861]"] = [[:SHIFT_JIS, :"UTF-8", :IBM861]]
  @paths["[SHIFT_JIS, IBM862]"] = [[:SHIFT_JIS, :"UTF-8", :IBM862]]
  @paths["[SHIFT_JIS, IBM863]"] = [[:SHIFT_JIS, :"UTF-8", :IBM863]]
  @paths["[SHIFT_JIS, IBM865]"] = [[:SHIFT_JIS, :"UTF-8", :IBM865]]
  @paths["[SHIFT_JIS, IBM866]"] = [[:SHIFT_JIS, :"UTF-8", :IBM866]]
  @paths["[SHIFT_JIS, IBM869]"] = [[:SHIFT_JIS, :"UTF-8", :IBM869]]
  @paths["[SHIFT_JIS, ISO-2022-JP]"] = [[:SHIFT_JIS, :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[SHIFT_JIS, ISO-2022-JP-KDDI]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[SHIFT_JIS, ISO-8859-1]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-1"]]
  @paths["[SHIFT_JIS, ISO-8859-10]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-10"]]
  @paths["[SHIFT_JIS, ISO-8859-11]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-11"]]
  @paths["[SHIFT_JIS, ISO-8859-13]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-13"]]
  @paths["[SHIFT_JIS, ISO-8859-14]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-14"]]
  @paths["[SHIFT_JIS, ISO-8859-15]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-15"]]
  @paths["[SHIFT_JIS, ISO-8859-2]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-2"]]
  @paths["[SHIFT_JIS, ISO-8859-3]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-3"]]
  @paths["[SHIFT_JIS, ISO-8859-4]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-4"]]
  @paths["[SHIFT_JIS, ISO-8859-5]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-5"]]
  @paths["[SHIFT_JIS, ISO-8859-6]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-6"]]
  @paths["[SHIFT_JIS, ISO-8859-7]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-7"]]
  @paths["[SHIFT_JIS, ISO-8859-8]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-8"]]
  @paths["[SHIFT_JIS, ISO-8859-9]"] = [[:SHIFT_JIS, :"UTF-8", :"ISO-8859-9"]]
  @paths["[SHIFT_JIS, KOI8-R]"] = [[:SHIFT_JIS, :"UTF-8", :"KOI8-R"]]
  @paths["[SHIFT_JIS, KOI8-U]"] = [[:SHIFT_JIS, :"UTF-8", :"KOI8-U"]]
  @paths["[SHIFT_JIS, MACCROATIAN]"] = [[:SHIFT_JIS, :"UTF-8", :MACCROATIAN]]
  @paths["[SHIFT_JIS, MACCYRILLIC]"] = [[:SHIFT_JIS, :"UTF-8", :MACCYRILLIC]]
  @paths["[SHIFT_JIS, MACGREEK]"] = [[:SHIFT_JIS, :"UTF-8", :MACGREEK]]
  @paths["[SHIFT_JIS, MACICELAND]"] = [[:SHIFT_JIS, :"UTF-8", :MACICELAND]]
  @paths["[SHIFT_JIS, MACROMAN]"] = [[:SHIFT_JIS, :"UTF-8", :MACROMAN]]
  @paths["[SHIFT_JIS, MACROMANIA]"] = [[:SHIFT_JIS, :"UTF-8", :MACROMANIA]]
  @paths["[SHIFT_JIS, MACTURKISH]"] = [[:SHIFT_JIS, :"UTF-8", :MACTURKISH]]
  @paths["[SHIFT_JIS, MACUKRAINE]"] = [[:SHIFT_JIS, :"UTF-8", :MACUKRAINE]]
  @paths["[SHIFT_JIS, SJIS-DOCOMO]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[SHIFT_JIS, SJIS-KDDI]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[SHIFT_JIS, SJIS-SOFTBANK]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[SHIFT_JIS, STATELESS-ISO-2022-JP]"] = [[:SHIFT_JIS, :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[SHIFT_JIS, STATELESS-ISO-2022-JP-KDDI]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[SHIFT_JIS, TIS-620]"] = [[:SHIFT_JIS, :"UTF-8", :"TIS-620"]]
  @paths["[SHIFT_JIS, US-ASCII]"] = [[:SHIFT_JIS, :"UTF-8", :"US-ASCII"]]
  @paths["[SHIFT_JIS, UTF-16]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF-16"]]
  @paths["[SHIFT_JIS, UTF-16BE]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF-16BE"]]
  @paths["[SHIFT_JIS, UTF-16LE]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF-16LE"]]
  @paths["[SHIFT_JIS, UTF-32]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF-32"]]
  @paths["[SHIFT_JIS, UTF-32BE]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF-32BE"]]
  @paths["[SHIFT_JIS, UTF-32LE]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF-32LE"]]
  @paths["[SHIFT_JIS, UTF-8]"] = [[:SHIFT_JIS, :"UTF-8"]]
  @paths["[SHIFT_JIS, UTF8-DOCOMO]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[SHIFT_JIS, UTF8-KDDI]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF8-KDDI"]]
  @paths["[SHIFT_JIS, UTF8-MAC]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF8-MAC"]]
  @paths["[SHIFT_JIS, UTF8-SOFTBANK]"] = [[:SHIFT_JIS, :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[SHIFT_JIS, WINDOWS-1250]"] = [[:SHIFT_JIS, :"UTF-8", :"WINDOWS-1250"]]
  @paths["[SHIFT_JIS, WINDOWS-1251]"] = [[:SHIFT_JIS, :"UTF-8", :"WINDOWS-1251"]]
  @paths["[SHIFT_JIS, WINDOWS-1252]"] = [[:SHIFT_JIS, :"UTF-8", :"WINDOWS-1252"]]
  @paths["[SHIFT_JIS, WINDOWS-1253]"] = [[:SHIFT_JIS, :"UTF-8", :"WINDOWS-1253"]]
  @paths["[SHIFT_JIS, WINDOWS-1254]"] = [[:SHIFT_JIS, :"UTF-8", :"WINDOWS-1254"]]
  @paths["[SHIFT_JIS, WINDOWS-1255]"] = [[:SHIFT_JIS, :"UTF-8", :"WINDOWS-1255"]]
  @paths["[SHIFT_JIS, WINDOWS-1256]"] = [[:SHIFT_JIS, :"UTF-8", :"WINDOWS-1256"]]
  @paths["[SHIFT_JIS, WINDOWS-1257]"] = [[:SHIFT_JIS, :"UTF-8", :"WINDOWS-1257"]]
  @paths["[SHIFT_JIS, WINDOWS-31J]"] = [[:SHIFT_JIS, :"UTF-8", :"WINDOWS-31J"]]
  @paths["[SHIFT_JIS, WINDOWS-874]"] = [[:SHIFT_JIS, :"UTF-8", :"WINDOWS-874"]]
  @paths["[SJIS-DOCOMO, ASCII-8BIT]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[SJIS-DOCOMO, BIG5]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :BIG5]]
  @paths["[SJIS-DOCOMO, BIG5-HKSCS]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[SJIS-DOCOMO, BIG5-UAO]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"BIG5-UAO"]]
  @paths["[SJIS-DOCOMO, CP50220]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :CP51932, :CP50220]]
  @paths["[SJIS-DOCOMO, CP50221]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :CP51932, :CP50221]]
  @paths["[SJIS-DOCOMO, CP51932]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :CP51932]]
  @paths["[SJIS-DOCOMO, CP850]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :CP850]]
  @paths["[SJIS-DOCOMO, CP852]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :CP852]]
  @paths["[SJIS-DOCOMO, CP855]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :CP855]]
  @paths["[SJIS-DOCOMO, CP949]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :CP949]]
  @paths["[SJIS-DOCOMO, CP950]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :CP950]]
  @paths["[SJIS-DOCOMO, CP951]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :CP951]]
  @paths["[SJIS-DOCOMO, EUC-JP]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"EUC-JP"]]
  @paths["[SJIS-DOCOMO, EUC-KR]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"EUC-KR"]]
  @paths["[SJIS-DOCOMO, EUCJP-MS]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"EUCJP-MS"]]
  @paths["[SJIS-DOCOMO, GB12345]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :GB12345]]
  @paths["[SJIS-DOCOMO, GB18030]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :GB18030]]
  @paths["[SJIS-DOCOMO, GB2312]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :GB2312]]
  @paths["[SJIS-DOCOMO, GBK]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :GBK]]
  @paths["[SJIS-DOCOMO, IBM437]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :IBM437]]
  @paths["[SJIS-DOCOMO, IBM737]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :IBM737]]
  @paths["[SJIS-DOCOMO, IBM775]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :IBM775]]
  @paths["[SJIS-DOCOMO, IBM852]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :IBM852]]
  @paths["[SJIS-DOCOMO, IBM855]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :IBM855]]
  @paths["[SJIS-DOCOMO, IBM857]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :IBM857]]
  @paths["[SJIS-DOCOMO, IBM860]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :IBM860]]
  @paths["[SJIS-DOCOMO, IBM861]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :IBM861]]
  @paths["[SJIS-DOCOMO, IBM862]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :IBM862]]
  @paths["[SJIS-DOCOMO, IBM863]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :IBM863]]
  @paths["[SJIS-DOCOMO, IBM865]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :IBM865]]
  @paths["[SJIS-DOCOMO, IBM866]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :IBM866]]
  @paths["[SJIS-DOCOMO, IBM869]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :IBM869]]
  @paths["[SJIS-DOCOMO, ISO-2022-JP]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[SJIS-DOCOMO, ISO-2022-JP-KDDI]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[SJIS-DOCOMO, ISO-8859-1]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-1"]]
  @paths["[SJIS-DOCOMO, ISO-8859-10]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-10"]]
  @paths["[SJIS-DOCOMO, ISO-8859-11]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-11"]]
  @paths["[SJIS-DOCOMO, ISO-8859-13]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-13"]]
  @paths["[SJIS-DOCOMO, ISO-8859-14]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-14"]]
  @paths["[SJIS-DOCOMO, ISO-8859-15]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-15"]]
  @paths["[SJIS-DOCOMO, ISO-8859-2]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-2"]]
  @paths["[SJIS-DOCOMO, ISO-8859-3]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-3"]]
  @paths["[SJIS-DOCOMO, ISO-8859-4]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-4"]]
  @paths["[SJIS-DOCOMO, ISO-8859-5]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-5"]]
  @paths["[SJIS-DOCOMO, ISO-8859-6]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-6"]]
  @paths["[SJIS-DOCOMO, ISO-8859-7]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-7"]]
  @paths["[SJIS-DOCOMO, ISO-8859-8]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-8"]]
  @paths["[SJIS-DOCOMO, ISO-8859-9]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-9"]]
  @paths["[SJIS-DOCOMO, KOI8-R]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"KOI8-R"]]
  @paths["[SJIS-DOCOMO, KOI8-U]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"KOI8-U"]]
  @paths["[SJIS-DOCOMO, MACCROATIAN]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :MACCROATIAN]]
  @paths["[SJIS-DOCOMO, MACCYRILLIC]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :MACCYRILLIC]]
  @paths["[SJIS-DOCOMO, MACGREEK]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :MACGREEK]]
  @paths["[SJIS-DOCOMO, MACICELAND]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :MACICELAND]]
  @paths["[SJIS-DOCOMO, MACROMAN]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :MACROMAN]]
  @paths["[SJIS-DOCOMO, MACROMANIA]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :MACROMANIA]]
  @paths["[SJIS-DOCOMO, MACTURKISH]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :MACTURKISH]]
  @paths["[SJIS-DOCOMO, MACUKRAINE]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :MACUKRAINE]]
  @paths["[SJIS-DOCOMO, SHIFT_JIS]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :SHIFT_JIS]]
  @paths["[SJIS-DOCOMO, SJIS-KDDI]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[SJIS-DOCOMO, SJIS-SOFTBANK]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[SJIS-DOCOMO, STATELESS-ISO-2022-JP]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[SJIS-DOCOMO, STATELESS-ISO-2022-JP-KDDI]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[SJIS-DOCOMO, TIS-620]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"TIS-620"]]
  @paths["[SJIS-DOCOMO, US-ASCII]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"US-ASCII"]]
  @paths["[SJIS-DOCOMO, UTF-16]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"UTF-16"]]
  @paths["[SJIS-DOCOMO, UTF-16BE]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"UTF-16BE"]]
  @paths["[SJIS-DOCOMO, UTF-16LE]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"UTF-16LE"]]
  @paths["[SJIS-DOCOMO, UTF-32]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"UTF-32"]]
  @paths["[SJIS-DOCOMO, UTF-32BE]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"UTF-32BE"]]
  @paths["[SJIS-DOCOMO, UTF-32LE]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"UTF-32LE"]]
  @paths["[SJIS-DOCOMO, UTF-8]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8"]]
  @paths["[SJIS-DOCOMO, UTF8-DOCOMO]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO"]]
  @paths["[SJIS-DOCOMO, UTF8-KDDI]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF8-KDDI"]]
  @paths["[SJIS-DOCOMO, UTF8-MAC]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"UTF8-MAC"]]
  @paths["[SJIS-DOCOMO, UTF8-SOFTBANK]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF8-SOFTBANK"]]
  @paths["[SJIS-DOCOMO, WINDOWS-1250]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[SJIS-DOCOMO, WINDOWS-1251]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[SJIS-DOCOMO, WINDOWS-1252]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[SJIS-DOCOMO, WINDOWS-1253]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[SJIS-DOCOMO, WINDOWS-1254]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[SJIS-DOCOMO, WINDOWS-1255]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[SJIS-DOCOMO, WINDOWS-1256]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[SJIS-DOCOMO, WINDOWS-1257]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[SJIS-DOCOMO, WINDOWS-31J]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[SJIS-DOCOMO, WINDOWS-874]"] = [[:"SJIS-DOCOMO", :"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-874"]]
  @paths["[SJIS-KDDI, ASCII-8BIT]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[SJIS-KDDI, BIG5]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :BIG5]]
  @paths["[SJIS-KDDI, BIG5-HKSCS]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[SJIS-KDDI, BIG5-UAO]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"BIG5-UAO"]]
  @paths["[SJIS-KDDI, CP50220]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :CP51932, :CP50220]]
  @paths["[SJIS-KDDI, CP50221]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :CP51932, :CP50221]]
  @paths["[SJIS-KDDI, CP51932]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :CP51932]]
  @paths["[SJIS-KDDI, CP850]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :CP850]]
  @paths["[SJIS-KDDI, CP852]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :CP852]]
  @paths["[SJIS-KDDI, CP855]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :CP855]]
  @paths["[SJIS-KDDI, CP949]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :CP949]]
  @paths["[SJIS-KDDI, CP950]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :CP950]]
  @paths["[SJIS-KDDI, CP951]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :CP951]]
  @paths["[SJIS-KDDI, EUC-JP]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUC-JP"]]
  @paths["[SJIS-KDDI, EUC-KR]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUC-KR"]]
  @paths["[SJIS-KDDI, EUCJP-MS]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUCJP-MS"]]
  @paths["[SJIS-KDDI, GB12345]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :GB12345]]
  @paths["[SJIS-KDDI, GB18030]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :GB18030]]
  @paths["[SJIS-KDDI, GB2312]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :GB2312]]
  @paths["[SJIS-KDDI, GBK]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :GBK]]
  @paths["[SJIS-KDDI, IBM437]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM437]]
  @paths["[SJIS-KDDI, IBM737]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM737]]
  @paths["[SJIS-KDDI, IBM775]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM775]]
  @paths["[SJIS-KDDI, IBM852]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM852]]
  @paths["[SJIS-KDDI, IBM855]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM855]]
  @paths["[SJIS-KDDI, IBM857]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM857]]
  @paths["[SJIS-KDDI, IBM860]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM860]]
  @paths["[SJIS-KDDI, IBM861]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM861]]
  @paths["[SJIS-KDDI, IBM862]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM862]]
  @paths["[SJIS-KDDI, IBM863]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM863]]
  @paths["[SJIS-KDDI, IBM865]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM865]]
  @paths["[SJIS-KDDI, IBM866]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM866]]
  @paths["[SJIS-KDDI, IBM869]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM869]]
  @paths["[SJIS-KDDI, ISO-2022-JP]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[SJIS-KDDI, ISO-2022-JP-KDDI]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[SJIS-KDDI, ISO-8859-1]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-1"]]
  @paths["[SJIS-KDDI, ISO-8859-10]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-10"]]
  @paths["[SJIS-KDDI, ISO-8859-11]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-11"]]
  @paths["[SJIS-KDDI, ISO-8859-13]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-13"]]
  @paths["[SJIS-KDDI, ISO-8859-14]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-14"]]
  @paths["[SJIS-KDDI, ISO-8859-15]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-15"]]
  @paths["[SJIS-KDDI, ISO-8859-2]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-2"]]
  @paths["[SJIS-KDDI, ISO-8859-3]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-3"]]
  @paths["[SJIS-KDDI, ISO-8859-4]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-4"]]
  @paths["[SJIS-KDDI, ISO-8859-5]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-5"]]
  @paths["[SJIS-KDDI, ISO-8859-6]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-6"]]
  @paths["[SJIS-KDDI, ISO-8859-7]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-7"]]
  @paths["[SJIS-KDDI, ISO-8859-8]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-8"]]
  @paths["[SJIS-KDDI, ISO-8859-9]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-9"]]
  @paths["[SJIS-KDDI, KOI8-R]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"KOI8-R"]]
  @paths["[SJIS-KDDI, KOI8-U]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"KOI8-U"]]
  @paths["[SJIS-KDDI, MACCROATIAN]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :MACCROATIAN]]
  @paths["[SJIS-KDDI, MACCYRILLIC]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :MACCYRILLIC]]
  @paths["[SJIS-KDDI, MACGREEK]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :MACGREEK]]
  @paths["[SJIS-KDDI, MACICELAND]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :MACICELAND]]
  @paths["[SJIS-KDDI, MACROMAN]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :MACROMAN]]
  @paths["[SJIS-KDDI, MACROMANIA]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :MACROMANIA]]
  @paths["[SJIS-KDDI, MACTURKISH]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :MACTURKISH]]
  @paths["[SJIS-KDDI, MACUKRAINE]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :MACUKRAINE]]
  @paths["[SJIS-KDDI, SHIFT_JIS]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :SHIFT_JIS]]
  @paths["[SJIS-KDDI, SJIS-DOCOMO]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[SJIS-KDDI, SJIS-SOFTBANK]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[SJIS-KDDI, STATELESS-ISO-2022-JP]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[SJIS-KDDI, STATELESS-ISO-2022-JP-KDDI]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[SJIS-KDDI, TIS-620]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"TIS-620"]]
  @paths["[SJIS-KDDI, US-ASCII]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"US-ASCII"]]
  @paths["[SJIS-KDDI, UTF-16]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-16"]]
  @paths["[SJIS-KDDI, UTF-16BE]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-16BE"]]
  @paths["[SJIS-KDDI, UTF-16LE]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-16LE"]]
  @paths["[SJIS-KDDI, UTF-32]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-32"]]
  @paths["[SJIS-KDDI, UTF-32BE]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-32BE"]]
  @paths["[SJIS-KDDI, UTF-32LE]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-32LE"]]
  @paths["[SJIS-KDDI, UTF-8]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8"]]
  @paths["[SJIS-KDDI, UTF8-DOCOMO]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF8-DOCOMO"]]
  @paths["[SJIS-KDDI, UTF8-KDDI]"] = [[:"SJIS-KDDI", :"UTF8-KDDI"]]
  @paths["[SJIS-KDDI, UTF8-MAC]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF8-MAC"]]
  @paths["[SJIS-KDDI, UTF8-SOFTBANK]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF8-SOFTBANK"]]
  @paths["[SJIS-KDDI, WINDOWS-1250]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[SJIS-KDDI, WINDOWS-1251]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[SJIS-KDDI, WINDOWS-1252]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[SJIS-KDDI, WINDOWS-1253]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[SJIS-KDDI, WINDOWS-1254]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[SJIS-KDDI, WINDOWS-1255]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[SJIS-KDDI, WINDOWS-1256]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[SJIS-KDDI, WINDOWS-1257]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[SJIS-KDDI, WINDOWS-31J]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[SJIS-KDDI, WINDOWS-874]"] = [[:"SJIS-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-874"]]
  @paths["[SJIS-SOFTBANK, ASCII-8BIT]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[SJIS-SOFTBANK, BIG5]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :BIG5]]
  @paths["[SJIS-SOFTBANK, BIG5-HKSCS]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[SJIS-SOFTBANK, BIG5-UAO]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"BIG5-UAO"]]
  @paths["[SJIS-SOFTBANK, CP50220]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :CP51932, :CP50220]]
  @paths["[SJIS-SOFTBANK, CP50221]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :CP51932, :CP50221]]
  @paths["[SJIS-SOFTBANK, CP51932]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :CP51932]]
  @paths["[SJIS-SOFTBANK, CP850]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :CP850]]
  @paths["[SJIS-SOFTBANK, CP852]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :CP852]]
  @paths["[SJIS-SOFTBANK, CP855]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :CP855]]
  @paths["[SJIS-SOFTBANK, CP949]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :CP949]]
  @paths["[SJIS-SOFTBANK, CP950]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :CP950]]
  @paths["[SJIS-SOFTBANK, CP951]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :CP951]]
  @paths["[SJIS-SOFTBANK, EUC-JP]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"EUC-JP"]]
  @paths["[SJIS-SOFTBANK, EUC-KR]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"EUC-KR"]]
  @paths["[SJIS-SOFTBANK, EUCJP-MS]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"EUCJP-MS"]]
  @paths["[SJIS-SOFTBANK, GB12345]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :GB12345]]
  @paths["[SJIS-SOFTBANK, GB18030]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :GB18030]]
  @paths["[SJIS-SOFTBANK, GB2312]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :GB2312]]
  @paths["[SJIS-SOFTBANK, GBK]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :GBK]]
  @paths["[SJIS-SOFTBANK, IBM437]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :IBM437]]
  @paths["[SJIS-SOFTBANK, IBM737]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :IBM737]]
  @paths["[SJIS-SOFTBANK, IBM775]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :IBM775]]
  @paths["[SJIS-SOFTBANK, IBM852]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :IBM852]]
  @paths["[SJIS-SOFTBANK, IBM855]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :IBM855]]
  @paths["[SJIS-SOFTBANK, IBM857]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :IBM857]]
  @paths["[SJIS-SOFTBANK, IBM860]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :IBM860]]
  @paths["[SJIS-SOFTBANK, IBM861]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :IBM861]]
  @paths["[SJIS-SOFTBANK, IBM862]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :IBM862]]
  @paths["[SJIS-SOFTBANK, IBM863]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :IBM863]]
  @paths["[SJIS-SOFTBANK, IBM865]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :IBM865]]
  @paths["[SJIS-SOFTBANK, IBM866]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :IBM866]]
  @paths["[SJIS-SOFTBANK, IBM869]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :IBM869]]
  @paths["[SJIS-SOFTBANK, ISO-2022-JP]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[SJIS-SOFTBANK, ISO-2022-JP-KDDI]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-1]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-1"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-10]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-10"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-11]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-11"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-13]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-13"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-14]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-14"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-15]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-15"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-2]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-2"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-3]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-3"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-4]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-4"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-5]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-5"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-6]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-6"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-7]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-7"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-8]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-8"]]
  @paths["[SJIS-SOFTBANK, ISO-8859-9]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-9"]]
  @paths["[SJIS-SOFTBANK, KOI8-R]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"KOI8-R"]]
  @paths["[SJIS-SOFTBANK, KOI8-U]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"KOI8-U"]]
  @paths["[SJIS-SOFTBANK, MACCROATIAN]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :MACCROATIAN]]
  @paths["[SJIS-SOFTBANK, MACCYRILLIC]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :MACCYRILLIC]]
  @paths["[SJIS-SOFTBANK, MACGREEK]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :MACGREEK]]
  @paths["[SJIS-SOFTBANK, MACICELAND]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :MACICELAND]]
  @paths["[SJIS-SOFTBANK, MACROMAN]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :MACROMAN]]
  @paths["[SJIS-SOFTBANK, MACROMANIA]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :MACROMANIA]]
  @paths["[SJIS-SOFTBANK, MACTURKISH]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :MACTURKISH]]
  @paths["[SJIS-SOFTBANK, MACUKRAINE]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :MACUKRAINE]]
  @paths["[SJIS-SOFTBANK, SHIFT_JIS]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :SHIFT_JIS]]
  @paths["[SJIS-SOFTBANK, SJIS-DOCOMO]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[SJIS-SOFTBANK, SJIS-KDDI]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[SJIS-SOFTBANK, STATELESS-ISO-2022-JP]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[SJIS-SOFTBANK, STATELESS-ISO-2022-JP-KDDI]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[SJIS-SOFTBANK, TIS-620]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"TIS-620"]]
  @paths["[SJIS-SOFTBANK, US-ASCII]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"US-ASCII"]]
  @paths["[SJIS-SOFTBANK, UTF-16]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"UTF-16"]]
  @paths["[SJIS-SOFTBANK, UTF-16BE]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"UTF-16BE"]]
  @paths["[SJIS-SOFTBANK, UTF-16LE]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"UTF-16LE"]]
  @paths["[SJIS-SOFTBANK, UTF-32]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"UTF-32"]]
  @paths["[SJIS-SOFTBANK, UTF-32BE]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"UTF-32BE"]]
  @paths["[SJIS-SOFTBANK, UTF-32LE]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"UTF-32LE"]]
  @paths["[SJIS-SOFTBANK, UTF-8]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8"]]
  @paths["[SJIS-SOFTBANK, UTF8-DOCOMO]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF8-DOCOMO"]]
  @paths["[SJIS-SOFTBANK, UTF8-KDDI]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF8-KDDI"]]
  @paths["[SJIS-SOFTBANK, UTF8-MAC]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"UTF8-MAC"]]
  @paths["[SJIS-SOFTBANK, UTF8-SOFTBANK]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK"]]
  @paths["[SJIS-SOFTBANK, WINDOWS-1250]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[SJIS-SOFTBANK, WINDOWS-1251]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[SJIS-SOFTBANK, WINDOWS-1252]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[SJIS-SOFTBANK, WINDOWS-1253]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[SJIS-SOFTBANK, WINDOWS-1254]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[SJIS-SOFTBANK, WINDOWS-1255]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[SJIS-SOFTBANK, WINDOWS-1256]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[SJIS-SOFTBANK, WINDOWS-1257]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[SJIS-SOFTBANK, WINDOWS-31J]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[SJIS-SOFTBANK, WINDOWS-874]"] = [[:"SJIS-SOFTBANK", :"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-874"]]
  @paths["[STATELESS-ISO-2022-JP, ASCII-8BIT]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[STATELESS-ISO-2022-JP, BIG5]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :BIG5]]
  @paths["[STATELESS-ISO-2022-JP, BIG5-HKSCS]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[STATELESS-ISO-2022-JP, BIG5-UAO]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"BIG5-UAO"]]
  @paths["[STATELESS-ISO-2022-JP, CP50220]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP51932, :CP50220]]
  @paths["[STATELESS-ISO-2022-JP, CP50221]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP51932, :CP50221]]
  @paths["[STATELESS-ISO-2022-JP, CP51932]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP51932]]
  @paths["[STATELESS-ISO-2022-JP, CP850]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP850]]
  @paths["[STATELESS-ISO-2022-JP, CP852]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP852]]
  @paths["[STATELESS-ISO-2022-JP, CP855]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP855]]
  @paths["[STATELESS-ISO-2022-JP, CP949]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP949]]
  @paths["[STATELESS-ISO-2022-JP, CP950]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP950]]
  @paths["[STATELESS-ISO-2022-JP, CP951]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :CP951]]
  @paths["[STATELESS-ISO-2022-JP, EUC-JP]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP"]]
  @paths["[STATELESS-ISO-2022-JP, EUC-KR]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"EUC-KR"]]
  @paths["[STATELESS-ISO-2022-JP, EUCJP-MS]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"EUCJP-MS"]]
  @paths["[STATELESS-ISO-2022-JP, GB12345]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :GB12345]]
  @paths["[STATELESS-ISO-2022-JP, GB18030]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :GB18030]]
  @paths["[STATELESS-ISO-2022-JP, GB2312]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :GB2312]]
  @paths["[STATELESS-ISO-2022-JP, GBK]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :GBK]]
  @paths["[STATELESS-ISO-2022-JP, IBM437]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM437]]
  @paths["[STATELESS-ISO-2022-JP, IBM737]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM737]]
  @paths["[STATELESS-ISO-2022-JP, IBM775]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM775]]
  @paths["[STATELESS-ISO-2022-JP, IBM852]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM852]]
  @paths["[STATELESS-ISO-2022-JP, IBM855]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM855]]
  @paths["[STATELESS-ISO-2022-JP, IBM857]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM857]]
  @paths["[STATELESS-ISO-2022-JP, IBM860]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM860]]
  @paths["[STATELESS-ISO-2022-JP, IBM861]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM861]]
  @paths["[STATELESS-ISO-2022-JP, IBM862]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM862]]
  @paths["[STATELESS-ISO-2022-JP, IBM863]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM863]]
  @paths["[STATELESS-ISO-2022-JP, IBM865]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM865]]
  @paths["[STATELESS-ISO-2022-JP, IBM866]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM866]]
  @paths["[STATELESS-ISO-2022-JP, IBM869]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :IBM869]]
  @paths["[STATELESS-ISO-2022-JP, ISO-2022-JP]"] = [[:"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-2022-JP-KDDI]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-1]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-1"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-10]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-10"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-11]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-11"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-13]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-13"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-14]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-14"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-15]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-15"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-2]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-2"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-3]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-3"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-4]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-4"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-5]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-5"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-6]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-6"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-7]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-7"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-8]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-8"]]
  @paths["[STATELESS-ISO-2022-JP, ISO-8859-9]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"ISO-8859-9"]]
  @paths["[STATELESS-ISO-2022-JP, KOI8-R]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"KOI8-R"]]
  @paths["[STATELESS-ISO-2022-JP, KOI8-U]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"KOI8-U"]]
  @paths["[STATELESS-ISO-2022-JP, MACCROATIAN]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACCROATIAN]]
  @paths["[STATELESS-ISO-2022-JP, MACCYRILLIC]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACCYRILLIC]]
  @paths["[STATELESS-ISO-2022-JP, MACGREEK]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACGREEK]]
  @paths["[STATELESS-ISO-2022-JP, MACICELAND]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACICELAND]]
  @paths["[STATELESS-ISO-2022-JP, MACROMAN]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACROMAN]]
  @paths["[STATELESS-ISO-2022-JP, MACROMANIA]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACROMANIA]]
  @paths["[STATELESS-ISO-2022-JP, MACTURKISH]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACTURKISH]]
  @paths["[STATELESS-ISO-2022-JP, MACUKRAINE]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :MACUKRAINE]]
  @paths["[STATELESS-ISO-2022-JP, SHIFT_JIS]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :SHIFT_JIS]]
  @paths["[STATELESS-ISO-2022-JP, SJIS-DOCOMO]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[STATELESS-ISO-2022-JP, SJIS-KDDI]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[STATELESS-ISO-2022-JP, SJIS-SOFTBANK]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[STATELESS-ISO-2022-JP, STATELESS-ISO-2022-JP-KDDI]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[STATELESS-ISO-2022-JP, TIS-620]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"TIS-620"]]
  @paths["[STATELESS-ISO-2022-JP, US-ASCII]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"US-ASCII"]]
  @paths["[STATELESS-ISO-2022-JP, UTF-16]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF-16"]]
  @paths["[STATELESS-ISO-2022-JP, UTF-16BE]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF-16BE"]]
  @paths["[STATELESS-ISO-2022-JP, UTF-16LE]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF-16LE"]]
  @paths["[STATELESS-ISO-2022-JP, UTF-32]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF-32"]]
  @paths["[STATELESS-ISO-2022-JP, UTF-32BE]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF-32BE"]]
  @paths["[STATELESS-ISO-2022-JP, UTF-32LE]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF-32LE"]]
  @paths["[STATELESS-ISO-2022-JP, UTF-8]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8"]]
  @paths["[STATELESS-ISO-2022-JP, UTF8-DOCOMO]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[STATELESS-ISO-2022-JP, UTF8-KDDI]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[STATELESS-ISO-2022-JP, UTF8-MAC]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-MAC"]]
  @paths["[STATELESS-ISO-2022-JP, UTF8-SOFTBANK]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[STATELESS-ISO-2022-JP, WINDOWS-1250]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[STATELESS-ISO-2022-JP, WINDOWS-1251]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[STATELESS-ISO-2022-JP, WINDOWS-1252]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[STATELESS-ISO-2022-JP, WINDOWS-1253]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[STATELESS-ISO-2022-JP, WINDOWS-1254]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[STATELESS-ISO-2022-JP, WINDOWS-1255]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[STATELESS-ISO-2022-JP, WINDOWS-1256]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[STATELESS-ISO-2022-JP, WINDOWS-1257]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[STATELESS-ISO-2022-JP, WINDOWS-31J]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[STATELESS-ISO-2022-JP, WINDOWS-874]"] = [[:"STATELESS-ISO-2022-JP", :"EUC-JP", :"UTF-8", :"WINDOWS-874"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ASCII-8BIT]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, BIG5]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :BIG5]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, BIG5-HKSCS]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, BIG5-UAO]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"BIG5-UAO"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, CP50220]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP51932, :CP50220]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, CP50221]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP51932, :CP50221]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, CP51932]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP51932]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, CP850]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP850]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, CP852]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP852]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, CP855]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP855]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, CP949]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP949]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, CP950]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP950]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, CP951]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :CP951]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, EUC-JP]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUC-JP"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, EUC-KR]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUC-KR"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, EUCJP-MS]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUCJP-MS"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, GB12345]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :GB12345]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, GB18030]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :GB18030]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, GB2312]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :GB2312]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, GBK]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :GBK]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, IBM437]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM437]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, IBM737]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM737]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, IBM775]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM775]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, IBM852]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM852]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, IBM855]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM855]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, IBM857]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM857]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, IBM860]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM860]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, IBM861]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM861]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, IBM862]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM862]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, IBM863]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM863]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, IBM865]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM865]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, IBM866]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM866]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, IBM869]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :IBM869]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-2022-JP]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-2022-JP-KDDI]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-1]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-1"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-10]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-10"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-11]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-11"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-13]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-13"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-14]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-14"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-15]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-15"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-2]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-2"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-3]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-3"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-4]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-4"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-5]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-5"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-6]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-6"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-7]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-7"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-8]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-8"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, ISO-8859-9]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"ISO-8859-9"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, KOI8-R]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"KOI8-R"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, KOI8-U]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"KOI8-U"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, MACCROATIAN]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACCROATIAN]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, MACCYRILLIC]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACCYRILLIC]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, MACGREEK]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACGREEK]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, MACICELAND]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACICELAND]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, MACROMAN]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACROMAN]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, MACROMANIA]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACROMANIA]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, MACTURKISH]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACTURKISH]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, MACUKRAINE]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :MACUKRAINE]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, SHIFT_JIS]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :SHIFT_JIS]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, SJIS-DOCOMO]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, SJIS-KDDI]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, SJIS-SOFTBANK]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, STATELESS-ISO-2022-JP]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, TIS-620]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"TIS-620"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, US-ASCII]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"US-ASCII"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, UTF-16]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-16"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, UTF-16BE]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-16BE"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, UTF-16LE]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-16LE"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, UTF-32]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-32"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, UTF-32BE]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-32BE"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, UTF-32LE]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF-32LE"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, UTF-8]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, UTF8-DOCOMO]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF8-DOCOMO"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, UTF8-KDDI]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, UTF8-MAC]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"UTF8-MAC"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, UTF8-SOFTBANK]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF8-SOFTBANK"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, WINDOWS-1250]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, WINDOWS-1251]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, WINDOWS-1252]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, WINDOWS-1253]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, WINDOWS-1254]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, WINDOWS-1255]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, WINDOWS-1256]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, WINDOWS-1257]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, WINDOWS-31J]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[STATELESS-ISO-2022-JP-KDDI, WINDOWS-874]"] = [[:"STATELESS-ISO-2022-JP-KDDI", :"UTF8-KDDI", :"UTF-8", :"WINDOWS-874"]]
  @paths["[TIS-620, ASCII-8BIT]"] = [[:"TIS-620", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[TIS-620, BIG5]"] = [[:"TIS-620", :"UTF-8", :BIG5]]
  @paths["[TIS-620, BIG5-HKSCS]"] = [[:"TIS-620", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[TIS-620, BIG5-UAO]"] = [[:"TIS-620", :"UTF-8", :"BIG5-UAO"]]
  @paths["[TIS-620, CP50220]"] = [[:"TIS-620", :"UTF-8", :CP51932, :CP50220]]
  @paths["[TIS-620, CP50221]"] = [[:"TIS-620", :"UTF-8", :CP51932, :CP50221]]
  @paths["[TIS-620, CP51932]"] = [[:"TIS-620", :"UTF-8", :CP51932]]
  @paths["[TIS-620, CP850]"] = [[:"TIS-620", :"UTF-8", :CP850]]
  @paths["[TIS-620, CP852]"] = [[:"TIS-620", :"UTF-8", :CP852]]
  @paths["[TIS-620, CP855]"] = [[:"TIS-620", :"UTF-8", :CP855]]
  @paths["[TIS-620, CP949]"] = [[:"TIS-620", :"UTF-8", :CP949]]
  @paths["[TIS-620, CP950]"] = [[:"TIS-620", :"UTF-8", :CP950]]
  @paths["[TIS-620, CP951]"] = [[:"TIS-620", :"UTF-8", :CP951]]
  @paths["[TIS-620, EUC-JP]"] = [[:"TIS-620", :"UTF-8", :"EUC-JP"]]
  @paths["[TIS-620, EUC-KR]"] = [[:"TIS-620", :"UTF-8", :"EUC-KR"]]
  @paths["[TIS-620, EUCJP-MS]"] = [[:"TIS-620", :"UTF-8", :"EUCJP-MS"]]
  @paths["[TIS-620, GB12345]"] = [[:"TIS-620", :"UTF-8", :GB12345]]
  @paths["[TIS-620, GB18030]"] = [[:"TIS-620", :"UTF-8", :GB18030]]
  @paths["[TIS-620, GB2312]"] = [[:"TIS-620", :"UTF-8", :GB2312]]
  @paths["[TIS-620, GBK]"] = [[:"TIS-620", :"UTF-8", :GBK]]
  @paths["[TIS-620, IBM437]"] = [[:"TIS-620", :"UTF-8", :IBM437]]
  @paths["[TIS-620, IBM737]"] = [[:"TIS-620", :"UTF-8", :IBM737]]
  @paths["[TIS-620, IBM775]"] = [[:"TIS-620", :"UTF-8", :IBM775]]
  @paths["[TIS-620, IBM852]"] = [[:"TIS-620", :"UTF-8", :IBM852]]
  @paths["[TIS-620, IBM855]"] = [[:"TIS-620", :"UTF-8", :IBM855]]
  @paths["[TIS-620, IBM857]"] = [[:"TIS-620", :"UTF-8", :IBM857]]
  @paths["[TIS-620, IBM860]"] = [[:"TIS-620", :"UTF-8", :IBM860]]
  @paths["[TIS-620, IBM861]"] = [[:"TIS-620", :"UTF-8", :IBM861]]
  @paths["[TIS-620, IBM862]"] = [[:"TIS-620", :"UTF-8", :IBM862]]
  @paths["[TIS-620, IBM863]"] = [[:"TIS-620", :"UTF-8", :IBM863]]
  @paths["[TIS-620, IBM865]"] = [[:"TIS-620", :"UTF-8", :IBM865]]
  @paths["[TIS-620, IBM866]"] = [[:"TIS-620", :"UTF-8", :IBM866]]
  @paths["[TIS-620, IBM869]"] = [[:"TIS-620", :"UTF-8", :IBM869]]
  @paths["[TIS-620, ISO-2022-JP]"] = [[:"TIS-620", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[TIS-620, ISO-2022-JP-KDDI]"] = [[:"TIS-620", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[TIS-620, ISO-8859-1]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-1"]]
  @paths["[TIS-620, ISO-8859-10]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-10"]]
  @paths["[TIS-620, ISO-8859-11]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-11"]]
  @paths["[TIS-620, ISO-8859-13]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-13"]]
  @paths["[TIS-620, ISO-8859-14]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-14"]]
  @paths["[TIS-620, ISO-8859-15]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-15"]]
  @paths["[TIS-620, ISO-8859-2]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-2"]]
  @paths["[TIS-620, ISO-8859-3]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-3"]]
  @paths["[TIS-620, ISO-8859-4]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-4"]]
  @paths["[TIS-620, ISO-8859-5]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-5"]]
  @paths["[TIS-620, ISO-8859-6]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-6"]]
  @paths["[TIS-620, ISO-8859-7]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-7"]]
  @paths["[TIS-620, ISO-8859-8]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-8"]]
  @paths["[TIS-620, ISO-8859-9]"] = [[:"TIS-620", :"UTF-8", :"ISO-8859-9"]]
  @paths["[TIS-620, KOI8-R]"] = [[:"TIS-620", :"UTF-8", :"KOI8-R"]]
  @paths["[TIS-620, KOI8-U]"] = [[:"TIS-620", :"UTF-8", :"KOI8-U"]]
  @paths["[TIS-620, MACCROATIAN]"] = [[:"TIS-620", :"UTF-8", :MACCROATIAN]]
  @paths["[TIS-620, MACCYRILLIC]"] = [[:"TIS-620", :"UTF-8", :MACCYRILLIC]]
  @paths["[TIS-620, MACGREEK]"] = [[:"TIS-620", :"UTF-8", :MACGREEK]]
  @paths["[TIS-620, MACICELAND]"] = [[:"TIS-620", :"UTF-8", :MACICELAND]]
  @paths["[TIS-620, MACROMAN]"] = [[:"TIS-620", :"UTF-8", :MACROMAN]]
  @paths["[TIS-620, MACROMANIA]"] = [[:"TIS-620", :"UTF-8", :MACROMANIA]]
  @paths["[TIS-620, MACTURKISH]"] = [[:"TIS-620", :"UTF-8", :MACTURKISH]]
  @paths["[TIS-620, MACUKRAINE]"] = [[:"TIS-620", :"UTF-8", :MACUKRAINE]]
  @paths["[TIS-620, SHIFT_JIS]"] = [[:"TIS-620", :"UTF-8", :SHIFT_JIS]]
  @paths["[TIS-620, SJIS-DOCOMO]"] = [[:"TIS-620", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[TIS-620, SJIS-KDDI]"] = [[:"TIS-620", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[TIS-620, SJIS-SOFTBANK]"] = [[:"TIS-620", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[TIS-620, STATELESS-ISO-2022-JP]"] = [[:"TIS-620", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[TIS-620, STATELESS-ISO-2022-JP-KDDI]"] = [[:"TIS-620", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[TIS-620, US-ASCII]"] = [[:"TIS-620", :"UTF-8", :"US-ASCII"]]
  @paths["[TIS-620, UTF-16]"] = [[:"TIS-620", :"UTF-8", :"UTF-16"]]
  @paths["[TIS-620, UTF-16BE]"] = [[:"TIS-620", :"UTF-8", :"UTF-16BE"]]
  @paths["[TIS-620, UTF-16LE]"] = [[:"TIS-620", :"UTF-8", :"UTF-16LE"]]
  @paths["[TIS-620, UTF-32]"] = [[:"TIS-620", :"UTF-8", :"UTF-32"]]
  @paths["[TIS-620, UTF-32BE]"] = [[:"TIS-620", :"UTF-8", :"UTF-32BE"]]
  @paths["[TIS-620, UTF-32LE]"] = [[:"TIS-620", :"UTF-8", :"UTF-32LE"]]
  @paths["[TIS-620, UTF-8]"] = [[:"TIS-620", :"UTF-8"]]
  @paths["[TIS-620, UTF8-DOCOMO]"] = [[:"TIS-620", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[TIS-620, UTF8-KDDI]"] = [[:"TIS-620", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[TIS-620, UTF8-MAC]"] = [[:"TIS-620", :"UTF-8", :"UTF8-MAC"]]
  @paths["[TIS-620, UTF8-SOFTBANK]"] = [[:"TIS-620", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[TIS-620, WINDOWS-1250]"] = [[:"TIS-620", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[TIS-620, WINDOWS-1251]"] = [[:"TIS-620", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[TIS-620, WINDOWS-1252]"] = [[:"TIS-620", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[TIS-620, WINDOWS-1253]"] = [[:"TIS-620", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[TIS-620, WINDOWS-1254]"] = [[:"TIS-620", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[TIS-620, WINDOWS-1255]"] = [[:"TIS-620", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[TIS-620, WINDOWS-1256]"] = [[:"TIS-620", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[TIS-620, WINDOWS-1257]"] = [[:"TIS-620", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[TIS-620, WINDOWS-31J]"] = [[:"TIS-620", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[TIS-620, WINDOWS-874]"] = [[:"TIS-620", :"UTF-8", :"WINDOWS-874"]]
  @paths["[US-ASCII, ASCII-8BIT]"] = [[:"US-ASCII", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[US-ASCII, BIG5]"] = [[:"US-ASCII", :"UTF-8", :BIG5]]
  @paths["[US-ASCII, BIG5-HKSCS]"] = [[:"US-ASCII", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[US-ASCII, BIG5-UAO]"] = [[:"US-ASCII", :"UTF-8", :"BIG5-UAO"]]
  @paths["[US-ASCII, CP50220]"] = [[:"US-ASCII", :"UTF-8", :CP51932, :CP50220]]
  @paths["[US-ASCII, CP50221]"] = [[:"US-ASCII", :"UTF-8", :CP51932, :CP50221]]
  @paths["[US-ASCII, CP51932]"] = [[:"US-ASCII", :"UTF-8", :CP51932]]
  @paths["[US-ASCII, CP850]"] = [[:"US-ASCII", :"UTF-8", :CP850]]
  @paths["[US-ASCII, CP852]"] = [[:"US-ASCII", :"UTF-8", :CP852]]
  @paths["[US-ASCII, CP855]"] = [[:"US-ASCII", :"UTF-8", :CP855]]
  @paths["[US-ASCII, CP949]"] = [[:"US-ASCII", :"UTF-8", :CP949]]
  @paths["[US-ASCII, CP950]"] = [[:"US-ASCII", :"UTF-8", :CP950]]
  @paths["[US-ASCII, CP951]"] = [[:"US-ASCII", :"UTF-8", :CP951]]
  @paths["[US-ASCII, EUC-JP]"] = [[:"US-ASCII", :"UTF-8", :"EUC-JP"]]
  @paths["[US-ASCII, EUC-KR]"] = [[:"US-ASCII", :"UTF-8", :"EUC-KR"]]
  @paths["[US-ASCII, EUCJP-MS]"] = [[:"US-ASCII", :"UTF-8", :"EUCJP-MS"]]
  @paths["[US-ASCII, GB12345]"] = [[:"US-ASCII", :"UTF-8", :GB12345]]
  @paths["[US-ASCII, GB18030]"] = [[:"US-ASCII", :"UTF-8", :GB18030]]
  @paths["[US-ASCII, GB2312]"] = [[:"US-ASCII", :"UTF-8", :GB2312]]
  @paths["[US-ASCII, GBK]"] = [[:"US-ASCII", :"UTF-8", :GBK]]
  @paths["[US-ASCII, IBM437]"] = [[:"US-ASCII", :"UTF-8", :IBM437]]
  @paths["[US-ASCII, IBM737]"] = [[:"US-ASCII", :"UTF-8", :IBM737]]
  @paths["[US-ASCII, IBM775]"] = [[:"US-ASCII", :"UTF-8", :IBM775]]
  @paths["[US-ASCII, IBM852]"] = [[:"US-ASCII", :"UTF-8", :IBM852]]
  @paths["[US-ASCII, IBM855]"] = [[:"US-ASCII", :"UTF-8", :IBM855]]
  @paths["[US-ASCII, IBM857]"] = [[:"US-ASCII", :"UTF-8", :IBM857]]
  @paths["[US-ASCII, IBM860]"] = [[:"US-ASCII", :"UTF-8", :IBM860]]
  @paths["[US-ASCII, IBM861]"] = [[:"US-ASCII", :"UTF-8", :IBM861]]
  @paths["[US-ASCII, IBM862]"] = [[:"US-ASCII", :"UTF-8", :IBM862]]
  @paths["[US-ASCII, IBM863]"] = [[:"US-ASCII", :"UTF-8", :IBM863]]
  @paths["[US-ASCII, IBM865]"] = [[:"US-ASCII", :"UTF-8", :IBM865]]
  @paths["[US-ASCII, IBM866]"] = [[:"US-ASCII", :"UTF-8", :IBM866]]
  @paths["[US-ASCII, IBM869]"] = [[:"US-ASCII", :"UTF-8", :IBM869]]
  @paths["[US-ASCII, ISO-2022-JP]"] = [[:"US-ASCII", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[US-ASCII, ISO-2022-JP-KDDI]"] = [[:"US-ASCII", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[US-ASCII, ISO-8859-1]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-1"]]
  @paths["[US-ASCII, ISO-8859-10]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-10"]]
  @paths["[US-ASCII, ISO-8859-11]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-11"]]
  @paths["[US-ASCII, ISO-8859-13]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-13"]]
  @paths["[US-ASCII, ISO-8859-14]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-14"]]
  @paths["[US-ASCII, ISO-8859-15]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-15"]]
  @paths["[US-ASCII, ISO-8859-2]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-2"]]
  @paths["[US-ASCII, ISO-8859-3]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-3"]]
  @paths["[US-ASCII, ISO-8859-4]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-4"]]
  @paths["[US-ASCII, ISO-8859-5]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-5"]]
  @paths["[US-ASCII, ISO-8859-6]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-6"]]
  @paths["[US-ASCII, ISO-8859-7]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-7"]]
  @paths["[US-ASCII, ISO-8859-8]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-8"]]
  @paths["[US-ASCII, ISO-8859-9]"] = [[:"US-ASCII", :"UTF-8", :"ISO-8859-9"]]
  @paths["[US-ASCII, KOI8-R]"] = [[:"US-ASCII", :"UTF-8", :"KOI8-R"]]
  @paths["[US-ASCII, KOI8-U]"] = [[:"US-ASCII", :"UTF-8", :"KOI8-U"]]
  @paths["[US-ASCII, MACCROATIAN]"] = [[:"US-ASCII", :"UTF-8", :MACCROATIAN]]
  @paths["[US-ASCII, MACCYRILLIC]"] = [[:"US-ASCII", :"UTF-8", :MACCYRILLIC]]
  @paths["[US-ASCII, MACGREEK]"] = [[:"US-ASCII", :"UTF-8", :MACGREEK]]
  @paths["[US-ASCII, MACICELAND]"] = [[:"US-ASCII", :"UTF-8", :MACICELAND]]
  @paths["[US-ASCII, MACROMAN]"] = [[:"US-ASCII", :"UTF-8", :MACROMAN]]
  @paths["[US-ASCII, MACROMANIA]"] = [[:"US-ASCII", :"UTF-8", :MACROMANIA]]
  @paths["[US-ASCII, MACTURKISH]"] = [[:"US-ASCII", :"UTF-8", :MACTURKISH]]
  @paths["[US-ASCII, MACUKRAINE]"] = [[:"US-ASCII", :"UTF-8", :MACUKRAINE]]
  @paths["[US-ASCII, SHIFT_JIS]"] = [[:"US-ASCII", :"UTF-8", :SHIFT_JIS]]
  @paths["[US-ASCII, SJIS-DOCOMO]"] = [[:"US-ASCII", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[US-ASCII, SJIS-KDDI]"] = [[:"US-ASCII", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[US-ASCII, SJIS-SOFTBANK]"] = [[:"US-ASCII", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[US-ASCII, STATELESS-ISO-2022-JP]"] = [[:"US-ASCII", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[US-ASCII, STATELESS-ISO-2022-JP-KDDI]"] = [[:"US-ASCII", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[US-ASCII, TIS-620]"] = [[:"US-ASCII", :"UTF-8", :"TIS-620"]]
  @paths["[US-ASCII, UTF-16]"] = [[:"US-ASCII", :"UTF-8", :"UTF-16"]]
  @paths["[US-ASCII, UTF-16BE]"] = [[:"US-ASCII", :"UTF-8", :"UTF-16BE"]]
  @paths["[US-ASCII, UTF-16LE]"] = [[:"US-ASCII", :"UTF-8", :"UTF-16LE"]]
  @paths["[US-ASCII, UTF-32]"] = [[:"US-ASCII", :"UTF-8", :"UTF-32"]]
  @paths["[US-ASCII, UTF-32BE]"] = [[:"US-ASCII", :"UTF-8", :"UTF-32BE"]]
  @paths["[US-ASCII, UTF-32LE]"] = [[:"US-ASCII", :"UTF-8", :"UTF-32LE"]]
  @paths["[US-ASCII, UTF-8]"] = [[:"US-ASCII", :"UTF-8"]]
  @paths["[US-ASCII, UTF8-DOCOMO]"] = [[:"US-ASCII", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[US-ASCII, UTF8-KDDI]"] = [[:"US-ASCII", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[US-ASCII, UTF8-MAC]"] = [[:"US-ASCII", :"UTF-8", :"UTF8-MAC"]]
  @paths["[US-ASCII, UTF8-SOFTBANK]"] = [[:"US-ASCII", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[US-ASCII, WINDOWS-1250]"] = [[:"US-ASCII", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[US-ASCII, WINDOWS-1251]"] = [[:"US-ASCII", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[US-ASCII, WINDOWS-1252]"] = [[:"US-ASCII", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[US-ASCII, WINDOWS-1253]"] = [[:"US-ASCII", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[US-ASCII, WINDOWS-1254]"] = [[:"US-ASCII", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[US-ASCII, WINDOWS-1255]"] = [[:"US-ASCII", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[US-ASCII, WINDOWS-1256]"] = [[:"US-ASCII", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[US-ASCII, WINDOWS-1257]"] = [[:"US-ASCII", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[US-ASCII, WINDOWS-31J]"] = [[:"US-ASCII", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[US-ASCII, WINDOWS-874]"] = [[:"US-ASCII", :"UTF-8", :"WINDOWS-874"]]
  @paths["[UTF-16, ASCII-8BIT]"] = [[:"UTF-16", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[UTF-16, BIG5]"] = [[:"UTF-16", :"UTF-8", :BIG5]]
  @paths["[UTF-16, BIG5-HKSCS]"] = [[:"UTF-16", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[UTF-16, BIG5-UAO]"] = [[:"UTF-16", :"UTF-8", :"BIG5-UAO"]]
  @paths["[UTF-16, CP50220]"] = [[:"UTF-16", :"UTF-8", :CP51932, :CP50220]]
  @paths["[UTF-16, CP50221]"] = [[:"UTF-16", :"UTF-8", :CP51932, :CP50221]]
  @paths["[UTF-16, CP51932]"] = [[:"UTF-16", :"UTF-8", :CP51932]]
  @paths["[UTF-16, CP850]"] = [[:"UTF-16", :"UTF-8", :CP850]]
  @paths["[UTF-16, CP852]"] = [[:"UTF-16", :"UTF-8", :CP852]]
  @paths["[UTF-16, CP855]"] = [[:"UTF-16", :"UTF-8", :CP855]]
  @paths["[UTF-16, CP949]"] = [[:"UTF-16", :"UTF-8", :CP949]]
  @paths["[UTF-16, CP950]"] = [[:"UTF-16", :"UTF-8", :CP950]]
  @paths["[UTF-16, CP951]"] = [[:"UTF-16", :"UTF-8", :CP951]]
  @paths["[UTF-16, EUC-JP]"] = [[:"UTF-16", :"UTF-8", :"EUC-JP"]]
  @paths["[UTF-16, EUC-KR]"] = [[:"UTF-16", :"UTF-8", :"EUC-KR"]]
  @paths["[UTF-16, EUCJP-MS]"] = [[:"UTF-16", :"UTF-8", :"EUCJP-MS"]]
  @paths["[UTF-16, GB12345]"] = [[:"UTF-16", :"UTF-8", :GB12345]]
  @paths["[UTF-16, GB18030]"] = [[:"UTF-16", :"UTF-8", :GB18030]]
  @paths["[UTF-16, GB2312]"] = [[:"UTF-16", :"UTF-8", :GB2312]]
  @paths["[UTF-16, GBK]"] = [[:"UTF-16", :"UTF-8", :GBK]]
  @paths["[UTF-16, IBM437]"] = [[:"UTF-16", :"UTF-8", :IBM437]]
  @paths["[UTF-16, IBM737]"] = [[:"UTF-16", :"UTF-8", :IBM737]]
  @paths["[UTF-16, IBM775]"] = [[:"UTF-16", :"UTF-8", :IBM775]]
  @paths["[UTF-16, IBM852]"] = [[:"UTF-16", :"UTF-8", :IBM852]]
  @paths["[UTF-16, IBM855]"] = [[:"UTF-16", :"UTF-8", :IBM855]]
  @paths["[UTF-16, IBM857]"] = [[:"UTF-16", :"UTF-8", :IBM857]]
  @paths["[UTF-16, IBM860]"] = [[:"UTF-16", :"UTF-8", :IBM860]]
  @paths["[UTF-16, IBM861]"] = [[:"UTF-16", :"UTF-8", :IBM861]]
  @paths["[UTF-16, IBM862]"] = [[:"UTF-16", :"UTF-8", :IBM862]]
  @paths["[UTF-16, IBM863]"] = [[:"UTF-16", :"UTF-8", :IBM863]]
  @paths["[UTF-16, IBM865]"] = [[:"UTF-16", :"UTF-8", :IBM865]]
  @paths["[UTF-16, IBM866]"] = [[:"UTF-16", :"UTF-8", :IBM866]]
  @paths["[UTF-16, IBM869]"] = [[:"UTF-16", :"UTF-8", :IBM869]]
  @paths["[UTF-16, ISO-2022-JP]"] = [[:"UTF-16", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[UTF-16, ISO-2022-JP-KDDI]"] = [[:"UTF-16", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[UTF-16, ISO-8859-1]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-1"]]
  @paths["[UTF-16, ISO-8859-10]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-10"]]
  @paths["[UTF-16, ISO-8859-11]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-11"]]
  @paths["[UTF-16, ISO-8859-13]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-13"]]
  @paths["[UTF-16, ISO-8859-14]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-14"]]
  @paths["[UTF-16, ISO-8859-15]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-15"]]
  @paths["[UTF-16, ISO-8859-2]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-2"]]
  @paths["[UTF-16, ISO-8859-3]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-3"]]
  @paths["[UTF-16, ISO-8859-4]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-4"]]
  @paths["[UTF-16, ISO-8859-5]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-5"]]
  @paths["[UTF-16, ISO-8859-6]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-6"]]
  @paths["[UTF-16, ISO-8859-7]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-7"]]
  @paths["[UTF-16, ISO-8859-8]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-8"]]
  @paths["[UTF-16, ISO-8859-9]"] = [[:"UTF-16", :"UTF-8", :"ISO-8859-9"]]
  @paths["[UTF-16, KOI8-R]"] = [[:"UTF-16", :"UTF-8", :"KOI8-R"]]
  @paths["[UTF-16, KOI8-U]"] = [[:"UTF-16", :"UTF-8", :"KOI8-U"]]
  @paths["[UTF-16, MACCROATIAN]"] = [[:"UTF-16", :"UTF-8", :MACCROATIAN]]
  @paths["[UTF-16, MACCYRILLIC]"] = [[:"UTF-16", :"UTF-8", :MACCYRILLIC]]
  @paths["[UTF-16, MACGREEK]"] = [[:"UTF-16", :"UTF-8", :MACGREEK]]
  @paths["[UTF-16, MACICELAND]"] = [[:"UTF-16", :"UTF-8", :MACICELAND]]
  @paths["[UTF-16, MACROMAN]"] = [[:"UTF-16", :"UTF-8", :MACROMAN]]
  @paths["[UTF-16, MACROMANIA]"] = [[:"UTF-16", :"UTF-8", :MACROMANIA]]
  @paths["[UTF-16, MACTURKISH]"] = [[:"UTF-16", :"UTF-8", :MACTURKISH]]
  @paths["[UTF-16, MACUKRAINE]"] = [[:"UTF-16", :"UTF-8", :MACUKRAINE]]
  @paths["[UTF-16, SHIFT_JIS]"] = [[:"UTF-16", :"UTF-8", :SHIFT_JIS]]
  @paths["[UTF-16, SJIS-DOCOMO]"] = [[:"UTF-16", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[UTF-16, SJIS-KDDI]"] = [[:"UTF-16", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[UTF-16, SJIS-SOFTBANK]"] = [[:"UTF-16", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[UTF-16, STATELESS-ISO-2022-JP]"] = [[:"UTF-16", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[UTF-16, STATELESS-ISO-2022-JP-KDDI]"] = [[:"UTF-16", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[UTF-16, TIS-620]"] = [[:"UTF-16", :"UTF-8", :"TIS-620"]]
  @paths["[UTF-16, US-ASCII]"] = [[:"UTF-16", :"UTF-8", :"US-ASCII"]]
  @paths["[UTF-16, UTF-16BE]"] = [[:"UTF-16", :"UTF-8", :"UTF-16BE"]]
  @paths["[UTF-16, UTF-16LE]"] = [[:"UTF-16", :"UTF-8", :"UTF-16LE"]]
  @paths["[UTF-16, UTF-32]"] = [[:"UTF-16", :"UTF-8", :"UTF-32"]]
  @paths["[UTF-16, UTF-32BE]"] = [[:"UTF-16", :"UTF-8", :"UTF-32BE"]]
  @paths["[UTF-16, UTF-32LE]"] = [[:"UTF-16", :"UTF-8", :"UTF-32LE"]]
  @paths["[UTF-16, UTF-8]"] = [[:"UTF-16", :"UTF-8"]]
  @paths["[UTF-16, UTF8-DOCOMO]"] = [[:"UTF-16", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[UTF-16, UTF8-KDDI]"] = [[:"UTF-16", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[UTF-16, UTF8-MAC]"] = [[:"UTF-16", :"UTF-8", :"UTF8-MAC"]]
  @paths["[UTF-16, UTF8-SOFTBANK]"] = [[:"UTF-16", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[UTF-16, WINDOWS-1250]"] = [[:"UTF-16", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[UTF-16, WINDOWS-1251]"] = [[:"UTF-16", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[UTF-16, WINDOWS-1252]"] = [[:"UTF-16", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[UTF-16, WINDOWS-1253]"] = [[:"UTF-16", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[UTF-16, WINDOWS-1254]"] = [[:"UTF-16", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[UTF-16, WINDOWS-1255]"] = [[:"UTF-16", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[UTF-16, WINDOWS-1256]"] = [[:"UTF-16", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[UTF-16, WINDOWS-1257]"] = [[:"UTF-16", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[UTF-16, WINDOWS-31J]"] = [[:"UTF-16", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[UTF-16, WINDOWS-874]"] = [[:"UTF-16", :"UTF-8", :"WINDOWS-874"]]
  @paths["[UTF-16BE, ASCII-8BIT]"] = [[:"UTF-16BE", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[UTF-16BE, BIG5]"] = [[:"UTF-16BE", :"UTF-8", :BIG5]]
  @paths["[UTF-16BE, BIG5-HKSCS]"] = [[:"UTF-16BE", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[UTF-16BE, BIG5-UAO]"] = [[:"UTF-16BE", :"UTF-8", :"BIG5-UAO"]]
  @paths["[UTF-16BE, CP50220]"] = [[:"UTF-16BE", :"UTF-8", :CP51932, :CP50220]]
  @paths["[UTF-16BE, CP50221]"] = [[:"UTF-16BE", :"UTF-8", :CP51932, :CP50221]]
  @paths["[UTF-16BE, CP51932]"] = [[:"UTF-16BE", :"UTF-8", :CP51932]]
  @paths["[UTF-16BE, CP850]"] = [[:"UTF-16BE", :"UTF-8", :CP850]]
  @paths["[UTF-16BE, CP852]"] = [[:"UTF-16BE", :"UTF-8", :CP852]]
  @paths["[UTF-16BE, CP855]"] = [[:"UTF-16BE", :"UTF-8", :CP855]]
  @paths["[UTF-16BE, CP949]"] = [[:"UTF-16BE", :"UTF-8", :CP949]]
  @paths["[UTF-16BE, CP950]"] = [[:"UTF-16BE", :"UTF-8", :CP950]]
  @paths["[UTF-16BE, CP951]"] = [[:"UTF-16BE", :"UTF-8", :CP951]]
  @paths["[UTF-16BE, EUC-JP]"] = [[:"UTF-16BE", :"UTF-8", :"EUC-JP"]]
  @paths["[UTF-16BE, EUC-KR]"] = [[:"UTF-16BE", :"UTF-8", :"EUC-KR"]]
  @paths["[UTF-16BE, EUCJP-MS]"] = [[:"UTF-16BE", :"UTF-8", :"EUCJP-MS"]]
  @paths["[UTF-16BE, GB12345]"] = [[:"UTF-16BE", :"UTF-8", :GB12345]]
  @paths["[UTF-16BE, GB18030]"] = [[:"UTF-16BE", :"UTF-8", :GB18030]]
  @paths["[UTF-16BE, GB2312]"] = [[:"UTF-16BE", :"UTF-8", :GB2312]]
  @paths["[UTF-16BE, GBK]"] = [[:"UTF-16BE", :"UTF-8", :GBK]]
  @paths["[UTF-16BE, IBM437]"] = [[:"UTF-16BE", :"UTF-8", :IBM437]]
  @paths["[UTF-16BE, IBM737]"] = [[:"UTF-16BE", :"UTF-8", :IBM737]]
  @paths["[UTF-16BE, IBM775]"] = [[:"UTF-16BE", :"UTF-8", :IBM775]]
  @paths["[UTF-16BE, IBM852]"] = [[:"UTF-16BE", :"UTF-8", :IBM852]]
  @paths["[UTF-16BE, IBM855]"] = [[:"UTF-16BE", :"UTF-8", :IBM855]]
  @paths["[UTF-16BE, IBM857]"] = [[:"UTF-16BE", :"UTF-8", :IBM857]]
  @paths["[UTF-16BE, IBM860]"] = [[:"UTF-16BE", :"UTF-8", :IBM860]]
  @paths["[UTF-16BE, IBM861]"] = [[:"UTF-16BE", :"UTF-8", :IBM861]]
  @paths["[UTF-16BE, IBM862]"] = [[:"UTF-16BE", :"UTF-8", :IBM862]]
  @paths["[UTF-16BE, IBM863]"] = [[:"UTF-16BE", :"UTF-8", :IBM863]]
  @paths["[UTF-16BE, IBM865]"] = [[:"UTF-16BE", :"UTF-8", :IBM865]]
  @paths["[UTF-16BE, IBM866]"] = [[:"UTF-16BE", :"UTF-8", :IBM866]]
  @paths["[UTF-16BE, IBM869]"] = [[:"UTF-16BE", :"UTF-8", :IBM869]]
  @paths["[UTF-16BE, ISO-2022-JP]"] = [[:"UTF-16BE", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[UTF-16BE, ISO-2022-JP-KDDI]"] = [[:"UTF-16BE", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[UTF-16BE, ISO-8859-1]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-1"]]
  @paths["[UTF-16BE, ISO-8859-10]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-10"]]
  @paths["[UTF-16BE, ISO-8859-11]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-11"]]
  @paths["[UTF-16BE, ISO-8859-13]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-13"]]
  @paths["[UTF-16BE, ISO-8859-14]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-14"]]
  @paths["[UTF-16BE, ISO-8859-15]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-15"]]
  @paths["[UTF-16BE, ISO-8859-2]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-2"]]
  @paths["[UTF-16BE, ISO-8859-3]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-3"]]
  @paths["[UTF-16BE, ISO-8859-4]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-4"]]
  @paths["[UTF-16BE, ISO-8859-5]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-5"]]
  @paths["[UTF-16BE, ISO-8859-6]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-6"]]
  @paths["[UTF-16BE, ISO-8859-7]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-7"]]
  @paths["[UTF-16BE, ISO-8859-8]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-8"]]
  @paths["[UTF-16BE, ISO-8859-9]"] = [[:"UTF-16BE", :"UTF-8", :"ISO-8859-9"]]
  @paths["[UTF-16BE, KOI8-R]"] = [[:"UTF-16BE", :"UTF-8", :"KOI8-R"]]
  @paths["[UTF-16BE, KOI8-U]"] = [[:"UTF-16BE", :"UTF-8", :"KOI8-U"]]
  @paths["[UTF-16BE, MACCROATIAN]"] = [[:"UTF-16BE", :"UTF-8", :MACCROATIAN]]
  @paths["[UTF-16BE, MACCYRILLIC]"] = [[:"UTF-16BE", :"UTF-8", :MACCYRILLIC]]
  @paths["[UTF-16BE, MACGREEK]"] = [[:"UTF-16BE", :"UTF-8", :MACGREEK]]
  @paths["[UTF-16BE, MACICELAND]"] = [[:"UTF-16BE", :"UTF-8", :MACICELAND]]
  @paths["[UTF-16BE, MACROMAN]"] = [[:"UTF-16BE", :"UTF-8", :MACROMAN]]
  @paths["[UTF-16BE, MACROMANIA]"] = [[:"UTF-16BE", :"UTF-8", :MACROMANIA]]
  @paths["[UTF-16BE, MACTURKISH]"] = [[:"UTF-16BE", :"UTF-8", :MACTURKISH]]
  @paths["[UTF-16BE, MACUKRAINE]"] = [[:"UTF-16BE", :"UTF-8", :MACUKRAINE]]
  @paths["[UTF-16BE, SHIFT_JIS]"] = [[:"UTF-16BE", :"UTF-8", :SHIFT_JIS]]
  @paths["[UTF-16BE, SJIS-DOCOMO]"] = [[:"UTF-16BE", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[UTF-16BE, SJIS-KDDI]"] = [[:"UTF-16BE", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[UTF-16BE, SJIS-SOFTBANK]"] = [[:"UTF-16BE", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[UTF-16BE, STATELESS-ISO-2022-JP]"] = [[:"UTF-16BE", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[UTF-16BE, STATELESS-ISO-2022-JP-KDDI]"] = [[:"UTF-16BE", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[UTF-16BE, TIS-620]"] = [[:"UTF-16BE", :"UTF-8", :"TIS-620"]]
  @paths["[UTF-16BE, US-ASCII]"] = [[:"UTF-16BE", :"UTF-8", :"US-ASCII"]]
  @paths["[UTF-16BE, UTF-16]"] = [[:"UTF-16BE", :"UTF-8", :"UTF-16"]]
  @paths["[UTF-16BE, UTF-16LE]"] = [[:"UTF-16BE", :"UTF-8", :"UTF-16LE"]]
  @paths["[UTF-16BE, UTF-32]"] = [[:"UTF-16BE", :"UTF-8", :"UTF-32"]]
  @paths["[UTF-16BE, UTF-32BE]"] = [[:"UTF-16BE", :"UTF-8", :"UTF-32BE"]]
  @paths["[UTF-16BE, UTF-32LE]"] = [[:"UTF-16BE", :"UTF-8", :"UTF-32LE"]]
  @paths["[UTF-16BE, UTF-8]"] = [[:"UTF-16BE", :"UTF-8"]]
  @paths["[UTF-16BE, UTF8-DOCOMO]"] = [[:"UTF-16BE", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[UTF-16BE, UTF8-KDDI]"] = [[:"UTF-16BE", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[UTF-16BE, UTF8-MAC]"] = [[:"UTF-16BE", :"UTF-8", :"UTF8-MAC"]]
  @paths["[UTF-16BE, UTF8-SOFTBANK]"] = [[:"UTF-16BE", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[UTF-16BE, WINDOWS-1250]"] = [[:"UTF-16BE", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[UTF-16BE, WINDOWS-1251]"] = [[:"UTF-16BE", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[UTF-16BE, WINDOWS-1252]"] = [[:"UTF-16BE", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[UTF-16BE, WINDOWS-1253]"] = [[:"UTF-16BE", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[UTF-16BE, WINDOWS-1254]"] = [[:"UTF-16BE", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[UTF-16BE, WINDOWS-1255]"] = [[:"UTF-16BE", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[UTF-16BE, WINDOWS-1256]"] = [[:"UTF-16BE", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[UTF-16BE, WINDOWS-1257]"] = [[:"UTF-16BE", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[UTF-16BE, WINDOWS-31J]"] = [[:"UTF-16BE", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[UTF-16BE, WINDOWS-874]"] = [[:"UTF-16BE", :"UTF-8", :"WINDOWS-874"]]
  @paths["[UTF-16LE, ASCII-8BIT]"] = [[:"UTF-16LE", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[UTF-16LE, BIG5]"] = [[:"UTF-16LE", :"UTF-8", :BIG5]]
  @paths["[UTF-16LE, BIG5-HKSCS]"] = [[:"UTF-16LE", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[UTF-16LE, BIG5-UAO]"] = [[:"UTF-16LE", :"UTF-8", :"BIG5-UAO"]]
  @paths["[UTF-16LE, CP50220]"] = [[:"UTF-16LE", :"UTF-8", :CP51932, :CP50220]]
  @paths["[UTF-16LE, CP50221]"] = [[:"UTF-16LE", :"UTF-8", :CP51932, :CP50221]]
  @paths["[UTF-16LE, CP51932]"] = [[:"UTF-16LE", :"UTF-8", :CP51932]]
  @paths["[UTF-16LE, CP850]"] = [[:"UTF-16LE", :"UTF-8", :CP850]]
  @paths["[UTF-16LE, CP852]"] = [[:"UTF-16LE", :"UTF-8", :CP852]]
  @paths["[UTF-16LE, CP855]"] = [[:"UTF-16LE", :"UTF-8", :CP855]]
  @paths["[UTF-16LE, CP949]"] = [[:"UTF-16LE", :"UTF-8", :CP949]]
  @paths["[UTF-16LE, CP950]"] = [[:"UTF-16LE", :"UTF-8", :CP950]]
  @paths["[UTF-16LE, CP951]"] = [[:"UTF-16LE", :"UTF-8", :CP951]]
  @paths["[UTF-16LE, EUC-JP]"] = [[:"UTF-16LE", :"UTF-8", :"EUC-JP"]]
  @paths["[UTF-16LE, EUC-KR]"] = [[:"UTF-16LE", :"UTF-8", :"EUC-KR"]]
  @paths["[UTF-16LE, EUCJP-MS]"] = [[:"UTF-16LE", :"UTF-8", :"EUCJP-MS"]]
  @paths["[UTF-16LE, GB12345]"] = [[:"UTF-16LE", :"UTF-8", :GB12345]]
  @paths["[UTF-16LE, GB18030]"] = [[:"UTF-16LE", :"UTF-8", :GB18030]]
  @paths["[UTF-16LE, GB2312]"] = [[:"UTF-16LE", :"UTF-8", :GB2312]]
  @paths["[UTF-16LE, GBK]"] = [[:"UTF-16LE", :"UTF-8", :GBK]]
  @paths["[UTF-16LE, IBM437]"] = [[:"UTF-16LE", :"UTF-8", :IBM437]]
  @paths["[UTF-16LE, IBM737]"] = [[:"UTF-16LE", :"UTF-8", :IBM737]]
  @paths["[UTF-16LE, IBM775]"] = [[:"UTF-16LE", :"UTF-8", :IBM775]]
  @paths["[UTF-16LE, IBM852]"] = [[:"UTF-16LE", :"UTF-8", :IBM852]]
  @paths["[UTF-16LE, IBM855]"] = [[:"UTF-16LE", :"UTF-8", :IBM855]]
  @paths["[UTF-16LE, IBM857]"] = [[:"UTF-16LE", :"UTF-8", :IBM857]]
  @paths["[UTF-16LE, IBM860]"] = [[:"UTF-16LE", :"UTF-8", :IBM860]]
  @paths["[UTF-16LE, IBM861]"] = [[:"UTF-16LE", :"UTF-8", :IBM861]]
  @paths["[UTF-16LE, IBM862]"] = [[:"UTF-16LE", :"UTF-8", :IBM862]]
  @paths["[UTF-16LE, IBM863]"] = [[:"UTF-16LE", :"UTF-8", :IBM863]]
  @paths["[UTF-16LE, IBM865]"] = [[:"UTF-16LE", :"UTF-8", :IBM865]]
  @paths["[UTF-16LE, IBM866]"] = [[:"UTF-16LE", :"UTF-8", :IBM866]]
  @paths["[UTF-16LE, IBM869]"] = [[:"UTF-16LE", :"UTF-8", :IBM869]]
  @paths["[UTF-16LE, ISO-2022-JP]"] = [[:"UTF-16LE", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[UTF-16LE, ISO-2022-JP-KDDI]"] = [[:"UTF-16LE", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[UTF-16LE, ISO-8859-1]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-1"]]
  @paths["[UTF-16LE, ISO-8859-10]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-10"]]
  @paths["[UTF-16LE, ISO-8859-11]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-11"]]
  @paths["[UTF-16LE, ISO-8859-13]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-13"]]
  @paths["[UTF-16LE, ISO-8859-14]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-14"]]
  @paths["[UTF-16LE, ISO-8859-15]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-15"]]
  @paths["[UTF-16LE, ISO-8859-2]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-2"]]
  @paths["[UTF-16LE, ISO-8859-3]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-3"]]
  @paths["[UTF-16LE, ISO-8859-4]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-4"]]
  @paths["[UTF-16LE, ISO-8859-5]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-5"]]
  @paths["[UTF-16LE, ISO-8859-6]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-6"]]
  @paths["[UTF-16LE, ISO-8859-7]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-7"]]
  @paths["[UTF-16LE, ISO-8859-8]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-8"]]
  @paths["[UTF-16LE, ISO-8859-9]"] = [[:"UTF-16LE", :"UTF-8", :"ISO-8859-9"]]
  @paths["[UTF-16LE, KOI8-R]"] = [[:"UTF-16LE", :"UTF-8", :"KOI8-R"]]
  @paths["[UTF-16LE, KOI8-U]"] = [[:"UTF-16LE", :"UTF-8", :"KOI8-U"]]
  @paths["[UTF-16LE, MACCROATIAN]"] = [[:"UTF-16LE", :"UTF-8", :MACCROATIAN]]
  @paths["[UTF-16LE, MACCYRILLIC]"] = [[:"UTF-16LE", :"UTF-8", :MACCYRILLIC]]
  @paths["[UTF-16LE, MACGREEK]"] = [[:"UTF-16LE", :"UTF-8", :MACGREEK]]
  @paths["[UTF-16LE, MACICELAND]"] = [[:"UTF-16LE", :"UTF-8", :MACICELAND]]
  @paths["[UTF-16LE, MACROMAN]"] = [[:"UTF-16LE", :"UTF-8", :MACROMAN]]
  @paths["[UTF-16LE, MACROMANIA]"] = [[:"UTF-16LE", :"UTF-8", :MACROMANIA]]
  @paths["[UTF-16LE, MACTURKISH]"] = [[:"UTF-16LE", :"UTF-8", :MACTURKISH]]
  @paths["[UTF-16LE, MACUKRAINE]"] = [[:"UTF-16LE", :"UTF-8", :MACUKRAINE]]
  @paths["[UTF-16LE, SHIFT_JIS]"] = [[:"UTF-16LE", :"UTF-8", :SHIFT_JIS]]
  @paths["[UTF-16LE, SJIS-DOCOMO]"] = [[:"UTF-16LE", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[UTF-16LE, SJIS-KDDI]"] = [[:"UTF-16LE", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[UTF-16LE, SJIS-SOFTBANK]"] = [[:"UTF-16LE", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[UTF-16LE, STATELESS-ISO-2022-JP]"] = [[:"UTF-16LE", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[UTF-16LE, STATELESS-ISO-2022-JP-KDDI]"] = [[:"UTF-16LE", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[UTF-16LE, TIS-620]"] = [[:"UTF-16LE", :"UTF-8", :"TIS-620"]]
  @paths["[UTF-16LE, US-ASCII]"] = [[:"UTF-16LE", :"UTF-8", :"US-ASCII"]]
  @paths["[UTF-16LE, UTF-16]"] = [[:"UTF-16LE", :"UTF-8", :"UTF-16"]]
  @paths["[UTF-16LE, UTF-16BE]"] = [[:"UTF-16LE", :"UTF-8", :"UTF-16BE"]]
  @paths["[UTF-16LE, UTF-32]"] = [[:"UTF-16LE", :"UTF-8", :"UTF-32"]]
  @paths["[UTF-16LE, UTF-32BE]"] = [[:"UTF-16LE", :"UTF-8", :"UTF-32BE"]]
  @paths["[UTF-16LE, UTF-32LE]"] = [[:"UTF-16LE", :"UTF-8", :"UTF-32LE"]]
  @paths["[UTF-16LE, UTF-8]"] = [[:"UTF-16LE", :"UTF-8"]]
  @paths["[UTF-16LE, UTF8-DOCOMO]"] = [[:"UTF-16LE", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[UTF-16LE, UTF8-KDDI]"] = [[:"UTF-16LE", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[UTF-16LE, UTF8-MAC]"] = [[:"UTF-16LE", :"UTF-8", :"UTF8-MAC"]]
  @paths["[UTF-16LE, UTF8-SOFTBANK]"] = [[:"UTF-16LE", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[UTF-16LE, WINDOWS-1250]"] = [[:"UTF-16LE", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[UTF-16LE, WINDOWS-1251]"] = [[:"UTF-16LE", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[UTF-16LE, WINDOWS-1252]"] = [[:"UTF-16LE", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[UTF-16LE, WINDOWS-1253]"] = [[:"UTF-16LE", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[UTF-16LE, WINDOWS-1254]"] = [[:"UTF-16LE", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[UTF-16LE, WINDOWS-1255]"] = [[:"UTF-16LE", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[UTF-16LE, WINDOWS-1256]"] = [[:"UTF-16LE", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[UTF-16LE, WINDOWS-1257]"] = [[:"UTF-16LE", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[UTF-16LE, WINDOWS-31J]"] = [[:"UTF-16LE", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[UTF-16LE, WINDOWS-874]"] = [[:"UTF-16LE", :"UTF-8", :"WINDOWS-874"]]
  @paths["[UTF-32, ASCII-8BIT]"] = [[:"UTF-32", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[UTF-32, BIG5]"] = [[:"UTF-32", :"UTF-8", :BIG5]]
  @paths["[UTF-32, BIG5-HKSCS]"] = [[:"UTF-32", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[UTF-32, BIG5-UAO]"] = [[:"UTF-32", :"UTF-8", :"BIG5-UAO"]]
  @paths["[UTF-32, CP50220]"] = [[:"UTF-32", :"UTF-8", :CP51932, :CP50220]]
  @paths["[UTF-32, CP50221]"] = [[:"UTF-32", :"UTF-8", :CP51932, :CP50221]]
  @paths["[UTF-32, CP51932]"] = [[:"UTF-32", :"UTF-8", :CP51932]]
  @paths["[UTF-32, CP850]"] = [[:"UTF-32", :"UTF-8", :CP850]]
  @paths["[UTF-32, CP852]"] = [[:"UTF-32", :"UTF-8", :CP852]]
  @paths["[UTF-32, CP855]"] = [[:"UTF-32", :"UTF-8", :CP855]]
  @paths["[UTF-32, CP949]"] = [[:"UTF-32", :"UTF-8", :CP949]]
  @paths["[UTF-32, CP950]"] = [[:"UTF-32", :"UTF-8", :CP950]]
  @paths["[UTF-32, CP951]"] = [[:"UTF-32", :"UTF-8", :CP951]]
  @paths["[UTF-32, EUC-JP]"] = [[:"UTF-32", :"UTF-8", :"EUC-JP"]]
  @paths["[UTF-32, EUC-KR]"] = [[:"UTF-32", :"UTF-8", :"EUC-KR"]]
  @paths["[UTF-32, EUCJP-MS]"] = [[:"UTF-32", :"UTF-8", :"EUCJP-MS"]]
  @paths["[UTF-32, GB12345]"] = [[:"UTF-32", :"UTF-8", :GB12345]]
  @paths["[UTF-32, GB18030]"] = [[:"UTF-32", :"UTF-8", :GB18030]]
  @paths["[UTF-32, GB2312]"] = [[:"UTF-32", :"UTF-8", :GB2312]]
  @paths["[UTF-32, GBK]"] = [[:"UTF-32", :"UTF-8", :GBK]]
  @paths["[UTF-32, IBM437]"] = [[:"UTF-32", :"UTF-8", :IBM437]]
  @paths["[UTF-32, IBM737]"] = [[:"UTF-32", :"UTF-8", :IBM737]]
  @paths["[UTF-32, IBM775]"] = [[:"UTF-32", :"UTF-8", :IBM775]]
  @paths["[UTF-32, IBM852]"] = [[:"UTF-32", :"UTF-8", :IBM852]]
  @paths["[UTF-32, IBM855]"] = [[:"UTF-32", :"UTF-8", :IBM855]]
  @paths["[UTF-32, IBM857]"] = [[:"UTF-32", :"UTF-8", :IBM857]]
  @paths["[UTF-32, IBM860]"] = [[:"UTF-32", :"UTF-8", :IBM860]]
  @paths["[UTF-32, IBM861]"] = [[:"UTF-32", :"UTF-8", :IBM861]]
  @paths["[UTF-32, IBM862]"] = [[:"UTF-32", :"UTF-8", :IBM862]]
  @paths["[UTF-32, IBM863]"] = [[:"UTF-32", :"UTF-8", :IBM863]]
  @paths["[UTF-32, IBM865]"] = [[:"UTF-32", :"UTF-8", :IBM865]]
  @paths["[UTF-32, IBM866]"] = [[:"UTF-32", :"UTF-8", :IBM866]]
  @paths["[UTF-32, IBM869]"] = [[:"UTF-32", :"UTF-8", :IBM869]]
  @paths["[UTF-32, ISO-2022-JP]"] = [[:"UTF-32", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[UTF-32, ISO-2022-JP-KDDI]"] = [[:"UTF-32", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[UTF-32, ISO-8859-1]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-1"]]
  @paths["[UTF-32, ISO-8859-10]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-10"]]
  @paths["[UTF-32, ISO-8859-11]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-11"]]
  @paths["[UTF-32, ISO-8859-13]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-13"]]
  @paths["[UTF-32, ISO-8859-14]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-14"]]
  @paths["[UTF-32, ISO-8859-15]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-15"]]
  @paths["[UTF-32, ISO-8859-2]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-2"]]
  @paths["[UTF-32, ISO-8859-3]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-3"]]
  @paths["[UTF-32, ISO-8859-4]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-4"]]
  @paths["[UTF-32, ISO-8859-5]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-5"]]
  @paths["[UTF-32, ISO-8859-6]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-6"]]
  @paths["[UTF-32, ISO-8859-7]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-7"]]
  @paths["[UTF-32, ISO-8859-8]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-8"]]
  @paths["[UTF-32, ISO-8859-9]"] = [[:"UTF-32", :"UTF-8", :"ISO-8859-9"]]
  @paths["[UTF-32, KOI8-R]"] = [[:"UTF-32", :"UTF-8", :"KOI8-R"]]
  @paths["[UTF-32, KOI8-U]"] = [[:"UTF-32", :"UTF-8", :"KOI8-U"]]
  @paths["[UTF-32, MACCROATIAN]"] = [[:"UTF-32", :"UTF-8", :MACCROATIAN]]
  @paths["[UTF-32, MACCYRILLIC]"] = [[:"UTF-32", :"UTF-8", :MACCYRILLIC]]
  @paths["[UTF-32, MACGREEK]"] = [[:"UTF-32", :"UTF-8", :MACGREEK]]
  @paths["[UTF-32, MACICELAND]"] = [[:"UTF-32", :"UTF-8", :MACICELAND]]
  @paths["[UTF-32, MACROMAN]"] = [[:"UTF-32", :"UTF-8", :MACROMAN]]
  @paths["[UTF-32, MACROMANIA]"] = [[:"UTF-32", :"UTF-8", :MACROMANIA]]
  @paths["[UTF-32, MACTURKISH]"] = [[:"UTF-32", :"UTF-8", :MACTURKISH]]
  @paths["[UTF-32, MACUKRAINE]"] = [[:"UTF-32", :"UTF-8", :MACUKRAINE]]
  @paths["[UTF-32, SHIFT_JIS]"] = [[:"UTF-32", :"UTF-8", :SHIFT_JIS]]
  @paths["[UTF-32, SJIS-DOCOMO]"] = [[:"UTF-32", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[UTF-32, SJIS-KDDI]"] = [[:"UTF-32", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[UTF-32, SJIS-SOFTBANK]"] = [[:"UTF-32", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[UTF-32, STATELESS-ISO-2022-JP]"] = [[:"UTF-32", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[UTF-32, STATELESS-ISO-2022-JP-KDDI]"] = [[:"UTF-32", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[UTF-32, TIS-620]"] = [[:"UTF-32", :"UTF-8", :"TIS-620"]]
  @paths["[UTF-32, US-ASCII]"] = [[:"UTF-32", :"UTF-8", :"US-ASCII"]]
  @paths["[UTF-32, UTF-16]"] = [[:"UTF-32", :"UTF-8", :"UTF-16"]]
  @paths["[UTF-32, UTF-16BE]"] = [[:"UTF-32", :"UTF-8", :"UTF-16BE"]]
  @paths["[UTF-32, UTF-16LE]"] = [[:"UTF-32", :"UTF-8", :"UTF-16LE"]]
  @paths["[UTF-32, UTF-32BE]"] = [[:"UTF-32", :"UTF-8", :"UTF-32BE"]]
  @paths["[UTF-32, UTF-32LE]"] = [[:"UTF-32", :"UTF-8", :"UTF-32LE"]]
  @paths["[UTF-32, UTF-8]"] = [[:"UTF-32", :"UTF-8"]]
  @paths["[UTF-32, UTF8-DOCOMO]"] = [[:"UTF-32", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[UTF-32, UTF8-KDDI]"] = [[:"UTF-32", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[UTF-32, UTF8-MAC]"] = [[:"UTF-32", :"UTF-8", :"UTF8-MAC"]]
  @paths["[UTF-32, UTF8-SOFTBANK]"] = [[:"UTF-32", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[UTF-32, WINDOWS-1250]"] = [[:"UTF-32", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[UTF-32, WINDOWS-1251]"] = [[:"UTF-32", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[UTF-32, WINDOWS-1252]"] = [[:"UTF-32", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[UTF-32, WINDOWS-1253]"] = [[:"UTF-32", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[UTF-32, WINDOWS-1254]"] = [[:"UTF-32", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[UTF-32, WINDOWS-1255]"] = [[:"UTF-32", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[UTF-32, WINDOWS-1256]"] = [[:"UTF-32", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[UTF-32, WINDOWS-1257]"] = [[:"UTF-32", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[UTF-32, WINDOWS-31J]"] = [[:"UTF-32", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[UTF-32, WINDOWS-874]"] = [[:"UTF-32", :"UTF-8", :"WINDOWS-874"]]
  @paths["[UTF-32BE, ASCII-8BIT]"] = [[:"UTF-32BE", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[UTF-32BE, BIG5]"] = [[:"UTF-32BE", :"UTF-8", :BIG5]]
  @paths["[UTF-32BE, BIG5-HKSCS]"] = [[:"UTF-32BE", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[UTF-32BE, BIG5-UAO]"] = [[:"UTF-32BE", :"UTF-8", :"BIG5-UAO"]]
  @paths["[UTF-32BE, CP50220]"] = [[:"UTF-32BE", :"UTF-8", :CP51932, :CP50220]]
  @paths["[UTF-32BE, CP50221]"] = [[:"UTF-32BE", :"UTF-8", :CP51932, :CP50221]]
  @paths["[UTF-32BE, CP51932]"] = [[:"UTF-32BE", :"UTF-8", :CP51932]]
  @paths["[UTF-32BE, CP850]"] = [[:"UTF-32BE", :"UTF-8", :CP850]]
  @paths["[UTF-32BE, CP852]"] = [[:"UTF-32BE", :"UTF-8", :CP852]]
  @paths["[UTF-32BE, CP855]"] = [[:"UTF-32BE", :"UTF-8", :CP855]]
  @paths["[UTF-32BE, CP949]"] = [[:"UTF-32BE", :"UTF-8", :CP949]]
  @paths["[UTF-32BE, CP950]"] = [[:"UTF-32BE", :"UTF-8", :CP950]]
  @paths["[UTF-32BE, CP951]"] = [[:"UTF-32BE", :"UTF-8", :CP951]]
  @paths["[UTF-32BE, EUC-JP]"] = [[:"UTF-32BE", :"UTF-8", :"EUC-JP"]]
  @paths["[UTF-32BE, EUC-KR]"] = [[:"UTF-32BE", :"UTF-8", :"EUC-KR"]]
  @paths["[UTF-32BE, EUCJP-MS]"] = [[:"UTF-32BE", :"UTF-8", :"EUCJP-MS"]]
  @paths["[UTF-32BE, GB12345]"] = [[:"UTF-32BE", :"UTF-8", :GB12345]]
  @paths["[UTF-32BE, GB18030]"] = [[:"UTF-32BE", :"UTF-8", :GB18030]]
  @paths["[UTF-32BE, GB2312]"] = [[:"UTF-32BE", :"UTF-8", :GB2312]]
  @paths["[UTF-32BE, GBK]"] = [[:"UTF-32BE", :"UTF-8", :GBK]]
  @paths["[UTF-32BE, IBM437]"] = [[:"UTF-32BE", :"UTF-8", :IBM437]]
  @paths["[UTF-32BE, IBM737]"] = [[:"UTF-32BE", :"UTF-8", :IBM737]]
  @paths["[UTF-32BE, IBM775]"] = [[:"UTF-32BE", :"UTF-8", :IBM775]]
  @paths["[UTF-32BE, IBM852]"] = [[:"UTF-32BE", :"UTF-8", :IBM852]]
  @paths["[UTF-32BE, IBM855]"] = [[:"UTF-32BE", :"UTF-8", :IBM855]]
  @paths["[UTF-32BE, IBM857]"] = [[:"UTF-32BE", :"UTF-8", :IBM857]]
  @paths["[UTF-32BE, IBM860]"] = [[:"UTF-32BE", :"UTF-8", :IBM860]]
  @paths["[UTF-32BE, IBM861]"] = [[:"UTF-32BE", :"UTF-8", :IBM861]]
  @paths["[UTF-32BE, IBM862]"] = [[:"UTF-32BE", :"UTF-8", :IBM862]]
  @paths["[UTF-32BE, IBM863]"] = [[:"UTF-32BE", :"UTF-8", :IBM863]]
  @paths["[UTF-32BE, IBM865]"] = [[:"UTF-32BE", :"UTF-8", :IBM865]]
  @paths["[UTF-32BE, IBM866]"] = [[:"UTF-32BE", :"UTF-8", :IBM866]]
  @paths["[UTF-32BE, IBM869]"] = [[:"UTF-32BE", :"UTF-8", :IBM869]]
  @paths["[UTF-32BE, ISO-2022-JP]"] = [[:"UTF-32BE", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[UTF-32BE, ISO-2022-JP-KDDI]"] = [[:"UTF-32BE", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[UTF-32BE, ISO-8859-1]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-1"]]
  @paths["[UTF-32BE, ISO-8859-10]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-10"]]
  @paths["[UTF-32BE, ISO-8859-11]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-11"]]
  @paths["[UTF-32BE, ISO-8859-13]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-13"]]
  @paths["[UTF-32BE, ISO-8859-14]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-14"]]
  @paths["[UTF-32BE, ISO-8859-15]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-15"]]
  @paths["[UTF-32BE, ISO-8859-2]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-2"]]
  @paths["[UTF-32BE, ISO-8859-3]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-3"]]
  @paths["[UTF-32BE, ISO-8859-4]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-4"]]
  @paths["[UTF-32BE, ISO-8859-5]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-5"]]
  @paths["[UTF-32BE, ISO-8859-6]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-6"]]
  @paths["[UTF-32BE, ISO-8859-7]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-7"]]
  @paths["[UTF-32BE, ISO-8859-8]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-8"]]
  @paths["[UTF-32BE, ISO-8859-9]"] = [[:"UTF-32BE", :"UTF-8", :"ISO-8859-9"]]
  @paths["[UTF-32BE, KOI8-R]"] = [[:"UTF-32BE", :"UTF-8", :"KOI8-R"]]
  @paths["[UTF-32BE, KOI8-U]"] = [[:"UTF-32BE", :"UTF-8", :"KOI8-U"]]
  @paths["[UTF-32BE, MACCROATIAN]"] = [[:"UTF-32BE", :"UTF-8", :MACCROATIAN]]
  @paths["[UTF-32BE, MACCYRILLIC]"] = [[:"UTF-32BE", :"UTF-8", :MACCYRILLIC]]
  @paths["[UTF-32BE, MACGREEK]"] = [[:"UTF-32BE", :"UTF-8", :MACGREEK]]
  @paths["[UTF-32BE, MACICELAND]"] = [[:"UTF-32BE", :"UTF-8", :MACICELAND]]
  @paths["[UTF-32BE, MACROMAN]"] = [[:"UTF-32BE", :"UTF-8", :MACROMAN]]
  @paths["[UTF-32BE, MACROMANIA]"] = [[:"UTF-32BE", :"UTF-8", :MACROMANIA]]
  @paths["[UTF-32BE, MACTURKISH]"] = [[:"UTF-32BE", :"UTF-8", :MACTURKISH]]
  @paths["[UTF-32BE, MACUKRAINE]"] = [[:"UTF-32BE", :"UTF-8", :MACUKRAINE]]
  @paths["[UTF-32BE, SHIFT_JIS]"] = [[:"UTF-32BE", :"UTF-8", :SHIFT_JIS]]
  @paths["[UTF-32BE, SJIS-DOCOMO]"] = [[:"UTF-32BE", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[UTF-32BE, SJIS-KDDI]"] = [[:"UTF-32BE", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[UTF-32BE, SJIS-SOFTBANK]"] = [[:"UTF-32BE", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[UTF-32BE, STATELESS-ISO-2022-JP]"] = [[:"UTF-32BE", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[UTF-32BE, STATELESS-ISO-2022-JP-KDDI]"] = [[:"UTF-32BE", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[UTF-32BE, TIS-620]"] = [[:"UTF-32BE", :"UTF-8", :"TIS-620"]]
  @paths["[UTF-32BE, US-ASCII]"] = [[:"UTF-32BE", :"UTF-8", :"US-ASCII"]]
  @paths["[UTF-32BE, UTF-16]"] = [[:"UTF-32BE", :"UTF-8", :"UTF-16"]]
  @paths["[UTF-32BE, UTF-16BE]"] = [[:"UTF-32BE", :"UTF-8", :"UTF-16BE"]]
  @paths["[UTF-32BE, UTF-16LE]"] = [[:"UTF-32BE", :"UTF-8", :"UTF-16LE"]]
  @paths["[UTF-32BE, UTF-32]"] = [[:"UTF-32BE", :"UTF-8", :"UTF-32"]]
  @paths["[UTF-32BE, UTF-32LE]"] = [[:"UTF-32BE", :"UTF-8", :"UTF-32LE"]]
  @paths["[UTF-32BE, UTF-8]"] = [[:"UTF-32BE", :"UTF-8"]]
  @paths["[UTF-32BE, UTF8-DOCOMO]"] = [[:"UTF-32BE", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[UTF-32BE, UTF8-KDDI]"] = [[:"UTF-32BE", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[UTF-32BE, UTF8-MAC]"] = [[:"UTF-32BE", :"UTF-8", :"UTF8-MAC"]]
  @paths["[UTF-32BE, UTF8-SOFTBANK]"] = [[:"UTF-32BE", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[UTF-32BE, WINDOWS-1250]"] = [[:"UTF-32BE", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[UTF-32BE, WINDOWS-1251]"] = [[:"UTF-32BE", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[UTF-32BE, WINDOWS-1252]"] = [[:"UTF-32BE", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[UTF-32BE, WINDOWS-1253]"] = [[:"UTF-32BE", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[UTF-32BE, WINDOWS-1254]"] = [[:"UTF-32BE", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[UTF-32BE, WINDOWS-1255]"] = [[:"UTF-32BE", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[UTF-32BE, WINDOWS-1256]"] = [[:"UTF-32BE", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[UTF-32BE, WINDOWS-1257]"] = [[:"UTF-32BE", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[UTF-32BE, WINDOWS-31J]"] = [[:"UTF-32BE", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[UTF-32BE, WINDOWS-874]"] = [[:"UTF-32BE", :"UTF-8", :"WINDOWS-874"]]
  @paths["[UTF-32LE, ASCII-8BIT]"] = [[:"UTF-32LE", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[UTF-32LE, BIG5]"] = [[:"UTF-32LE", :"UTF-8", :BIG5]]
  @paths["[UTF-32LE, BIG5-HKSCS]"] = [[:"UTF-32LE", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[UTF-32LE, BIG5-UAO]"] = [[:"UTF-32LE", :"UTF-8", :"BIG5-UAO"]]
  @paths["[UTF-32LE, CP50220]"] = [[:"UTF-32LE", :"UTF-8", :CP51932, :CP50220]]
  @paths["[UTF-32LE, CP50221]"] = [[:"UTF-32LE", :"UTF-8", :CP51932, :CP50221]]
  @paths["[UTF-32LE, CP51932]"] = [[:"UTF-32LE", :"UTF-8", :CP51932]]
  @paths["[UTF-32LE, CP850]"] = [[:"UTF-32LE", :"UTF-8", :CP850]]
  @paths["[UTF-32LE, CP852]"] = [[:"UTF-32LE", :"UTF-8", :CP852]]
  @paths["[UTF-32LE, CP855]"] = [[:"UTF-32LE", :"UTF-8", :CP855]]
  @paths["[UTF-32LE, CP949]"] = [[:"UTF-32LE", :"UTF-8", :CP949]]
  @paths["[UTF-32LE, CP950]"] = [[:"UTF-32LE", :"UTF-8", :CP950]]
  @paths["[UTF-32LE, CP951]"] = [[:"UTF-32LE", :"UTF-8", :CP951]]
  @paths["[UTF-32LE, EUC-JP]"] = [[:"UTF-32LE", :"UTF-8", :"EUC-JP"]]
  @paths["[UTF-32LE, EUC-KR]"] = [[:"UTF-32LE", :"UTF-8", :"EUC-KR"]]
  @paths["[UTF-32LE, EUCJP-MS]"] = [[:"UTF-32LE", :"UTF-8", :"EUCJP-MS"]]
  @paths["[UTF-32LE, GB12345]"] = [[:"UTF-32LE", :"UTF-8", :GB12345]]
  @paths["[UTF-32LE, GB18030]"] = [[:"UTF-32LE", :"UTF-8", :GB18030]]
  @paths["[UTF-32LE, GB2312]"] = [[:"UTF-32LE", :"UTF-8", :GB2312]]
  @paths["[UTF-32LE, GBK]"] = [[:"UTF-32LE", :"UTF-8", :GBK]]
  @paths["[UTF-32LE, IBM437]"] = [[:"UTF-32LE", :"UTF-8", :IBM437]]
  @paths["[UTF-32LE, IBM737]"] = [[:"UTF-32LE", :"UTF-8", :IBM737]]
  @paths["[UTF-32LE, IBM775]"] = [[:"UTF-32LE", :"UTF-8", :IBM775]]
  @paths["[UTF-32LE, IBM852]"] = [[:"UTF-32LE", :"UTF-8", :IBM852]]
  @paths["[UTF-32LE, IBM855]"] = [[:"UTF-32LE", :"UTF-8", :IBM855]]
  @paths["[UTF-32LE, IBM857]"] = [[:"UTF-32LE", :"UTF-8", :IBM857]]
  @paths["[UTF-32LE, IBM860]"] = [[:"UTF-32LE", :"UTF-8", :IBM860]]
  @paths["[UTF-32LE, IBM861]"] = [[:"UTF-32LE", :"UTF-8", :IBM861]]
  @paths["[UTF-32LE, IBM862]"] = [[:"UTF-32LE", :"UTF-8", :IBM862]]
  @paths["[UTF-32LE, IBM863]"] = [[:"UTF-32LE", :"UTF-8", :IBM863]]
  @paths["[UTF-32LE, IBM865]"] = [[:"UTF-32LE", :"UTF-8", :IBM865]]
  @paths["[UTF-32LE, IBM866]"] = [[:"UTF-32LE", :"UTF-8", :IBM866]]
  @paths["[UTF-32LE, IBM869]"] = [[:"UTF-32LE", :"UTF-8", :IBM869]]
  @paths["[UTF-32LE, ISO-2022-JP]"] = [[:"UTF-32LE", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[UTF-32LE, ISO-2022-JP-KDDI]"] = [[:"UTF-32LE", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[UTF-32LE, ISO-8859-1]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-1"]]
  @paths["[UTF-32LE, ISO-8859-10]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-10"]]
  @paths["[UTF-32LE, ISO-8859-11]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-11"]]
  @paths["[UTF-32LE, ISO-8859-13]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-13"]]
  @paths["[UTF-32LE, ISO-8859-14]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-14"]]
  @paths["[UTF-32LE, ISO-8859-15]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-15"]]
  @paths["[UTF-32LE, ISO-8859-2]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-2"]]
  @paths["[UTF-32LE, ISO-8859-3]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-3"]]
  @paths["[UTF-32LE, ISO-8859-4]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-4"]]
  @paths["[UTF-32LE, ISO-8859-5]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-5"]]
  @paths["[UTF-32LE, ISO-8859-6]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-6"]]
  @paths["[UTF-32LE, ISO-8859-7]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-7"]]
  @paths["[UTF-32LE, ISO-8859-8]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-8"]]
  @paths["[UTF-32LE, ISO-8859-9]"] = [[:"UTF-32LE", :"UTF-8", :"ISO-8859-9"]]
  @paths["[UTF-32LE, KOI8-R]"] = [[:"UTF-32LE", :"UTF-8", :"KOI8-R"]]
  @paths["[UTF-32LE, KOI8-U]"] = [[:"UTF-32LE", :"UTF-8", :"KOI8-U"]]
  @paths["[UTF-32LE, MACCROATIAN]"] = [[:"UTF-32LE", :"UTF-8", :MACCROATIAN]]
  @paths["[UTF-32LE, MACCYRILLIC]"] = [[:"UTF-32LE", :"UTF-8", :MACCYRILLIC]]
  @paths["[UTF-32LE, MACGREEK]"] = [[:"UTF-32LE", :"UTF-8", :MACGREEK]]
  @paths["[UTF-32LE, MACICELAND]"] = [[:"UTF-32LE", :"UTF-8", :MACICELAND]]
  @paths["[UTF-32LE, MACROMAN]"] = [[:"UTF-32LE", :"UTF-8", :MACROMAN]]
  @paths["[UTF-32LE, MACROMANIA]"] = [[:"UTF-32LE", :"UTF-8", :MACROMANIA]]
  @paths["[UTF-32LE, MACTURKISH]"] = [[:"UTF-32LE", :"UTF-8", :MACTURKISH]]
  @paths["[UTF-32LE, MACUKRAINE]"] = [[:"UTF-32LE", :"UTF-8", :MACUKRAINE]]
  @paths["[UTF-32LE, SHIFT_JIS]"] = [[:"UTF-32LE", :"UTF-8", :SHIFT_JIS]]
  @paths["[UTF-32LE, SJIS-DOCOMO]"] = [[:"UTF-32LE", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[UTF-32LE, SJIS-KDDI]"] = [[:"UTF-32LE", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[UTF-32LE, SJIS-SOFTBANK]"] = [[:"UTF-32LE", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[UTF-32LE, STATELESS-ISO-2022-JP]"] = [[:"UTF-32LE", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[UTF-32LE, STATELESS-ISO-2022-JP-KDDI]"] = [[:"UTF-32LE", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[UTF-32LE, TIS-620]"] = [[:"UTF-32LE", :"UTF-8", :"TIS-620"]]
  @paths["[UTF-32LE, US-ASCII]"] = [[:"UTF-32LE", :"UTF-8", :"US-ASCII"]]
  @paths["[UTF-32LE, UTF-16]"] = [[:"UTF-32LE", :"UTF-8", :"UTF-16"]]
  @paths["[UTF-32LE, UTF-16BE]"] = [[:"UTF-32LE", :"UTF-8", :"UTF-16BE"]]
  @paths["[UTF-32LE, UTF-16LE]"] = [[:"UTF-32LE", :"UTF-8", :"UTF-16LE"]]
  @paths["[UTF-32LE, UTF-32]"] = [[:"UTF-32LE", :"UTF-8", :"UTF-32"]]
  @paths["[UTF-32LE, UTF-32BE]"] = [[:"UTF-32LE", :"UTF-8", :"UTF-32BE"]]
  @paths["[UTF-32LE, UTF-8]"] = [[:"UTF-32LE", :"UTF-8"]]
  @paths["[UTF-32LE, UTF8-DOCOMO]"] = [[:"UTF-32LE", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[UTF-32LE, UTF8-KDDI]"] = [[:"UTF-32LE", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[UTF-32LE, UTF8-MAC]"] = [[:"UTF-32LE", :"UTF-8", :"UTF8-MAC"]]
  @paths["[UTF-32LE, UTF8-SOFTBANK]"] = [[:"UTF-32LE", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[UTF-32LE, WINDOWS-1250]"] = [[:"UTF-32LE", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[UTF-32LE, WINDOWS-1251]"] = [[:"UTF-32LE", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[UTF-32LE, WINDOWS-1252]"] = [[:"UTF-32LE", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[UTF-32LE, WINDOWS-1253]"] = [[:"UTF-32LE", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[UTF-32LE, WINDOWS-1254]"] = [[:"UTF-32LE", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[UTF-32LE, WINDOWS-1255]"] = [[:"UTF-32LE", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[UTF-32LE, WINDOWS-1256]"] = [[:"UTF-32LE", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[UTF-32LE, WINDOWS-1257]"] = [[:"UTF-32LE", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[UTF-32LE, WINDOWS-31J]"] = [[:"UTF-32LE", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[UTF-32LE, WINDOWS-874]"] = [[:"UTF-32LE", :"UTF-8", :"WINDOWS-874"]]
  @paths["[UTF-8, ASCII-8BIT]"] = [[:"UTF-8", :"ASCII-8BIT"]]
  @paths["[UTF-8, BIG5]"] = [[:"UTF-8", :BIG5]]
  @paths["[UTF-8, BIG5-HKSCS]"] = [[:"UTF-8", :"BIG5-HKSCS"]]
  @paths["[UTF-8, BIG5-UAO]"] = [[:"UTF-8", :"BIG5-UAO"]]
  @paths["[UTF-8, CP50220]"] = [[:"UTF-8", :CP51932, :CP50220]]
  @paths["[UTF-8, CP50221]"] = [[:"UTF-8", :CP51932, :CP50221]]
  @paths["[UTF-8, CP51932]"] = [[:"UTF-8", :CP51932]]
  @paths["[UTF-8, CP850]"] = [[:"UTF-8", :CP850]]
  @paths["[UTF-8, CP852]"] = [[:"UTF-8", :CP852]]
  @paths["[UTF-8, CP855]"] = [[:"UTF-8", :CP855]]
  @paths["[UTF-8, CP949]"] = [[:"UTF-8", :CP949]]
  @paths["[UTF-8, CP950]"] = [[:"UTF-8", :CP950]]
  @paths["[UTF-8, CP951]"] = [[:"UTF-8", :CP951]]
  @paths["[UTF-8, EUC-JP]"] = [[:"UTF-8", :"EUC-JP"]]
  @paths["[UTF-8, EUC-KR]"] = [[:"UTF-8", :"EUC-KR"]]
  @paths["[UTF-8, EUCJP-MS]"] = [[:"UTF-8", :"EUCJP-MS"]]
  @paths["[UTF-8, GB12345]"] = [[:"UTF-8", :GB12345]]
  @paths["[UTF-8, GB18030]"] = [[:"UTF-8", :GB18030]]
  @paths["[UTF-8, GB2312]"] = [[:"UTF-8", :GB2312]]
  @paths["[UTF-8, GBK]"] = [[:"UTF-8", :GBK]]
  @paths["[UTF-8, IBM437]"] = [[:"UTF-8", :IBM437]]
  @paths["[UTF-8, IBM737]"] = [[:"UTF-8", :IBM737]]
  @paths["[UTF-8, IBM775]"] = [[:"UTF-8", :IBM775]]
  @paths["[UTF-8, IBM852]"] = [[:"UTF-8", :IBM852]]
  @paths["[UTF-8, IBM855]"] = [[:"UTF-8", :IBM855]]
  @paths["[UTF-8, IBM857]"] = [[:"UTF-8", :IBM857]]
  @paths["[UTF-8, IBM860]"] = [[:"UTF-8", :IBM860]]
  @paths["[UTF-8, IBM861]"] = [[:"UTF-8", :IBM861]]
  @paths["[UTF-8, IBM862]"] = [[:"UTF-8", :IBM862]]
  @paths["[UTF-8, IBM863]"] = [[:"UTF-8", :IBM863]]
  @paths["[UTF-8, IBM865]"] = [[:"UTF-8", :IBM865]]
  @paths["[UTF-8, IBM866]"] = [[:"UTF-8", :IBM866]]
  @paths["[UTF-8, IBM869]"] = [[:"UTF-8", :IBM869]]
  @paths["[UTF-8, ISO-2022-JP]"] = [[:"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[UTF-8, ISO-2022-JP-KDDI]"] = [[:"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[UTF-8, ISO-8859-1]"] = [[:"UTF-8", :"ISO-8859-1"]]
  @paths["[UTF-8, ISO-8859-10]"] = [[:"UTF-8", :"ISO-8859-10"]]
  @paths["[UTF-8, ISO-8859-11]"] = [[:"UTF-8", :"ISO-8859-11"]]
  @paths["[UTF-8, ISO-8859-13]"] = [[:"UTF-8", :"ISO-8859-13"]]
  @paths["[UTF-8, ISO-8859-14]"] = [[:"UTF-8", :"ISO-8859-14"]]
  @paths["[UTF-8, ISO-8859-15]"] = [[:"UTF-8", :"ISO-8859-15"]]
  @paths["[UTF-8, ISO-8859-2]"] = [[:"UTF-8", :"ISO-8859-2"]]
  @paths["[UTF-8, ISO-8859-3]"] = [[:"UTF-8", :"ISO-8859-3"]]
  @paths["[UTF-8, ISO-8859-4]"] = [[:"UTF-8", :"ISO-8859-4"]]
  @paths["[UTF-8, ISO-8859-5]"] = [[:"UTF-8", :"ISO-8859-5"]]
  @paths["[UTF-8, ISO-8859-6]"] = [[:"UTF-8", :"ISO-8859-6"]]
  @paths["[UTF-8, ISO-8859-7]"] = [[:"UTF-8", :"ISO-8859-7"]]
  @paths["[UTF-8, ISO-8859-8]"] = [[:"UTF-8", :"ISO-8859-8"]]
  @paths["[UTF-8, ISO-8859-9]"] = [[:"UTF-8", :"ISO-8859-9"]]
  @paths["[UTF-8, KOI8-R]"] = [[:"UTF-8", :"KOI8-R"]]
  @paths["[UTF-8, KOI8-U]"] = [[:"UTF-8", :"KOI8-U"]]
  @paths["[UTF-8, MACCROATIAN]"] = [[:"UTF-8", :MACCROATIAN]]
  @paths["[UTF-8, MACCYRILLIC]"] = [[:"UTF-8", :MACCYRILLIC]]
  @paths["[UTF-8, MACGREEK]"] = [[:"UTF-8", :MACGREEK]]
  @paths["[UTF-8, MACICELAND]"] = [[:"UTF-8", :MACICELAND]]
  @paths["[UTF-8, MACROMAN]"] = [[:"UTF-8", :MACROMAN]]
  @paths["[UTF-8, MACROMANIA]"] = [[:"UTF-8", :MACROMANIA]]
  @paths["[UTF-8, MACTURKISH]"] = [[:"UTF-8", :MACTURKISH]]
  @paths["[UTF-8, MACUKRAINE]"] = [[:"UTF-8", :MACUKRAINE]]
  @paths["[UTF-8, SHIFT_JIS]"] = [[:"UTF-8", :SHIFT_JIS]]
  @paths["[UTF-8, SJIS-DOCOMO]"] = [[:"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[UTF-8, SJIS-KDDI]"] = [[:"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[UTF-8, SJIS-SOFTBANK]"] = [[:"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[UTF-8, STATELESS-ISO-2022-JP]"] = [[:"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[UTF-8, STATELESS-ISO-2022-JP-KDDI]"] = [[:"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[UTF-8, TIS-620]"] = [[:"UTF-8", :"TIS-620"]]
  @paths["[UTF-8, US-ASCII]"] = [[:"UTF-8", :"US-ASCII"]]
  @paths["[UTF-8, UTF-16]"] = [[:"UTF-8", :"UTF-16"]]
  @paths["[UTF-8, UTF-16BE]"] = [[:"UTF-8", :"UTF-16BE"]]
  @paths["[UTF-8, UTF-16LE]"] = [[:"UTF-8", :"UTF-16LE"]]
  @paths["[UTF-8, UTF-32]"] = [[:"UTF-8", :"UTF-32"]]
  @paths["[UTF-8, UTF-32BE]"] = [[:"UTF-8", :"UTF-32BE"]]
  @paths["[UTF-8, UTF-32LE]"] = [[:"UTF-8", :"UTF-32LE"]]
  @paths["[UTF-8, UTF8-DOCOMO]"] = [[:"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[UTF-8, UTF8-KDDI]"] = [[:"UTF-8", :"UTF8-KDDI"]]
  @paths["[UTF-8, UTF8-MAC]"] = [[:"UTF-8", :"UTF8-MAC"]]
  @paths["[UTF-8, UTF8-SOFTBANK]"] = [[:"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[UTF-8, WINDOWS-1250]"] = [[:"UTF-8", :"WINDOWS-1250"]]
  @paths["[UTF-8, WINDOWS-1251]"] = [[:"UTF-8", :"WINDOWS-1251"]]
  @paths["[UTF-8, WINDOWS-1252]"] = [[:"UTF-8", :"WINDOWS-1252"]]
  @paths["[UTF-8, WINDOWS-1253]"] = [[:"UTF-8", :"WINDOWS-1253"]]
  @paths["[UTF-8, WINDOWS-1254]"] = [[:"UTF-8", :"WINDOWS-1254"]]
  @paths["[UTF-8, WINDOWS-1255]"] = [[:"UTF-8", :"WINDOWS-1255"]]
  @paths["[UTF-8, WINDOWS-1256]"] = [[:"UTF-8", :"WINDOWS-1256"]]
  @paths["[UTF-8, WINDOWS-1257]"] = [[:"UTF-8", :"WINDOWS-1257"]]
  @paths["[UTF-8, WINDOWS-31J]"] = [[:"UTF-8", :"WINDOWS-31J"]]
  @paths["[UTF-8, WINDOWS-874]"] = [[:"UTF-8", :"WINDOWS-874"]]
  @paths["[UTF8-DOCOMO, ASCII-8BIT]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[UTF8-DOCOMO, BIG5]"] = [[:"UTF8-DOCOMO", :"UTF-8", :BIG5]]
  @paths["[UTF8-DOCOMO, BIG5-HKSCS]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[UTF8-DOCOMO, BIG5-UAO]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"BIG5-UAO"]]
  @paths["[UTF8-DOCOMO, CP50220]"] = [[:"UTF8-DOCOMO", :"UTF-8", :CP51932, :CP50220]]
  @paths["[UTF8-DOCOMO, CP50221]"] = [[:"UTF8-DOCOMO", :"UTF-8", :CP51932, :CP50221]]
  @paths["[UTF8-DOCOMO, CP51932]"] = [[:"UTF8-DOCOMO", :"UTF-8", :CP51932]]
  @paths["[UTF8-DOCOMO, CP850]"] = [[:"UTF8-DOCOMO", :"UTF-8", :CP850]]
  @paths["[UTF8-DOCOMO, CP852]"] = [[:"UTF8-DOCOMO", :"UTF-8", :CP852]]
  @paths["[UTF8-DOCOMO, CP855]"] = [[:"UTF8-DOCOMO", :"UTF-8", :CP855]]
  @paths["[UTF8-DOCOMO, CP949]"] = [[:"UTF8-DOCOMO", :"UTF-8", :CP949]]
  @paths["[UTF8-DOCOMO, CP950]"] = [[:"UTF8-DOCOMO", :"UTF-8", :CP950]]
  @paths["[UTF8-DOCOMO, CP951]"] = [[:"UTF8-DOCOMO", :"UTF-8", :CP951]]
  @paths["[UTF8-DOCOMO, EUC-JP]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"EUC-JP"]]
  @paths["[UTF8-DOCOMO, EUC-KR]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"EUC-KR"]]
  @paths["[UTF8-DOCOMO, EUCJP-MS]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"EUCJP-MS"]]
  @paths["[UTF8-DOCOMO, GB12345]"] = [[:"UTF8-DOCOMO", :"UTF-8", :GB12345]]
  @paths["[UTF8-DOCOMO, GB18030]"] = [[:"UTF8-DOCOMO", :"UTF-8", :GB18030]]
  @paths["[UTF8-DOCOMO, GB2312]"] = [[:"UTF8-DOCOMO", :"UTF-8", :GB2312]]
  @paths["[UTF8-DOCOMO, GBK]"] = [[:"UTF8-DOCOMO", :"UTF-8", :GBK]]
  @paths["[UTF8-DOCOMO, IBM437]"] = [[:"UTF8-DOCOMO", :"UTF-8", :IBM437]]
  @paths["[UTF8-DOCOMO, IBM737]"] = [[:"UTF8-DOCOMO", :"UTF-8", :IBM737]]
  @paths["[UTF8-DOCOMO, IBM775]"] = [[:"UTF8-DOCOMO", :"UTF-8", :IBM775]]
  @paths["[UTF8-DOCOMO, IBM852]"] = [[:"UTF8-DOCOMO", :"UTF-8", :IBM852]]
  @paths["[UTF8-DOCOMO, IBM855]"] = [[:"UTF8-DOCOMO", :"UTF-8", :IBM855]]
  @paths["[UTF8-DOCOMO, IBM857]"] = [[:"UTF8-DOCOMO", :"UTF-8", :IBM857]]
  @paths["[UTF8-DOCOMO, IBM860]"] = [[:"UTF8-DOCOMO", :"UTF-8", :IBM860]]
  @paths["[UTF8-DOCOMO, IBM861]"] = [[:"UTF8-DOCOMO", :"UTF-8", :IBM861]]
  @paths["[UTF8-DOCOMO, IBM862]"] = [[:"UTF8-DOCOMO", :"UTF-8", :IBM862]]
  @paths["[UTF8-DOCOMO, IBM863]"] = [[:"UTF8-DOCOMO", :"UTF-8", :IBM863]]
  @paths["[UTF8-DOCOMO, IBM865]"] = [[:"UTF8-DOCOMO", :"UTF-8", :IBM865]]
  @paths["[UTF8-DOCOMO, IBM866]"] = [[:"UTF8-DOCOMO", :"UTF-8", :IBM866]]
  @paths["[UTF8-DOCOMO, IBM869]"] = [[:"UTF8-DOCOMO", :"UTF-8", :IBM869]]
  @paths["[UTF8-DOCOMO, ISO-2022-JP]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[UTF8-DOCOMO, ISO-2022-JP-KDDI]"] = [[:"UTF8-DOCOMO", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[UTF8-DOCOMO, ISO-8859-1]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-1"]]
  @paths["[UTF8-DOCOMO, ISO-8859-10]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-10"]]
  @paths["[UTF8-DOCOMO, ISO-8859-11]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-11"]]
  @paths["[UTF8-DOCOMO, ISO-8859-13]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-13"]]
  @paths["[UTF8-DOCOMO, ISO-8859-14]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-14"]]
  @paths["[UTF8-DOCOMO, ISO-8859-15]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-15"]]
  @paths["[UTF8-DOCOMO, ISO-8859-2]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-2"]]
  @paths["[UTF8-DOCOMO, ISO-8859-3]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-3"]]
  @paths["[UTF8-DOCOMO, ISO-8859-4]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-4"]]
  @paths["[UTF8-DOCOMO, ISO-8859-5]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-5"]]
  @paths["[UTF8-DOCOMO, ISO-8859-6]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-6"]]
  @paths["[UTF8-DOCOMO, ISO-8859-7]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-7"]]
  @paths["[UTF8-DOCOMO, ISO-8859-8]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-8"]]
  @paths["[UTF8-DOCOMO, ISO-8859-9]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"ISO-8859-9"]]
  @paths["[UTF8-DOCOMO, KOI8-R]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"KOI8-R"]]
  @paths["[UTF8-DOCOMO, KOI8-U]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"KOI8-U"]]
  @paths["[UTF8-DOCOMO, MACCROATIAN]"] = [[:"UTF8-DOCOMO", :"UTF-8", :MACCROATIAN]]
  @paths["[UTF8-DOCOMO, MACCYRILLIC]"] = [[:"UTF8-DOCOMO", :"UTF-8", :MACCYRILLIC]]
  @paths["[UTF8-DOCOMO, MACGREEK]"] = [[:"UTF8-DOCOMO", :"UTF-8", :MACGREEK]]
  @paths["[UTF8-DOCOMO, MACICELAND]"] = [[:"UTF8-DOCOMO", :"UTF-8", :MACICELAND]]
  @paths["[UTF8-DOCOMO, MACROMAN]"] = [[:"UTF8-DOCOMO", :"UTF-8", :MACROMAN]]
  @paths["[UTF8-DOCOMO, MACROMANIA]"] = [[:"UTF8-DOCOMO", :"UTF-8", :MACROMANIA]]
  @paths["[UTF8-DOCOMO, MACTURKISH]"] = [[:"UTF8-DOCOMO", :"UTF-8", :MACTURKISH]]
  @paths["[UTF8-DOCOMO, MACUKRAINE]"] = [[:"UTF8-DOCOMO", :"UTF-8", :MACUKRAINE]]
  @paths["[UTF8-DOCOMO, SHIFT_JIS]"] = [[:"UTF8-DOCOMO", :"UTF-8", :SHIFT_JIS]]
  @paths["[UTF8-DOCOMO, SJIS-DOCOMO]"] = [[:"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[UTF8-DOCOMO, SJIS-KDDI]"] = [[:"UTF8-DOCOMO", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[UTF8-DOCOMO, SJIS-SOFTBANK]"] = [[:"UTF8-DOCOMO", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[UTF8-DOCOMO, STATELESS-ISO-2022-JP]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[UTF8-DOCOMO, STATELESS-ISO-2022-JP-KDDI]"] = [[:"UTF8-DOCOMO", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[UTF8-DOCOMO, TIS-620]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"TIS-620"]]
  @paths["[UTF8-DOCOMO, US-ASCII]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"US-ASCII"]]
  @paths["[UTF8-DOCOMO, UTF-16]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"UTF-16"]]
  @paths["[UTF8-DOCOMO, UTF-16BE]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"UTF-16BE"]]
  @paths["[UTF8-DOCOMO, UTF-16LE]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"UTF-16LE"]]
  @paths["[UTF8-DOCOMO, UTF-32]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"UTF-32"]]
  @paths["[UTF8-DOCOMO, UTF-32BE]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"UTF-32BE"]]
  @paths["[UTF8-DOCOMO, UTF-32LE]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"UTF-32LE"]]
  @paths["[UTF8-DOCOMO, UTF-8]"] = [[:"UTF8-DOCOMO", :"UTF-8"]]
  @paths["[UTF8-DOCOMO, UTF8-KDDI]"] = [[:"UTF8-DOCOMO", :"UTF8-KDDI"]]
  @paths["[UTF8-DOCOMO, UTF8-MAC]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"UTF8-MAC"]]
  @paths["[UTF8-DOCOMO, UTF8-SOFTBANK]"] = [[:"UTF8-DOCOMO", :"UTF8-SOFTBANK"]]
  @paths["[UTF8-DOCOMO, WINDOWS-1250]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[UTF8-DOCOMO, WINDOWS-1251]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[UTF8-DOCOMO, WINDOWS-1252]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[UTF8-DOCOMO, WINDOWS-1253]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[UTF8-DOCOMO, WINDOWS-1254]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[UTF8-DOCOMO, WINDOWS-1255]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[UTF8-DOCOMO, WINDOWS-1256]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[UTF8-DOCOMO, WINDOWS-1257]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[UTF8-DOCOMO, WINDOWS-31J]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[UTF8-DOCOMO, WINDOWS-874]"] = [[:"UTF8-DOCOMO", :"UTF-8", :"WINDOWS-874"]]
  @paths["[UTF8-KDDI, ASCII-8BIT]"] = [[:"UTF8-KDDI", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[UTF8-KDDI, BIG5]"] = [[:"UTF8-KDDI", :"UTF-8", :BIG5]]
  @paths["[UTF8-KDDI, BIG5-HKSCS]"] = [[:"UTF8-KDDI", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[UTF8-KDDI, BIG5-UAO]"] = [[:"UTF8-KDDI", :"UTF-8", :"BIG5-UAO"]]
  @paths["[UTF8-KDDI, CP50220]"] = [[:"UTF8-KDDI", :"UTF-8", :CP51932, :CP50220]]
  @paths["[UTF8-KDDI, CP50221]"] = [[:"UTF8-KDDI", :"UTF-8", :CP51932, :CP50221]]
  @paths["[UTF8-KDDI, CP51932]"] = [[:"UTF8-KDDI", :"UTF-8", :CP51932]]
  @paths["[UTF8-KDDI, CP850]"] = [[:"UTF8-KDDI", :"UTF-8", :CP850]]
  @paths["[UTF8-KDDI, CP852]"] = [[:"UTF8-KDDI", :"UTF-8", :CP852]]
  @paths["[UTF8-KDDI, CP855]"] = [[:"UTF8-KDDI", :"UTF-8", :CP855]]
  @paths["[UTF8-KDDI, CP949]"] = [[:"UTF8-KDDI", :"UTF-8", :CP949]]
  @paths["[UTF8-KDDI, CP950]"] = [[:"UTF8-KDDI", :"UTF-8", :CP950]]
  @paths["[UTF8-KDDI, CP951]"] = [[:"UTF8-KDDI", :"UTF-8", :CP951]]
  @paths["[UTF8-KDDI, EUC-JP]"] = [[:"UTF8-KDDI", :"UTF-8", :"EUC-JP"]]
  @paths["[UTF8-KDDI, EUC-KR]"] = [[:"UTF8-KDDI", :"UTF-8", :"EUC-KR"]]
  @paths["[UTF8-KDDI, EUCJP-MS]"] = [[:"UTF8-KDDI", :"UTF-8", :"EUCJP-MS"]]
  @paths["[UTF8-KDDI, GB12345]"] = [[:"UTF8-KDDI", :"UTF-8", :GB12345]]
  @paths["[UTF8-KDDI, GB18030]"] = [[:"UTF8-KDDI", :"UTF-8", :GB18030]]
  @paths["[UTF8-KDDI, GB2312]"] = [[:"UTF8-KDDI", :"UTF-8", :GB2312]]
  @paths["[UTF8-KDDI, GBK]"] = [[:"UTF8-KDDI", :"UTF-8", :GBK]]
  @paths["[UTF8-KDDI, IBM437]"] = [[:"UTF8-KDDI", :"UTF-8", :IBM437]]
  @paths["[UTF8-KDDI, IBM737]"] = [[:"UTF8-KDDI", :"UTF-8", :IBM737]]
  @paths["[UTF8-KDDI, IBM775]"] = [[:"UTF8-KDDI", :"UTF-8", :IBM775]]
  @paths["[UTF8-KDDI, IBM852]"] = [[:"UTF8-KDDI", :"UTF-8", :IBM852]]
  @paths["[UTF8-KDDI, IBM855]"] = [[:"UTF8-KDDI", :"UTF-8", :IBM855]]
  @paths["[UTF8-KDDI, IBM857]"] = [[:"UTF8-KDDI", :"UTF-8", :IBM857]]
  @paths["[UTF8-KDDI, IBM860]"] = [[:"UTF8-KDDI", :"UTF-8", :IBM860]]
  @paths["[UTF8-KDDI, IBM861]"] = [[:"UTF8-KDDI", :"UTF-8", :IBM861]]
  @paths["[UTF8-KDDI, IBM862]"] = [[:"UTF8-KDDI", :"UTF-8", :IBM862]]
  @paths["[UTF8-KDDI, IBM863]"] = [[:"UTF8-KDDI", :"UTF-8", :IBM863]]
  @paths["[UTF8-KDDI, IBM865]"] = [[:"UTF8-KDDI", :"UTF-8", :IBM865]]
  @paths["[UTF8-KDDI, IBM866]"] = [[:"UTF8-KDDI", :"UTF-8", :IBM866]]
  @paths["[UTF8-KDDI, IBM869]"] = [[:"UTF8-KDDI", :"UTF-8", :IBM869]]
  @paths["[UTF8-KDDI, ISO-2022-JP]"] = [[:"UTF8-KDDI", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[UTF8-KDDI, ISO-2022-JP-KDDI]"] = [[:"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[UTF8-KDDI, ISO-8859-1]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-1"]]
  @paths["[UTF8-KDDI, ISO-8859-10]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-10"]]
  @paths["[UTF8-KDDI, ISO-8859-11]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-11"]]
  @paths["[UTF8-KDDI, ISO-8859-13]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-13"]]
  @paths["[UTF8-KDDI, ISO-8859-14]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-14"]]
  @paths["[UTF8-KDDI, ISO-8859-15]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-15"]]
  @paths["[UTF8-KDDI, ISO-8859-2]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-2"]]
  @paths["[UTF8-KDDI, ISO-8859-3]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-3"]]
  @paths["[UTF8-KDDI, ISO-8859-4]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-4"]]
  @paths["[UTF8-KDDI, ISO-8859-5]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-5"]]
  @paths["[UTF8-KDDI, ISO-8859-6]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-6"]]
  @paths["[UTF8-KDDI, ISO-8859-7]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-7"]]
  @paths["[UTF8-KDDI, ISO-8859-8]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-8"]]
  @paths["[UTF8-KDDI, ISO-8859-9]"] = [[:"UTF8-KDDI", :"UTF-8", :"ISO-8859-9"]]
  @paths["[UTF8-KDDI, KOI8-R]"] = [[:"UTF8-KDDI", :"UTF-8", :"KOI8-R"]]
  @paths["[UTF8-KDDI, KOI8-U]"] = [[:"UTF8-KDDI", :"UTF-8", :"KOI8-U"]]
  @paths["[UTF8-KDDI, MACCROATIAN]"] = [[:"UTF8-KDDI", :"UTF-8", :MACCROATIAN]]
  @paths["[UTF8-KDDI, MACCYRILLIC]"] = [[:"UTF8-KDDI", :"UTF-8", :MACCYRILLIC]]
  @paths["[UTF8-KDDI, MACGREEK]"] = [[:"UTF8-KDDI", :"UTF-8", :MACGREEK]]
  @paths["[UTF8-KDDI, MACICELAND]"] = [[:"UTF8-KDDI", :"UTF-8", :MACICELAND]]
  @paths["[UTF8-KDDI, MACROMAN]"] = [[:"UTF8-KDDI", :"UTF-8", :MACROMAN]]
  @paths["[UTF8-KDDI, MACROMANIA]"] = [[:"UTF8-KDDI", :"UTF-8", :MACROMANIA]]
  @paths["[UTF8-KDDI, MACTURKISH]"] = [[:"UTF8-KDDI", :"UTF-8", :MACTURKISH]]
  @paths["[UTF8-KDDI, MACUKRAINE]"] = [[:"UTF8-KDDI", :"UTF-8", :MACUKRAINE]]
  @paths["[UTF8-KDDI, SHIFT_JIS]"] = [[:"UTF8-KDDI", :"UTF-8", :SHIFT_JIS]]
  @paths["[UTF8-KDDI, SJIS-DOCOMO]"] = [[:"UTF8-KDDI", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[UTF8-KDDI, SJIS-KDDI]"] = [[:"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[UTF8-KDDI, SJIS-SOFTBANK]"] = [[:"UTF8-KDDI", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[UTF8-KDDI, STATELESS-ISO-2022-JP]"] = [[:"UTF8-KDDI", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[UTF8-KDDI, STATELESS-ISO-2022-JP-KDDI]"] = [[:"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[UTF8-KDDI, TIS-620]"] = [[:"UTF8-KDDI", :"UTF-8", :"TIS-620"]]
  @paths["[UTF8-KDDI, US-ASCII]"] = [[:"UTF8-KDDI", :"UTF-8", :"US-ASCII"]]
  @paths["[UTF8-KDDI, UTF-16]"] = [[:"UTF8-KDDI", :"UTF-8", :"UTF-16"]]
  @paths["[UTF8-KDDI, UTF-16BE]"] = [[:"UTF8-KDDI", :"UTF-8", :"UTF-16BE"]]
  @paths["[UTF8-KDDI, UTF-16LE]"] = [[:"UTF8-KDDI", :"UTF-8", :"UTF-16LE"]]
  @paths["[UTF8-KDDI, UTF-32]"] = [[:"UTF8-KDDI", :"UTF-8", :"UTF-32"]]
  @paths["[UTF8-KDDI, UTF-32BE]"] = [[:"UTF8-KDDI", :"UTF-8", :"UTF-32BE"]]
  @paths["[UTF8-KDDI, UTF-32LE]"] = [[:"UTF8-KDDI", :"UTF-8", :"UTF-32LE"]]
  @paths["[UTF8-KDDI, UTF-8]"] = [[:"UTF8-KDDI", :"UTF-8"]]
  @paths["[UTF8-KDDI, UTF8-DOCOMO]"] = [[:"UTF8-KDDI", :"UTF8-DOCOMO"]]
  @paths["[UTF8-KDDI, UTF8-MAC]"] = [[:"UTF8-KDDI", :"UTF-8", :"UTF8-MAC"]]
  @paths["[UTF8-KDDI, UTF8-SOFTBANK]"] = [[:"UTF8-KDDI", :"UTF8-SOFTBANK"]]
  @paths["[UTF8-KDDI, WINDOWS-1250]"] = [[:"UTF8-KDDI", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[UTF8-KDDI, WINDOWS-1251]"] = [[:"UTF8-KDDI", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[UTF8-KDDI, WINDOWS-1252]"] = [[:"UTF8-KDDI", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[UTF8-KDDI, WINDOWS-1253]"] = [[:"UTF8-KDDI", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[UTF8-KDDI, WINDOWS-1254]"] = [[:"UTF8-KDDI", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[UTF8-KDDI, WINDOWS-1255]"] = [[:"UTF8-KDDI", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[UTF8-KDDI, WINDOWS-1256]"] = [[:"UTF8-KDDI", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[UTF8-KDDI, WINDOWS-1257]"] = [[:"UTF8-KDDI", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[UTF8-KDDI, WINDOWS-31J]"] = [[:"UTF8-KDDI", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[UTF8-KDDI, WINDOWS-874]"] = [[:"UTF8-KDDI", :"UTF-8", :"WINDOWS-874"]]
  @paths["[UTF8-MAC, ASCII-8BIT]"] = [[:"UTF8-MAC", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[UTF8-MAC, BIG5]"] = [[:"UTF8-MAC", :"UTF-8", :BIG5]]
  @paths["[UTF8-MAC, BIG5-HKSCS]"] = [[:"UTF8-MAC", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[UTF8-MAC, BIG5-UAO]"] = [[:"UTF8-MAC", :"UTF-8", :"BIG5-UAO"]]
  @paths["[UTF8-MAC, CP50220]"] = [[:"UTF8-MAC", :"UTF-8", :CP51932, :CP50220]]
  @paths["[UTF8-MAC, CP50221]"] = [[:"UTF8-MAC", :"UTF-8", :CP51932, :CP50221]]
  @paths["[UTF8-MAC, CP51932]"] = [[:"UTF8-MAC", :"UTF-8", :CP51932]]
  @paths["[UTF8-MAC, CP850]"] = [[:"UTF8-MAC", :"UTF-8", :CP850]]
  @paths["[UTF8-MAC, CP852]"] = [[:"UTF8-MAC", :"UTF-8", :CP852]]
  @paths["[UTF8-MAC, CP855]"] = [[:"UTF8-MAC", :"UTF-8", :CP855]]
  @paths["[UTF8-MAC, CP949]"] = [[:"UTF8-MAC", :"UTF-8", :CP949]]
  @paths["[UTF8-MAC, CP950]"] = [[:"UTF8-MAC", :"UTF-8", :CP950]]
  @paths["[UTF8-MAC, CP951]"] = [[:"UTF8-MAC", :"UTF-8", :CP951]]
  @paths["[UTF8-MAC, EUC-JP]"] = [[:"UTF8-MAC", :"UTF-8", :"EUC-JP"]]
  @paths["[UTF8-MAC, EUC-KR]"] = [[:"UTF8-MAC", :"UTF-8", :"EUC-KR"]]
  @paths["[UTF8-MAC, EUCJP-MS]"] = [[:"UTF8-MAC", :"UTF-8", :"EUCJP-MS"]]
  @paths["[UTF8-MAC, GB12345]"] = [[:"UTF8-MAC", :"UTF-8", :GB12345]]
  @paths["[UTF8-MAC, GB18030]"] = [[:"UTF8-MAC", :"UTF-8", :GB18030]]
  @paths["[UTF8-MAC, GB2312]"] = [[:"UTF8-MAC", :"UTF-8", :GB2312]]
  @paths["[UTF8-MAC, GBK]"] = [[:"UTF8-MAC", :"UTF-8", :GBK]]
  @paths["[UTF8-MAC, IBM437]"] = [[:"UTF8-MAC", :"UTF-8", :IBM437]]
  @paths["[UTF8-MAC, IBM737]"] = [[:"UTF8-MAC", :"UTF-8", :IBM737]]
  @paths["[UTF8-MAC, IBM775]"] = [[:"UTF8-MAC", :"UTF-8", :IBM775]]
  @paths["[UTF8-MAC, IBM852]"] = [[:"UTF8-MAC", :"UTF-8", :IBM852]]
  @paths["[UTF8-MAC, IBM855]"] = [[:"UTF8-MAC", :"UTF-8", :IBM855]]
  @paths["[UTF8-MAC, IBM857]"] = [[:"UTF8-MAC", :"UTF-8", :IBM857]]
  @paths["[UTF8-MAC, IBM860]"] = [[:"UTF8-MAC", :"UTF-8", :IBM860]]
  @paths["[UTF8-MAC, IBM861]"] = [[:"UTF8-MAC", :"UTF-8", :IBM861]]
  @paths["[UTF8-MAC, IBM862]"] = [[:"UTF8-MAC", :"UTF-8", :IBM862]]
  @paths["[UTF8-MAC, IBM863]"] = [[:"UTF8-MAC", :"UTF-8", :IBM863]]
  @paths["[UTF8-MAC, IBM865]"] = [[:"UTF8-MAC", :"UTF-8", :IBM865]]
  @paths["[UTF8-MAC, IBM866]"] = [[:"UTF8-MAC", :"UTF-8", :IBM866]]
  @paths["[UTF8-MAC, IBM869]"] = [[:"UTF8-MAC", :"UTF-8", :IBM869]]
  @paths["[UTF8-MAC, ISO-2022-JP]"] = [[:"UTF8-MAC", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[UTF8-MAC, ISO-2022-JP-KDDI]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[UTF8-MAC, ISO-8859-1]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-1"]]
  @paths["[UTF8-MAC, ISO-8859-10]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-10"]]
  @paths["[UTF8-MAC, ISO-8859-11]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-11"]]
  @paths["[UTF8-MAC, ISO-8859-13]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-13"]]
  @paths["[UTF8-MAC, ISO-8859-14]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-14"]]
  @paths["[UTF8-MAC, ISO-8859-15]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-15"]]
  @paths["[UTF8-MAC, ISO-8859-2]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-2"]]
  @paths["[UTF8-MAC, ISO-8859-3]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-3"]]
  @paths["[UTF8-MAC, ISO-8859-4]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-4"]]
  @paths["[UTF8-MAC, ISO-8859-5]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-5"]]
  @paths["[UTF8-MAC, ISO-8859-6]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-6"]]
  @paths["[UTF8-MAC, ISO-8859-7]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-7"]]
  @paths["[UTF8-MAC, ISO-8859-8]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-8"]]
  @paths["[UTF8-MAC, ISO-8859-9]"] = [[:"UTF8-MAC", :"UTF-8", :"ISO-8859-9"]]
  @paths["[UTF8-MAC, KOI8-R]"] = [[:"UTF8-MAC", :"UTF-8", :"KOI8-R"]]
  @paths["[UTF8-MAC, KOI8-U]"] = [[:"UTF8-MAC", :"UTF-8", :"KOI8-U"]]
  @paths["[UTF8-MAC, MACCROATIAN]"] = [[:"UTF8-MAC", :"UTF-8", :MACCROATIAN]]
  @paths["[UTF8-MAC, MACCYRILLIC]"] = [[:"UTF8-MAC", :"UTF-8", :MACCYRILLIC]]
  @paths["[UTF8-MAC, MACGREEK]"] = [[:"UTF8-MAC", :"UTF-8", :MACGREEK]]
  @paths["[UTF8-MAC, MACICELAND]"] = [[:"UTF8-MAC", :"UTF-8", :MACICELAND]]
  @paths["[UTF8-MAC, MACROMAN]"] = [[:"UTF8-MAC", :"UTF-8", :MACROMAN]]
  @paths["[UTF8-MAC, MACROMANIA]"] = [[:"UTF8-MAC", :"UTF-8", :MACROMANIA]]
  @paths["[UTF8-MAC, MACTURKISH]"] = [[:"UTF8-MAC", :"UTF-8", :MACTURKISH]]
  @paths["[UTF8-MAC, MACUKRAINE]"] = [[:"UTF8-MAC", :"UTF-8", :MACUKRAINE]]
  @paths["[UTF8-MAC, SHIFT_JIS]"] = [[:"UTF8-MAC", :"UTF-8", :SHIFT_JIS]]
  @paths["[UTF8-MAC, SJIS-DOCOMO]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[UTF8-MAC, SJIS-KDDI]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[UTF8-MAC, SJIS-SOFTBANK]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[UTF8-MAC, STATELESS-ISO-2022-JP]"] = [[:"UTF8-MAC", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[UTF8-MAC, STATELESS-ISO-2022-JP-KDDI]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[UTF8-MAC, TIS-620]"] = [[:"UTF8-MAC", :"UTF-8", :"TIS-620"]]
  @paths["[UTF8-MAC, US-ASCII]"] = [[:"UTF8-MAC", :"UTF-8", :"US-ASCII"]]
  @paths["[UTF8-MAC, UTF-16]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF-16"]]
  @paths["[UTF8-MAC, UTF-16BE]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF-16BE"]]
  @paths["[UTF8-MAC, UTF-16LE]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF-16LE"]]
  @paths["[UTF8-MAC, UTF-32]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF-32"]]
  @paths["[UTF8-MAC, UTF-32BE]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF-32BE"]]
  @paths["[UTF8-MAC, UTF-32LE]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF-32LE"]]
  @paths["[UTF8-MAC, UTF-8]"] = [[:"UTF8-MAC", :"UTF-8"]]
  @paths["[UTF8-MAC, UTF8-DOCOMO]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[UTF8-MAC, UTF8-KDDI]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[UTF8-MAC, UTF8-SOFTBANK]"] = [[:"UTF8-MAC", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[UTF8-MAC, WINDOWS-1250]"] = [[:"UTF8-MAC", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[UTF8-MAC, WINDOWS-1251]"] = [[:"UTF8-MAC", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[UTF8-MAC, WINDOWS-1252]"] = [[:"UTF8-MAC", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[UTF8-MAC, WINDOWS-1253]"] = [[:"UTF8-MAC", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[UTF8-MAC, WINDOWS-1254]"] = [[:"UTF8-MAC", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[UTF8-MAC, WINDOWS-1255]"] = [[:"UTF8-MAC", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[UTF8-MAC, WINDOWS-1256]"] = [[:"UTF8-MAC", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[UTF8-MAC, WINDOWS-1257]"] = [[:"UTF8-MAC", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[UTF8-MAC, WINDOWS-31J]"] = [[:"UTF8-MAC", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[UTF8-MAC, WINDOWS-874]"] = [[:"UTF8-MAC", :"UTF-8", :"WINDOWS-874"]]
  @paths["[UTF8-SOFTBANK, ASCII-8BIT]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[UTF8-SOFTBANK, BIG5]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :BIG5]]
  @paths["[UTF8-SOFTBANK, BIG5-HKSCS]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[UTF8-SOFTBANK, BIG5-UAO]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"BIG5-UAO"]]
  @paths["[UTF8-SOFTBANK, CP50220]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :CP51932, :CP50220]]
  @paths["[UTF8-SOFTBANK, CP50221]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :CP51932, :CP50221]]
  @paths["[UTF8-SOFTBANK, CP51932]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :CP51932]]
  @paths["[UTF8-SOFTBANK, CP850]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :CP850]]
  @paths["[UTF8-SOFTBANK, CP852]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :CP852]]
  @paths["[UTF8-SOFTBANK, CP855]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :CP855]]
  @paths["[UTF8-SOFTBANK, CP949]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :CP949]]
  @paths["[UTF8-SOFTBANK, CP950]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :CP950]]
  @paths["[UTF8-SOFTBANK, CP951]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :CP951]]
  @paths["[UTF8-SOFTBANK, EUC-JP]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"EUC-JP"]]
  @paths["[UTF8-SOFTBANK, EUC-KR]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"EUC-KR"]]
  @paths["[UTF8-SOFTBANK, EUCJP-MS]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"EUCJP-MS"]]
  @paths["[UTF8-SOFTBANK, GB12345]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :GB12345]]
  @paths["[UTF8-SOFTBANK, GB18030]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :GB18030]]
  @paths["[UTF8-SOFTBANK, GB2312]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :GB2312]]
  @paths["[UTF8-SOFTBANK, GBK]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :GBK]]
  @paths["[UTF8-SOFTBANK, IBM437]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :IBM437]]
  @paths["[UTF8-SOFTBANK, IBM737]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :IBM737]]
  @paths["[UTF8-SOFTBANK, IBM775]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :IBM775]]
  @paths["[UTF8-SOFTBANK, IBM852]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :IBM852]]
  @paths["[UTF8-SOFTBANK, IBM855]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :IBM855]]
  @paths["[UTF8-SOFTBANK, IBM857]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :IBM857]]
  @paths["[UTF8-SOFTBANK, IBM860]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :IBM860]]
  @paths["[UTF8-SOFTBANK, IBM861]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :IBM861]]
  @paths["[UTF8-SOFTBANK, IBM862]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :IBM862]]
  @paths["[UTF8-SOFTBANK, IBM863]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :IBM863]]
  @paths["[UTF8-SOFTBANK, IBM865]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :IBM865]]
  @paths["[UTF8-SOFTBANK, IBM866]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :IBM866]]
  @paths["[UTF8-SOFTBANK, IBM869]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :IBM869]]
  @paths["[UTF8-SOFTBANK, ISO-2022-JP]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[UTF8-SOFTBANK, ISO-2022-JP-KDDI]"] = [[:"UTF8-SOFTBANK", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-1]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-1"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-10]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-10"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-11]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-11"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-13]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-13"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-14]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-14"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-15]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-15"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-2]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-2"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-3]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-3"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-4]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-4"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-5]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-5"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-6]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-6"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-7]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-7"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-8]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-8"]]
  @paths["[UTF8-SOFTBANK, ISO-8859-9]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"ISO-8859-9"]]
  @paths["[UTF8-SOFTBANK, KOI8-R]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"KOI8-R"]]
  @paths["[UTF8-SOFTBANK, KOI8-U]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"KOI8-U"]]
  @paths["[UTF8-SOFTBANK, MACCROATIAN]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :MACCROATIAN]]
  @paths["[UTF8-SOFTBANK, MACCYRILLIC]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :MACCYRILLIC]]
  @paths["[UTF8-SOFTBANK, MACGREEK]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :MACGREEK]]
  @paths["[UTF8-SOFTBANK, MACICELAND]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :MACICELAND]]
  @paths["[UTF8-SOFTBANK, MACROMAN]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :MACROMAN]]
  @paths["[UTF8-SOFTBANK, MACROMANIA]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :MACROMANIA]]
  @paths["[UTF8-SOFTBANK, MACTURKISH]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :MACTURKISH]]
  @paths["[UTF8-SOFTBANK, MACUKRAINE]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :MACUKRAINE]]
  @paths["[UTF8-SOFTBANK, SHIFT_JIS]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :SHIFT_JIS]]
  @paths["[UTF8-SOFTBANK, SJIS-DOCOMO]"] = [[:"UTF8-SOFTBANK", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[UTF8-SOFTBANK, SJIS-KDDI]"] = [[:"UTF8-SOFTBANK", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[UTF8-SOFTBANK, SJIS-SOFTBANK]"] = [[:"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[UTF8-SOFTBANK, STATELESS-ISO-2022-JP]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[UTF8-SOFTBANK, STATELESS-ISO-2022-JP-KDDI]"] = [[:"UTF8-SOFTBANK", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[UTF8-SOFTBANK, TIS-620]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"TIS-620"]]
  @paths["[UTF8-SOFTBANK, US-ASCII]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"US-ASCII"]]
  @paths["[UTF8-SOFTBANK, UTF-16]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"UTF-16"]]
  @paths["[UTF8-SOFTBANK, UTF-16BE]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"UTF-16BE"]]
  @paths["[UTF8-SOFTBANK, UTF-16LE]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"UTF-16LE"]]
  @paths["[UTF8-SOFTBANK, UTF-32]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"UTF-32"]]
  @paths["[UTF8-SOFTBANK, UTF-32BE]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"UTF-32BE"]]
  @paths["[UTF8-SOFTBANK, UTF-32LE]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"UTF-32LE"]]
  @paths["[UTF8-SOFTBANK, UTF-8]"] = [[:"UTF8-SOFTBANK", :"UTF-8"]]
  @paths["[UTF8-SOFTBANK, UTF8-DOCOMO]"] = [[:"UTF8-SOFTBANK", :"UTF8-DOCOMO"]]
  @paths["[UTF8-SOFTBANK, UTF8-KDDI]"] = [[:"UTF8-SOFTBANK", :"UTF8-KDDI"]]
  @paths["[UTF8-SOFTBANK, UTF8-MAC]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"UTF8-MAC"]]
  @paths["[UTF8-SOFTBANK, WINDOWS-1250]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[UTF8-SOFTBANK, WINDOWS-1251]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[UTF8-SOFTBANK, WINDOWS-1252]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[UTF8-SOFTBANK, WINDOWS-1253]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[UTF8-SOFTBANK, WINDOWS-1254]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[UTF8-SOFTBANK, WINDOWS-1255]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[UTF8-SOFTBANK, WINDOWS-1256]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[UTF8-SOFTBANK, WINDOWS-1257]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[UTF8-SOFTBANK, WINDOWS-31J]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[UTF8-SOFTBANK, WINDOWS-874]"] = [[:"UTF8-SOFTBANK", :"UTF-8", :"WINDOWS-874"]]
  @paths["[WINDOWS-1250, ASCII-8BIT]"] = [[:"WINDOWS-1250", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[WINDOWS-1250, BIG5]"] = [[:"WINDOWS-1250", :"UTF-8", :BIG5]]
  @paths["[WINDOWS-1250, BIG5-HKSCS]"] = [[:"WINDOWS-1250", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[WINDOWS-1250, BIG5-UAO]"] = [[:"WINDOWS-1250", :"UTF-8", :"BIG5-UAO"]]
  @paths["[WINDOWS-1250, CP50220]"] = [[:"WINDOWS-1250", :"UTF-8", :CP51932, :CP50220]]
  @paths["[WINDOWS-1250, CP50221]"] = [[:"WINDOWS-1250", :"UTF-8", :CP51932, :CP50221]]
  @paths["[WINDOWS-1250, CP51932]"] = [[:"WINDOWS-1250", :"UTF-8", :CP51932]]
  @paths["[WINDOWS-1250, CP850]"] = [[:"WINDOWS-1250", :"UTF-8", :CP850]]
  @paths["[WINDOWS-1250, CP852]"] = [[:"WINDOWS-1250", :"UTF-8", :CP852]]
  @paths["[WINDOWS-1250, CP855]"] = [[:"WINDOWS-1250", :"UTF-8", :CP855]]
  @paths["[WINDOWS-1250, CP949]"] = [[:"WINDOWS-1250", :"UTF-8", :CP949]]
  @paths["[WINDOWS-1250, CP950]"] = [[:"WINDOWS-1250", :"UTF-8", :CP950]]
  @paths["[WINDOWS-1250, CP951]"] = [[:"WINDOWS-1250", :"UTF-8", :CP951]]
  @paths["[WINDOWS-1250, EUC-JP]"] = [[:"WINDOWS-1250", :"UTF-8", :"EUC-JP"]]
  @paths["[WINDOWS-1250, EUC-KR]"] = [[:"WINDOWS-1250", :"UTF-8", :"EUC-KR"]]
  @paths["[WINDOWS-1250, EUCJP-MS]"] = [[:"WINDOWS-1250", :"UTF-8", :"EUCJP-MS"]]
  @paths["[WINDOWS-1250, GB12345]"] = [[:"WINDOWS-1250", :"UTF-8", :GB12345]]
  @paths["[WINDOWS-1250, GB18030]"] = [[:"WINDOWS-1250", :"UTF-8", :GB18030]]
  @paths["[WINDOWS-1250, GB2312]"] = [[:"WINDOWS-1250", :"UTF-8", :GB2312]]
  @paths["[WINDOWS-1250, GBK]"] = [[:"WINDOWS-1250", :"UTF-8", :GBK]]
  @paths["[WINDOWS-1250, IBM437]"] = [[:"WINDOWS-1250", :"UTF-8", :IBM437]]
  @paths["[WINDOWS-1250, IBM737]"] = [[:"WINDOWS-1250", :"UTF-8", :IBM737]]
  @paths["[WINDOWS-1250, IBM775]"] = [[:"WINDOWS-1250", :"UTF-8", :IBM775]]
  @paths["[WINDOWS-1250, IBM852]"] = [[:"WINDOWS-1250", :"UTF-8", :IBM852]]
  @paths["[WINDOWS-1250, IBM855]"] = [[:"WINDOWS-1250", :"UTF-8", :IBM855]]
  @paths["[WINDOWS-1250, IBM857]"] = [[:"WINDOWS-1250", :"UTF-8", :IBM857]]
  @paths["[WINDOWS-1250, IBM860]"] = [[:"WINDOWS-1250", :"UTF-8", :IBM860]]
  @paths["[WINDOWS-1250, IBM861]"] = [[:"WINDOWS-1250", :"UTF-8", :IBM861]]
  @paths["[WINDOWS-1250, IBM862]"] = [[:"WINDOWS-1250", :"UTF-8", :IBM862]]
  @paths["[WINDOWS-1250, IBM863]"] = [[:"WINDOWS-1250", :"UTF-8", :IBM863]]
  @paths["[WINDOWS-1250, IBM865]"] = [[:"WINDOWS-1250", :"UTF-8", :IBM865]]
  @paths["[WINDOWS-1250, IBM866]"] = [[:"WINDOWS-1250", :"UTF-8", :IBM866]]
  @paths["[WINDOWS-1250, IBM869]"] = [[:"WINDOWS-1250", :"UTF-8", :IBM869]]
  @paths["[WINDOWS-1250, ISO-2022-JP]"] = [[:"WINDOWS-1250", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[WINDOWS-1250, ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1250, ISO-8859-1]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-1"]]
  @paths["[WINDOWS-1250, ISO-8859-10]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-10"]]
  @paths["[WINDOWS-1250, ISO-8859-11]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-11"]]
  @paths["[WINDOWS-1250, ISO-8859-13]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-13"]]
  @paths["[WINDOWS-1250, ISO-8859-14]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-14"]]
  @paths["[WINDOWS-1250, ISO-8859-15]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-15"]]
  @paths["[WINDOWS-1250, ISO-8859-2]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-2"]]
  @paths["[WINDOWS-1250, ISO-8859-3]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-3"]]
  @paths["[WINDOWS-1250, ISO-8859-4]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-4"]]
  @paths["[WINDOWS-1250, ISO-8859-5]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-5"]]
  @paths["[WINDOWS-1250, ISO-8859-6]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-6"]]
  @paths["[WINDOWS-1250, ISO-8859-7]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-7"]]
  @paths["[WINDOWS-1250, ISO-8859-8]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-8"]]
  @paths["[WINDOWS-1250, ISO-8859-9]"] = [[:"WINDOWS-1250", :"UTF-8", :"ISO-8859-9"]]
  @paths["[WINDOWS-1250, KOI8-R]"] = [[:"WINDOWS-1250", :"UTF-8", :"KOI8-R"]]
  @paths["[WINDOWS-1250, KOI8-U]"] = [[:"WINDOWS-1250", :"UTF-8", :"KOI8-U"]]
  @paths["[WINDOWS-1250, MACCROATIAN]"] = [[:"WINDOWS-1250", :"UTF-8", :MACCROATIAN]]
  @paths["[WINDOWS-1250, MACCYRILLIC]"] = [[:"WINDOWS-1250", :"UTF-8", :MACCYRILLIC]]
  @paths["[WINDOWS-1250, MACGREEK]"] = [[:"WINDOWS-1250", :"UTF-8", :MACGREEK]]
  @paths["[WINDOWS-1250, MACICELAND]"] = [[:"WINDOWS-1250", :"UTF-8", :MACICELAND]]
  @paths["[WINDOWS-1250, MACROMAN]"] = [[:"WINDOWS-1250", :"UTF-8", :MACROMAN]]
  @paths["[WINDOWS-1250, MACROMANIA]"] = [[:"WINDOWS-1250", :"UTF-8", :MACROMANIA]]
  @paths["[WINDOWS-1250, MACTURKISH]"] = [[:"WINDOWS-1250", :"UTF-8", :MACTURKISH]]
  @paths["[WINDOWS-1250, MACUKRAINE]"] = [[:"WINDOWS-1250", :"UTF-8", :MACUKRAINE]]
  @paths["[WINDOWS-1250, SHIFT_JIS]"] = [[:"WINDOWS-1250", :"UTF-8", :SHIFT_JIS]]
  @paths["[WINDOWS-1250, SJIS-DOCOMO]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[WINDOWS-1250, SJIS-KDDI]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[WINDOWS-1250, SJIS-SOFTBANK]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[WINDOWS-1250, STATELESS-ISO-2022-JP]"] = [[:"WINDOWS-1250", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[WINDOWS-1250, STATELESS-ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1250, TIS-620]"] = [[:"WINDOWS-1250", :"UTF-8", :"TIS-620"]]
  @paths["[WINDOWS-1250, US-ASCII]"] = [[:"WINDOWS-1250", :"UTF-8", :"US-ASCII"]]
  @paths["[WINDOWS-1250, UTF-16]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF-16"]]
  @paths["[WINDOWS-1250, UTF-16BE]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF-16BE"]]
  @paths["[WINDOWS-1250, UTF-16LE]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF-16LE"]]
  @paths["[WINDOWS-1250, UTF-32]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF-32"]]
  @paths["[WINDOWS-1250, UTF-32BE]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF-32BE"]]
  @paths["[WINDOWS-1250, UTF-32LE]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF-32LE"]]
  @paths["[WINDOWS-1250, UTF-8]"] = [[:"WINDOWS-1250", :"UTF-8"]]
  @paths["[WINDOWS-1250, UTF8-DOCOMO]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[WINDOWS-1250, UTF8-KDDI]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[WINDOWS-1250, UTF8-MAC]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF8-MAC"]]
  @paths["[WINDOWS-1250, UTF8-SOFTBANK]"] = [[:"WINDOWS-1250", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[WINDOWS-1250, WINDOWS-1251]"] = [[:"WINDOWS-1250", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[WINDOWS-1250, WINDOWS-1252]"] = [[:"WINDOWS-1250", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[WINDOWS-1250, WINDOWS-1253]"] = [[:"WINDOWS-1250", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[WINDOWS-1250, WINDOWS-1254]"] = [[:"WINDOWS-1250", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[WINDOWS-1250, WINDOWS-1255]"] = [[:"WINDOWS-1250", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[WINDOWS-1250, WINDOWS-1256]"] = [[:"WINDOWS-1250", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[WINDOWS-1250, WINDOWS-1257]"] = [[:"WINDOWS-1250", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[WINDOWS-1250, WINDOWS-31J]"] = [[:"WINDOWS-1250", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[WINDOWS-1250, WINDOWS-874]"] = [[:"WINDOWS-1250", :"UTF-8", :"WINDOWS-874"]]
  @paths["[WINDOWS-1251, ASCII-8BIT]"] = [[:"WINDOWS-1251", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[WINDOWS-1251, BIG5]"] = [[:"WINDOWS-1251", :"UTF-8", :BIG5]]
  @paths["[WINDOWS-1251, BIG5-HKSCS]"] = [[:"WINDOWS-1251", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[WINDOWS-1251, BIG5-UAO]"] = [[:"WINDOWS-1251", :"UTF-8", :"BIG5-UAO"]]
  @paths["[WINDOWS-1251, CP50220]"] = [[:"WINDOWS-1251", :"UTF-8", :CP51932, :CP50220]]
  @paths["[WINDOWS-1251, CP50221]"] = [[:"WINDOWS-1251", :"UTF-8", :CP51932, :CP50221]]
  @paths["[WINDOWS-1251, CP51932]"] = [[:"WINDOWS-1251", :"UTF-8", :CP51932]]
  @paths["[WINDOWS-1251, CP850]"] = [[:"WINDOWS-1251", :"UTF-8", :CP850]]
  @paths["[WINDOWS-1251, CP852]"] = [[:"WINDOWS-1251", :"UTF-8", :CP852]]
  @paths["[WINDOWS-1251, CP855]"] = [[:"WINDOWS-1251", :"UTF-8", :CP855]]
  @paths["[WINDOWS-1251, CP949]"] = [[:"WINDOWS-1251", :"UTF-8", :CP949]]
  @paths["[WINDOWS-1251, CP950]"] = [[:"WINDOWS-1251", :"UTF-8", :CP950]]
  @paths["[WINDOWS-1251, CP951]"] = [[:"WINDOWS-1251", :"UTF-8", :CP951]]
  @paths["[WINDOWS-1251, EUC-JP]"] = [[:"WINDOWS-1251", :"UTF-8", :"EUC-JP"]]
  @paths["[WINDOWS-1251, EUC-KR]"] = [[:"WINDOWS-1251", :"UTF-8", :"EUC-KR"]]
  @paths["[WINDOWS-1251, EUCJP-MS]"] = [[:"WINDOWS-1251", :"UTF-8", :"EUCJP-MS"]]
  @paths["[WINDOWS-1251, GB12345]"] = [[:"WINDOWS-1251", :"UTF-8", :GB12345]]
  @paths["[WINDOWS-1251, GB18030]"] = [[:"WINDOWS-1251", :"UTF-8", :GB18030]]
  @paths["[WINDOWS-1251, GB2312]"] = [[:"WINDOWS-1251", :"UTF-8", :GB2312]]
  @paths["[WINDOWS-1251, GBK]"] = [[:"WINDOWS-1251", :"UTF-8", :GBK]]
  @paths["[WINDOWS-1251, IBM437]"] = [[:"WINDOWS-1251", :"UTF-8", :IBM437]]
  @paths["[WINDOWS-1251, IBM737]"] = [[:"WINDOWS-1251", :"UTF-8", :IBM737]]
  @paths["[WINDOWS-1251, IBM775]"] = [[:"WINDOWS-1251", :"UTF-8", :IBM775]]
  @paths["[WINDOWS-1251, IBM852]"] = [[:"WINDOWS-1251", :"UTF-8", :IBM852]]
  @paths["[WINDOWS-1251, IBM855]"] = [[:"WINDOWS-1251", :"UTF-8", :IBM855]]
  @paths["[WINDOWS-1251, IBM857]"] = [[:"WINDOWS-1251", :"UTF-8", :IBM857]]
  @paths["[WINDOWS-1251, IBM860]"] = [[:"WINDOWS-1251", :"UTF-8", :IBM860]]
  @paths["[WINDOWS-1251, IBM861]"] = [[:"WINDOWS-1251", :"UTF-8", :IBM861]]
  @paths["[WINDOWS-1251, IBM862]"] = [[:"WINDOWS-1251", :"UTF-8", :IBM862]]
  @paths["[WINDOWS-1251, IBM863]"] = [[:"WINDOWS-1251", :"UTF-8", :IBM863]]
  @paths["[WINDOWS-1251, IBM865]"] = [[:"WINDOWS-1251", :"UTF-8", :IBM865]]
  @paths["[WINDOWS-1251, IBM866]"] = [[:"WINDOWS-1251", :"UTF-8", :IBM866]]
  @paths["[WINDOWS-1251, IBM869]"] = [[:"WINDOWS-1251", :"UTF-8", :IBM869]]
  @paths["[WINDOWS-1251, ISO-2022-JP]"] = [[:"WINDOWS-1251", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[WINDOWS-1251, ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1251, ISO-8859-1]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-1"]]
  @paths["[WINDOWS-1251, ISO-8859-10]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-10"]]
  @paths["[WINDOWS-1251, ISO-8859-11]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-11"]]
  @paths["[WINDOWS-1251, ISO-8859-13]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-13"]]
  @paths["[WINDOWS-1251, ISO-8859-14]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-14"]]
  @paths["[WINDOWS-1251, ISO-8859-15]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-15"]]
  @paths["[WINDOWS-1251, ISO-8859-2]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-2"]]
  @paths["[WINDOWS-1251, ISO-8859-3]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-3"]]
  @paths["[WINDOWS-1251, ISO-8859-4]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-4"]]
  @paths["[WINDOWS-1251, ISO-8859-5]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-5"]]
  @paths["[WINDOWS-1251, ISO-8859-6]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-6"]]
  @paths["[WINDOWS-1251, ISO-8859-7]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-7"]]
  @paths["[WINDOWS-1251, ISO-8859-8]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-8"]]
  @paths["[WINDOWS-1251, ISO-8859-9]"] = [[:"WINDOWS-1251", :"UTF-8", :"ISO-8859-9"]]
  @paths["[WINDOWS-1251, KOI8-R]"] = [[:"WINDOWS-1251", :"UTF-8", :"KOI8-R"]]
  @paths["[WINDOWS-1251, KOI8-U]"] = [[:"WINDOWS-1251", :"UTF-8", :"KOI8-U"]]
  @paths["[WINDOWS-1251, MACCROATIAN]"] = [[:"WINDOWS-1251", :"UTF-8", :MACCROATIAN]]
  @paths["[WINDOWS-1251, MACCYRILLIC]"] = [[:"WINDOWS-1251", :"UTF-8", :MACCYRILLIC]]
  @paths["[WINDOWS-1251, MACGREEK]"] = [[:"WINDOWS-1251", :"UTF-8", :MACGREEK]]
  @paths["[WINDOWS-1251, MACICELAND]"] = [[:"WINDOWS-1251", :"UTF-8", :MACICELAND]]
  @paths["[WINDOWS-1251, MACROMAN]"] = [[:"WINDOWS-1251", :"UTF-8", :MACROMAN]]
  @paths["[WINDOWS-1251, MACROMANIA]"] = [[:"WINDOWS-1251", :"UTF-8", :MACROMANIA]]
  @paths["[WINDOWS-1251, MACTURKISH]"] = [[:"WINDOWS-1251", :"UTF-8", :MACTURKISH]]
  @paths["[WINDOWS-1251, MACUKRAINE]"] = [[:"WINDOWS-1251", :"UTF-8", :MACUKRAINE]]
  @paths["[WINDOWS-1251, SHIFT_JIS]"] = [[:"WINDOWS-1251", :"UTF-8", :SHIFT_JIS]]
  @paths["[WINDOWS-1251, SJIS-DOCOMO]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[WINDOWS-1251, SJIS-KDDI]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[WINDOWS-1251, SJIS-SOFTBANK]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[WINDOWS-1251, STATELESS-ISO-2022-JP]"] = [[:"WINDOWS-1251", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[WINDOWS-1251, STATELESS-ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1251, TIS-620]"] = [[:"WINDOWS-1251", :"UTF-8", :"TIS-620"]]
  @paths["[WINDOWS-1251, US-ASCII]"] = [[:"WINDOWS-1251", :"UTF-8", :"US-ASCII"]]
  @paths["[WINDOWS-1251, UTF-16]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF-16"]]
  @paths["[WINDOWS-1251, UTF-16BE]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF-16BE"]]
  @paths["[WINDOWS-1251, UTF-16LE]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF-16LE"]]
  @paths["[WINDOWS-1251, UTF-32]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF-32"]]
  @paths["[WINDOWS-1251, UTF-32BE]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF-32BE"]]
  @paths["[WINDOWS-1251, UTF-32LE]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF-32LE"]]
  @paths["[WINDOWS-1251, UTF-8]"] = [[:"WINDOWS-1251", :"UTF-8"]]
  @paths["[WINDOWS-1251, UTF8-DOCOMO]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[WINDOWS-1251, UTF8-KDDI]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[WINDOWS-1251, UTF8-MAC]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF8-MAC"]]
  @paths["[WINDOWS-1251, UTF8-SOFTBANK]"] = [[:"WINDOWS-1251", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[WINDOWS-1251, WINDOWS-1250]"] = [[:"WINDOWS-1251", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[WINDOWS-1251, WINDOWS-1252]"] = [[:"WINDOWS-1251", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[WINDOWS-1251, WINDOWS-1253]"] = [[:"WINDOWS-1251", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[WINDOWS-1251, WINDOWS-1254]"] = [[:"WINDOWS-1251", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[WINDOWS-1251, WINDOWS-1255]"] = [[:"WINDOWS-1251", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[WINDOWS-1251, WINDOWS-1256]"] = [[:"WINDOWS-1251", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[WINDOWS-1251, WINDOWS-1257]"] = [[:"WINDOWS-1251", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[WINDOWS-1251, WINDOWS-31J]"] = [[:"WINDOWS-1251", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[WINDOWS-1251, WINDOWS-874]"] = [[:"WINDOWS-1251", :"UTF-8", :"WINDOWS-874"]]
  @paths["[WINDOWS-1252, ASCII-8BIT]"] = [[:"WINDOWS-1252", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[WINDOWS-1252, BIG5]"] = [[:"WINDOWS-1252", :"UTF-8", :BIG5]]
  @paths["[WINDOWS-1252, BIG5-HKSCS]"] = [[:"WINDOWS-1252", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[WINDOWS-1252, BIG5-UAO]"] = [[:"WINDOWS-1252", :"UTF-8", :"BIG5-UAO"]]
  @paths["[WINDOWS-1252, CP50220]"] = [[:"WINDOWS-1252", :"UTF-8", :CP51932, :CP50220]]
  @paths["[WINDOWS-1252, CP50221]"] = [[:"WINDOWS-1252", :"UTF-8", :CP51932, :CP50221]]
  @paths["[WINDOWS-1252, CP51932]"] = [[:"WINDOWS-1252", :"UTF-8", :CP51932]]
  @paths["[WINDOWS-1252, CP850]"] = [[:"WINDOWS-1252", :"UTF-8", :CP850]]
  @paths["[WINDOWS-1252, CP852]"] = [[:"WINDOWS-1252", :"UTF-8", :CP852]]
  @paths["[WINDOWS-1252, CP855]"] = [[:"WINDOWS-1252", :"UTF-8", :CP855]]
  @paths["[WINDOWS-1252, CP949]"] = [[:"WINDOWS-1252", :"UTF-8", :CP949]]
  @paths["[WINDOWS-1252, CP950]"] = [[:"WINDOWS-1252", :"UTF-8", :CP950]]
  @paths["[WINDOWS-1252, CP951]"] = [[:"WINDOWS-1252", :"UTF-8", :CP951]]
  @paths["[WINDOWS-1252, EUC-JP]"] = [[:"WINDOWS-1252", :"UTF-8", :"EUC-JP"]]
  @paths["[WINDOWS-1252, EUC-KR]"] = [[:"WINDOWS-1252", :"UTF-8", :"EUC-KR"]]
  @paths["[WINDOWS-1252, EUCJP-MS]"] = [[:"WINDOWS-1252", :"UTF-8", :"EUCJP-MS"]]
  @paths["[WINDOWS-1252, GB12345]"] = [[:"WINDOWS-1252", :"UTF-8", :GB12345]]
  @paths["[WINDOWS-1252, GB18030]"] = [[:"WINDOWS-1252", :"UTF-8", :GB18030]]
  @paths["[WINDOWS-1252, GB2312]"] = [[:"WINDOWS-1252", :"UTF-8", :GB2312]]
  @paths["[WINDOWS-1252, GBK]"] = [[:"WINDOWS-1252", :"UTF-8", :GBK]]
  @paths["[WINDOWS-1252, IBM437]"] = [[:"WINDOWS-1252", :"UTF-8", :IBM437]]
  @paths["[WINDOWS-1252, IBM737]"] = [[:"WINDOWS-1252", :"UTF-8", :IBM737]]
  @paths["[WINDOWS-1252, IBM775]"] = [[:"WINDOWS-1252", :"UTF-8", :IBM775]]
  @paths["[WINDOWS-1252, IBM852]"] = [[:"WINDOWS-1252", :"UTF-8", :IBM852]]
  @paths["[WINDOWS-1252, IBM855]"] = [[:"WINDOWS-1252", :"UTF-8", :IBM855]]
  @paths["[WINDOWS-1252, IBM857]"] = [[:"WINDOWS-1252", :"UTF-8", :IBM857]]
  @paths["[WINDOWS-1252, IBM860]"] = [[:"WINDOWS-1252", :"UTF-8", :IBM860]]
  @paths["[WINDOWS-1252, IBM861]"] = [[:"WINDOWS-1252", :"UTF-8", :IBM861]]
  @paths["[WINDOWS-1252, IBM862]"] = [[:"WINDOWS-1252", :"UTF-8", :IBM862]]
  @paths["[WINDOWS-1252, IBM863]"] = [[:"WINDOWS-1252", :"UTF-8", :IBM863]]
  @paths["[WINDOWS-1252, IBM865]"] = [[:"WINDOWS-1252", :"UTF-8", :IBM865]]
  @paths["[WINDOWS-1252, IBM866]"] = [[:"WINDOWS-1252", :"UTF-8", :IBM866]]
  @paths["[WINDOWS-1252, IBM869]"] = [[:"WINDOWS-1252", :"UTF-8", :IBM869]]
  @paths["[WINDOWS-1252, ISO-2022-JP]"] = [[:"WINDOWS-1252", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[WINDOWS-1252, ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1252, ISO-8859-1]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-1"]]
  @paths["[WINDOWS-1252, ISO-8859-10]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-10"]]
  @paths["[WINDOWS-1252, ISO-8859-11]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-11"]]
  @paths["[WINDOWS-1252, ISO-8859-13]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-13"]]
  @paths["[WINDOWS-1252, ISO-8859-14]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-14"]]
  @paths["[WINDOWS-1252, ISO-8859-15]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-15"]]
  @paths["[WINDOWS-1252, ISO-8859-2]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-2"]]
  @paths["[WINDOWS-1252, ISO-8859-3]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-3"]]
  @paths["[WINDOWS-1252, ISO-8859-4]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-4"]]
  @paths["[WINDOWS-1252, ISO-8859-5]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-5"]]
  @paths["[WINDOWS-1252, ISO-8859-6]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-6"]]
  @paths["[WINDOWS-1252, ISO-8859-7]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-7"]]
  @paths["[WINDOWS-1252, ISO-8859-8]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-8"]]
  @paths["[WINDOWS-1252, ISO-8859-9]"] = [[:"WINDOWS-1252", :"UTF-8", :"ISO-8859-9"]]
  @paths["[WINDOWS-1252, KOI8-R]"] = [[:"WINDOWS-1252", :"UTF-8", :"KOI8-R"]]
  @paths["[WINDOWS-1252, KOI8-U]"] = [[:"WINDOWS-1252", :"UTF-8", :"KOI8-U"]]
  @paths["[WINDOWS-1252, MACCROATIAN]"] = [[:"WINDOWS-1252", :"UTF-8", :MACCROATIAN]]
  @paths["[WINDOWS-1252, MACCYRILLIC]"] = [[:"WINDOWS-1252", :"UTF-8", :MACCYRILLIC]]
  @paths["[WINDOWS-1252, MACGREEK]"] = [[:"WINDOWS-1252", :"UTF-8", :MACGREEK]]
  @paths["[WINDOWS-1252, MACICELAND]"] = [[:"WINDOWS-1252", :"UTF-8", :MACICELAND]]
  @paths["[WINDOWS-1252, MACROMAN]"] = [[:"WINDOWS-1252", :"UTF-8", :MACROMAN]]
  @paths["[WINDOWS-1252, MACROMANIA]"] = [[:"WINDOWS-1252", :"UTF-8", :MACROMANIA]]
  @paths["[WINDOWS-1252, MACTURKISH]"] = [[:"WINDOWS-1252", :"UTF-8", :MACTURKISH]]
  @paths["[WINDOWS-1252, MACUKRAINE]"] = [[:"WINDOWS-1252", :"UTF-8", :MACUKRAINE]]
  @paths["[WINDOWS-1252, SHIFT_JIS]"] = [[:"WINDOWS-1252", :"UTF-8", :SHIFT_JIS]]
  @paths["[WINDOWS-1252, SJIS-DOCOMO]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[WINDOWS-1252, SJIS-KDDI]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[WINDOWS-1252, SJIS-SOFTBANK]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[WINDOWS-1252, STATELESS-ISO-2022-JP]"] = [[:"WINDOWS-1252", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[WINDOWS-1252, STATELESS-ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1252, TIS-620]"] = [[:"WINDOWS-1252", :"UTF-8", :"TIS-620"]]
  @paths["[WINDOWS-1252, US-ASCII]"] = [[:"WINDOWS-1252", :"UTF-8", :"US-ASCII"]]
  @paths["[WINDOWS-1252, UTF-16]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF-16"]]
  @paths["[WINDOWS-1252, UTF-16BE]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF-16BE"]]
  @paths["[WINDOWS-1252, UTF-16LE]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF-16LE"]]
  @paths["[WINDOWS-1252, UTF-32]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF-32"]]
  @paths["[WINDOWS-1252, UTF-32BE]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF-32BE"]]
  @paths["[WINDOWS-1252, UTF-32LE]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF-32LE"]]
  @paths["[WINDOWS-1252, UTF-8]"] = [[:"WINDOWS-1252", :"UTF-8"]]
  @paths["[WINDOWS-1252, UTF8-DOCOMO]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[WINDOWS-1252, UTF8-KDDI]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[WINDOWS-1252, UTF8-MAC]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF8-MAC"]]
  @paths["[WINDOWS-1252, UTF8-SOFTBANK]"] = [[:"WINDOWS-1252", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[WINDOWS-1252, WINDOWS-1250]"] = [[:"WINDOWS-1252", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[WINDOWS-1252, WINDOWS-1251]"] = [[:"WINDOWS-1252", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[WINDOWS-1252, WINDOWS-1253]"] = [[:"WINDOWS-1252", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[WINDOWS-1252, WINDOWS-1254]"] = [[:"WINDOWS-1252", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[WINDOWS-1252, WINDOWS-1255]"] = [[:"WINDOWS-1252", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[WINDOWS-1252, WINDOWS-1256]"] = [[:"WINDOWS-1252", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[WINDOWS-1252, WINDOWS-1257]"] = [[:"WINDOWS-1252", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[WINDOWS-1252, WINDOWS-31J]"] = [[:"WINDOWS-1252", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[WINDOWS-1252, WINDOWS-874]"] = [[:"WINDOWS-1252", :"UTF-8", :"WINDOWS-874"]]
  @paths["[WINDOWS-1253, ASCII-8BIT]"] = [[:"WINDOWS-1253", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[WINDOWS-1253, BIG5]"] = [[:"WINDOWS-1253", :"UTF-8", :BIG5]]
  @paths["[WINDOWS-1253, BIG5-HKSCS]"] = [[:"WINDOWS-1253", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[WINDOWS-1253, BIG5-UAO]"] = [[:"WINDOWS-1253", :"UTF-8", :"BIG5-UAO"]]
  @paths["[WINDOWS-1253, CP50220]"] = [[:"WINDOWS-1253", :"UTF-8", :CP51932, :CP50220]]
  @paths["[WINDOWS-1253, CP50221]"] = [[:"WINDOWS-1253", :"UTF-8", :CP51932, :CP50221]]
  @paths["[WINDOWS-1253, CP51932]"] = [[:"WINDOWS-1253", :"UTF-8", :CP51932]]
  @paths["[WINDOWS-1253, CP850]"] = [[:"WINDOWS-1253", :"UTF-8", :CP850]]
  @paths["[WINDOWS-1253, CP852]"] = [[:"WINDOWS-1253", :"UTF-8", :CP852]]
  @paths["[WINDOWS-1253, CP855]"] = [[:"WINDOWS-1253", :"UTF-8", :CP855]]
  @paths["[WINDOWS-1253, CP949]"] = [[:"WINDOWS-1253", :"UTF-8", :CP949]]
  @paths["[WINDOWS-1253, CP950]"] = [[:"WINDOWS-1253", :"UTF-8", :CP950]]
  @paths["[WINDOWS-1253, CP951]"] = [[:"WINDOWS-1253", :"UTF-8", :CP951]]
  @paths["[WINDOWS-1253, EUC-JP]"] = [[:"WINDOWS-1253", :"UTF-8", :"EUC-JP"]]
  @paths["[WINDOWS-1253, EUC-KR]"] = [[:"WINDOWS-1253", :"UTF-8", :"EUC-KR"]]
  @paths["[WINDOWS-1253, EUCJP-MS]"] = [[:"WINDOWS-1253", :"UTF-8", :"EUCJP-MS"]]
  @paths["[WINDOWS-1253, GB12345]"] = [[:"WINDOWS-1253", :"UTF-8", :GB12345]]
  @paths["[WINDOWS-1253, GB18030]"] = [[:"WINDOWS-1253", :"UTF-8", :GB18030]]
  @paths["[WINDOWS-1253, GB2312]"] = [[:"WINDOWS-1253", :"UTF-8", :GB2312]]
  @paths["[WINDOWS-1253, GBK]"] = [[:"WINDOWS-1253", :"UTF-8", :GBK]]
  @paths["[WINDOWS-1253, IBM437]"] = [[:"WINDOWS-1253", :"UTF-8", :IBM437]]
  @paths["[WINDOWS-1253, IBM737]"] = [[:"WINDOWS-1253", :"UTF-8", :IBM737]]
  @paths["[WINDOWS-1253, IBM775]"] = [[:"WINDOWS-1253", :"UTF-8", :IBM775]]
  @paths["[WINDOWS-1253, IBM852]"] = [[:"WINDOWS-1253", :"UTF-8", :IBM852]]
  @paths["[WINDOWS-1253, IBM855]"] = [[:"WINDOWS-1253", :"UTF-8", :IBM855]]
  @paths["[WINDOWS-1253, IBM857]"] = [[:"WINDOWS-1253", :"UTF-8", :IBM857]]
  @paths["[WINDOWS-1253, IBM860]"] = [[:"WINDOWS-1253", :"UTF-8", :IBM860]]
  @paths["[WINDOWS-1253, IBM861]"] = [[:"WINDOWS-1253", :"UTF-8", :IBM861]]
  @paths["[WINDOWS-1253, IBM862]"] = [[:"WINDOWS-1253", :"UTF-8", :IBM862]]
  @paths["[WINDOWS-1253, IBM863]"] = [[:"WINDOWS-1253", :"UTF-8", :IBM863]]
  @paths["[WINDOWS-1253, IBM865]"] = [[:"WINDOWS-1253", :"UTF-8", :IBM865]]
  @paths["[WINDOWS-1253, IBM866]"] = [[:"WINDOWS-1253", :"UTF-8", :IBM866]]
  @paths["[WINDOWS-1253, IBM869]"] = [[:"WINDOWS-1253", :"UTF-8", :IBM869]]
  @paths["[WINDOWS-1253, ISO-2022-JP]"] = [[:"WINDOWS-1253", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[WINDOWS-1253, ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1253, ISO-8859-1]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-1"]]
  @paths["[WINDOWS-1253, ISO-8859-10]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-10"]]
  @paths["[WINDOWS-1253, ISO-8859-11]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-11"]]
  @paths["[WINDOWS-1253, ISO-8859-13]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-13"]]
  @paths["[WINDOWS-1253, ISO-8859-14]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-14"]]
  @paths["[WINDOWS-1253, ISO-8859-15]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-15"]]
  @paths["[WINDOWS-1253, ISO-8859-2]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-2"]]
  @paths["[WINDOWS-1253, ISO-8859-3]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-3"]]
  @paths["[WINDOWS-1253, ISO-8859-4]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-4"]]
  @paths["[WINDOWS-1253, ISO-8859-5]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-5"]]
  @paths["[WINDOWS-1253, ISO-8859-6]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-6"]]
  @paths["[WINDOWS-1253, ISO-8859-7]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-7"]]
  @paths["[WINDOWS-1253, ISO-8859-8]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-8"]]
  @paths["[WINDOWS-1253, ISO-8859-9]"] = [[:"WINDOWS-1253", :"UTF-8", :"ISO-8859-9"]]
  @paths["[WINDOWS-1253, KOI8-R]"] = [[:"WINDOWS-1253", :"UTF-8", :"KOI8-R"]]
  @paths["[WINDOWS-1253, KOI8-U]"] = [[:"WINDOWS-1253", :"UTF-8", :"KOI8-U"]]
  @paths["[WINDOWS-1253, MACCROATIAN]"] = [[:"WINDOWS-1253", :"UTF-8", :MACCROATIAN]]
  @paths["[WINDOWS-1253, MACCYRILLIC]"] = [[:"WINDOWS-1253", :"UTF-8", :MACCYRILLIC]]
  @paths["[WINDOWS-1253, MACGREEK]"] = [[:"WINDOWS-1253", :"UTF-8", :MACGREEK]]
  @paths["[WINDOWS-1253, MACICELAND]"] = [[:"WINDOWS-1253", :"UTF-8", :MACICELAND]]
  @paths["[WINDOWS-1253, MACROMAN]"] = [[:"WINDOWS-1253", :"UTF-8", :MACROMAN]]
  @paths["[WINDOWS-1253, MACROMANIA]"] = [[:"WINDOWS-1253", :"UTF-8", :MACROMANIA]]
  @paths["[WINDOWS-1253, MACTURKISH]"] = [[:"WINDOWS-1253", :"UTF-8", :MACTURKISH]]
  @paths["[WINDOWS-1253, MACUKRAINE]"] = [[:"WINDOWS-1253", :"UTF-8", :MACUKRAINE]]
  @paths["[WINDOWS-1253, SHIFT_JIS]"] = [[:"WINDOWS-1253", :"UTF-8", :SHIFT_JIS]]
  @paths["[WINDOWS-1253, SJIS-DOCOMO]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[WINDOWS-1253, SJIS-KDDI]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[WINDOWS-1253, SJIS-SOFTBANK]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[WINDOWS-1253, STATELESS-ISO-2022-JP]"] = [[:"WINDOWS-1253", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[WINDOWS-1253, STATELESS-ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1253, TIS-620]"] = [[:"WINDOWS-1253", :"UTF-8", :"TIS-620"]]
  @paths["[WINDOWS-1253, US-ASCII]"] = [[:"WINDOWS-1253", :"UTF-8", :"US-ASCII"]]
  @paths["[WINDOWS-1253, UTF-16]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF-16"]]
  @paths["[WINDOWS-1253, UTF-16BE]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF-16BE"]]
  @paths["[WINDOWS-1253, UTF-16LE]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF-16LE"]]
  @paths["[WINDOWS-1253, UTF-32]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF-32"]]
  @paths["[WINDOWS-1253, UTF-32BE]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF-32BE"]]
  @paths["[WINDOWS-1253, UTF-32LE]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF-32LE"]]
  @paths["[WINDOWS-1253, UTF-8]"] = [[:"WINDOWS-1253", :"UTF-8"]]
  @paths["[WINDOWS-1253, UTF8-DOCOMO]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[WINDOWS-1253, UTF8-KDDI]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[WINDOWS-1253, UTF8-MAC]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF8-MAC"]]
  @paths["[WINDOWS-1253, UTF8-SOFTBANK]"] = [[:"WINDOWS-1253", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[WINDOWS-1253, WINDOWS-1250]"] = [[:"WINDOWS-1253", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[WINDOWS-1253, WINDOWS-1251]"] = [[:"WINDOWS-1253", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[WINDOWS-1253, WINDOWS-1252]"] = [[:"WINDOWS-1253", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[WINDOWS-1253, WINDOWS-1254]"] = [[:"WINDOWS-1253", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[WINDOWS-1253, WINDOWS-1255]"] = [[:"WINDOWS-1253", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[WINDOWS-1253, WINDOWS-1256]"] = [[:"WINDOWS-1253", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[WINDOWS-1253, WINDOWS-1257]"] = [[:"WINDOWS-1253", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[WINDOWS-1253, WINDOWS-31J]"] = [[:"WINDOWS-1253", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[WINDOWS-1253, WINDOWS-874]"] = [[:"WINDOWS-1253", :"UTF-8", :"WINDOWS-874"]]
  @paths["[WINDOWS-1254, ASCII-8BIT]"] = [[:"WINDOWS-1254", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[WINDOWS-1254, BIG5]"] = [[:"WINDOWS-1254", :"UTF-8", :BIG5]]
  @paths["[WINDOWS-1254, BIG5-HKSCS]"] = [[:"WINDOWS-1254", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[WINDOWS-1254, BIG5-UAO]"] = [[:"WINDOWS-1254", :"UTF-8", :"BIG5-UAO"]]
  @paths["[WINDOWS-1254, CP50220]"] = [[:"WINDOWS-1254", :"UTF-8", :CP51932, :CP50220]]
  @paths["[WINDOWS-1254, CP50221]"] = [[:"WINDOWS-1254", :"UTF-8", :CP51932, :CP50221]]
  @paths["[WINDOWS-1254, CP51932]"] = [[:"WINDOWS-1254", :"UTF-8", :CP51932]]
  @paths["[WINDOWS-1254, CP850]"] = [[:"WINDOWS-1254", :"UTF-8", :CP850]]
  @paths["[WINDOWS-1254, CP852]"] = [[:"WINDOWS-1254", :"UTF-8", :CP852]]
  @paths["[WINDOWS-1254, CP855]"] = [[:"WINDOWS-1254", :"UTF-8", :CP855]]
  @paths["[WINDOWS-1254, CP949]"] = [[:"WINDOWS-1254", :"UTF-8", :CP949]]
  @paths["[WINDOWS-1254, CP950]"] = [[:"WINDOWS-1254", :"UTF-8", :CP950]]
  @paths["[WINDOWS-1254, CP951]"] = [[:"WINDOWS-1254", :"UTF-8", :CP951]]
  @paths["[WINDOWS-1254, EUC-JP]"] = [[:"WINDOWS-1254", :"UTF-8", :"EUC-JP"]]
  @paths["[WINDOWS-1254, EUC-KR]"] = [[:"WINDOWS-1254", :"UTF-8", :"EUC-KR"]]
  @paths["[WINDOWS-1254, EUCJP-MS]"] = [[:"WINDOWS-1254", :"UTF-8", :"EUCJP-MS"]]
  @paths["[WINDOWS-1254, GB12345]"] = [[:"WINDOWS-1254", :"UTF-8", :GB12345]]
  @paths["[WINDOWS-1254, GB18030]"] = [[:"WINDOWS-1254", :"UTF-8", :GB18030]]
  @paths["[WINDOWS-1254, GB2312]"] = [[:"WINDOWS-1254", :"UTF-8", :GB2312]]
  @paths["[WINDOWS-1254, GBK]"] = [[:"WINDOWS-1254", :"UTF-8", :GBK]]
  @paths["[WINDOWS-1254, IBM437]"] = [[:"WINDOWS-1254", :"UTF-8", :IBM437]]
  @paths["[WINDOWS-1254, IBM737]"] = [[:"WINDOWS-1254", :"UTF-8", :IBM737]]
  @paths["[WINDOWS-1254, IBM775]"] = [[:"WINDOWS-1254", :"UTF-8", :IBM775]]
  @paths["[WINDOWS-1254, IBM852]"] = [[:"WINDOWS-1254", :"UTF-8", :IBM852]]
  @paths["[WINDOWS-1254, IBM855]"] = [[:"WINDOWS-1254", :"UTF-8", :IBM855]]
  @paths["[WINDOWS-1254, IBM857]"] = [[:"WINDOWS-1254", :"UTF-8", :IBM857]]
  @paths["[WINDOWS-1254, IBM860]"] = [[:"WINDOWS-1254", :"UTF-8", :IBM860]]
  @paths["[WINDOWS-1254, IBM861]"] = [[:"WINDOWS-1254", :"UTF-8", :IBM861]]
  @paths["[WINDOWS-1254, IBM862]"] = [[:"WINDOWS-1254", :"UTF-8", :IBM862]]
  @paths["[WINDOWS-1254, IBM863]"] = [[:"WINDOWS-1254", :"UTF-8", :IBM863]]
  @paths["[WINDOWS-1254, IBM865]"] = [[:"WINDOWS-1254", :"UTF-8", :IBM865]]
  @paths["[WINDOWS-1254, IBM866]"] = [[:"WINDOWS-1254", :"UTF-8", :IBM866]]
  @paths["[WINDOWS-1254, IBM869]"] = [[:"WINDOWS-1254", :"UTF-8", :IBM869]]
  @paths["[WINDOWS-1254, ISO-2022-JP]"] = [[:"WINDOWS-1254", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[WINDOWS-1254, ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1254, ISO-8859-1]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-1"]]
  @paths["[WINDOWS-1254, ISO-8859-10]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-10"]]
  @paths["[WINDOWS-1254, ISO-8859-11]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-11"]]
  @paths["[WINDOWS-1254, ISO-8859-13]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-13"]]
  @paths["[WINDOWS-1254, ISO-8859-14]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-14"]]
  @paths["[WINDOWS-1254, ISO-8859-15]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-15"]]
  @paths["[WINDOWS-1254, ISO-8859-2]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-2"]]
  @paths["[WINDOWS-1254, ISO-8859-3]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-3"]]
  @paths["[WINDOWS-1254, ISO-8859-4]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-4"]]
  @paths["[WINDOWS-1254, ISO-8859-5]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-5"]]
  @paths["[WINDOWS-1254, ISO-8859-6]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-6"]]
  @paths["[WINDOWS-1254, ISO-8859-7]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-7"]]
  @paths["[WINDOWS-1254, ISO-8859-8]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-8"]]
  @paths["[WINDOWS-1254, ISO-8859-9]"] = [[:"WINDOWS-1254", :"UTF-8", :"ISO-8859-9"]]
  @paths["[WINDOWS-1254, KOI8-R]"] = [[:"WINDOWS-1254", :"UTF-8", :"KOI8-R"]]
  @paths["[WINDOWS-1254, KOI8-U]"] = [[:"WINDOWS-1254", :"UTF-8", :"KOI8-U"]]
  @paths["[WINDOWS-1254, MACCROATIAN]"] = [[:"WINDOWS-1254", :"UTF-8", :MACCROATIAN]]
  @paths["[WINDOWS-1254, MACCYRILLIC]"] = [[:"WINDOWS-1254", :"UTF-8", :MACCYRILLIC]]
  @paths["[WINDOWS-1254, MACGREEK]"] = [[:"WINDOWS-1254", :"UTF-8", :MACGREEK]]
  @paths["[WINDOWS-1254, MACICELAND]"] = [[:"WINDOWS-1254", :"UTF-8", :MACICELAND]]
  @paths["[WINDOWS-1254, MACROMAN]"] = [[:"WINDOWS-1254", :"UTF-8", :MACROMAN]]
  @paths["[WINDOWS-1254, MACROMANIA]"] = [[:"WINDOWS-1254", :"UTF-8", :MACROMANIA]]
  @paths["[WINDOWS-1254, MACTURKISH]"] = [[:"WINDOWS-1254", :"UTF-8", :MACTURKISH]]
  @paths["[WINDOWS-1254, MACUKRAINE]"] = [[:"WINDOWS-1254", :"UTF-8", :MACUKRAINE]]
  @paths["[WINDOWS-1254, SHIFT_JIS]"] = [[:"WINDOWS-1254", :"UTF-8", :SHIFT_JIS]]
  @paths["[WINDOWS-1254, SJIS-DOCOMO]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[WINDOWS-1254, SJIS-KDDI]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[WINDOWS-1254, SJIS-SOFTBANK]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[WINDOWS-1254, STATELESS-ISO-2022-JP]"] = [[:"WINDOWS-1254", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[WINDOWS-1254, STATELESS-ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1254, TIS-620]"] = [[:"WINDOWS-1254", :"UTF-8", :"TIS-620"]]
  @paths["[WINDOWS-1254, US-ASCII]"] = [[:"WINDOWS-1254", :"UTF-8", :"US-ASCII"]]
  @paths["[WINDOWS-1254, UTF-16]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF-16"]]
  @paths["[WINDOWS-1254, UTF-16BE]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF-16BE"]]
  @paths["[WINDOWS-1254, UTF-16LE]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF-16LE"]]
  @paths["[WINDOWS-1254, UTF-32]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF-32"]]
  @paths["[WINDOWS-1254, UTF-32BE]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF-32BE"]]
  @paths["[WINDOWS-1254, UTF-32LE]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF-32LE"]]
  @paths["[WINDOWS-1254, UTF-8]"] = [[:"WINDOWS-1254", :"UTF-8"]]
  @paths["[WINDOWS-1254, UTF8-DOCOMO]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[WINDOWS-1254, UTF8-KDDI]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[WINDOWS-1254, UTF8-MAC]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF8-MAC"]]
  @paths["[WINDOWS-1254, UTF8-SOFTBANK]"] = [[:"WINDOWS-1254", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[WINDOWS-1254, WINDOWS-1250]"] = [[:"WINDOWS-1254", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[WINDOWS-1254, WINDOWS-1251]"] = [[:"WINDOWS-1254", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[WINDOWS-1254, WINDOWS-1252]"] = [[:"WINDOWS-1254", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[WINDOWS-1254, WINDOWS-1253]"] = [[:"WINDOWS-1254", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[WINDOWS-1254, WINDOWS-1255]"] = [[:"WINDOWS-1254", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[WINDOWS-1254, WINDOWS-1256]"] = [[:"WINDOWS-1254", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[WINDOWS-1254, WINDOWS-1257]"] = [[:"WINDOWS-1254", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[WINDOWS-1254, WINDOWS-31J]"] = [[:"WINDOWS-1254", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[WINDOWS-1254, WINDOWS-874]"] = [[:"WINDOWS-1254", :"UTF-8", :"WINDOWS-874"]]
  @paths["[WINDOWS-1255, ASCII-8BIT]"] = [[:"WINDOWS-1255", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[WINDOWS-1255, BIG5]"] = [[:"WINDOWS-1255", :"UTF-8", :BIG5]]
  @paths["[WINDOWS-1255, BIG5-HKSCS]"] = [[:"WINDOWS-1255", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[WINDOWS-1255, BIG5-UAO]"] = [[:"WINDOWS-1255", :"UTF-8", :"BIG5-UAO"]]
  @paths["[WINDOWS-1255, CP50220]"] = [[:"WINDOWS-1255", :"UTF-8", :CP51932, :CP50220]]
  @paths["[WINDOWS-1255, CP50221]"] = [[:"WINDOWS-1255", :"UTF-8", :CP51932, :CP50221]]
  @paths["[WINDOWS-1255, CP51932]"] = [[:"WINDOWS-1255", :"UTF-8", :CP51932]]
  @paths["[WINDOWS-1255, CP850]"] = [[:"WINDOWS-1255", :"UTF-8", :CP850]]
  @paths["[WINDOWS-1255, CP852]"] = [[:"WINDOWS-1255", :"UTF-8", :CP852]]
  @paths["[WINDOWS-1255, CP855]"] = [[:"WINDOWS-1255", :"UTF-8", :CP855]]
  @paths["[WINDOWS-1255, CP949]"] = [[:"WINDOWS-1255", :"UTF-8", :CP949]]
  @paths["[WINDOWS-1255, CP950]"] = [[:"WINDOWS-1255", :"UTF-8", :CP950]]
  @paths["[WINDOWS-1255, CP951]"] = [[:"WINDOWS-1255", :"UTF-8", :CP951]]
  @paths["[WINDOWS-1255, EUC-JP]"] = [[:"WINDOWS-1255", :"UTF-8", :"EUC-JP"]]
  @paths["[WINDOWS-1255, EUC-KR]"] = [[:"WINDOWS-1255", :"UTF-8", :"EUC-KR"]]
  @paths["[WINDOWS-1255, EUCJP-MS]"] = [[:"WINDOWS-1255", :"UTF-8", :"EUCJP-MS"]]
  @paths["[WINDOWS-1255, GB12345]"] = [[:"WINDOWS-1255", :"UTF-8", :GB12345]]
  @paths["[WINDOWS-1255, GB18030]"] = [[:"WINDOWS-1255", :"UTF-8", :GB18030]]
  @paths["[WINDOWS-1255, GB2312]"] = [[:"WINDOWS-1255", :"UTF-8", :GB2312]]
  @paths["[WINDOWS-1255, GBK]"] = [[:"WINDOWS-1255", :"UTF-8", :GBK]]
  @paths["[WINDOWS-1255, IBM437]"] = [[:"WINDOWS-1255", :"UTF-8", :IBM437]]
  @paths["[WINDOWS-1255, IBM737]"] = [[:"WINDOWS-1255", :"UTF-8", :IBM737]]
  @paths["[WINDOWS-1255, IBM775]"] = [[:"WINDOWS-1255", :"UTF-8", :IBM775]]
  @paths["[WINDOWS-1255, IBM852]"] = [[:"WINDOWS-1255", :"UTF-8", :IBM852]]
  @paths["[WINDOWS-1255, IBM855]"] = [[:"WINDOWS-1255", :"UTF-8", :IBM855]]
  @paths["[WINDOWS-1255, IBM857]"] = [[:"WINDOWS-1255", :"UTF-8", :IBM857]]
  @paths["[WINDOWS-1255, IBM860]"] = [[:"WINDOWS-1255", :"UTF-8", :IBM860]]
  @paths["[WINDOWS-1255, IBM861]"] = [[:"WINDOWS-1255", :"UTF-8", :IBM861]]
  @paths["[WINDOWS-1255, IBM862]"] = [[:"WINDOWS-1255", :"UTF-8", :IBM862]]
  @paths["[WINDOWS-1255, IBM863]"] = [[:"WINDOWS-1255", :"UTF-8", :IBM863]]
  @paths["[WINDOWS-1255, IBM865]"] = [[:"WINDOWS-1255", :"UTF-8", :IBM865]]
  @paths["[WINDOWS-1255, IBM866]"] = [[:"WINDOWS-1255", :"UTF-8", :IBM866]]
  @paths["[WINDOWS-1255, IBM869]"] = [[:"WINDOWS-1255", :"UTF-8", :IBM869]]
  @paths["[WINDOWS-1255, ISO-2022-JP]"] = [[:"WINDOWS-1255", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[WINDOWS-1255, ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1255, ISO-8859-1]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-1"]]
  @paths["[WINDOWS-1255, ISO-8859-10]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-10"]]
  @paths["[WINDOWS-1255, ISO-8859-11]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-11"]]
  @paths["[WINDOWS-1255, ISO-8859-13]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-13"]]
  @paths["[WINDOWS-1255, ISO-8859-14]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-14"]]
  @paths["[WINDOWS-1255, ISO-8859-15]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-15"]]
  @paths["[WINDOWS-1255, ISO-8859-2]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-2"]]
  @paths["[WINDOWS-1255, ISO-8859-3]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-3"]]
  @paths["[WINDOWS-1255, ISO-8859-4]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-4"]]
  @paths["[WINDOWS-1255, ISO-8859-5]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-5"]]
  @paths["[WINDOWS-1255, ISO-8859-6]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-6"]]
  @paths["[WINDOWS-1255, ISO-8859-7]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-7"]]
  @paths["[WINDOWS-1255, ISO-8859-8]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-8"]]
  @paths["[WINDOWS-1255, ISO-8859-9]"] = [[:"WINDOWS-1255", :"UTF-8", :"ISO-8859-9"]]
  @paths["[WINDOWS-1255, KOI8-R]"] = [[:"WINDOWS-1255", :"UTF-8", :"KOI8-R"]]
  @paths["[WINDOWS-1255, KOI8-U]"] = [[:"WINDOWS-1255", :"UTF-8", :"KOI8-U"]]
  @paths["[WINDOWS-1255, MACCROATIAN]"] = [[:"WINDOWS-1255", :"UTF-8", :MACCROATIAN]]
  @paths["[WINDOWS-1255, MACCYRILLIC]"] = [[:"WINDOWS-1255", :"UTF-8", :MACCYRILLIC]]
  @paths["[WINDOWS-1255, MACGREEK]"] = [[:"WINDOWS-1255", :"UTF-8", :MACGREEK]]
  @paths["[WINDOWS-1255, MACICELAND]"] = [[:"WINDOWS-1255", :"UTF-8", :MACICELAND]]
  @paths["[WINDOWS-1255, MACROMAN]"] = [[:"WINDOWS-1255", :"UTF-8", :MACROMAN]]
  @paths["[WINDOWS-1255, MACROMANIA]"] = [[:"WINDOWS-1255", :"UTF-8", :MACROMANIA]]
  @paths["[WINDOWS-1255, MACTURKISH]"] = [[:"WINDOWS-1255", :"UTF-8", :MACTURKISH]]
  @paths["[WINDOWS-1255, MACUKRAINE]"] = [[:"WINDOWS-1255", :"UTF-8", :MACUKRAINE]]
  @paths["[WINDOWS-1255, SHIFT_JIS]"] = [[:"WINDOWS-1255", :"UTF-8", :SHIFT_JIS]]
  @paths["[WINDOWS-1255, SJIS-DOCOMO]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[WINDOWS-1255, SJIS-KDDI]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[WINDOWS-1255, SJIS-SOFTBANK]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[WINDOWS-1255, STATELESS-ISO-2022-JP]"] = [[:"WINDOWS-1255", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[WINDOWS-1255, STATELESS-ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1255, TIS-620]"] = [[:"WINDOWS-1255", :"UTF-8", :"TIS-620"]]
  @paths["[WINDOWS-1255, US-ASCII]"] = [[:"WINDOWS-1255", :"UTF-8", :"US-ASCII"]]
  @paths["[WINDOWS-1255, UTF-16]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF-16"]]
  @paths["[WINDOWS-1255, UTF-16BE]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF-16BE"]]
  @paths["[WINDOWS-1255, UTF-16LE]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF-16LE"]]
  @paths["[WINDOWS-1255, UTF-32]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF-32"]]
  @paths["[WINDOWS-1255, UTF-32BE]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF-32BE"]]
  @paths["[WINDOWS-1255, UTF-32LE]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF-32LE"]]
  @paths["[WINDOWS-1255, UTF-8]"] = [[:"WINDOWS-1255", :"UTF-8"]]
  @paths["[WINDOWS-1255, UTF8-DOCOMO]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[WINDOWS-1255, UTF8-KDDI]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[WINDOWS-1255, UTF8-MAC]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF8-MAC"]]
  @paths["[WINDOWS-1255, UTF8-SOFTBANK]"] = [[:"WINDOWS-1255", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[WINDOWS-1255, WINDOWS-1250]"] = [[:"WINDOWS-1255", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[WINDOWS-1255, WINDOWS-1251]"] = [[:"WINDOWS-1255", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[WINDOWS-1255, WINDOWS-1252]"] = [[:"WINDOWS-1255", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[WINDOWS-1255, WINDOWS-1253]"] = [[:"WINDOWS-1255", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[WINDOWS-1255, WINDOWS-1254]"] = [[:"WINDOWS-1255", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[WINDOWS-1255, WINDOWS-1256]"] = [[:"WINDOWS-1255", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[WINDOWS-1255, WINDOWS-1257]"] = [[:"WINDOWS-1255", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[WINDOWS-1255, WINDOWS-31J]"] = [[:"WINDOWS-1255", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[WINDOWS-1255, WINDOWS-874]"] = [[:"WINDOWS-1255", :"UTF-8", :"WINDOWS-874"]]
  @paths["[WINDOWS-1256, ASCII-8BIT]"] = [[:"WINDOWS-1256", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[WINDOWS-1256, BIG5]"] = [[:"WINDOWS-1256", :"UTF-8", :BIG5]]
  @paths["[WINDOWS-1256, BIG5-HKSCS]"] = [[:"WINDOWS-1256", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[WINDOWS-1256, BIG5-UAO]"] = [[:"WINDOWS-1256", :"UTF-8", :"BIG5-UAO"]]
  @paths["[WINDOWS-1256, CP50220]"] = [[:"WINDOWS-1256", :"UTF-8", :CP51932, :CP50220]]
  @paths["[WINDOWS-1256, CP50221]"] = [[:"WINDOWS-1256", :"UTF-8", :CP51932, :CP50221]]
  @paths["[WINDOWS-1256, CP51932]"] = [[:"WINDOWS-1256", :"UTF-8", :CP51932]]
  @paths["[WINDOWS-1256, CP850]"] = [[:"WINDOWS-1256", :"UTF-8", :CP850]]
  @paths["[WINDOWS-1256, CP852]"] = [[:"WINDOWS-1256", :"UTF-8", :CP852]]
  @paths["[WINDOWS-1256, CP855]"] = [[:"WINDOWS-1256", :"UTF-8", :CP855]]
  @paths["[WINDOWS-1256, CP949]"] = [[:"WINDOWS-1256", :"UTF-8", :CP949]]
  @paths["[WINDOWS-1256, CP950]"] = [[:"WINDOWS-1256", :"UTF-8", :CP950]]
  @paths["[WINDOWS-1256, CP951]"] = [[:"WINDOWS-1256", :"UTF-8", :CP951]]
  @paths["[WINDOWS-1256, EUC-JP]"] = [[:"WINDOWS-1256", :"UTF-8", :"EUC-JP"]]
  @paths["[WINDOWS-1256, EUC-KR]"] = [[:"WINDOWS-1256", :"UTF-8", :"EUC-KR"]]
  @paths["[WINDOWS-1256, EUCJP-MS]"] = [[:"WINDOWS-1256", :"UTF-8", :"EUCJP-MS"]]
  @paths["[WINDOWS-1256, GB12345]"] = [[:"WINDOWS-1256", :"UTF-8", :GB12345]]
  @paths["[WINDOWS-1256, GB18030]"] = [[:"WINDOWS-1256", :"UTF-8", :GB18030]]
  @paths["[WINDOWS-1256, GB2312]"] = [[:"WINDOWS-1256", :"UTF-8", :GB2312]]
  @paths["[WINDOWS-1256, GBK]"] = [[:"WINDOWS-1256", :"UTF-8", :GBK]]
  @paths["[WINDOWS-1256, IBM437]"] = [[:"WINDOWS-1256", :"UTF-8", :IBM437]]
  @paths["[WINDOWS-1256, IBM737]"] = [[:"WINDOWS-1256", :"UTF-8", :IBM737]]
  @paths["[WINDOWS-1256, IBM775]"] = [[:"WINDOWS-1256", :"UTF-8", :IBM775]]
  @paths["[WINDOWS-1256, IBM852]"] = [[:"WINDOWS-1256", :"UTF-8", :IBM852]]
  @paths["[WINDOWS-1256, IBM855]"] = [[:"WINDOWS-1256", :"UTF-8", :IBM855]]
  @paths["[WINDOWS-1256, IBM857]"] = [[:"WINDOWS-1256", :"UTF-8", :IBM857]]
  @paths["[WINDOWS-1256, IBM860]"] = [[:"WINDOWS-1256", :"UTF-8", :IBM860]]
  @paths["[WINDOWS-1256, IBM861]"] = [[:"WINDOWS-1256", :"UTF-8", :IBM861]]
  @paths["[WINDOWS-1256, IBM862]"] = [[:"WINDOWS-1256", :"UTF-8", :IBM862]]
  @paths["[WINDOWS-1256, IBM863]"] = [[:"WINDOWS-1256", :"UTF-8", :IBM863]]
  @paths["[WINDOWS-1256, IBM865]"] = [[:"WINDOWS-1256", :"UTF-8", :IBM865]]
  @paths["[WINDOWS-1256, IBM866]"] = [[:"WINDOWS-1256", :"UTF-8", :IBM866]]
  @paths["[WINDOWS-1256, IBM869]"] = [[:"WINDOWS-1256", :"UTF-8", :IBM869]]
  @paths["[WINDOWS-1256, ISO-2022-JP]"] = [[:"WINDOWS-1256", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[WINDOWS-1256, ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1256, ISO-8859-1]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-1"]]
  @paths["[WINDOWS-1256, ISO-8859-10]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-10"]]
  @paths["[WINDOWS-1256, ISO-8859-11]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-11"]]
  @paths["[WINDOWS-1256, ISO-8859-13]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-13"]]
  @paths["[WINDOWS-1256, ISO-8859-14]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-14"]]
  @paths["[WINDOWS-1256, ISO-8859-15]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-15"]]
  @paths["[WINDOWS-1256, ISO-8859-2]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-2"]]
  @paths["[WINDOWS-1256, ISO-8859-3]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-3"]]
  @paths["[WINDOWS-1256, ISO-8859-4]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-4"]]
  @paths["[WINDOWS-1256, ISO-8859-5]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-5"]]
  @paths["[WINDOWS-1256, ISO-8859-6]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-6"]]
  @paths["[WINDOWS-1256, ISO-8859-7]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-7"]]
  @paths["[WINDOWS-1256, ISO-8859-8]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-8"]]
  @paths["[WINDOWS-1256, ISO-8859-9]"] = [[:"WINDOWS-1256", :"UTF-8", :"ISO-8859-9"]]
  @paths["[WINDOWS-1256, KOI8-R]"] = [[:"WINDOWS-1256", :"UTF-8", :"KOI8-R"]]
  @paths["[WINDOWS-1256, KOI8-U]"] = [[:"WINDOWS-1256", :"UTF-8", :"KOI8-U"]]
  @paths["[WINDOWS-1256, MACCROATIAN]"] = [[:"WINDOWS-1256", :"UTF-8", :MACCROATIAN]]
  @paths["[WINDOWS-1256, MACCYRILLIC]"] = [[:"WINDOWS-1256", :"UTF-8", :MACCYRILLIC]]
  @paths["[WINDOWS-1256, MACGREEK]"] = [[:"WINDOWS-1256", :"UTF-8", :MACGREEK]]
  @paths["[WINDOWS-1256, MACICELAND]"] = [[:"WINDOWS-1256", :"UTF-8", :MACICELAND]]
  @paths["[WINDOWS-1256, MACROMAN]"] = [[:"WINDOWS-1256", :"UTF-8", :MACROMAN]]
  @paths["[WINDOWS-1256, MACROMANIA]"] = [[:"WINDOWS-1256", :"UTF-8", :MACROMANIA]]
  @paths["[WINDOWS-1256, MACTURKISH]"] = [[:"WINDOWS-1256", :"UTF-8", :MACTURKISH]]
  @paths["[WINDOWS-1256, MACUKRAINE]"] = [[:"WINDOWS-1256", :"UTF-8", :MACUKRAINE]]
  @paths["[WINDOWS-1256, SHIFT_JIS]"] = [[:"WINDOWS-1256", :"UTF-8", :SHIFT_JIS]]
  @paths["[WINDOWS-1256, SJIS-DOCOMO]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[WINDOWS-1256, SJIS-KDDI]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[WINDOWS-1256, SJIS-SOFTBANK]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[WINDOWS-1256, STATELESS-ISO-2022-JP]"] = [[:"WINDOWS-1256", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[WINDOWS-1256, STATELESS-ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1256, TIS-620]"] = [[:"WINDOWS-1256", :"UTF-8", :"TIS-620"]]
  @paths["[WINDOWS-1256, US-ASCII]"] = [[:"WINDOWS-1256", :"UTF-8", :"US-ASCII"]]
  @paths["[WINDOWS-1256, UTF-16]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF-16"]]
  @paths["[WINDOWS-1256, UTF-16BE]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF-16BE"]]
  @paths["[WINDOWS-1256, UTF-16LE]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF-16LE"]]
  @paths["[WINDOWS-1256, UTF-32]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF-32"]]
  @paths["[WINDOWS-1256, UTF-32BE]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF-32BE"]]
  @paths["[WINDOWS-1256, UTF-32LE]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF-32LE"]]
  @paths["[WINDOWS-1256, UTF-8]"] = [[:"WINDOWS-1256", :"UTF-8"]]
  @paths["[WINDOWS-1256, UTF8-DOCOMO]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[WINDOWS-1256, UTF8-KDDI]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[WINDOWS-1256, UTF8-MAC]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF8-MAC"]]
  @paths["[WINDOWS-1256, UTF8-SOFTBANK]"] = [[:"WINDOWS-1256", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[WINDOWS-1256, WINDOWS-1250]"] = [[:"WINDOWS-1256", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[WINDOWS-1256, WINDOWS-1251]"] = [[:"WINDOWS-1256", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[WINDOWS-1256, WINDOWS-1252]"] = [[:"WINDOWS-1256", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[WINDOWS-1256, WINDOWS-1253]"] = [[:"WINDOWS-1256", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[WINDOWS-1256, WINDOWS-1254]"] = [[:"WINDOWS-1256", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[WINDOWS-1256, WINDOWS-1255]"] = [[:"WINDOWS-1256", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[WINDOWS-1256, WINDOWS-1257]"] = [[:"WINDOWS-1256", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[WINDOWS-1256, WINDOWS-31J]"] = [[:"WINDOWS-1256", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[WINDOWS-1256, WINDOWS-874]"] = [[:"WINDOWS-1256", :"UTF-8", :"WINDOWS-874"]]
  @paths["[WINDOWS-1257, ASCII-8BIT]"] = [[:"WINDOWS-1257", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[WINDOWS-1257, BIG5]"] = [[:"WINDOWS-1257", :"UTF-8", :BIG5]]
  @paths["[WINDOWS-1257, BIG5-HKSCS]"] = [[:"WINDOWS-1257", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[WINDOWS-1257, BIG5-UAO]"] = [[:"WINDOWS-1257", :"UTF-8", :"BIG5-UAO"]]
  @paths["[WINDOWS-1257, CP50220]"] = [[:"WINDOWS-1257", :"UTF-8", :CP51932, :CP50220]]
  @paths["[WINDOWS-1257, CP50221]"] = [[:"WINDOWS-1257", :"UTF-8", :CP51932, :CP50221]]
  @paths["[WINDOWS-1257, CP51932]"] = [[:"WINDOWS-1257", :"UTF-8", :CP51932]]
  @paths["[WINDOWS-1257, CP850]"] = [[:"WINDOWS-1257", :"UTF-8", :CP850]]
  @paths["[WINDOWS-1257, CP852]"] = [[:"WINDOWS-1257", :"UTF-8", :CP852]]
  @paths["[WINDOWS-1257, CP855]"] = [[:"WINDOWS-1257", :"UTF-8", :CP855]]
  @paths["[WINDOWS-1257, CP949]"] = [[:"WINDOWS-1257", :"UTF-8", :CP949]]
  @paths["[WINDOWS-1257, CP950]"] = [[:"WINDOWS-1257", :"UTF-8", :CP950]]
  @paths["[WINDOWS-1257, CP951]"] = [[:"WINDOWS-1257", :"UTF-8", :CP951]]
  @paths["[WINDOWS-1257, EUC-JP]"] = [[:"WINDOWS-1257", :"UTF-8", :"EUC-JP"]]
  @paths["[WINDOWS-1257, EUC-KR]"] = [[:"WINDOWS-1257", :"UTF-8", :"EUC-KR"]]
  @paths["[WINDOWS-1257, EUCJP-MS]"] = [[:"WINDOWS-1257", :"UTF-8", :"EUCJP-MS"]]
  @paths["[WINDOWS-1257, GB12345]"] = [[:"WINDOWS-1257", :"UTF-8", :GB12345]]
  @paths["[WINDOWS-1257, GB18030]"] = [[:"WINDOWS-1257", :"UTF-8", :GB18030]]
  @paths["[WINDOWS-1257, GB2312]"] = [[:"WINDOWS-1257", :"UTF-8", :GB2312]]
  @paths["[WINDOWS-1257, GBK]"] = [[:"WINDOWS-1257", :"UTF-8", :GBK]]
  @paths["[WINDOWS-1257, IBM437]"] = [[:"WINDOWS-1257", :"UTF-8", :IBM437]]
  @paths["[WINDOWS-1257, IBM737]"] = [[:"WINDOWS-1257", :"UTF-8", :IBM737]]
  @paths["[WINDOWS-1257, IBM775]"] = [[:"WINDOWS-1257", :"UTF-8", :IBM775]]
  @paths["[WINDOWS-1257, IBM852]"] = [[:"WINDOWS-1257", :"UTF-8", :IBM852]]
  @paths["[WINDOWS-1257, IBM855]"] = [[:"WINDOWS-1257", :"UTF-8", :IBM855]]
  @paths["[WINDOWS-1257, IBM857]"] = [[:"WINDOWS-1257", :"UTF-8", :IBM857]]
  @paths["[WINDOWS-1257, IBM860]"] = [[:"WINDOWS-1257", :"UTF-8", :IBM860]]
  @paths["[WINDOWS-1257, IBM861]"] = [[:"WINDOWS-1257", :"UTF-8", :IBM861]]
  @paths["[WINDOWS-1257, IBM862]"] = [[:"WINDOWS-1257", :"UTF-8", :IBM862]]
  @paths["[WINDOWS-1257, IBM863]"] = [[:"WINDOWS-1257", :"UTF-8", :IBM863]]
  @paths["[WINDOWS-1257, IBM865]"] = [[:"WINDOWS-1257", :"UTF-8", :IBM865]]
  @paths["[WINDOWS-1257, IBM866]"] = [[:"WINDOWS-1257", :"UTF-8", :IBM866]]
  @paths["[WINDOWS-1257, IBM869]"] = [[:"WINDOWS-1257", :"UTF-8", :IBM869]]
  @paths["[WINDOWS-1257, ISO-2022-JP]"] = [[:"WINDOWS-1257", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[WINDOWS-1257, ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1257, ISO-8859-1]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-1"]]
  @paths["[WINDOWS-1257, ISO-8859-10]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-10"]]
  @paths["[WINDOWS-1257, ISO-8859-11]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-11"]]
  @paths["[WINDOWS-1257, ISO-8859-13]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-13"]]
  @paths["[WINDOWS-1257, ISO-8859-14]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-14"]]
  @paths["[WINDOWS-1257, ISO-8859-15]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-15"]]
  @paths["[WINDOWS-1257, ISO-8859-2]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-2"]]
  @paths["[WINDOWS-1257, ISO-8859-3]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-3"]]
  @paths["[WINDOWS-1257, ISO-8859-4]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-4"]]
  @paths["[WINDOWS-1257, ISO-8859-5]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-5"]]
  @paths["[WINDOWS-1257, ISO-8859-6]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-6"]]
  @paths["[WINDOWS-1257, ISO-8859-7]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-7"]]
  @paths["[WINDOWS-1257, ISO-8859-8]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-8"]]
  @paths["[WINDOWS-1257, ISO-8859-9]"] = [[:"WINDOWS-1257", :"UTF-8", :"ISO-8859-9"]]
  @paths["[WINDOWS-1257, KOI8-R]"] = [[:"WINDOWS-1257", :"UTF-8", :"KOI8-R"]]
  @paths["[WINDOWS-1257, KOI8-U]"] = [[:"WINDOWS-1257", :"UTF-8", :"KOI8-U"]]
  @paths["[WINDOWS-1257, MACCROATIAN]"] = [[:"WINDOWS-1257", :"UTF-8", :MACCROATIAN]]
  @paths["[WINDOWS-1257, MACCYRILLIC]"] = [[:"WINDOWS-1257", :"UTF-8", :MACCYRILLIC]]
  @paths["[WINDOWS-1257, MACGREEK]"] = [[:"WINDOWS-1257", :"UTF-8", :MACGREEK]]
  @paths["[WINDOWS-1257, MACICELAND]"] = [[:"WINDOWS-1257", :"UTF-8", :MACICELAND]]
  @paths["[WINDOWS-1257, MACROMAN]"] = [[:"WINDOWS-1257", :"UTF-8", :MACROMAN]]
  @paths["[WINDOWS-1257, MACROMANIA]"] = [[:"WINDOWS-1257", :"UTF-8", :MACROMANIA]]
  @paths["[WINDOWS-1257, MACTURKISH]"] = [[:"WINDOWS-1257", :"UTF-8", :MACTURKISH]]
  @paths["[WINDOWS-1257, MACUKRAINE]"] = [[:"WINDOWS-1257", :"UTF-8", :MACUKRAINE]]
  @paths["[WINDOWS-1257, SHIFT_JIS]"] = [[:"WINDOWS-1257", :"UTF-8", :SHIFT_JIS]]
  @paths["[WINDOWS-1257, SJIS-DOCOMO]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[WINDOWS-1257, SJIS-KDDI]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[WINDOWS-1257, SJIS-SOFTBANK]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[WINDOWS-1257, STATELESS-ISO-2022-JP]"] = [[:"WINDOWS-1257", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[WINDOWS-1257, STATELESS-ISO-2022-JP-KDDI]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-1257, TIS-620]"] = [[:"WINDOWS-1257", :"UTF-8", :"TIS-620"]]
  @paths["[WINDOWS-1257, US-ASCII]"] = [[:"WINDOWS-1257", :"UTF-8", :"US-ASCII"]]
  @paths["[WINDOWS-1257, UTF-16]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF-16"]]
  @paths["[WINDOWS-1257, UTF-16BE]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF-16BE"]]
  @paths["[WINDOWS-1257, UTF-16LE]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF-16LE"]]
  @paths["[WINDOWS-1257, UTF-32]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF-32"]]
  @paths["[WINDOWS-1257, UTF-32BE]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF-32BE"]]
  @paths["[WINDOWS-1257, UTF-32LE]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF-32LE"]]
  @paths["[WINDOWS-1257, UTF-8]"] = [[:"WINDOWS-1257", :"UTF-8"]]
  @paths["[WINDOWS-1257, UTF8-DOCOMO]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[WINDOWS-1257, UTF8-KDDI]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[WINDOWS-1257, UTF8-MAC]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF8-MAC"]]
  @paths["[WINDOWS-1257, UTF8-SOFTBANK]"] = [[:"WINDOWS-1257", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[WINDOWS-1257, WINDOWS-1250]"] = [[:"WINDOWS-1257", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[WINDOWS-1257, WINDOWS-1251]"] = [[:"WINDOWS-1257", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[WINDOWS-1257, WINDOWS-1252]"] = [[:"WINDOWS-1257", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[WINDOWS-1257, WINDOWS-1253]"] = [[:"WINDOWS-1257", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[WINDOWS-1257, WINDOWS-1254]"] = [[:"WINDOWS-1257", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[WINDOWS-1257, WINDOWS-1255]"] = [[:"WINDOWS-1257", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[WINDOWS-1257, WINDOWS-1256]"] = [[:"WINDOWS-1257", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[WINDOWS-1257, WINDOWS-31J]"] = [[:"WINDOWS-1257", :"UTF-8", :"WINDOWS-31J"]]
  @paths["[WINDOWS-1257, WINDOWS-874]"] = [[:"WINDOWS-1257", :"UTF-8", :"WINDOWS-874"]]
  @paths["[WINDOWS-31J, ASCII-8BIT]"] = [[:"WINDOWS-31J", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[WINDOWS-31J, BIG5]"] = [[:"WINDOWS-31J", :"UTF-8", :BIG5]]
  @paths["[WINDOWS-31J, BIG5-HKSCS]"] = [[:"WINDOWS-31J", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[WINDOWS-31J, BIG5-UAO]"] = [[:"WINDOWS-31J", :"UTF-8", :"BIG5-UAO"]]
  @paths["[WINDOWS-31J, CP50220]"] = [[:"WINDOWS-31J", :"UTF-8", :CP51932, :CP50220]]
  @paths["[WINDOWS-31J, CP50221]"] = [[:"WINDOWS-31J", :"UTF-8", :CP51932, :CP50221]]
  @paths["[WINDOWS-31J, CP51932]"] = [[:"WINDOWS-31J", :"UTF-8", :CP51932]]
  @paths["[WINDOWS-31J, CP850]"] = [[:"WINDOWS-31J", :"UTF-8", :CP850]]
  @paths["[WINDOWS-31J, CP852]"] = [[:"WINDOWS-31J", :"UTF-8", :CP852]]
  @paths["[WINDOWS-31J, CP855]"] = [[:"WINDOWS-31J", :"UTF-8", :CP855]]
  @paths["[WINDOWS-31J, CP949]"] = [[:"WINDOWS-31J", :"UTF-8", :CP949]]
  @paths["[WINDOWS-31J, CP950]"] = [[:"WINDOWS-31J", :"UTF-8", :CP950]]
  @paths["[WINDOWS-31J, CP951]"] = [[:"WINDOWS-31J", :"UTF-8", :CP951]]
  @paths["[WINDOWS-31J, EUC-JP]"] = [[:"WINDOWS-31J", :"UTF-8", :"EUC-JP"]]
  @paths["[WINDOWS-31J, EUC-KR]"] = [[:"WINDOWS-31J", :"UTF-8", :"EUC-KR"]]
  @paths["[WINDOWS-31J, EUCJP-MS]"] = [[:"WINDOWS-31J", :"UTF-8", :"EUCJP-MS"]]
  @paths["[WINDOWS-31J, GB12345]"] = [[:"WINDOWS-31J", :"UTF-8", :GB12345]]
  @paths["[WINDOWS-31J, GB18030]"] = [[:"WINDOWS-31J", :"UTF-8", :GB18030]]
  @paths["[WINDOWS-31J, GB2312]"] = [[:"WINDOWS-31J", :"UTF-8", :GB2312]]
  @paths["[WINDOWS-31J, GBK]"] = [[:"WINDOWS-31J", :"UTF-8", :GBK]]
  @paths["[WINDOWS-31J, IBM437]"] = [[:"WINDOWS-31J", :"UTF-8", :IBM437]]
  @paths["[WINDOWS-31J, IBM737]"] = [[:"WINDOWS-31J", :"UTF-8", :IBM737]]
  @paths["[WINDOWS-31J, IBM775]"] = [[:"WINDOWS-31J", :"UTF-8", :IBM775]]
  @paths["[WINDOWS-31J, IBM852]"] = [[:"WINDOWS-31J", :"UTF-8", :IBM852]]
  @paths["[WINDOWS-31J, IBM855]"] = [[:"WINDOWS-31J", :"UTF-8", :IBM855]]
  @paths["[WINDOWS-31J, IBM857]"] = [[:"WINDOWS-31J", :"UTF-8", :IBM857]]
  @paths["[WINDOWS-31J, IBM860]"] = [[:"WINDOWS-31J", :"UTF-8", :IBM860]]
  @paths["[WINDOWS-31J, IBM861]"] = [[:"WINDOWS-31J", :"UTF-8", :IBM861]]
  @paths["[WINDOWS-31J, IBM862]"] = [[:"WINDOWS-31J", :"UTF-8", :IBM862]]
  @paths["[WINDOWS-31J, IBM863]"] = [[:"WINDOWS-31J", :"UTF-8", :IBM863]]
  @paths["[WINDOWS-31J, IBM865]"] = [[:"WINDOWS-31J", :"UTF-8", :IBM865]]
  @paths["[WINDOWS-31J, IBM866]"] = [[:"WINDOWS-31J", :"UTF-8", :IBM866]]
  @paths["[WINDOWS-31J, IBM869]"] = [[:"WINDOWS-31J", :"UTF-8", :IBM869]]
  @paths["[WINDOWS-31J, ISO-2022-JP]"] = [[:"WINDOWS-31J", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[WINDOWS-31J, ISO-2022-JP-KDDI]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-31J, ISO-8859-1]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-1"]]
  @paths["[WINDOWS-31J, ISO-8859-10]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-10"]]
  @paths["[WINDOWS-31J, ISO-8859-11]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-11"]]
  @paths["[WINDOWS-31J, ISO-8859-13]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-13"]]
  @paths["[WINDOWS-31J, ISO-8859-14]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-14"]]
  @paths["[WINDOWS-31J, ISO-8859-15]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-15"]]
  @paths["[WINDOWS-31J, ISO-8859-2]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-2"]]
  @paths["[WINDOWS-31J, ISO-8859-3]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-3"]]
  @paths["[WINDOWS-31J, ISO-8859-4]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-4"]]
  @paths["[WINDOWS-31J, ISO-8859-5]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-5"]]
  @paths["[WINDOWS-31J, ISO-8859-6]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-6"]]
  @paths["[WINDOWS-31J, ISO-8859-7]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-7"]]
  @paths["[WINDOWS-31J, ISO-8859-8]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-8"]]
  @paths["[WINDOWS-31J, ISO-8859-9]"] = [[:"WINDOWS-31J", :"UTF-8", :"ISO-8859-9"]]
  @paths["[WINDOWS-31J, KOI8-R]"] = [[:"WINDOWS-31J", :"UTF-8", :"KOI8-R"]]
  @paths["[WINDOWS-31J, KOI8-U]"] = [[:"WINDOWS-31J", :"UTF-8", :"KOI8-U"]]
  @paths["[WINDOWS-31J, MACCROATIAN]"] = [[:"WINDOWS-31J", :"UTF-8", :MACCROATIAN]]
  @paths["[WINDOWS-31J, MACCYRILLIC]"] = [[:"WINDOWS-31J", :"UTF-8", :MACCYRILLIC]]
  @paths["[WINDOWS-31J, MACGREEK]"] = [[:"WINDOWS-31J", :"UTF-8", :MACGREEK]]
  @paths["[WINDOWS-31J, MACICELAND]"] = [[:"WINDOWS-31J", :"UTF-8", :MACICELAND]]
  @paths["[WINDOWS-31J, MACROMAN]"] = [[:"WINDOWS-31J", :"UTF-8", :MACROMAN]]
  @paths["[WINDOWS-31J, MACROMANIA]"] = [[:"WINDOWS-31J", :"UTF-8", :MACROMANIA]]
  @paths["[WINDOWS-31J, MACTURKISH]"] = [[:"WINDOWS-31J", :"UTF-8", :MACTURKISH]]
  @paths["[WINDOWS-31J, MACUKRAINE]"] = [[:"WINDOWS-31J", :"UTF-8", :MACUKRAINE]]
  @paths["[WINDOWS-31J, SHIFT_JIS]"] = [[:"WINDOWS-31J", :"UTF-8", :SHIFT_JIS]]
  @paths["[WINDOWS-31J, SJIS-DOCOMO]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[WINDOWS-31J, SJIS-KDDI]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[WINDOWS-31J, SJIS-SOFTBANK]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[WINDOWS-31J, STATELESS-ISO-2022-JP]"] = [[:"WINDOWS-31J", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[WINDOWS-31J, STATELESS-ISO-2022-JP-KDDI]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-31J, TIS-620]"] = [[:"WINDOWS-31J", :"UTF-8", :"TIS-620"]]
  @paths["[WINDOWS-31J, US-ASCII]"] = [[:"WINDOWS-31J", :"UTF-8", :"US-ASCII"]]
  @paths["[WINDOWS-31J, UTF-16]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF-16"]]
  @paths["[WINDOWS-31J, UTF-16BE]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF-16BE"]]
  @paths["[WINDOWS-31J, UTF-16LE]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF-16LE"]]
  @paths["[WINDOWS-31J, UTF-32]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF-32"]]
  @paths["[WINDOWS-31J, UTF-32BE]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF-32BE"]]
  @paths["[WINDOWS-31J, UTF-32LE]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF-32LE"]]
  @paths["[WINDOWS-31J, UTF-8]"] = [[:"WINDOWS-31J", :"UTF-8"]]
  @paths["[WINDOWS-31J, UTF8-DOCOMO]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[WINDOWS-31J, UTF8-KDDI]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[WINDOWS-31J, UTF8-MAC]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF8-MAC"]]
  @paths["[WINDOWS-31J, UTF8-SOFTBANK]"] = [[:"WINDOWS-31J", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[WINDOWS-31J, WINDOWS-1250]"] = [[:"WINDOWS-31J", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[WINDOWS-31J, WINDOWS-1251]"] = [[:"WINDOWS-31J", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[WINDOWS-31J, WINDOWS-1252]"] = [[:"WINDOWS-31J", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[WINDOWS-31J, WINDOWS-1253]"] = [[:"WINDOWS-31J", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[WINDOWS-31J, WINDOWS-1254]"] = [[:"WINDOWS-31J", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[WINDOWS-31J, WINDOWS-1255]"] = [[:"WINDOWS-31J", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[WINDOWS-31J, WINDOWS-1256]"] = [[:"WINDOWS-31J", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[WINDOWS-31J, WINDOWS-1257]"] = [[:"WINDOWS-31J", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[WINDOWS-31J, WINDOWS-874]"] = [[:"WINDOWS-31J", :"UTF-8", :"WINDOWS-874"]]
  @paths["[WINDOWS-874, ASCII-8BIT]"] = [[:"WINDOWS-874", :"UTF-8", :"ASCII-8BIT"]]
  @paths["[WINDOWS-874, BIG5]"] = [[:"WINDOWS-874", :"UTF-8", :BIG5]]
  @paths["[WINDOWS-874, BIG5-HKSCS]"] = [[:"WINDOWS-874", :"UTF-8", :"BIG5-HKSCS"]]
  @paths["[WINDOWS-874, BIG5-UAO]"] = [[:"WINDOWS-874", :"UTF-8", :"BIG5-UAO"]]
  @paths["[WINDOWS-874, CP50220]"] = [[:"WINDOWS-874", :"UTF-8", :CP51932, :CP50220]]
  @paths["[WINDOWS-874, CP50221]"] = [[:"WINDOWS-874", :"UTF-8", :CP51932, :CP50221]]
  @paths["[WINDOWS-874, CP51932]"] = [[:"WINDOWS-874", :"UTF-8", :CP51932]]
  @paths["[WINDOWS-874, CP850]"] = [[:"WINDOWS-874", :"UTF-8", :CP850]]
  @paths["[WINDOWS-874, CP852]"] = [[:"WINDOWS-874", :"UTF-8", :CP852]]
  @paths["[WINDOWS-874, CP855]"] = [[:"WINDOWS-874", :"UTF-8", :CP855]]
  @paths["[WINDOWS-874, CP949]"] = [[:"WINDOWS-874", :"UTF-8", :CP949]]
  @paths["[WINDOWS-874, CP950]"] = [[:"WINDOWS-874", :"UTF-8", :CP950]]
  @paths["[WINDOWS-874, CP951]"] = [[:"WINDOWS-874", :"UTF-8", :CP951]]
  @paths["[WINDOWS-874, EUC-JP]"] = [[:"WINDOWS-874", :"UTF-8", :"EUC-JP"]]
  @paths["[WINDOWS-874, EUC-KR]"] = [[:"WINDOWS-874", :"UTF-8", :"EUC-KR"]]
  @paths["[WINDOWS-874, EUCJP-MS]"] = [[:"WINDOWS-874", :"UTF-8", :"EUCJP-MS"]]
  @paths["[WINDOWS-874, GB12345]"] = [[:"WINDOWS-874", :"UTF-8", :GB12345]]
  @paths["[WINDOWS-874, GB18030]"] = [[:"WINDOWS-874", :"UTF-8", :GB18030]]
  @paths["[WINDOWS-874, GB2312]"] = [[:"WINDOWS-874", :"UTF-8", :GB2312]]
  @paths["[WINDOWS-874, GBK]"] = [[:"WINDOWS-874", :"UTF-8", :GBK]]
  @paths["[WINDOWS-874, IBM437]"] = [[:"WINDOWS-874", :"UTF-8", :IBM437]]
  @paths["[WINDOWS-874, IBM737]"] = [[:"WINDOWS-874", :"UTF-8", :IBM737]]
  @paths["[WINDOWS-874, IBM775]"] = [[:"WINDOWS-874", :"UTF-8", :IBM775]]
  @paths["[WINDOWS-874, IBM852]"] = [[:"WINDOWS-874", :"UTF-8", :IBM852]]
  @paths["[WINDOWS-874, IBM855]"] = [[:"WINDOWS-874", :"UTF-8", :IBM855]]
  @paths["[WINDOWS-874, IBM857]"] = [[:"WINDOWS-874", :"UTF-8", :IBM857]]
  @paths["[WINDOWS-874, IBM860]"] = [[:"WINDOWS-874", :"UTF-8", :IBM860]]
  @paths["[WINDOWS-874, IBM861]"] = [[:"WINDOWS-874", :"UTF-8", :IBM861]]
  @paths["[WINDOWS-874, IBM862]"] = [[:"WINDOWS-874", :"UTF-8", :IBM862]]
  @paths["[WINDOWS-874, IBM863]"] = [[:"WINDOWS-874", :"UTF-8", :IBM863]]
  @paths["[WINDOWS-874, IBM865]"] = [[:"WINDOWS-874", :"UTF-8", :IBM865]]
  @paths["[WINDOWS-874, IBM866]"] = [[:"WINDOWS-874", :"UTF-8", :IBM866]]
  @paths["[WINDOWS-874, IBM869]"] = [[:"WINDOWS-874", :"UTF-8", :IBM869]]
  @paths["[WINDOWS-874, ISO-2022-JP]"] = [[:"WINDOWS-874", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP", :"ISO-2022-JP"]]
  @paths["[WINDOWS-874, ISO-2022-JP-KDDI]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI", :"ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-874, ISO-8859-1]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-1"]]
  @paths["[WINDOWS-874, ISO-8859-10]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-10"]]
  @paths["[WINDOWS-874, ISO-8859-11]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-11"]]
  @paths["[WINDOWS-874, ISO-8859-13]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-13"]]
  @paths["[WINDOWS-874, ISO-8859-14]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-14"]]
  @paths["[WINDOWS-874, ISO-8859-15]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-15"]]
  @paths["[WINDOWS-874, ISO-8859-2]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-2"]]
  @paths["[WINDOWS-874, ISO-8859-3]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-3"]]
  @paths["[WINDOWS-874, ISO-8859-4]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-4"]]
  @paths["[WINDOWS-874, ISO-8859-5]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-5"]]
  @paths["[WINDOWS-874, ISO-8859-6]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-6"]]
  @paths["[WINDOWS-874, ISO-8859-7]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-7"]]
  @paths["[WINDOWS-874, ISO-8859-8]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-8"]]
  @paths["[WINDOWS-874, ISO-8859-9]"] = [[:"WINDOWS-874", :"UTF-8", :"ISO-8859-9"]]
  @paths["[WINDOWS-874, KOI8-R]"] = [[:"WINDOWS-874", :"UTF-8", :"KOI8-R"]]
  @paths["[WINDOWS-874, KOI8-U]"] = [[:"WINDOWS-874", :"UTF-8", :"KOI8-U"]]
  @paths["[WINDOWS-874, MACCROATIAN]"] = [[:"WINDOWS-874", :"UTF-8", :MACCROATIAN]]
  @paths["[WINDOWS-874, MACCYRILLIC]"] = [[:"WINDOWS-874", :"UTF-8", :MACCYRILLIC]]
  @paths["[WINDOWS-874, MACGREEK]"] = [[:"WINDOWS-874", :"UTF-8", :MACGREEK]]
  @paths["[WINDOWS-874, MACICELAND]"] = [[:"WINDOWS-874", :"UTF-8", :MACICELAND]]
  @paths["[WINDOWS-874, MACROMAN]"] = [[:"WINDOWS-874", :"UTF-8", :MACROMAN]]
  @paths["[WINDOWS-874, MACROMANIA]"] = [[:"WINDOWS-874", :"UTF-8", :MACROMANIA]]
  @paths["[WINDOWS-874, MACTURKISH]"] = [[:"WINDOWS-874", :"UTF-8", :MACTURKISH]]
  @paths["[WINDOWS-874, MACUKRAINE]"] = [[:"WINDOWS-874", :"UTF-8", :MACUKRAINE]]
  @paths["[WINDOWS-874, SHIFT_JIS]"] = [[:"WINDOWS-874", :"UTF-8", :SHIFT_JIS]]
  @paths["[WINDOWS-874, SJIS-DOCOMO]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF8-DOCOMO", :"SJIS-DOCOMO"]]
  @paths["[WINDOWS-874, SJIS-KDDI]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF8-KDDI", :"SJIS-KDDI"]]
  @paths["[WINDOWS-874, SJIS-SOFTBANK]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF8-SOFTBANK", :"SJIS-SOFTBANK"]]
  @paths["[WINDOWS-874, STATELESS-ISO-2022-JP]"] = [[:"WINDOWS-874", :"UTF-8", :"EUC-JP", :"STATELESS-ISO-2022-JP"]]
  @paths["[WINDOWS-874, STATELESS-ISO-2022-JP-KDDI]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF8-KDDI", :"STATELESS-ISO-2022-JP-KDDI"]]
  @paths["[WINDOWS-874, TIS-620]"] = [[:"WINDOWS-874", :"UTF-8", :"TIS-620"]]
  @paths["[WINDOWS-874, US-ASCII]"] = [[:"WINDOWS-874", :"UTF-8", :"US-ASCII"]]
  @paths["[WINDOWS-874, UTF-16]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF-16"]]
  @paths["[WINDOWS-874, UTF-16BE]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF-16BE"]]
  @paths["[WINDOWS-874, UTF-16LE]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF-16LE"]]
  @paths["[WINDOWS-874, UTF-32]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF-32"]]
  @paths["[WINDOWS-874, UTF-32BE]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF-32BE"]]
  @paths["[WINDOWS-874, UTF-32LE]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF-32LE"]]
  @paths["[WINDOWS-874, UTF-8]"] = [[:"WINDOWS-874", :"UTF-8"]]
  @paths["[WINDOWS-874, UTF8-DOCOMO]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF8-DOCOMO"]]
  @paths["[WINDOWS-874, UTF8-KDDI]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF8-KDDI"]]
  @paths["[WINDOWS-874, UTF8-MAC]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF8-MAC"]]
  @paths["[WINDOWS-874, UTF8-SOFTBANK]"] = [[:"WINDOWS-874", :"UTF-8", :"UTF8-SOFTBANK"]]
  @paths["[WINDOWS-874, WINDOWS-1250]"] = [[:"WINDOWS-874", :"UTF-8", :"WINDOWS-1250"]]
  @paths["[WINDOWS-874, WINDOWS-1251]"] = [[:"WINDOWS-874", :"UTF-8", :"WINDOWS-1251"]]
  @paths["[WINDOWS-874, WINDOWS-1252]"] = [[:"WINDOWS-874", :"UTF-8", :"WINDOWS-1252"]]
  @paths["[WINDOWS-874, WINDOWS-1253]"] = [[:"WINDOWS-874", :"UTF-8", :"WINDOWS-1253"]]
  @paths["[WINDOWS-874, WINDOWS-1254]"] = [[:"WINDOWS-874", :"UTF-8", :"WINDOWS-1254"]]
  @paths["[WINDOWS-874, WINDOWS-1255]"] = [[:"WINDOWS-874", :"UTF-8", :"WINDOWS-1255"]]
  @paths["[WINDOWS-874, WINDOWS-1256]"] = [[:"WINDOWS-874", :"UTF-8", :"WINDOWS-1256"]]
  @paths["[WINDOWS-874, WINDOWS-1257]"] = [[:"WINDOWS-874", :"UTF-8", :"WINDOWS-1257"]]
  @paths["[WINDOWS-874, WINDOWS-31J]"] = [[:"WINDOWS-874", :"UTF-8", :"WINDOWS-31J"]]
end
